/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yydebug         VLdebug
#define yynerrs         VLnerrs

#define yylval          VLlval
#define yychar          VLchar
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */
#line 2 "parse.y" /* yacc.c:339  */

/*
 * Copyright (c) 1998-2017 Stephen Williams (steve@icarus.com)
 * Copyright CERN 2012-2013 / Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_end_table();

static list<pform_range_t>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      data_type_t* data_type;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT, 0};

/* Modport port declaration lists use this structure for context. */
enum modport_port_type_t { MP_NONE, MP_SIMPLE, MP_TF, MP_CLOCKING };
static struct {
      modport_port_type_t type;
      union {
	    NetNet::PortType direction;
	    bool is_import;
      };
} last_modport_port = { MP_NONE, {NetNet::NOT_A_PORT}};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* The variable declaration rules need to know if a lifetime has been
   specified. */
static LexicalScope::lifetime_t var_lifetime;

static pform_name_t* pform_create_this(void)
{
      name_component_t name (perm_string::literal("@"));
      pform_name_t*res = new pform_name_t;
      res->push_back(name);
      return res;
}

static pform_name_t* pform_create_super(void)
{
      name_component_t name (perm_string::literal("#"));
      pform_name_t*res = new pform_name_t;
      res->push_back(name);
      return res;
}

/* This is used to keep track of the extra arguments after the notifier
 * in the $setuphold and $recrem timing checks. This allows us to print
 * a warning message that the delayed signals will not be created. We
 * need to do this since not driving these signals creates real
 * simulation issues. */
static unsigned args_after_notifier;

/* The rules sometimes push attributes into a global context where
   sub-rules may grab them. This makes parser rules a little easier to
   write in some cases. */
static list<named_pexpr_t>*attributes_in_context = 0;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied.

   The YYLLOC_DEFAULT blends the file range for the tokens of Rhs
   rule, which has N tokens.
*/
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {				\
      if (N) {							        \
	    (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	    (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	    (Current).last_line    = YYRHSLOC (Rhs, N).last_line;	\
	    (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	    (Current).text         = YYRHSLOC (Rhs, 1).text;		\
      } else {								\
	    (Current).first_line   = YYRHSLOC (Rhs, 0).last_line;	\
	    (Current).first_column = YYRHSLOC (Rhs, 0).last_column;	\
	    (Current).last_line    = YYRHSLOC (Rhs, 0).last_line;	\
	    (Current).last_column  = YYRHSLOC (Rhs, 0).last_column;	\
	    (Current).text         = YYRHSLOC (Rhs, 0).text;		\
      }									\
   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
static const struct str_pair_t pull_strength = { IVL_DR_PULL,  IVL_DR_PULL };
static const struct str_pair_t str_strength = { IVL_DR_STRONG, IVL_DR_STRONG };

static list<pform_port_t>* make_port_list(char*id, list<pform_range_t>*udims, PExpr*expr)
{
      list<pform_port_t>*tmp = new list<pform_port_t>;
      tmp->push_back(pform_port_t(lex_strings.make(id), udims, expr));
      delete[]id;
      return tmp;
}
static list<pform_port_t>* make_port_list(list<pform_port_t>*tmp,
                                          char*id, list<pform_range_t>*udims, PExpr*expr)
{
      tmp->push_back(pform_port_t(lex_strings.make(id), udims, expr));
      delete[]id;
      return tmp;
}

list<pform_range_t>* make_range_from_width(uint64_t wid)
{
      pform_range_t range;
      range.first  = new PENumber(new verinum(wid-1, integer_width));
      range.second = new PENumber(new verinum((uint64_t)0, integer_width));

      list<pform_range_t>*rlist = new list<pform_range_t>;
      rlist->push_back(range);
      return rlist;
}

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

list<pform_range_t>* copy_range(list<pform_range_t>* orig)
{
      list<pform_range_t>*copy = 0;

      if (orig)
	    copy = new list<pform_range_t> (*orig);

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * Look at the list and pull null pointers off the end.
 */
static void strip_tail_items(list<PExpr*>*lst)
{
      while (! lst->empty()) {
	    if (lst->back() != 0)
		  return;
	    lst->pop_back();
      }
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      vector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      vector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static list<named_pexpr_t>* make_named_numbers(perm_string name, long first, long last, PExpr*val =0)
{
      list<named_pexpr_t>*lst = new list<named_pexpr_t>;
      named_pexpr_t tmp;
	// We are counting up.
      if (first <= last) {
	    for (long idx = first ; idx <= last ; idx += 1) {
		  ostringstream buf;
		  buf << name.str() << idx << ends;
		  tmp.name = lex_strings.make(buf.str());
		  tmp.parm = val;
		  val = 0;
		  lst->push_back(tmp);
	    }
	// We are counting down.
      } else {
	    for (long idx = first ; idx >= last ; idx -= 1) {
		  ostringstream buf;
		  buf << name.str() << idx << ends;
		  tmp.name = lex_strings.make(buf.str());
		  tmp.parm = val;
		  val = 0;
		  lst->push_back(tmp);
	    }
      }
      return lst;
}

static list<named_pexpr_t>* make_named_number(perm_string name, PExpr*val =0)
{
      list<named_pexpr_t>*lst = new list<named_pexpr_t>;
      named_pexpr_t tmp;
      tmp.name = name;
      tmp.parm = val;
      lst->push_back(tmp);
      return lst;
}

static long check_enum_seq_value(const YYLTYPE&loc, verinum *arg, bool zero_ok)
{
      long value = 1;
	// We can never have an undefined value in an enumeration name
	// declaration sequence.
      if (! arg->is_defined()) {
	    yyerror(loc, "error: undefined value used in enum name sequence.");
	// We can never have a negative value in an enumeration name
	// declaration sequence.
      } else if (arg->is_negative()) {
	    yyerror(loc, "error: negative value used in enum name sequence.");
      } else {
	    value = arg->as_ulong();
	      // We cannot have a zero enumeration name declaration count.
	    if (! zero_ok && (value == 0)) {
		  yyerror(loc, "error: zero count used in enum name sequence.");
		  value = 1;
	    }
      }
      return value;
}

static void current_task_set_statement(const YYLTYPE&loc, vector<Statement*>*s)
{
      if (s == 0) {
	      /* if the statement list is null, then the parser
		 detected the case that there are no statements in the
		 task. If this is SystemVerilog, handle it as an
		 an empty block. */
	    if (!gn_system_verilog()) {
		  yyerror(loc, "error: Support for empty tasks requires SystemVerilog.");
	    }
	    PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	    FILE_NAME(tmp, loc);
	    current_task->set_statement(tmp);
	    return;
      }
      assert(s);

        /* An empty vector represents one or more null statements. Handle
           this as a simple null statement. */
      if (s->empty())
            return;

	/* A vector of 1 is handled as a simple statement. */
      if (s->size() == 1) {
	    current_task->set_statement((*s)[0]);
	    return;
      }

      if (!gn_system_verilog()) {
	    yyerror(loc, "error: Task body with multiple statements requires SystemVerilog.");
      }

      PBlock*tmp = new PBlock(PBlock::BL_SEQ);
      FILE_NAME(tmp, loc);
      tmp->set_statement(*s);
      current_task->set_statement(tmp);
}

static void current_function_set_statement(const YYLTYPE&loc, vector<Statement*>*s)
{
      if (s == 0) {
	      /* if the statement list is null, then the parser
		 detected the case that there are no statements in the
		 task. If this is SystemVerilog, handle it as an
		 an empty block. */
	    if (!gn_system_verilog()) {
		  yyerror(loc, "error: Support for empty functions requires SystemVerilog.");
	    }
	    PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	    FILE_NAME(tmp, loc);
	    current_function->set_statement(tmp);
	    return;
      }
      assert(s);

        /* An empty vector represents one or more null statements. Handle
           this as a simple null statement. */
      if (s->empty())
            return;

	/* A vector of 1 is handled as a simple statement. */
      if (s->size() == 1) {
	    current_function->set_statement((*s)[0]);
	    return;
      }

      if (!gn_system_verilog()) {
	    yyerror(loc, "error: Function body with multiple statements requires SystemVerilog.");
      }

      PBlock*tmp = new PBlock(PBlock::BL_SEQ);
      FILE_NAME(tmp, loc);
      tmp->set_statement(*s);
      current_function->set_statement(tmp);
}


#line 436 "parse.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parse.hh".  */
#ifndef YY_VL_PARSE_HH_INCLUDED
# define YY_VL_PARSE_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int VLdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENTIFIER = 258,
    SYSTEM_IDENTIFIER = 259,
    STRING = 260,
    TIME_LITERAL = 261,
    TYPE_IDENTIFIER = 262,
    PACKAGE_IDENTIFIER = 263,
    DISCIPLINE_IDENTIFIER = 264,
    PATHPULSE_IDENTIFIER = 265,
    BASED_NUMBER = 266,
    DEC_NUMBER = 267,
    UNBASED_NUMBER = 268,
    REALTIME = 269,
    K_PLUS_EQ = 270,
    K_MINUS_EQ = 271,
    K_INCR = 272,
    K_DECR = 273,
    K_LE = 274,
    K_GE = 275,
    K_EG = 276,
    K_EQ = 277,
    K_NE = 278,
    K_CEQ = 279,
    K_CNE = 280,
    K_WEQ = 281,
    K_WNE = 282,
    K_LP = 283,
    K_LS = 284,
    K_RS = 285,
    K_RSS = 286,
    K_SG = 287,
    K_CONTRIBUTE = 288,
    K_PO_POS = 289,
    K_PO_NEG = 290,
    K_POW = 291,
    K_PSTAR = 292,
    K_STARP = 293,
    K_DOTSTAR = 294,
    K_LOR = 295,
    K_LAND = 296,
    K_NAND = 297,
    K_NOR = 298,
    K_NXOR = 299,
    K_TRIGGER = 300,
    K_SCOPE_RES = 301,
    K_edge_descriptor = 302,
    K_always = 303,
    K_and = 304,
    K_assign = 305,
    K_begin = 306,
    K_buf = 307,
    K_bufif0 = 308,
    K_bufif1 = 309,
    K_case = 310,
    K_casex = 311,
    K_casez = 312,
    K_cmos = 313,
    K_deassign = 314,
    K_default = 315,
    K_defparam = 316,
    K_disable = 317,
    K_edge = 318,
    K_else = 319,
    K_end = 320,
    K_endcase = 321,
    K_endfunction = 322,
    K_endmodule = 323,
    K_endprimitive = 324,
    K_endspecify = 325,
    K_endtable = 326,
    K_endtask = 327,
    K_event = 328,
    K_for = 329,
    K_force = 330,
    K_forever = 331,
    K_fork = 332,
    K_function = 333,
    K_highz0 = 334,
    K_highz1 = 335,
    K_if = 336,
    K_ifnone = 337,
    K_initial = 338,
    K_inout = 339,
    K_input = 340,
    K_integer = 341,
    K_join = 342,
    K_large = 343,
    K_macromodule = 344,
    K_medium = 345,
    K_module = 346,
    K_nand = 347,
    K_negedge = 348,
    K_nmos = 349,
    K_nor = 350,
    K_not = 351,
    K_notif0 = 352,
    K_notif1 = 353,
    K_or = 354,
    K_output = 355,
    K_parameter = 356,
    K_pmos = 357,
    K_posedge = 358,
    K_primitive = 359,
    K_pull0 = 360,
    K_pull1 = 361,
    K_pulldown = 362,
    K_pullup = 363,
    K_rcmos = 364,
    K_real = 365,
    K_realtime = 366,
    K_reg = 367,
    K_release = 368,
    K_repeat = 369,
    K_rnmos = 370,
    K_rpmos = 371,
    K_rtran = 372,
    K_rtranif0 = 373,
    K_rtranif1 = 374,
    K_scalared = 375,
    K_small = 376,
    K_specify = 377,
    K_specparam = 378,
    K_strong0 = 379,
    K_strong1 = 380,
    K_supply0 = 381,
    K_supply1 = 382,
    K_table = 383,
    K_task = 384,
    K_time = 385,
    K_tran = 386,
    K_tranif0 = 387,
    K_tranif1 = 388,
    K_tri = 389,
    K_tri0 = 390,
    K_tri1 = 391,
    K_triand = 392,
    K_trior = 393,
    K_trireg = 394,
    K_vectored = 395,
    K_wait = 396,
    K_wand = 397,
    K_weak0 = 398,
    K_weak1 = 399,
    K_while = 400,
    K_wire = 401,
    K_wor = 402,
    K_xnor = 403,
    K_xor = 404,
    K_Shold = 405,
    K_Snochange = 406,
    K_Speriod = 407,
    K_Srecovery = 408,
    K_Ssetup = 409,
    K_Ssetuphold = 410,
    K_Sskew = 411,
    K_Swidth = 412,
    KK_attribute = 413,
    K_bool = 414,
    K_logic = 415,
    K_automatic = 416,
    K_endgenerate = 417,
    K_generate = 418,
    K_genvar = 419,
    K_localparam = 420,
    K_noshowcancelled = 421,
    K_pulsestyle_onevent = 422,
    K_pulsestyle_ondetect = 423,
    K_showcancelled = 424,
    K_signed = 425,
    K_unsigned = 426,
    K_Sfullskew = 427,
    K_Srecrem = 428,
    K_Sremoval = 429,
    K_Stimeskew = 430,
    K_cell = 431,
    K_config = 432,
    K_design = 433,
    K_endconfig = 434,
    K_incdir = 435,
    K_include = 436,
    K_instance = 437,
    K_liblist = 438,
    K_library = 439,
    K_use = 440,
    K_wone = 441,
    K_uwire = 442,
    K_alias = 443,
    K_always_comb = 444,
    K_always_ff = 445,
    K_always_latch = 446,
    K_assert = 447,
    K_assume = 448,
    K_before = 449,
    K_bind = 450,
    K_bins = 451,
    K_binsof = 452,
    K_bit = 453,
    K_break = 454,
    K_byte = 455,
    K_chandle = 456,
    K_class = 457,
    K_clocking = 458,
    K_const = 459,
    K_constraint = 460,
    K_context = 461,
    K_continue = 462,
    K_cover = 463,
    K_covergroup = 464,
    K_coverpoint = 465,
    K_cross = 466,
    K_dist = 467,
    K_do = 468,
    K_endclass = 469,
    K_endclocking = 470,
    K_endgroup = 471,
    K_endinterface = 472,
    K_endpackage = 473,
    K_endprogram = 474,
    K_endproperty = 475,
    K_endsequence = 476,
    K_enum = 477,
    K_expect = 478,
    K_export = 479,
    K_extends = 480,
    K_extern = 481,
    K_final = 482,
    K_first_match = 483,
    K_foreach = 484,
    K_forkjoin = 485,
    K_iff = 486,
    K_ignore_bins = 487,
    K_illegal_bins = 488,
    K_import = 489,
    K_inside = 490,
    K_int = 491,
    K_interface = 492,
    K_intersect = 493,
    K_join_any = 494,
    K_join_none = 495,
    K_local = 496,
    K_longint = 497,
    K_matches = 498,
    K_modport = 499,
    K_new = 500,
    K_null = 501,
    K_package = 502,
    K_packed = 503,
    K_priority = 504,
    K_program = 505,
    K_property = 506,
    K_protected = 507,
    K_pure = 508,
    K_rand = 509,
    K_randc = 510,
    K_randcase = 511,
    K_randsequence = 512,
    K_ref = 513,
    K_return = 514,
    K_sequence = 515,
    K_shortint = 516,
    K_shortreal = 517,
    K_solve = 518,
    K_static = 519,
    K_string = 520,
    K_struct = 521,
    K_super = 522,
    K_tagged = 523,
    K_this = 524,
    K_throughout = 525,
    K_timeprecision = 526,
    K_timeunit = 527,
    K_type = 528,
    K_typedef = 529,
    K_union = 530,
    K_unique = 531,
    K_var = 532,
    K_virtual = 533,
    K_void = 534,
    K_wait_order = 535,
    K_wildcard = 536,
    K_with = 537,
    K_within = 538,
    K_accept_on = 539,
    K_checker = 540,
    K_endchecker = 541,
    K_eventually = 542,
    K_global = 543,
    K_implies = 544,
    K_let = 545,
    K_nexttime = 546,
    K_reject_on = 547,
    K_restrict = 548,
    K_s_always = 549,
    K_s_eventually = 550,
    K_s_nexttime = 551,
    K_s_until = 552,
    K_s_until_with = 553,
    K_strong = 554,
    K_sync_accept_on = 555,
    K_sync_reject_on = 556,
    K_unique0 = 557,
    K_until = 558,
    K_until_with = 559,
    K_untyped = 560,
    K_weak = 561,
    K_implements = 562,
    K_interconnect = 563,
    K_nettype = 564,
    K_soft = 565,
    K_above = 566,
    K_abs = 567,
    K_absdelay = 568,
    K_abstol = 569,
    K_access = 570,
    K_acos = 571,
    K_acosh = 572,
    K_ac_stim = 573,
    K_aliasparam = 574,
    K_analog = 575,
    K_analysis = 576,
    K_asin = 577,
    K_asinh = 578,
    K_atan = 579,
    K_atan2 = 580,
    K_atanh = 581,
    K_branch = 582,
    K_ceil = 583,
    K_connect = 584,
    K_connectmodule = 585,
    K_connectrules = 586,
    K_continuous = 587,
    K_cos = 588,
    K_cosh = 589,
    K_ddt = 590,
    K_ddt_nature = 591,
    K_ddx = 592,
    K_discipline = 593,
    K_discrete = 594,
    K_domain = 595,
    K_driver_update = 596,
    K_endconnectrules = 597,
    K_enddiscipline = 598,
    K_endnature = 599,
    K_endparamset = 600,
    K_exclude = 601,
    K_exp = 602,
    K_final_step = 603,
    K_flicker_noise = 604,
    K_floor = 605,
    K_flow = 606,
    K_from = 607,
    K_ground = 608,
    K_hypot = 609,
    K_idt = 610,
    K_idtmod = 611,
    K_idt_nature = 612,
    K_inf = 613,
    K_initial_step = 614,
    K_laplace_nd = 615,
    K_laplace_np = 616,
    K_laplace_zd = 617,
    K_laplace_zp = 618,
    K_last_crossing = 619,
    K_limexp = 620,
    K_ln = 621,
    K_log = 622,
    K_max = 623,
    K_merged = 624,
    K_min = 625,
    K_nature = 626,
    K_net_resolution = 627,
    K_noise_table = 628,
    K_paramset = 629,
    K_potential = 630,
    K_pow = 631,
    K_resolveto = 632,
    K_sin = 633,
    K_sinh = 634,
    K_slew = 635,
    K_split = 636,
    K_sqrt = 637,
    K_tan = 638,
    K_tanh = 639,
    K_timer = 640,
    K_transition = 641,
    K_units = 642,
    K_white_noise = 643,
    K_wreal = 644,
    K_zi_nd = 645,
    K_zi_np = 646,
    K_zi_zd = 647,
    K_zi_zp = 648,
    K_TAND = 649,
    K_MUL_EQ = 650,
    K_DIV_EQ = 651,
    K_MOD_EQ = 652,
    K_AND_EQ = 653,
    K_OR_EQ = 654,
    K_XOR_EQ = 655,
    K_LS_EQ = 656,
    K_RS_EQ = 657,
    K_RSS_EQ = 658,
    UNARY_PREC = 659,
    less_than_K_else = 660,
    no_timeunits_declaration = 661,
    one_timeunits_declaration = 662
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 363 "parse.y" /* yacc.c:355  */

      bool flag;

      char letter;
      int  int_val;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;

      list<pform_port_t>*port_list;

      vector<pform_tf_port_t>* tf_ports;

      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_number_t* named_number;
      list<named_number_t>* named_numbers;

      named_pexpr_t*named_pexpr;
      list<named_pexpr_t>*named_pexprs;
      struct parmvalue_t*parmvalue;
      list<pform_range_t>*ranges;

      PExpr*expr;
      list<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t vartype;
      PBlock::BL_TYPE join_keyword;

      PWire*wire;
      vector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      vector<Statement*>*statement_list;

      net_decl_assign_t*net_decl_assign;
      enum_type_t*enum_type;

      decl_assignment_t*decl_assignment;
      list<decl_assignment_t*>*decl_assignments;

      struct_member_t*struct_member;
      list<struct_member_t*>*struct_members;
      struct_type_t*struct_type;

      data_type_t*data_type;
      class_type_t*class_type;
      real_type_t::type_t real_type;
      property_qualifier_t property_qualifier;
      PPackage*package;

      struct {
	    char*text;
	    data_type_t*type;
      } type_identifier;

      struct {
	    data_type_t*type;
	    list<PExpr*>*exprs;
      } class_declaration_extends;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;

      LexicalScope::lifetime_t lifetime;

#line 981 "parse.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE VLlval;
extern YYLTYPE VLlloc;
int VLparse (void);

#endif /* !YY_VL_PARSE_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1012 "parse.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   23508

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  455
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  326
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1099
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2500

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   662

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   434,     2,   431,   430,   415,   408,   435,
     418,   423,   413,   411,   427,   412,   429,   414,   436,   437,
       2,     2,     2,     2,     2,     2,     2,     2,   405,   422,
     409,   428,   410,   404,   432,     2,   444,     2,     2,     2,
     441,     2,     2,     2,     2,     2,     2,   447,   449,     2,
     451,   452,   446,     2,     2,     2,     2,     2,     2,     2,
       2,   425,     2,   426,   407,   454,     2,     2,   439,     2,
       2,     2,   440,     2,   443,     2,     2,     2,   442,     2,
     448,     2,   450,   453,   445,     2,     2,     2,     2,     2,
     438,     2,     2,   424,   406,   421,   433,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   416,
     417,   419,   420
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   712,   712,   711,   714,   718,   722,   728,   738,   739,
     744,   746,   743,   759,   760,   764,   774,   788,   798,   801,
     813,   818,   824,   831,   832,   836,   837,   844,   843,   861,
     864,   869,   872,   877,   879,   881,   886,   891,   895,   902,
     907,   912,   917,   922,   930,   931,   932,   936,   937,   941,
     942,   946,   954,   962,   973,   980,   987,   991,   992,   995,
     997,  1001,  1006,  1011,  1012,  1013,  1014,  1015,  1016,  1020,
    1021,  1025,  1030,  1031,  1035,  1046,  1058,  1063,  1069,  1071,
    1076,  1083,  1089,  1098,  1097,  1104,  1118,  1120,  1126,  1133,
    1138,  1140,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
    1168,  1169,  1175,  1175,  1181,  1185,  1192,  1197,  1199,  1210,
    1215,  1209,  1239,  1246,  1238,  1275,  1274,  1302,  1303,  1307,
    1308,  1318,  1323,  1328,  1333,  1341,  1348,  1349,  1350,  1351,
    1355,  1357,  1359,  1364,  1368,  1373,  1381,  1382,  1386,  1387,
    1393,  1405,  1404,  1439,  1445,  1451,  1457,  1466,  1465,  1491,
    1497,  1503,  1508,  1513,  1518,  1527,  1532,  1540,  1550,  1557,
    1570,  1576,  1585,  1586,  1590,  1591,  1596,  1595,  1603,  1604,
    1609,  1608,  1622,  1623,  1624,  1633,  1637,  1646,  1651,  1658,
    1665,  1672,  1678,  1688,  1698,  1699,  1700,  1701,  1705,  1706,
    1707,  1710,  1712,  1714,  1717,  1719,  1726,  1727,  1732,  1734,
    1731,  1749,  1751,  1755,  1756,  1760,  1765,  1769,  1775,  1776,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1791,  1792,
    1795,  1795,  1798,  1799,  1800,  1801,  1815,  1816,  1820,  1824,
    1828,  1832,  1843,  1844,  1848,  1849,  1853,  1854,  1863,  1867,
    1868,  1872,  1873,  1879,  1880,  1884,  1885,  1889,  1901,  1906,
    1911,  1918,  1924,  1929,  1928,  1935,  1943,  1953,  1955,  1960,
    1964,  1965,  1969,  1970,  1974,  1994,  2000,  1993,  2030,  2037,
    2029,  2064,  2070,  2063,  2104,  2103,  2133,  2144,  2153,  2162,
    2171,  2190,  2242,  2252,  2259,  2263,  2263,  2271,  2288,  2293,
    2297,  2301,  2308,  2310,  2315,  2322,  2323,  2324,  2328,  2330,
    2335,  2341,  2355,  2361,  2374,  2390,  2393,  2397,  2398,  2399,
    2400,  2411,  2417,  2427,  2434,  2456,  2460,  2465,  2469,  2474,
    2478,  2479,  2483,  2488,  2493,  2498,  2502,  2509,  2510,  2514,
    2515,  2521,  2530,  2543,  2552,  2554,  2556,  2558,  2568,  2581,
    2591,  2601,  2611,  2621,  2631,  2644,  2647,  2656,  2659,  2667,
    2672,  2679,  2687,  2692,  2699,  2710,  2718,  2726,  2735,  2751,
    2756,  2764,  2771,  2779,  2786,  2791,  2796,  2803,  2809,  2817,
    2818,  2819,  2823,  2824,  2828,  2835,  2836,  2840,  2844,  2849,
    2857,  2862,  2867,  2873,  2883,  2884,  2888,  2893,  2901,  2905,
    2911,  2922,  2932,  2938,  2961,  2961,  2965,  2964,  2971,  2972,
    2976,  2978,  2980,  2982,  2988,  2987,  2995,  2996,  3000,  3002,
    3003,  3005,  3007,  3012,  3022,  3025,  3028,  3030,  3034,  3035,
    3037,  3039,  3040,  3043,  3045,  3049,  3051,  3055,  3057,  3062,
    3066,  3070,  3074,  3078,  3082,  3089,  3090,  3094,  3095,  3096,
    3097,  3101,  3102,  3103,  3104,  3108,  3109,  3113,  3121,  3127,
    3134,  3136,  3142,  3151,  3158,  3165,  3179,  3181,  3186,  3188,
    3190,  3192,  3194,  3199,  3204,  3209,  3214,  3219,  3224,  3229,
    3234,  3239,  3244,  3249,  3254,  3259,  3264,  3269,  3274,  3279,
    3284,  3289,  3294,  3299,  3304,  3309,  3314,  3319,  3324,  3329,
    3334,  3339,  3344,  3349,  3354,  3359,  3364,  3369,  3374,  3379,
    3384,  3389,  3394,  3399,  3407,  3409,  3456,  3461,  3467,  3471,
    3479,  3484,  3492,  3496,  3506,  3512,  3517,  3522,  3538,  3549,
    3556,  3565,  3573,  3586,  3593,  3600,  3612,  3619,  3635,  3642,
    3649,  3656,  3663,  3670,  3677,  3684,  3691,  3698,  3705,  3712,
    3719,  3726,  3733,  3740,  3747,  3754,  3761,  3768,  3775,  3786,
    3792,  3798,  3806,  3811,  3817,  3824,  3835,  3850,  3862,  3876,
    3880,  3883,  3896,  3897,  3901,  3903,  3922,  3924,  3931,  3941,
    3956,  3967,  3985,  3996,  4012,  4025,  4040,  4048,  4057,  4058,
    4059,  4060,  4061,  4062,  4063,  4064,  4065,  4066,  4067,  4068,
    4072,  4073,  4074,  4075,  4076,  4077,  4078,  4079,  4080,  4081,
    4082,  4083,  4093,  4098,  4104,  4113,  4127,  4137,  4147,  4163,
    4165,  4170,  4172,  4177,  4179,  4181,  4183,  4205,  4211,  4219,
    4225,  4230,  4248,  4253,  4261,  4274,  4290,  4305,  4321,  4357,
    4373,  4403,  4404,  4418,  4419,  4420,  4424,  4425,  4426,  4434,
    4435,  4436,  4437,  4445,  4452,  4465,  4472,  4482,  4491,  4497,
    4507,  4512,  4514,  4517,  4506,  4592,  4593,  4594,  4595,  4599,
    4600,  4601,  4605,  4606,  4610,  4611,  4615,  4616,  4617,  4618,
    4628,  4630,  4634,  4635,  4636,  4642,  4644,  4659,  4669,  4679,
    4696,  4710,  4720,  4731,  4734,  4745,  4757,  4769,  4797,  4804,
    4811,  4818,  4828,  4834,  4834,  4842,  4841,  4852,  4855,  4858,
    4861,  4865,  4868,  4874,  4876,  4879,  4882,  4885,  4888,  4891,
    4894,  4901,  4908,  4919,  4924,  4928,  4932,  4936,  4940,  4944,
    4949,  4952,  4954,  4956,  4958,  4960,  4968,  4978,  4984,  4981,
    4991,  4988,  4995,  5000,  4999,  5005,  5007,  5012,  5011,  5021,
    5020,  5027,  5036,  5041,  5047,  5053,  5069,  5076,  5082,  5083,
    5087,  5088,  5091,  5094,  5095,  5099,  5099,  5101,  5101,  5106,
    5108,  5115,  5115,  5128,  5129,  5133,  5134,  5144,  5145,  5146,
    5163,  5163,  5174,  5185,  5191,  5197,  5198,  5199,  5203,  5204,
    5208,  5209,  5210,  5211,  5212,  5213,  5214,  5215,  5216,  5217,
    5218,  5223,  5227,  5235,  5240,  5245,  5250,  5255,  5268,  5269,
    5273,  5274,  5278,  5287,  5295,  5295,  5298,  5300,  5305,  5307,
    5309,  5311,  5313,  5318,  5319,  5320,  5321,  5324,  5324,  5343,
    5349,  5355,  5367,  5378,  5384,  5388,  5395,  5405,  5411,  5434,
    5442,  5453,  5462,  5471,  5472,  5480,  5488,  5497,  5505,  5514,
    5523,  5529,  5538,  5544,  5551,  5555,  5574,  5582,  5605,  5627,
    5641,  5643,  5653,  5654,  5658,  5660,  5676,  5683,  5700,  5706,
    5715,  5725,  5731,  5740,  5750,  5752,  5757,  5758,  5761,  5764,
    5772,  5780,  5788,  5793,  5798,  5802,  5807,  5811,  5815,  5820,
    5824,  5828,  5833,  5837,  5841,  5846,  5849,  5852,  5855,  5858,
    5864,  5865,  5870,  5871,  5875,  5877,  5884,  5884,  5887,  5891,
    5895,  5899,  5906,  5907,  5908,  5912,  5914,  5919,  5927,  5930,
    5933,  5940,  5946,  5957,  5968,  5974,  5985,  5999,  6005,  6044,
    6048,  6056,  6057,  6061,  6063,  6062,  6069,  6070,  6071,  6075,
    6077,  6079,  6083,  6087,  6089,  6093,  6097,  6106,  6107,  6112,
    6113,  6117,  6119,  6121,  6123,  6132,  6144,  6150,  6160,  6165,
    6177,  6184,  6189,  6183,  6219,  6218,  6250,  6257,  6262,  6256,
    6293,  6292,  6320,  6326,  6332,  6339,  6341,  6343,  6345,  6350,
    6355,  6360,  6362,  6364,  6366,  6371,  6376,  6380,  6386,  6392,
    6397,  6406,  6416,  6422,  6431,  6437,  6442,  6447,  6452,  6459,
    6466,  6471,  6477,  6482,  6493,  6502,  6508,  6516,  6521,  6528,
    6536,  6543,  6560,  6574,  6588,  6594,  6602,  6611,  6616,  6621,
    6626,  6631,  6636,  6641,  6646,  6651,  6656,  6661,  6670,  6673,
    6677,  6682,  6690,  6697,  6698,  6702,  6711,  6716,  6719,  6723,
    6724,  6732,  6736,  6741,  6750,  6751,  6755,  6768,  6774,  6783,
    6789,  6798,  6812,  6823,  6824,  6828,  6834,  6846,  6847,  6848,
    6849,  6850,  6851,  6852,  6853,  6854,  6855,  6856,  6857,  6858,
    6859,  6860,  6861,  6862,  6863,  6864,  6865,  6866,  6867,  6868,
    6869,  6873,  6874,  6875,  6876,  6877,  6884,  6886,  6894,  6902,
    6913,  6915,  6927,  6933,  6941,  6941,  6944,  6945,  6949,  6955,
    6968,  6994,  7024,  7024,  7025,  7025,  7026,  7026,  7027,  7027
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "TIME_LITERAL", "TYPE_IDENTIFIER", "PACKAGE_IDENTIFIER",
  "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER", "BASED_NUMBER",
  "DEC_NUMBER", "UNBASED_NUMBER", "REALTIME", "K_PLUS_EQ", "K_MINUS_EQ",
  "K_INCR", "K_DECR", "K_LE", "K_GE", "K_EG", "K_EQ", "K_NE", "K_CEQ",
  "K_CNE", "K_WEQ", "K_WNE", "K_LP", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_DOTSTAR", "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER",
  "K_SCOPE_RES", "K_edge_descriptor", "K_always", "K_and", "K_assign",
  "K_begin", "K_buf", "K_bufif0", "K_bufif1", "K_case", "K_casex",
  "K_casez", "K_cmos", "K_deassign", "K_default", "K_defparam",
  "K_disable", "K_edge", "K_else", "K_end", "K_endcase", "K_endfunction",
  "K_endmodule", "K_endprimitive", "K_endspecify", "K_endtable",
  "K_endtask", "K_event", "K_for", "K_force", "K_forever", "K_fork",
  "K_function", "K_highz0", "K_highz1", "K_if", "K_ifnone", "K_initial",
  "K_inout", "K_input", "K_integer", "K_join", "K_large", "K_macromodule",
  "K_medium", "K_module", "K_nand", "K_negedge", "K_nmos", "K_nor",
  "K_not", "K_notif0", "K_notif1", "K_or", "K_output", "K_parameter",
  "K_pmos", "K_posedge", "K_primitive", "K_pull0", "K_pull1", "K_pulldown",
  "K_pullup", "K_rcmos", "K_real", "K_realtime", "K_reg", "K_release",
  "K_repeat", "K_rnmos", "K_rpmos", "K_rtran", "K_rtranif0", "K_rtranif1",
  "K_scalared", "K_small", "K_specify", "K_specparam", "K_strong0",
  "K_strong1", "K_supply0", "K_supply1", "K_table", "K_task", "K_time",
  "K_tran", "K_tranif0", "K_tranif1", "K_tri", "K_tri0", "K_tri1",
  "K_triand", "K_trior", "K_trireg", "K_vectored", "K_wait", "K_wand",
  "K_weak0", "K_weak1", "K_while", "K_wire", "K_wor", "K_xnor", "K_xor",
  "K_Shold", "K_Snochange", "K_Speriod", "K_Srecovery", "K_Ssetup",
  "K_Ssetuphold", "K_Sskew", "K_Swidth", "KK_attribute", "K_bool",
  "K_logic", "K_automatic", "K_endgenerate", "K_generate", "K_genvar",
  "K_localparam", "K_noshowcancelled", "K_pulsestyle_onevent",
  "K_pulsestyle_ondetect", "K_showcancelled", "K_signed", "K_unsigned",
  "K_Sfullskew", "K_Srecrem", "K_Sremoval", "K_Stimeskew", "K_cell",
  "K_config", "K_design", "K_endconfig", "K_incdir", "K_include",
  "K_instance", "K_liblist", "K_library", "K_use", "K_wone", "K_uwire",
  "K_alias", "K_always_comb", "K_always_ff", "K_always_latch", "K_assert",
  "K_assume", "K_before", "K_bind", "K_bins", "K_binsof", "K_bit",
  "K_break", "K_byte", "K_chandle", "K_class", "K_clocking", "K_const",
  "K_constraint", "K_context", "K_continue", "K_cover", "K_covergroup",
  "K_coverpoint", "K_cross", "K_dist", "K_do", "K_endclass",
  "K_endclocking", "K_endgroup", "K_endinterface", "K_endpackage",
  "K_endprogram", "K_endproperty", "K_endsequence", "K_enum", "K_expect",
  "K_export", "K_extends", "K_extern", "K_final", "K_first_match",
  "K_foreach", "K_forkjoin", "K_iff", "K_ignore_bins", "K_illegal_bins",
  "K_import", "K_inside", "K_int", "K_interface", "K_intersect",
  "K_join_any", "K_join_none", "K_local", "K_longint", "K_matches",
  "K_modport", "K_new", "K_null", "K_package", "K_packed", "K_priority",
  "K_program", "K_property", "K_protected", "K_pure", "K_rand", "K_randc",
  "K_randcase", "K_randsequence", "K_ref", "K_return", "K_sequence",
  "K_shortint", "K_shortreal", "K_solve", "K_static", "K_string",
  "K_struct", "K_super", "K_tagged", "K_this", "K_throughout",
  "K_timeprecision", "K_timeunit", "K_type", "K_typedef", "K_union",
  "K_unique", "K_var", "K_virtual", "K_void", "K_wait_order", "K_wildcard",
  "K_with", "K_within", "K_accept_on", "K_checker", "K_endchecker",
  "K_eventually", "K_global", "K_implies", "K_let", "K_nexttime",
  "K_reject_on", "K_restrict", "K_s_always", "K_s_eventually",
  "K_s_nexttime", "K_s_until", "K_s_until_with", "K_strong",
  "K_sync_accept_on", "K_sync_reject_on", "K_unique0", "K_until",
  "K_until_with", "K_untyped", "K_weak", "K_implements", "K_interconnect",
  "K_nettype", "K_soft", "K_above", "K_abs", "K_absdelay", "K_abstol",
  "K_access", "K_acos", "K_acosh", "K_ac_stim", "K_aliasparam", "K_analog",
  "K_analysis", "K_asin", "K_asinh", "K_atan", "K_atan2", "K_atanh",
  "K_branch", "K_ceil", "K_connect", "K_connectmodule", "K_connectrules",
  "K_continuous", "K_cos", "K_cosh", "K_ddt", "K_ddt_nature", "K_ddx",
  "K_discipline", "K_discrete", "K_domain", "K_driver_update",
  "K_endconnectrules", "K_enddiscipline", "K_endnature", "K_endparamset",
  "K_exclude", "K_exp", "K_final_step", "K_flicker_noise", "K_floor",
  "K_flow", "K_from", "K_ground", "K_hypot", "K_idt", "K_idtmod",
  "K_idt_nature", "K_inf", "K_initial_step", "K_laplace_nd",
  "K_laplace_np", "K_laplace_zd", "K_laplace_zp", "K_last_crossing",
  "K_limexp", "K_ln", "K_log", "K_max", "K_merged", "K_min", "K_nature",
  "K_net_resolution", "K_noise_table", "K_paramset", "K_potential",
  "K_pow", "K_resolveto", "K_sin", "K_sinh", "K_slew", "K_split", "K_sqrt",
  "K_tan", "K_tanh", "K_timer", "K_transition", "K_units", "K_white_noise",
  "K_wreal", "K_zi_nd", "K_zi_np", "K_zi_zd", "K_zi_zp", "K_TAND",
  "K_MUL_EQ", "K_DIV_EQ", "K_MOD_EQ", "K_AND_EQ", "K_OR_EQ", "K_XOR_EQ",
  "K_LS_EQ", "K_RS_EQ", "K_RSS_EQ", "'?'", "':'", "'|'", "'^'", "'&'",
  "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "UNARY_PREC",
  "less_than_K_else", "'('", "no_timeunits_declaration",
  "one_timeunits_declaration", "'}'", "';'", "')'", "'{'", "'['", "']'",
  "','", "'='", "'.'", "'$'", "'#'", "'@'", "'~'", "'!'", "'\\''", "'0'",
  "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'", "'B'", "'r'", "'R'",
  "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'", "'_'", "$accept",
  "source_text", "$@1", "assertion_item", "assignment_pattern",
  "block_identifier_opt", "class_declaration", "$@2", "$@3",
  "class_constraint", "class_identifier", "class_declaration_endlabel_opt",
  "class_declaration_extends_opt", "class_items_opt", "class_items",
  "class_item", "$@4", "class_item_qualifier", "class_item_qualifier_list",
  "class_item_qualifier_opt", "class_new", "concurrent_assertion_item",
  "constraint_block_item", "constraint_block_item_list",
  "constraint_block_item_list_opt", "constraint_declaration",
  "constraint_expression", "constraint_expression_list",
  "constraint_prototype", "constraint_set", "data_declaration",
  "data_type", "$@5", "data_type_or_implicit",
  "data_type_or_implicit_or_void", "description", "description_list",
  "endnew_opt", "dynamic_array_new", "for_step", "function_declaration",
  "$@6", "$@7", "$@8", "$@9", "$@10", "import_export",
  "implicit_class_handle", "inc_or_dec_expression", "inside_expression",
  "integer_vector_type", "join_keyword", "jump_statement", "lifetime",
  "lifetime_opt", "loop_statement", "$@11", "$@12",
  "list_of_variable_decl_assignments", "variable_decl_assignment",
  "loop_variables", "method_qualifier", "method_qualifier_opt",
  "modport_declaration", "$@13", "modport_item_list", "modport_item",
  "$@14", "modport_ports_list", "modport_ports_declaration",
  "modport_simple_port", "modport_tf_port", "non_integer_type", "number",
  "open_range_list", "package_declaration", "$@15", "$@16",
  "module_package_import_list_opt", "package_import_list",
  "package_import_declaration", "package_import_item",
  "package_import_item_list", "package_item", "package_item_list",
  "package_item_list_opt", "port_direction", "port_direction_opt",
  "property_expr", "procedural_assertion_statement", "property_qualifier",
  "property_qualifier_opt", "property_qualifier_list", "property_spec",
  "property_spec_disable_iff_opt", "random_qualifier", "real_or_realtime",
  "signing", "simple_type_or_string", "$@17", "statement",
  "statement_or_null", "stream_expression", "stream_expression_list",
  "stream_operator", "streaming_concatenation", "task_declaration", "$@18",
  "$@19", "$@20", "$@21", "$@22", "$@23", "$@24", "tf_port_declaration",
  "tf_port_item", "tf_port_item_expr_opt", "tf_port_list", "$@25",
  "tf_port_item_list", "timeunits_declaration",
  "timeunits_declaration_opt", "value_range", "variable_dimension",
  "variable_lifetime", "attribute_list_opt", "attribute_instance_list",
  "attribute_list", "attribute", "block_item_decl", "block_item_decls",
  "block_item_decls_opt", "type_declaration", "enum_data_type",
  "enum_name_list", "pos_neg_number", "enum_name", "struct_data_type",
  "struct_union_member_list", "struct_union_member", "case_item",
  "case_items", "charge_strength", "charge_strength_opt",
  "defparam_assign", "defparam_assign_list", "delay1", "delay3",
  "delay3_opt", "delay_value_list", "delay_value", "delay_value_simple",
  "optional_semicolon", "discipline_declaration", "$@26",
  "discipline_items", "discipline_item", "nature_declaration", "$@27",
  "nature_items", "nature_item", "config_declaration",
  "lib_cell_identifiers", "list_of_config_rule_statements",
  "config_rule_statement", "opt_config", "lib_cell_id",
  "list_of_libraries", "drive_strength", "drive_strength_opt",
  "dr_strength0", "dr_strength1", "clocking_event_opt", "event_control",
  "event_expression_list", "event_expression", "branch_probe_expression",
  "expression", "expr_mintypmax", "expression_list_with_nuls",
  "expression_list_proper", "expr_primary_or_typename", "expr_primary",
  "function_item_list_opt", "function_item_list", "function_item",
  "gate_instance", "gate_instance_list", "gatetype", "switchtype",
  "hierarchy_identifier", "list_of_identifiers",
  "list_of_port_identifiers", "list_of_variable_port_identifiers",
  "list_of_ports", "list_of_port_declarations", "port_declaration",
  "net_type_opt", "unsigned_signed_opt", "signed_unsigned_opt",
  "atom2_type", "lpvalue", "cont_assign", "cont_assign_list", "module",
  "$@28", "$@29", "$@30", "$@31", "module_start", "module_end",
  "endlabel_opt", "module_attribute_foreign", "module_port_list_opt",
  "module_parameter_port_list_opt", "module_parameter_port_list",
  "module_item", "$@32", "$@33", "$@34", "$@35", "$@36", "$@37", "$@38",
  "module_item_list", "module_item_list_opt", "generate_if",
  "generate_case_items", "generate_case_item", "$@39", "$@40",
  "generate_item", "$@41", "generate_item_list", "generate_item_list_opt",
  "generate_block", "generate_block_opt", "net_decl_assign",
  "net_decl_assigns", "bit_logic", "bit_logic_opt", "net_type",
  "param_type", "parameter_assign_list", "localparam_assign_list",
  "parameter_assign", "localparam_assign", "parameter_value_ranges_opt",
  "parameter_value_ranges", "parameter_value_range",
  "value_range_expression", "from_exclude", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_name", "port_name_list",
  "port_conn_expression_list_with_nuls", "port_reference",
  "port_reference_list", "dimensions_opt", "dimensions",
  "register_variable", "register_variable_list", "net_variable",
  "net_variable_list", "event_variable", "event_variable_list",
  "specify_item", "specify_item_list", "specify_item_list_opt",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "specparam_decl", "$@42", "spec_polarity", "spec_reference_event",
  "edge_descriptor_list", "spec_notifier_opt", "spec_notifier",
  "statement_item", "$@43", "$@44", "$@45", "$@46", "$@47", "$@48",
  "compressed_statement", "statement_or_null_list_opt",
  "statement_or_null_list", "analog_statement", "task_item",
  "task_item_list", "task_item_list_opt", "tf_port_list_opt", "udp_body",
  "udp_entry_list", "udp_comb_entry", "udp_comb_entry_list",
  "udp_sequ_entry_list", "udp_sequ_entry", "udp_initial", "udp_init_opt",
  "udp_input_list", "udp_input_sym", "udp_output_sym", "udp_port_decl",
  "udp_port_decls", "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", "K_packed_opt",
  "K_reg_opt", "K_static_opt", "K_virtual_opt", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,    63,    58,   124,    94,    38,    60,
      62,    43,    45,    42,    47,    37,   659,   660,    40,   661,
     662,   125,    59,    41,   123,    91,    93,    44,    61,    46,
      36,    35,    64,   126,    33,    39,    48,    49,   120,    98,
     102,    70,   108,   104,    66,   114,    82,    77,   110,    78,
     112,    80,    81,   113,    95
};
# endif

#define YYPACT_NINF -1997

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1997)))

#define YYTABLE_NINF -1100

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     125,   379,   423,   329,   783, -1997,   174,   431, -1997, -1997,
    4625, -1997,   666, -1997,   262,   144,   890,   601,   144,   230,
     890,   693,   144, 22892, -1997,   712,   764, -1997, -1997, -1997,
    2597, -1997, -1997, -1997, -1997, -1997,  1817,   756, -1997, -1997,
   -1997, -1997, -1997, -1997,   644,   443,   348, -1997,    42, -1997,
   -1997, -1997, -1997,  6710, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997,  1130,
     940,   551,   994,  1104,  1151,   749,  1179,   774,   790,   811,
    1207,  1152, -1997, -1997, -1997, -1997, -1997, -1997, -1997,  1259,
     989, -1997, -1997,   136,   182,   244,  1130, -1997, -1997, -1997,
    1152,   854,   854, -1997, -1997, -1997, -1997, -1997,   845, -1997,
   -1997,  1122,  1122, 10143, -1997,  1379,   811, -1997,   144,   811,
     425,   144, -1997, 14687, -1997,  1385, -1997, -1997,  1427, -1997,
   -1997,   811,  1058,  -143, -1997,   549,   105,  1066,  1088,   561,
   -1997,  1327,  1127, -1997, -1997, -1997,   811, -1997, -1997, -1997,
   -1997,  1159,  1185,  1152,  1130,  1130,  1130,  1571,  1152,  1187,
   -1997,  1221,  1218,  1223,   811,  1260,   811, -1997, -1997, -1997,
   -1997, -1997,  1220, -1997, -1997,  1217,  1655, -1997,   913, -1997,
   -1997,    66,    66, 11685,  1671,  1671,  1671, -1997, -1997, -1997,
   -1997, -1997, -1997,  1326,  1330,  1332,  1334,  1344,  1348,  1353,
    1357,  1373,  1378,  1380,  1381,  1402,  1403,  1408,  1409,  1411,
    1412,  1413,  1414,  1418,  1419,  1420,  1422,  1671, 15378,  1671,
    1671,  1671, 14687,  9500, -1997,  1284,   353, 15654, -1997,  1287,
   -1997, -1997, -1997, -1997, -1997,  1299,  1146,  9151, -1997,  1362,
     181, -1997,  1321,   616,   675, -1997, -1997,  1719, -1997, -1997,
     104,  1227, 20969, -1997,   128, -1997, 14687, -1997,   940, -1997,
    1729,   926,  1770,  1421, -1997,  1838, 14687, -1997,  1151, -1997,
   -1997,  1839, -1997, -1997,  1423,   811,   811,   811,   934,   323,
   -1997,  1424, -1997, 22900, -1997, 23013,  1428, -1997, -1997,   426,
     801, 12070,  1842, -1997, -1997, 10528,  1429, -1997,   975, -1997,
   -1997, -1997, 20969,   354, 16331, 16331, 16331, 14687, 14687, 14687,
   14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687,
   14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687,
   14687, 16331, -1997, 16331, 16331, 16331, 16331, 20406,  1426, -1997,
   -1997, -1997,  1432, 10693,   452, -1997,  1671,  1671,  1671, 16331,
   -1997, 16331,  1848,  1434,  1671,  1671,  1671,  1671,  1671,  1671,
    1671,  1671,  1671,  1671,  1671,  1671,  1671,  1671,  1671,  1671,
    1671,  1433,  1671, 14687,  1671,  1671,  1671,  1671,  1671,  1671,
    1671,  1671,  1671,  1671, -1997,  1441, 12199,  1857,  1444, -1997,
   -1997, 12584, -1997, -1997,  1379, -1997, -1997, -1997, -1997,  1639,
    1798, -1997,  1448, 20380, -1997, -1997,  1866,  1449,  1867, -1997,
    1450, -1997, 23199,  1447, 20969, -1997,   123,   783, -1997,  1571,
    1451,  1453,  1456,   211, 14687, -1997,  1571,  1571,  1204, 15218,
    4658, -1997,  1241,  5684, -1997,   363,  1878,  1880,   422, -1997,
    1459,  1460,  1462,  1463,  1464,   474, -1997, -1997,  1091,  1466,
    1886,   975,   493,  1848, -1997, 14687, -1997,  9500,  1465, -1997,
    1362,   166,  1362,  1362, 12235, 12662, 12749, 13176, 13263, 13690,
    4127, 13799, 14251, 14338, 14765, 14852, 15266,  5412, 17099, 17168,
    6438,  7360,  8632, 17194, 17220, 17246, 17282, 17313,  1362,  1362,
    1362,  1362,  1362, 14687, -1997, 14687, 14687,  1404, 16331, 16331,
   16331,  1362,  1362,   184, 14687, 14687, 14687, 14687, 14687, 14687,
   14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687,
   14687, 14687, 12713, 14687,  4819, 14687, 14687, 14687, 14687, 14687,
   14687, 14687, 14687, 14687, 14687, 14687,  1470,  8852, -1997, 14687,
    1480, 20969, -1997,  1666,  1900,  1487, -1997, 23199,  1479, 15201,
   -1997, -1997,   497, -1997,   465,  1482,   678, -1997,  1507, -1997,
    1491,  3511,  1912, -1997, -1997,   742, -1997,   511, 15218,   951,
    1663, -1997,  1913, -1997,   126, -1997, 15611, -1997, -1997, -1997,
   23199,   256,  1914,  1488, -1997, -1997, -1997,   495,  1571,  1571,
    1571,  1107, -1997,   446, 20969, -1997,   547, -1997, -1997,  1379,
    1496, -1997, -1997, -1997, -1997,  1498,  1499,  1500,  1501, -1997,
   -1997, 14687,  1923,  1927,  1929,  1928, -1997, -1997, -1997, 14687,
   -1997, -1997,   975, 20969,   659,  1848, -1997, -1997, -1997, -1997,
   -1997, -1997, 14687, -1997, -1997, -1997, -1997, -1997, -1997, 14687,
   -1997, -1997, 14687, 14687, 14687, -1997, -1997, -1997, -1997, -1997,
   20432, -1997,   673, 20969,   706,  1362,  1362,  1362, 14687, 17349,
     231,   231,   278,   278,   278,   278,   278,   278,   263,   263,
     263, -1997,  5585,  1591,  2595,  2518,  2518, 14687,   715, -1997,
   20969, 20736, -1997,  2092,  2518,  2595,   231,   231,   223,   223,
    1898,  1898,  1898, 17375, -1997, 14687, 14687, 14687, -1997, 20969,
    1115,  1512,  1930,  1506,  1666, -1997,  1521, -1997,  1507, -1997,
   -1997, 23104, -1997, -1997,  1518, 20969, -1997, 13098, 13098, 14687,
    1515,  1940,  1941,   637, -1997,   878,  1942, -1997, 23233,  1526,
    1519, -1997, 11524, -1997,   682,   811, -1997,   752,  1527,  1528,
     940,  1913,  1529,  1557,  1151,   811, -1997,   771,  1940, -1997,
    1940,  1940,  1940,  1130, 15218,  1913, -1997, -1997, -1997,  2417,
    1908,   733,  1558,  1979,   140,  2773, -1997,   723,   754,   763,
   -1997,   211,  1556, -1997,   772, -1997, -1997, -1997, -1997, 19394,
    1563,  1564,  1567,  1568,  1116, -1997,   390, 17401, 17427, 17509,
   17829, 17855, 14687,  1572, 14687,   115,  1118, -1997, 20829, -1997,
   12713, 14687, -1997,  5845,  6871,  9578, -1997, 14687, -1997,  1946,
   -1997,   806,  1576,  1577, -1997, 14687, 16171, -1997, -1997,  1943,
    1574, -1997,   121,   234, 20969,  1602,  1603, 20969,  1924, -1997,
     815,  1589,  1592,  2010,  2013, -1997,  1891, -1997, -1997, -1997,
   23233,  1671, 23233,   192,  2017, -1997,   309, -1997, -1997,  1912,
   -1997, -1997,   822,   824, -1997, -1997,   841,  1594, -1997,  1913,
     843,   844,   850,   851,   811,  1913,   853,    60,  1126,  1848,
      66,    20,  1606,  1607,  1608,    66,   337,  1609,    66,  1671,
     671,  1610,    66,  1611,    68,  1612,  1614,  1613,  1671,  1615,
   13227, -1997,   153,   151,  1605,  1618, -1997, -1997, -1997,  1671,
    1671,   699,   820, -1997,  1619, -1997, -1997, -1997, -1997,  1854,
    2035, -1997,  1848, -1997, -1997,  2859,  1824, 11524, -1997, -1997,
   -1997,  1617, 14687, -1997, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997, -1997, 20969, -1997, -1997,  1623, -1997,
   -1997, 14687, -1997, 20969, -1997, -1997, -1997, 20969,   100, -1997,
    1930,  1944,    49,  2009,  1123,  1625,   550,    16, -1997, -1997,
   -1997, -1997,  1843, -1997, -1997,  1836, 22801, -1997,   327, -1997,
   -1997, -1997,   328, -1997,  6601,  1000, -1997,  1846, -1997, 23233,
   -1997, -1997, 13098, 13098,  2049,  1134, -1997,  2052, -1997, -1997,
    1634,  1629,   214,  1989, -1997,   405,   256, -1997,    72, -1997,
   -1997, -1997, -1997, -1997, 14687, -1997, -1997, -1997, -1997, -1997,
    1940,   861, -1997, 14687, -1997, 14687, 14687, -1997,   574,  1632,
   -1997,  2058, 23233, 14687, 14687, 14687,  1640,  1641,   660,  4329,
    1636, -1997, -1997, -1997, -1997,  2062, -1997, 23233,  7496,  1644,
   14687,  1646, 14687,  7673, 14687, -1997,  1925,  2068, -1997, 19420,
   -1997, -1997, -1997, -1997, 14687, -1997,  1671,  4307,   975,   165,
   -1997, -1997, -1997,  1649,  4870, -1997, 14687, 14687,  9629, 14687,
   14687, 14687, 14687, 14687, 14687, 14687, 14687, 14687,  9115, -1997,
    1507, -1997,   962,   516, -1997,  1507,  1647, 20969, -1997, 10092,
   -1997, -1997, -1997,   890,  1136,  1651,  1656,  2077,  2081,   778,
    1141,   739, -1997, -1997, -1997, -1997,  2082,  1664, -1997, -1997,
   -1997, -1997,   550, 15218, -1997,   403, -1997, -1997,   154, -1997,
   -1997,  2086,  1025, -1997, -1997,  2087,  1507,   602,  1331,  1333,
   -1997,  1667,  2006, -1997, -1997,  1107,  2022, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997,  2023, -1997,  1083,  1083, -1997,   620, -1997,  1507,
   -1997,  2024, -1997,  1669, 20969,   868, -1997, 19446, 19472,  1143,
   -1997, 14687, -1997, -1997, 17911, 17937, 17963, -1997, -1997, -1997,
    1672,  2095,  1673, 14687, -1997, -1997,  1676, 17989, -1997, 18015,
   -1997, 18051,  1682, 18077, 18107,  1688,  1683, -1997,  1684, 20855,
   -1997,  1686, 14687, 14687,  1687,    11, -1997, 20969,  1695,   609,
   10657,  1697,  1149, 20969, 20969,  1706,    93, 14687, 14687, 19498,
   20969, 20969, 20969, 20969, 20969, 20969, 20969, 20969, 20969,  1707,
      92,  1704,  1705, 14687, 14687, 19524, -1997,   127, -1997,  2035,
   -1997,  2035, -1997, 14687, -1997,   940, -1997,   318, -1997,  7960,
   -1997,   765,  1711,  2174,  2254,  2453, -1997,    63, -1997, -1997,
      98,  2044, -1997, -1997,  1379,  3518,  2128,  1727,   108,  1715,
    1717,   877,   476, -1997,  2066, -1997, -1997, -1997, -1997,  1891,
    2139,  1721, -1997, -1997, -1997,  1028, -1997,  1147,  1365, -1997,
   -1997,  1507, -1997, 14687, -1997, -1997, -1997, -1997,  1722, 19564,
   23233,  1671,  6360,  6745,  6922,  1671,  1718, 14687, 19590, 23233,
    1671,  1671,  1671,  1671,  1671,  1671,  1671,   404,  8137,  1210,
   -1997, 14687, -1997, 20969, 20969,  1671, 11042, -1997, 11042, 14687,
   14687,  1730,  1751, -1997, 10657,  1724, -1997, 19367,  1725,  1759,
   14687,  5157, 19616, 19642, -1997, 14687, 14687, 14687,   975, -1997,
   -1997, 19668, 19694, -1997, -1997, -1997,   133,  1777,   137,  1777,
   20969, -1997,   890, -1997,  1757,  9665, -1997,  2077,    95, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997,  2182, 11524, -1997,  2183, 11524,  2185, 11524, -1997, -1997,
   -1997,  2186,   783,   881,  1184,  2187,  1190,  1616, -1997,  2124,
    1774, -1997, -1997, -1997, -1997,  4693, -1997,  2126, -1997, -1997,
      71,  1083,  1771, -1997,  1775,  1776,  1780,  1791,  1782, -1997,
    1507, 20969, -1997, -1997,   259,   410,    80,   169, -1997,  5334,
    -114,   111,  5719,   183,  5896, -1997, 14687, 20095, -1997,   177,
     642,  2142,  2143, -1997, -1997, -1997, -1997,  1671,  2144,  3235,
    1786, 18133,  1784, -1997,  1265, 20881, -1997, -1997, -1997,  1214,
    1216, 14687,  2208, -1997,  1790, 11171,  1789, -1997, -1997, -1997,
   18159, -1997, -1997, 18185,  1230, 10179, -1997, -1997, -1997,  2037,
    1793, -1997,  1794,   940, -1997, 14687, -1997, -1997,  2077,  1797,
   -1997,  2214, -1997,  2218, -1997,  2219,  1795, -1997, -1997,  1479,
   -1997,  1236,  1479, -1997, -1997, -1997,  1819,  1479,  1804,  1806,
    1507,  1507, -1997, -1997, -1997, -1997,    71, -1997, -1997,  2167,
   -1997, -1997,  1671,  1671, -1997,  1828, -1997, -1997,  1671, -1997,
   -1997, -1997, -1997, 20121,  8424,   529, -1997,  1671,  1671, -1997,
    1671,  1812,  1813,  1814,  1815,  2233, 14687,  1818,  1821, 18587,
    1816, -1997,  8986, -1997, -1997,  1827,  1807,  1807, -1997,  1831,
   -1997, -1997, -1997, -1997, 10606,   770, -1997,   811,   811,  1020,
    2240, 21337,  1829,  1479, -1997,  1830,  2005, -1997,  1832, -1997,
   -1997, -1997, -1997,  1837,  1507, -1997, -1997, -1997, 14687,  1840,
   20147,  1507, -1997, -1997, -1997, -1997, -1997,  1671, -1997, -1997,
   20969, -1997, -1997, 11171,  2248, -1997, 10014, 12148,  1841, 14687,
   14687, 14687, -1997,  1835, -1997, -1997, 14687, -1997,  1844,  1845,
    1940,   120,  1850, -1997,  1851,  3699,  1852,   129,   145,  2256,
    1855,  1856, 22033,  1940, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, 22729, -1997, -1997, 21569,   161, 16002,  1853,  1849,  1858,
   -1997,  1859, -1997, -1997, 20173,   134,   110, -1997, -1997,  1671,
    2190,  1306, -1997, -1997, -1997, 20199, 20225, 18613, -1997, 20969,
    2222, -1997,   887,   608,  1524, -1997,  1860, 14687,    99,  2258,
    2209, 14687,   533,  1201, -1997,   888,  1201,   891,  2212,  3060,
     818, -1997,   811,  1226, 16679, -1997, -1997, 21801,  2121,   894,
    2282,   242,  3235, -1997, -1997, -1997, -1997, -1997,  3235,  4105,
    4105, -1997, -1997, -1997, -1997, -1997, -1997, -1997,  4105, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997,  3235,  3235,  3235,  3235,  2287,    58, -1997,  2100,
   -1997,  2598,    40,    62, 23233, 11524, -1997, -1997, -1997, -1997,
   -1997, 16911, -1997, -1997, -1997,  2229, -1997,  1872, -1997, 23199,
     134,  1876, -1997,   807, -1997,  1879,  1881, -1997, 11171,  1884,
   -1997, -1997, -1997, -1997, -1997, -1997, 14687,  1887,  1888, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997,  1890,  1892,   157,
   -1997,    66, 18639, -1997,   897,  1081,    99,  1885,  1507, 18665,
    3062,   552, 14687,  1232,  1897,  1242, -1997,   147,  1902,  1248,
   -1997, -1997,  1909,  1915,    97,  1916,  1917,  1918,  1921,  1926,
    1931,  1932,  1933,  2315,  2315,  2315,  2315,  1935,  1947,  1948,
    1949,   751, -1997,  3060,  2260,  1910,  1919,  1937,  1945,  1920,
    1922,  1951,  1860,  1952,  1955,  2365,  2304, -1997, -1997, -1997,
   -1997,   908, -1997, -1997,   143,   117, -1997, -1997,  1244,  1281,
    1405,    97, -1997, -1997, -1997, -1997,  1953,  2339, -1997,  1335,
    2373, -1997,   909, -1997,   915,  2127,  2381, 11524,   750,   147,
      62,   919,    47,   147,   928, -1997,    34,  1507,  2382,  2321,
   -1997, -1997,   602, 23199,  1964,  1671, 14687,  1671,  1671, -1997,
   11171, 20251,  1016,  1052,  1004,  1029, 14687, -1997,  1969, -1997,
     929, -1997, -1997,  1848, 14687, -1997, 14687, -1997, -1997,  1975,
   -1997, 13612, -1997,  1249,  1250,  3873, 20969,   147,  1016,  1052,
   -1997,   156, -1997,  1016,   147,  1052, 14687,  1977,  1980,  1976,
    1987,   811, -1997,  1978,  1981, 16202, 16202, 16202, 16202, 16202,
   16202, 16202, 16202,  1991,   930,   939,   946,   949, 16202, 16202,
   16202, 16202,  1994, -1997, -1997,  2315,   480, -1997, -1997, -1997,
     158, -1997,   180, -1997, -1997, -1997,  1940,  1997,  2421, -1997,
   -1997,  2014, -1997,  2282, -1997, -1997, -1997, 13741,  2011,   952,
    2016,   811,   958,  2020,   970,  2021,   811,   972,  2025,  2424,
   14687, 14687, -1997,   811,   974, -1997,  2433, -1997,  2373,  2026,
     976,  1435,   993,   147,  1007, -1997,  1015, -1997,  2445,  2433,
   -1997, 22265, -1997, 22497,  2383, -1997, -1997, 20969, -1997, -1997,
   -1997, -1997,  2028,  2030,  2031,  2032,  2033,  2034,  1251, 14687,
   -1997,    66, 14173, -1997, 20969, 20277, -1997,  2446, -1997,  1478,
   -1997,  2036,  1257,  1258,  1022,  2038,  2040, 14687,  2041,  1024,
    2042, 18691, -1997, -1997, 14687, 14816,   984,   984, -1997,  2045,
   14687, 14687,  -125,  2039,  2048,  2051,  2053,  2054,  2055,  2056,
    2057, 16331, -1997,  2455, -1997, -1997, -1997,  2059,  2060,  2061,
    2063, -1997,   480, -1997, -1997,   695, 14687, -1997,  8601, -1997,
    1032, -1997,  2069, 22265,  1671, -1997,  2466,  1266, -1997,  1275,
   -1997, -1997, -1997, -1997, -1997,  2468, -1997, -1997, -1997,  2067,
   -1997,  2482, -1997,  1277, 20309, 20969, -1997,  2088, -1997, -1997,
    6183, -1997,  2075,  1033, -1997,  1034, -1997, -1997,  1035,  1036,
    1062,  2452, -1997,  1819,  1671, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997, 14687, 20969, -1997,  2084,    27, 11556, -1997, 14687,
    2101,  2089, -1997, -1997, -1997, -1997, -1997,   147,   147, 20969,
     147, -1997,   147,  1915, 20917, 14687, 20969,  1978, -1997,  2478,
   20969,  -112, 20969,   290, 14687, 16202, 16202, 14687, 16202, 16202,
   16202, 16202, 14687,   198,  2102, 16202, 16202, 16202, 16202,   795,
     159,   163,  1280, -1997,  2103,  1286, -1997,  2523,  2464,  1292,
   -1997,   922,  2114, -1997, -1997,  2104,   811, 14687,   811, -1997,
    2531, -1997,  2113,  2116,  2484, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997,  1507, -1997, -1997,  1298, -1997, -1997, -1997, -1997,
   20335,  7209,  1063,  1070,  1077,  1086,  2129,  2130, 14687,  4018,
   -1997,  1316, 14687, 14687, 20969,  2123,  2132,    78,  2134,  2137,
    2138,  2149,  1301, -1997, -1997, -1997, -1997, 16331, 16331,  2150,
    2151,  2158,  2165,  2135,  2148,  2315,  1304,  2315,  1312, -1997,
   14687, -1997, -1997,  2133, -1997, -1997,    75,  2552, -1997, -1997,
     247,    74, 14302, -1997, -1997, 20969,  2166,  2170,  1671,  1671,
    2326, 14687, -1997, -1997, 14687, 16002, 16002,  2593,  2175, -1997,
   18717, -1997, -1997, -1997, -1997, -1997, -1997, 20943, 14687, 16331,
    2554, 20969, 20969, 14687, 14687, -1997,  1848,  2179,  2176, 14687,
   14687, 14687, 14687,  2184, 14687,   185,   200, 14687, 14687, 14687,
   14687,  2315,  2315,   207, -1997,   207, -1997, -1997,  2188, -1997,
    6710,  2602,  2604, -1997, -1997, -1997, -1997, -1997, -1997, -1997,
   -1997, -1997, 18743, 14687, -1997, -1997, -1997,  2193, -1997, 20969,
    2189, -1997, -1997,  2180, -1997, -1997, 14687, 18769,   347, -1997,
      78,  2196,   975,  2191,  1848,    78,    78,  2202,    78, -1997,
    3135, -1997, -1997, 16331,  2205,  2206,    78,    78,   207,   207,
   14687, 14687, -1997,  2632,  2220,  2223, -1997, 20969, 14687, -1997,
   14687, 20969, -1997, 14687,  2213, 14687, -1997,   975,  2224,  2225,
   14687,  2227,  2228,   293, 14687, 14687,  2230,  2232, 14687, 14687,
   18809, 18835,  2234,  1479, 14687, 18861, 18887, 20969,  2215,    78,
    2235,  2237,    78,  2241,  2243, -1997,    78,    78,  2244,  2245,
   18913, 18939,  2239,  2249,  1479,  2250, 19341, -1997, -1997, -1997,
    2255, -1997, -1997,  2257, -1997, -1997,  2259,  2267, -1997, -1997,
    2268,  2269, -1997, -1997,  2270, -1997, -1997, 22497,  2272,  2273,
    2274,  2275, -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     295,     0,     0,     0,   296,     2,     0,     0,     1,   297,
     306,   294,     0,   292,     0,   139,   779,     0,   139,     0,
     779,     0,   139,     0,  1098,     0,     0,   217,   216,   100,
     306,   214,    96,    98,   215,   210,    89,   305,   213,    97,
      95,    94,    92,    93,     0,     0,   313,   307,     0,   312,
     136,   137,   138,    89,   797,   793,   243,   244,   794,   776,
     775,   777,   639,   641,   642,   640,   795,   796,   778,   635,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   852,
       0,   638,   188,   189,   126,    81,   129,   128,   127,     0,
       0,   190,    85,  1093,  1093,     0,   635,    76,    78,    77,
     638,   395,   395,   101,   656,   655,   245,   246,     0,   658,
     657,  1093,  1093,     0,    86,     0,   852,   854,   139,    88,
       0,   139,   293,     0,   308,     0,    91,    90,     0,   633,
     634,   852,     0,     0,   798,     0,     0,     0,     0,     0,
     800,     0,     0,   338,   337,    82,   853,    83,   636,   637,
      80,     0,     0,   638,   635,   635,   635,     0,   638,     0,
    1092,     0,     0,     0,   852,     0,   852,    79,   394,   396,
     404,   602,   518,   516,   517,   513,     0,   191,   192,   194,
     515,     0,     0,     0,   306,   306,   306,   250,   251,   561,
     255,   120,   119,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   306,     0,   306,
     306,   306,     0,     0,   302,     0,   306,     0,   559,   526,
     459,   460,   247,   248,   514,     0,   560,     0,   458,   512,
     519,   249,     0,   852,     0,   155,    87,     0,   855,   309,
       0,     0,   314,   311,     0,   792,     0,   211,     0,  1082,
    1085,     0,     0,   268,   265,     0,     0,   212,     0,   414,
     198,     0,   333,   334,     0,   852,   852,   852,   349,     0,
     345,     0,   335,     0,   336,     0,     0,   332,    75,     0,
       0,     0,   253,   193,   195,     0,     0,   646,   643,   121,
     123,     7,   511,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   475,     0,     0,     0,     0,   504,     0,   262,
     263,   556,     0,   511,     0,   303,   306,   306,   306,     0,
     474,     0,     0,     0,   306,   306,   306,   306,   306,   306,
     306,   306,   306,   306,   306,   306,   306,   306,   306,   306,
     306,     0,   306,     0,   306,   306,   306,   306,   306,   306,
     306,   306,   306,   306,   301,     0,     0,     0,     0,   122,
     124,     0,   157,    74,     0,   650,   310,    15,    16,    22,
       0,   109,     0,   805,   799,  1084,     0,     0,     0,   274,
       0,   285,  1028,     0,   803,   801,     0,   295,    84,     0,
       0,     0,     0,     0,     0,   339,     0,     0,     0,     0,
       0,   360,     0,     0,   331,     0,     0,     0,     0,   399,
       0,     0,     0,     0,     0,     0,   407,   525,     0,   602,
       0,   520,     0,     0,     6,     0,   252,     0,   526,   560,
     471,   519,   472,   473,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   466,   467,
     464,   461,   462,     0,   552,     0,     0,   553,     0,     0,
       0,   463,   465,   527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   603,   508,
       0,   158,   156,   201,     0,     0,   115,     0,   285,   818,
     817,   802,   804,   807,     0,  1087,     0,  1083,   663,   271,
       0,     0,     0,   224,   222,     0,   223,     0,   126,     0,
       0,   225,     0,   304,  1095,  1024,     0,  1023,   322,  1026,
    1027,   306,     0,   425,   416,   415,   199,     0,     0,     0,
       0,     0,   347,     0,   352,   346,     0,   357,   362,     0,
       0,   355,   359,   358,   356,     0,     0,     0,     0,   397,
     398,     0,     0,     0,     0,     0,   405,   406,   523,     0,
     254,   645,   644,   510,     0,     0,   549,   528,   529,   530,
     531,   532,     0,   533,   535,   536,   537,   538,   539,     0,
     541,   542,     0,     0,     0,   544,   545,   546,   547,   548,
       0,   261,     0,   259,     0,   469,   470,   468,   508,     0,
     496,   497,   493,   498,   494,   499,   495,   500,   490,   491,
     492,   477,   501,   502,   485,   486,   487,     0,     0,   197,
     298,     0,   300,   484,   476,   483,   488,   489,   481,   482,
     478,   479,   480,     0,   605,     0,     0,     0,   604,   507,
       0,     0,     0,   670,   202,   203,    20,    10,   663,   566,
     567,   306,   564,  1029,     0,   812,   806,     0,     0,     0,
       0,     0,     0,     0,  1080,  1044,     0,   275,   330,     0,
       0,   226,    89,   288,   286,   852,   864,     0,     0,     0,
       0,     0,     0,     0,     0,   852,   858,     0,     0,  1094,
       0,     0,     0,   635,   126,     0,  1025,   257,  1021,     0,
       0,   306,     0,     0,     0,   306,   341,     0,     0,     0,
     348,     0,   350,   340,     0,   401,   400,   403,   402,     0,
       0,     0,     0,     0,     0,   553,   527,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   558,     0,   125,
       0,     0,   557,     0,     0,     0,   521,   509,   159,     0,
     209,     0,     0,   668,   204,   508,     0,   116,   565,     0,
       0,   814,   306,   306,   813,     0,     0,  1086,     0,   609,
       0,     0,     0,     0,     0,  1043,     0,  1081,   662,   327,
     329,   306,   330,   227,     0,   291,   227,   863,   319,     0,
     323,   325,     0,     0,   324,   326,     0,   856,   315,     0,
       0,     0,     0,     0,   852,     0,     0,     0,     0,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,   306,
     957,     0,     0,     0,     0,     0,     0,     0,   306,     0,
       0,   258,     0,     0,     0,     0,   967,   966,   965,   306,
     306,   643,     0,   256,     0,   266,  1020,    99,   426,     0,
       0,   413,     0,   417,   219,   306,     0,    89,   343,   342,
     344,     0,     0,   361,   409,   410,   412,   411,   408,   524,
     534,   540,   550,   551,   543,   505,   264,   260,     0,   554,
     522,     0,   196,   503,   607,   608,   606,   506,     0,   205,
       0,     0,     0,   665,     0,     0,    50,   165,    46,    45,
     241,   242,    44,   162,    39,     0,     0,    26,   232,    14,
      13,   164,     0,   237,     0,   234,   233,     0,   110,   330,
     815,   816,     0,     0,     0,     0,  1076,     0,  1077,  1078,
       0,     0,     0,     0,   328,   306,   306,   289,     0,   287,
     865,   320,   317,   321,     0,   859,   277,   278,   280,   279,
       0,     0,   316,     0,  1006,     0,   508,   999,     0,     0,
     950,     0,   330,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   130,   132,   131,     0,   956,   330,     0,     0,
       0,     0,     0,     0,     0,   133,     0,     0,   134,     0,
     392,   393,   390,   391,     0,   378,   306,     0,   447,     0,
     979,   980,   981,     0,     0,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   978,
     663,   427,     0,     0,   218,   663,   351,   353,   555,     0,
     206,   207,   208,   779,     0,     0,   846,     0,     0,     0,
       0,     0,   619,   833,   617,   829,     0,     0,    21,    43,
      44,    48,    49,     0,   163,     0,    11,    25,   139,    32,
      31,     0,     0,   232,   236,     0,   663,   306,     0,     0,
    1088,     0,     0,   610,  1079,     0,     0,  1070,  1032,  1050,
    1069,  1052,  1053,  1047,  1048,  1049,  1051,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,     0,  1037,  1034,  1035,  1039,     0,  1045,   663,
     272,     0,   282,   284,   857,     0,   318,     0,     0,     0,
     964,     0,   954,   952,     0,     0,     0,   947,   963,   962,
       0,     0,     0,     0,   960,   958,     0,     0,   949,     0,
     997,     0,     0,     0,     0,     0,     0,   135,     0,   388,
     982,     0,     0,     0,     0,     0,   450,   455,     0,   644,
      59,     0,     0,  1007,  1008,     0,     0,     0,     0,     0,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,     0,
      53,     0,     0,     0,     0,     0,   267,     0,   427,     0,
     427,     0,   200,     0,   299,     0,   671,     0,   669,     0,
     850,     0,     0,   632,   632,   632,   666,   834,   623,   667,
     306,     0,   651,    47,     0,    89,     0,    19,     0,     0,
       0,     0,     0,   111,     0,   811,   810,   809,   808,     0,
       0,     0,  1033,  1031,  1038,     0,  1040,     0,     0,  1046,
    1090,   663,   269,     0,   281,   276,   987,   985,     0,     0,
     330,   306,     0,     0,     0,   306,     0,     0,     0,   330,
     306,   306,   306,   306,   306,   306,   306,   306,     0,     0,
     379,     0,   449,   454,   453,   306,     0,   448,     0,   508,
     508,     0,     0,    58,    60,     0,    56,     0,     0,     0,
       0,     0,     0,     0,   986,     0,   508,     0,    52,   995,
     994,     0,     0,   984,   428,   418,     0,   423,     0,   423,
     354,   672,   779,   673,     0,     0,   831,     0,     0,   783,
     787,   781,   786,   782,   785,   789,   784,   780,   788,   790,
     791,     0,    89,   631,     0,    89,     0,    89,   618,   621,
     620,     0,   295,     0,     0,     0,     0,     0,    12,     0,
       0,    41,    40,    29,    71,     0,   113,     0,  1089,  1042,
       0,     0,  1070,  1074,  1047,  1048,  1049,     0,     0,   273,
     663,   283,   998,   946,   306,   306,     0,   306,   368,     0,
       0,     0,     0,     0,     0,   151,     0,     0,   948,   306,
     306,   976,   974,   144,   996,   152,   145,   306,   229,     0,
       0,     0,     0,   161,     0,     0,   983,   451,   452,     0,
       0,     0,     0,    57,     0,     0,     0,    63,  1005,  1000,
       0,   989,   992,     0,     0,     0,   988,   990,   421,     0,
       0,   419,     0,     0,   849,     0,   848,   851,     0,     0,
     627,     0,   625,     0,   629,     0,     0,   652,    30,   285,
      33,     0,   285,    37,    18,    17,   103,   285,     0,     0,
     663,   663,  1075,  1071,  1072,  1073,     0,  1036,   270,     0,
     953,   971,   306,   306,   365,     0,   968,   367,   306,   972,
     969,   973,   970,     0,     0,     0,   959,   306,   306,   230,
     306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1001,     0,    72,    65,     0,     0,     0,    51,   104,
     424,   422,   420,   674,     0,     0,   830,   852,   852,   852,
       0,     0,     0,   285,    35,     0,     0,    42,     0,    62,
      61,   114,  1091,     0,   663,   366,   364,   363,     0,     0,
       0,   663,   977,   975,   231,   153,   146,   306,   147,   160,
     389,  1004,  1002,     0,     0,    70,     0,   511,     0,     0,
       0,     0,   847,     0,   626,   624,     0,   628,     0,     0,
       0,     0,     0,   695,     0,     0,     0,     0,     0,     0,
     373,     0,     0,     0,   166,   723,   725,   735,   736,   724,
     722,   693,   675,   749,     0,     0,     0,     0,     0,     0,
     102,     0,  1041,   955,     0,     0,     0,   961,   154,   306,
      66,     0,    73,    69,    64,     0,     0,     0,   832,   630,
       0,   742,     0,     0,     0,   435,   385,     0,     0,     0,
       0,     0,     0,   306,   577,     0,   306,     0,     0,   892,
       0,   372,   852,     0,     0,   759,   764,     0,     0,     0,
       0,   824,     0,   578,   584,   585,   586,   594,     0,   224,
     222,   579,   590,   581,   587,   588,   589,   580,   223,   592,
     595,   591,   593,   597,   600,   601,   737,   596,   598,   599,
     583,   582,     0,     0,     0,     0,     0,     0,   721,     0,
       5,     0,     0,     0,     0,    89,   748,   659,   661,   660,
     653,     0,   771,   767,   770,   732,    34,     0,    38,   563,
       0,     0,   107,     0,   108,     0,     0,   148,     0,     0,
     993,   991,   105,   664,   692,   744,     0,     0,     0,   439,
     443,   438,   442,   437,   441,   440,   444,     0,     0,     0,
     384,     0,     0,   375,     0,     0,     0,     0,   663,     0,
       0,   571,     0,     0,     0,     0,   704,     0,     0,     0,
     703,   741,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   890,   893,     0,     0,     0,     0,     0,     0,
       0,     0,   385,     0,     0,     0,     0,   763,   726,   727,
     170,     0,   168,     8,     0,     0,   714,   718,     0,     0,
       0,     0,   715,   716,   717,   719,     0,     0,   720,   852,
       0,   774,     0,   861,     0,     0,     0,    89,   306,     0,
       0,     0,   306,     0,     0,   694,   385,   663,     0,     0,
     730,    36,   306,   562,     0,   306,     0,   306,   306,    67,
       0,     0,     0,     0,     0,     0,     0,   380,     0,   649,
       0,   733,   696,     0,     0,   376,     0,   745,   752,     0,
     839,     0,   841,     0,     0,     0,   843,     0,     0,     0,
     570,   306,   576,     0,     0,     0,     0,     0,     0,     0,
       0,   924,   921,   923,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   911,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   897,   896,     0,   928,   891,   740,   868,
       0,   867,     0,   371,   370,   369,     0,     0,     0,   761,
     760,     0,   167,     0,   823,   821,   822,   508,     0,     0,
       0,   852,     0,     0,     0,     0,   852,     0,     0,     0,
       0,     0,   860,   852,     0,   681,     0,   678,     0,     0,
       0,     0,     0,     0,     0,   697,     0,   701,     0,     0,
     654,     0,   768,     0,     0,   141,   150,   106,   149,   140,
      68,   743,     0,     0,     0,     0,     0,     0,     0,     0,
     713,     0,     0,   377,   374,     0,   574,     0,   572,   306,
     568,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   872,   871,     0,     0,     0,     0,   866,     0,
       0,     0,   936,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   889,     0,   886,   887,   888,     0,     0,     0,
       0,   910,   928,   926,   927,     0,     0,   895,     0,   906,
       0,   747,     0,     0,   306,   169,     0,     0,   827,     0,
     712,   711,   689,   611,   685,     0,   690,   686,   691,   613,
     687,     0,   738,     0,     0,   772,   677,     0,   773,   862,
       0,   684,     0,     0,   698,     0,   699,   702,     0,     0,
       0,     0,   731,   103,   306,   434,   433,   431,   429,   432,
     430,   381,     0,   647,   648,     0,     0,     0,   754,     0,
     838,     0,   840,   575,   573,   569,   708,     0,     0,   842,
       0,   705,     0,     0,   917,     0,   919,   925,   922,     0,
     930,   512,   929,   512,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,     0,     0,     0,     0,     0,
       0,     0,     0,   386,     0,     0,   682,     0,     0,     0,
     172,     0,     0,   819,   820,     0,   852,     0,   852,   457,
       0,  1022,     0,     0,   240,   445,   688,   683,   700,   679,
     676,   680,   663,    28,   142,     0,   757,   755,   734,   753,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   504,
     938,     0,     0,     0,   935,     0,     0,   939,     0,     0,
       0,     0,     0,   902,   903,   904,   912,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   894,
       0,   907,   905,     0,   762,   171,   306,     0,   118,   117,
       0,     0,     0,   828,   612,   614,   615,     0,   306,   306,
       0,     0,   769,   382,     0,     0,     0,     0,     0,   837,
       0,   710,   709,   707,   706,   870,   869,     0,     0,     0,
       0,   932,   931,     0,     0,   945,   941,     0,   940,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   908,     0,   909,   387,     0,   176,
      89,     0,     0,   173,   174,   175,   182,   180,   181,   178,
     179,   826,     0,     0,   456,    55,    54,     0,   238,   228,
       0,   758,   756,     0,   836,   835,     0,     0,   933,   937,
     939,     0,   942,     0,   943,   939,   939,     0,   939,   885,
     939,   913,   915,     0,     0,     0,   939,   939,     0,     0,
       0,     0,   746,     0,   184,     0,   825,   616,     0,   383,
       0,   918,   920,     0,     0,     0,   876,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   186,   285,     0,     0,     0,   934,     0,   939,
       0,     0,   939,     0,     0,   916,   939,   939,     0,     0,
       0,     0,     0,     0,   285,     0,     0,   239,   728,   874,
       0,   877,   880,     0,   882,   884,     0,     0,   879,   883,
       0,     0,   898,   900,     0,   185,   183,     0,     0,     0,
       0,     0,   899,   901,   187,   729,   875,   881,   873,   878
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1997, -1997, -1997, -1997, -1997, -1997,    44, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997, -1997,  1679, -1997,  -712, -1997, -1997,
   -1997, -1997,  1337, -1997,  1256, -1997,  -931, -1997, -1997, -1508,
   -1997,    17, -1997,    -2, -1262,  2612, -1997,   503, -1997, -1438,
      14, -1997, -1997, -1997, -1997, -1997, -1997,   553,  -733, -1997,
      -8, -1211, -1997,    -4,   686, -1997, -1997, -1997,  -580,  2283,
    1065, -1997,  1742, -1997, -1997, -1997,   707, -1997, -1997,   407,
     406,   408,    10,  -396, -1997, -1997, -1997, -1997, -1997, -1997,
    -365,  1755, -1997,  -574, -1997, -1997,  -560, -1997, -1997, -1997,
    1731, -1997, -1997, -1997, -1997, -1997,  2136, -1997, -1997, -1997,
   -1139,  -455,  1934, -1997, -1997,   613,    41, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997,  -185,   924, -1997,  2316, -1997, -1997,
      38,  -385,  1938,  -116, -1997,   -10, -1997,  2609,  2605,  -400,
   -1997,  -782,    52, -1997,  -153,  1960,  2311, -1997,  2454,  1351,
    -504,   469, -1997, -1997, -1581, -1997,  -257,  -967, -1606,   633,
    -923, -1594,  2640, -1997, -1997, -1997,  2305, -1997, -1997, -1997,
    2301, -1997, -1997, -1997, -1997,  1387,  -662,   317, -1533, -1997,
    -897, -1013, -1997, -1037, -1997,   237, -1997,  1645, -1997,  -633,
    -176, -1997,   834, -1997,   978,  -703,   933, -1563, -1997, -1997,
    1895,  -693, -1690, -1997, -1997, -1997,  1493,   521,   -67,   598,
     -14,  -165,   716, -1997,   570, -1997, -1997, -1997, -1997, -1997,
   -1997,  -673, -1997, -1997, -1997, -1997, -1532, -1997, -1997, -1997,
   -1997, -1997, -1997, -1997, -1997, -1997, -1997, -1997,   590, -1997,
   -1997,  1059, -1997, -1997, -1483, -1996,  -528,   753,  -239, -1997,
   -1997, -1408,     3,  2043,  2071,  -253,  2500, -1997, -1997,  2226,
    -534, -1997, -1997,   554, -1997, -1997,  1505,   717,   840, -1623,
    -916,  1282,   -23,   -32,  1939,  -483,   768, -1667,  1957, -1997,
     938, -1997, -1997, -1724, -1997, -1997, -1513, -1719, -1997, -1744,
     705,   711,   945, -1997,   698,  3124, -1997, -1109, -1997,  -486,
   -1997, -1997, -1997, -1997, -1997, -1997, -1378,  -701,  -805, -1997,
    2217, -1997, -1997, -1445,  1533, -1997,  1637, -1997, -1997,  1652,
   -1997, -1997,   630,  -994,  1297,  2099, -1997, -1997, -1997, -1997,
   -1997, -1997,   680, -1997, -1997, -1997
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,    10,  1748,   228,  1749,  1645,   816,  1277,   964,
     399,  1408,   545,   965,   966,   967,  1410,   968,  1112,  1113,
    1241,  1750,  1343,  1344,  1345,   969,  1563,  1616,   970,  1564,
      28,   572,   271,   127,   128,    29,    30,  1587,  1242,  1771,
    1646,   547,  1126,   402,  1520,   708,  2300,   229,   230,   231,
     232,  1036,   896,   573,    53,   897,  2154,  1669,   244,   245,
    1464,   971,   972,  1647,  1710,  1861,  1862,  1991,  2219,  2220,
    2364,  2365,   233,   234,   678,    32,   417,   765,   703,   704,
    1648,   810,   811,    33,   915,   916,   574,   732,  2378,   898,
     973,   974,   975,  2233,  2311,   976,    66,   116,   235,   450,
     757,   758,   651,   652,   342,   236,  1649,   412,  1080,   411,
    1430,   728,  1301,   558,   709,   733,  1304,   713,   561,   734,
    1650,     5,   679,   117,   576,   759,    37,    48,    49,   839,
     840,   841,   578,    98,   279,   593,   280,    99,   430,   431,
    1438,  1439,  1701,  1702,  1803,  1804,   899,  1800,  1801,  2212,
    2213,  1055,   169,    39,   289,   438,   439,    40,   290,   445,
     446,    41,   416,   764,   913,  1490,   585,  1247,  1685,  1686,
    1797,  1798,  2234,   900,  1215,  1216,  1877,  1209,   338,   700,
    1440,   238,   239,  1902,   711,   712,  1694,  1695,  1752,  1753,
     240,   830,  2002,  2007,  1100,  1101,  1102,  1392,   131,   150,
     241,   242,  1919,  1920,  1652,   543,  1402,  1581,  1897,   118,
    1760,   727,  1107,   953,   813,  1094,  1705,  1754,  1688,  2487,
    2033,  2052,  1871,  1699,  1654,  1655,  1656,  2167,  2168,  2316,
    2315,  1706,  2113,  1707,  1708,  1764,  1765,  1881,  1882,    68,
      69,  1393,    70,   133,   139,   134,   140,   551,   552,   553,
     825,   554,  1865,  2118,  2119,  1103,  1104,  1932,  1933,  1815,
    1105,  1261,  2012,   146,   746,   747,  1883,  1884,   736,   737,
    1842,  1843,  1844,  1845,  1975,  1846,  2277,  1847,  1848,  1964,
    1952,  1953,  1954,  2076,  2105,  2083,  2261,  2337,  2338,   903,
    1022,  1311,  1310,  1037,  1320,  1319,   904,   760,   761,  1878,
     579,   580,   581,   714,   993,  1162,  1163,  1164,  1165,  1166,
     835,   836,  1167,  1168,  1428,   724,   725,   261,   406,   720,
     985,    43,   161,   753,   977,    44
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   731,    67,   248,   119,   404,    67,   303,   818,   100,
     819,    52,   577,  1405,    52,    96,   299,   300,    52,   774,
      36,   119,   100,    74,    31,   796,   895,   592,    96,   166,
     248,  1228,   586,    97,   115,   817,   995,  2152,     4,   100,
      95,  1244,     9,  1692,    31,    96,    97,   344,    35,  1653,
    1095,    34,  1096,   114,    27,   860,   145,   861,   862,   863,
     996,  1879,    38,    97,  1582,  1692,  1096,  1585,    35,   171,
     114,    34,  1588,  1172,    27,  1697,   158,  2369,  2359,  1013,
     124,  2335,    38,  1522,    14,  1020,    14,   275,   276,   277,
    1965,  1966,  1967,   246,   158,   171,   171,  1976,  1096,  1947,
    1949,  1399,   171,  1090,  1948,  1670,   262,  1950,   255,  1409,
    1336,  1775,    14,   171,    52,   448,   938,    52,  1998,   452,
    1692,  1683,  1756,  -436,  1763,    -4,   583,   181,   182,   400,
    1364,  1208,  1692,  -306,  -306,    14,  1364,   171,  1658,   159,
    1364,   286,   396,   288,  1994,  1041,  1531,   710,  1692,  -306,
    1692,   181,   182,  2360,   171,  1995,  1050,  1996,    14,  1051,
    1050,  1050,  1963,  1051,  1051,  1052,  1963,  1053,   171,  1052,
    1052,  1053,  1053,  1299,   304,   305,   306,  1539,   705,  2004,
     577,  1260,   954,  1050,   826,   162,  1051,  1934,  1458,  1891,
    1894,   914,  1052,    14,  1053,   770,  2020,  1127,  -643,  -643,
     909,  -644,  -644,    14,  2361,  1917,    14,   331,   333,   334,
     335,   336,   748,  2014,    14,  1136,   349,   351,    14,  1890,
     392,  1856,   177,   178,   179,  1925,  1137,   575,  1776,  1757,
     388,  2102,  2273,  2274,  2273,  2274,    56,    57,   749,  1546,
    1183,  2273,  2274,  1755,  1111,  1114,  1986,   164,  1082,  1541,
    2367,   165,   420,   421,   422,  1195,   750,   958,   853,   365,
     362,   363,   364,  1123, -1019,    46,   587,   365,   959,  2194,
    1909,    14,   866,   429,   596,   429,   563,   564,  1899,   257,
    1110,   624,  2262,   731,   258,  1138,   731,  1774,  1774,  1346,
    2028,  1538,   566,    14,   963,  1171,    14,   354,   355,   365,
      47,  1299,  1999,  1299,  1427,    50,   906,   362,   363,   364,
     385,   710,  2063,   455,   365,    50,   910,  1175,  1549,   911,
     654,   132,   912,   385, -1019,  2360,  2022,  2024, -1019,     8,
    2026,  2143,  1904,   191,  1601,   192,   498,   499,   500,   814,
     171,  1084,  2053,  1887,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,  2149,   523,  2029,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,  2064,   592,  2361,   191,  1758,   192,
    1759,  2069,  1011,  1179,   160,     6,  2107,  -436,  2109,  -436,
      14,   751,  1774,   563,   564,   575,     1,     2,   100,  1278,
    1273,   191,  2040,   192,    96,  -163,  1118,  1246,    51,   566,
    1218,  1604,  1252,  1346,  1027,   100, -1019, -1019,    51,  1372,
     429,    96,    97,   429,  1031,  1021,  1284,  1427,    46,     7,
     160,  1222,  2247,  1046,  1337,   767,   768,   769,  1338,    97,
     994,    14,    14,   784,  1061,  1062,   599,    14,  1128,  1129,
     571,   388,  1684,  1283,   455,     4,  -163,    18,  1888,  2256,
    2145,  1497,  1499,   249,  2257,  1799,  2286,  2288,  1457,   125,
    -844,  1799,  -834,  1097,  -844,  1530,  -834,  1170,  1098,   980,
    1892,  1275,  1014,  1423,  1346,  1532,  1042,  1097,  1015,  1799,
     295,  2495,  1098,  1799,  -852,  -852,  1300,   113,  -177,  -852,
    -852,  1763,  -177,  2362,  2362,  2336,  1435,  1523,  1524,  1525,
    1356,  1351,   739,  1091,  -779,  1450,  1532,  1357,    54,  1498,
    -622,  -622,   113,   263,   113,  -622,   -27,   264,  1434,  1619,
    1620,   125,  1276,   100,   295,  1892,   939,  1449,  1684,    96,
     906,  2353,  1281,  2355,  -436,   584,  -112,  1693,  2151,  1365,
     401,  -436,   259,    67,   100,  1488,    67,    97,   295,  1491,
      96,  1997,   100,  1696,  1056,  1892,   100,   571,    96,  1057,
     740,  1054,    96,   744,  1533,  1916,  2106,  2285,    97,  -845,
      42,  2287,  1260,  -845,  -306,   741,    97,  1367,  1532,  1369,
      97,   386,   981,   755,   902,   387,    11,    55,  2108,  -306,
      42,  1210,   658,  2275,    71,  2275,   386,  2408,  2409,   386,
     387,  2401,  2275,   387,  2252,  2253,  1032,  2254,  1139,  2255,
     385,    56,    57,   591,  2276,  1140,  2402,  1141,  1429,  1142,
    2218,  1615,  1137,   385,  2093,   385,   381,   382,   383,    14,
     832,    58,   379,   380,   381,   382,   383,  1863,    73,   260,
    1143,  1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161, -1019,
      59,    60,    45,  1864,   379,   380,   381,   382,   383,    14,
    1814,  -779,  -779,  1819,  2263,  1673,   864,   377,   378,   379,
     380,   381,   382,   383,  1403,   605,    75,   100,   167,  1250,
     119,  1251,   606,    96,    72,  1019,  1469,  1470,    76,    61,
    1026,    62,   847,  1030,   100,   101,  2210,  1039,   100,  2455,
      96,    97,   857,  1484,    96,   385,   895,  2211,   385,  1032,
     844,  -290,  -290,  1529,   296,   296,  -290,   833,    97,  1291,
     100,  2423,    97,   738,   425,  -638,    96,    63,  1545,   114,
     426,   274,  1972,    64,  1963,   917,   281,  1528,  1032,   346,
     347,   348,   435,   721,    97,   609,   435,   102,  1033,  1034,
      14,   865,    65,   436,   163,   454,   123,   436,   722,    31,
    1880,   455,   385,  1763,  1763,  1889,  1893,    14,   440,   441,
     723,   958,   163,   120,   297,   297,  1813,   437, -1018,  1818,
   -1018,   437,   959,    35,   247, -1018,    34,   251,   658,    27,
     442,  1227,   335,   336,  1110,   386,  2283,    38,   616,   387,
   -1018,  1243,  1066,  1067,   389,   390,   100,  2284,   100,  1787,
    1788,   443,    96,  2403,    96,  1066,  1067,   389,   390,  1068,
    2410,  1010,  2411,   549,  1973,    12,   121,  1591,  1592,   550,
      97,   771,    97,    13,  1974,  1789,  1790,   458,   458,   458,
    1445,   444,  1263,  1264,  1192,   122,  1451,  1452,  1453,  1454,
    1455,  1456,   772,   497,  1791,  1792,  1793,  1794,  1265,   455,
    1466,  1033,  1034,   717,   458,   119,   458,   458,   458,   458,
     718,  2103,  2104,  1795,  1796,  2438,  2439,    54,  1414,  2042,
    1415,  2045,   458,   100,   458,   917,  1849,  2093,  1850,    96,
    1033,  1034,   148,   149,   621,   115,   766,   459,   459,   459,
     455,  1663,   426,  2023,   293,  2065,   294,    97,  1667,    31,
    2068,   153,  1772,  1772,   114,  1537,  -779,  1682,  1537,  1851,
    1537,   386,  1099,   132,   459,   387,   459,   459,   459,   459,
    1709,  1810,   742,    35,   -81,  1763,    34,   154,   113,    27,
     100,   834,   459,   721,   459,   100,    96,    38,   773,   135,
    1935,    96, -1018, -1018,   426,  1173,    55,   113,   722,   895,
     906,  1063,  1534,   267,    97,   895,  1119,  1949,   268,    97,
     723,  1122,   152,  2048,  1950,   906,  1180,   136,  2465,   386,
      56,    57,  1371,   387,  1373,   155,   563,   564,   100,   895,
     895,   895,   895,  1120,    96,   100,  2043,  1507,  2047,  2484,
      58,    96,   566,   100,  1139,  1298,  1280,  1340,   243,    96,
    1785,  1140,    97,  1141,   386,  1142,  1786,  1772,   387,    97,
    1137,   113,  2066,   156,   391,    62,  1191,    97,  2070,    59,
      60,   458,   458,   458,     1,     2,  1143,  1144,  1145,  1146,
    1147,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,  1160,  1161,   153,  1035,  1595,  1596,    67,
     785,    63,  1189,  1597,  2044,   386,   455,    64,    61,   387,
      62,  1751,  1602,  1603,   793,  1137,  1255,   393,  2413,   100,
     794,   154,   394,  2235,   845,    96,    65,   137,  2046,   846,
    1790,   459,   459,   459,    52,   440,   441,  1064,   177,   178,
     179,  1065,  1790,    97,   386,  2297,    63,   795,   387,  1792,
    1274,  1794,    64,   455,  1789,  1927,   799,   442,   460,   462,
     463,  1792,   800,  1794,   918,  1248,  2298,  1249,  1796,   155,
     426,    65,  1668,  1791,   138,  1793,  2299,  1789,   443,  1137,
    1796,  1268,  1269,  -646,  -646,   488,  1270,   489,   490,   491,
     492,   141,  1795,  -844,   848,   919,  1791,  -844,  1793,   849,
     571,   426,   142,   501,   920,   502,  1376,   156,   444,    62,
     426,  1623,  1377,   858,   923,  1795,   143,  1377,   859,   394,
     818,  2034,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1462,   144,  1463,  1777,  1069,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,  1077,  2030,    63,  1866,  1853,   949,  1854,
     397,    64,  1867,   950,   398,  1906,   113,   986,    14,  2245,
    1573,   958,   987,   119,  1001,  2000,  1002,  2001,  1078,   258,
      65,   859,   959,   147,   960,   961,  1872,  1873,  1874,  1875,
    1099,   100,   151,  1003,  1110,  1006,  1007,    96,   268,   157,
     987,   987,  1008,  1009,  2267,  1012,   168,   987,   987,  2272,
     859,  2424,  2003,  1176,  2001,    97,  2428,  2429,   859,  2431,
    1305,  2432,   114,  2110,   902,   987,   100,  2436,  2437,  1413,
     129,   130,    96,  1508,   394,   100,  1789,  1790,   394,  1784,
    1816,    96,   894,  1820,   987,  1817,  1859,  1459,  1817,  1922,
      97,   987,   148,   149,  1923,  1791,  1792,  1793,  1794,    97,
    1992,  2015,   655,   656,   657,  1993,  2016,  2017,   389,   390,
    2470,  2025,  2018,  2473,  1795,  1796,  1817,  2476,  2477,   407,
    2027,  2050,  2092,   408,  1895,  1817,  2051,  2093,    67,   423,
     119,  2094,   424,   119,  2117,   119,  2093,  2357,  2095,   710,
     160,  2096,   297,  2093,  2121,  1493,  2093,  1422,   100,  1817,
    2124,   100,   243,   100,    96,  2125,   344,    96,    46,    96,
    1501,  2380,  2127,  1503,  2130,  1505,  2136,  2125,  2141,  2131,
     386,  2018,    97,  2125,   387,    97,  2005,    97,  2006,   114,
    2390,  2391,   114,   157,   114,  2144,  2395,  2396,  2397,  2398,
    1817,  -645,  -645,   296,  2404,  2405,  2406,  2407,   296,  2146,
     254,   296,  1139,  1420,  1817,   296,  2142,  2147,  2001,  1140,
       4,  1141,  1817,  1142,  2176,   113,  2181,  1459,  1626,  1817,
    2036,  1817,  2038,  2039,  2216,  2237,  2238,  2239,  2240,   987,
    2125,  1817,  2016,  2018,  1143,  1144,  1145,  1146,  1147,  1148,
    1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,  1160,  1161,   297,  2241,  2321,   256,  1139,   297,  2016,
    1817,   297,  2322,   265,  1140,   297,  1141,  1817,  1142,  2323,
    1773,  1773,  2449,   710,  1817,   269,   386,  2452,  2324,  1924,
     387,  2456,  2457,  1817,   618,    14,   266,  1930,   455,  1143,
    1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,   806,   929,
    1459,   940,   807,   455,  1016,   807,  1108,   902,  1017,   270,
     807,  1139,  1421,   902,  1624,  1625,  1627,  1131,  1140,  1256,
    1141,  1132,  1142,  1257,  1266,  1366,  1308,  1368,  1267,  2312,
     807,  1651,  1349,  1467,   278,  1468,   807,   902,   902,   902,
     902,   272,   296,  1143,  1144,  1145,  1146,  1147,  1148,  1149,
    1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
    1160,  1161,  1509,  1787,  1788,  1773,  1510,   273,  1512,   282,
     354,   355,  1513,   356,   357,   358,   359,   360,   361,  1514,
     362,   363,   364,  1515,  -844,   597,   598,   365,  -844,  1789,
    1790,    52,  1651,   368,   369,   370,  1918,  1557,   291,  1558,
     284,   807,   297,   807,  1651,   283,  1651,   285,  1791,  1792,
    1793,  1794,  -252,  1568,  1583,  1937,  1806,   807,  1584,  1938,
    1811,  2301,   603,   598,   743,  1940,  -779,  1795,  1796,  1941,
      54,  1944,  2058,  2060,  2161,  1945,  2059,  1941,  2162,  1852,
    2174,  2175,   287,  1812,  2059,  1941,  1812,   119,   119,  2223,
     248,  1554,  1555,   807,  1651,   248,   119,  1651,  2224,  2244,
    2229,   292,  2225,  2289,  2230,   100,   100,  2290,    14,  2292,
     345,    96,    96,  2290,   100,  2295,   352,  1868,  1869,  2296,
      96,  2313,   395,   119,  2343,  2314,  1870,  2354,  2344,    97,
      97,  2093,  1779,  1555,   353,  2356,   114,   114,    97,  2093,
     100,   100,  2329,  2330,   307,   114,    96,    96,   308,    55,
     309,  1651,   310,  1896,  1285,   100,  1287,  1286,   237,  1288,
     113,    96,   311,  2011,    97,    97,   312,   997,   252,  1139,
     999,   313,   114,    56,    57,   314,  1140,  1423,  1141,    97,
    1142,   602,  1442,  1444,   602,  1395,  1397,  2381,  2382,  2148,
    2150,   315,  1951,    58,  1295,  1297,   316,   385,   317,   318,
    1931,  1424,  1425,  1426,  1146,  1147,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,
     319,   320,    59,    60,    79,    80,   321,   322,   302,   323,
     324,   325,   326,  -779,  -779,   248,   327,   328,   329,  1951,
     330,   405,   409,   413,   410,   449,   418,   419,   427,   494,
     434,   171,   504,  2375,  2376,   119,   495,   522,   453,   535,
     538,    61,   539,    62,   544,   546,   548,   337,   343,   555,
     557,   556,   559,   100,   582,   588,  2166,   589,  1812,    96,
     590,   607,  1812,   608,   619,  2021,  1918,   611,   612,   100,
     613,   614,   615,   620,   625,    96,   694,    97,   701,    63,
     702,   403, -1030,    81,   114,    64,   104,   706,   105,   707,
     719,   414,   726,    97,   729,   735,   745,   763,   598,   762,
     775,   776,   777,   778,    65,  1931,   780,    82,    83,    84,
     781,  2067,   782,   783,   365,   808,   302,   812,   809,   815,
     302,   820,   828,   829,   831,   838,   843,    85,   842,   850,
     851,   854,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,    86,    87,  2123,   855,
     905,   907,   908,  2129,   922,   925,   926,   106,   107,   927,
     928,  2166,   948,   936,   951,   952,   979,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   982,   983,   984,
     978,   988,   894,   990,   989,    88,   991,    62,   524,   992,
     998,  1651,  1004,  1651,  1023,  1024,  1025,  1029,  1038,  1040,
    1043,   537,  1044,  1047,  1059,  1045,   541,  1081,   583,   108,
    1060,  1079,  1085,  1086,  1088,  1093,  1106,  1109, -1096,  2171,
    1116,  1125,  1130,    63,   109,  1133,  1134,  1135,  1169,    64,
    1181,  1182,  1187,  1188,  1193,  1194,  1198,   110,  1200,   594,
    1205,  1206,   297,  1220,  1258,  1253,   298,   298,    65,    91,
    1096,  1259,    92,   111,  1262,  1271,  1272,  1279,  -779,  1289,
    1282,  1290,   112,  1292,  1293,  1315,  1302,  1303,  1316,  1321,
     623,  1317,   343,  1651,  2221,  1325,  1328,  1330,  1329,  1332,
    1335,   354,   355,  1339,   356,   357,   358,   359,   360,   361,
    1348,   362,   363,   364,  1350,  1355,  1359,  1360,   365,  1378,
    1401,  1406,  1407,  1416,   368,   369,   370,  1411,   650,  1412,
     653,   302,  1418,  1419,  1432,  1474,  1446,  1478,  1471,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,   676,   680,   681,  1472,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,  1479,  1489,  1494,   699,  1500,  1502,   451,  1504,  1506,
    1511,  1516,  1517, -1075,   715,  1521,  1526, -1071, -1072,   461,
     461,   461, -1073,  2304,  1527,  2306,  1547,  1548,  1550,  1551,
    1553,  1560,  1561,  1565,  1570,  1571,  1572,  1577,   296,   296,
    1576,  1578,  1579,  1580,  1586,  1589,   461,  1590,   461,   461,
     461,   461,  1594,  1532,  1605,  1606,  1609,  1607,  1608,  1226,
    1611,  1614,   113,  1612,   461,  1628,   461,   503,  1618,  1621,
    1660,  1463,  1657,  1659,  1778,  1661,   779,  1698,  1678,  1662,
    1783,  1807,  1665,  1674,   302,   894,  1680,  1681,  1687,  1689,
    1691,   894,  1767,  1700,  1703,  1766,  1808,   787,   297,   297,
    1768,  1769,  1821,  1858,   788,  1860,  2221,   789,   790,   791,
    1876,  1799,  1885,  1900,  1901,   894,   894,   894,   894,  1905,
    1379,  1380,  1907,   699,  1908,  1651,  1651,  1910,  1381,  1382,
    1383,  1384,  1385,  1926,  1912,  1913,  1386,  1914,  1963,  1915,
    1387,  1388,   798,   296,  1939,   297,  -739,  1946,   119,  1943,
    1978,   297,  1979,  1841,  1955,  1956,  1957,  -739,  -739,  1958,
     803,   804,   805,  1983,  1959,  1984,   100,  1980,   622,  1960,
    1961,  1962,    96,  1968,   296,   297,   297,   297,   297,  1981,
    1389,  1390,   824,   824,   827,  1969,  1970,  1971,  1989,  1990,
      97,  2009,  2010,  1982,  1985,  1987,  2013,   114,  2019,  -739,
    1379,  1380,  1988,   297,  2001,  2031,  2032,  2035,  1381,  1382,
    1383,  1384,  1385,   461,   461,   461,  1386,  2049,  2056,  2072,
    1387,  1388,  2073,  2078,  2074,  2077,  -739,  -739,  -739,  -739,
    -739,  -739,  -739,  -739,   297,  2075,  2091,  2101,   867,  2111,
     171,   868,  -739,  -739,  -739,  -739,  2112,  2133,  -739,  -739,
    -739,  -739,  2114,  2120,   181,   182,  2137,   935,  2122,   653,
    1389,  1390,  2126,  2128,  2140,   680,   943,  2132,  1879,  2170,
    2153,  2155,   947,  2156,  2157,  2158,  2159,  2160,  2204,  2173,
     699,  2177,   869,  2178,  2180,  2182,  2195,   870,   871,  2222,
    2189,  2226,   872,   873,   874,  2196,   875,  1651,  2197,   876,
    2198,  2199,  2200,  2201,  2202,  2228,  2205,  2206,  2207,  2246,
    2208,   877,   878,   879,   880,  2227,  2217,  2236,   881,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   458,   458,
     458,   458,   458,   458,   458,   458,  2011,  2242,  2057,  2251,
     786,   458,   458,   458,   458,  2260,  2291,  2278,  2293,  2294,
     882,   883,  2302,  2116,  2307,  1049,  2308,   354,   355,  2309,
     356,   357,   358,   359,   360,   361,  2310,   362,   363,   364,
    2333,  2325,  2326,  2351,   365,  2366,  2358,  2377,   884,  2334,
     368,  2339,   885,  1391,  2340,  2341,  2352,  1087,   459,   459,
     459,   459,   459,   459,   459,   459,  2342,  2347,  2348,  1379,
    1380,   459,   459,   459,   459,  2349,  1089,  1381,  1382,  1383,
    1384,  1385,  2350,  2374,  2373,  1386,  2383,    -3,  2384,  1387,
    1388,  2389,  2393,  2394,   296,  2414,  2399,  2415,  2420,   886,
    2412,  2418,  2419,  2426,   354,   355,   887,   356,   357,   358,
     359,   360,   361,  2425,   362,   363,   364,   824,   824,  2430,
     888,   365,  2434,  2435,    14,  2442,  2448,  2469,  2443,  1389,
    1390,  2444,   103,  1394,   458,  1117,   889,  2450,  2451,  1174,
    2453,  2454,  2464,  2458,   901,  2459,  2243,  2471,  1177,  2472,
    1178,   699,  2482,  2474,   297,  2475,  2478,  2479,  1184,  1185,
    1186,  1519,  2483,  2485,  -739,    15,   890,   542,  2488,  1671,
    2489,  1473,  2490,  1197,   191,  1199,   192,  1201,  1203,  1204,
    2491,  2492,  2493,  2494,  2496,  2497,  2498,  2499,    16,  1115,
    2115,    17,  1217,  2363,   459,  1092,  1124,  2370,  2368,   699,
     752,  1223,  1224,  1229,  1230,  1231,  1232,  1233,  1234,  1235,
    1236,  1237,  1238,  1245,  1379,  1380,    18,   560,   937,   250,
     253,   921,  1381,  1382,  1383,  1384,  1385,   595,   942,   433,
    1386,  2215,   170,   610,  1387,  1388,   617,  1903,   458,   458,
    1942,   458,   458,   458,   458,    19,  1492,  2249,   458,   458,
     458,   458,    20,  1400,  1018,   298,  1857,  2164,   415,  2138,
     298,  1028,  1398,   298,    21,  2062,  2172,   298,   716,  2303,
    1575,  1977,  2188,   852,  1389,  1390,  2139,  2187,  1058,  2082,
    2082,  2082,  2082,  2082,  2082,  2082,  2082,   756,  1005, -1099,
    2209,  1294,  2082,  2082,  2082,  2082,  1000,  1083,   459,   459,
      14,   459,   459,   459,   459,   856,  2008,  1296,   459,   459,
     459,   459,  1417,  1593,   837,     0,  1309,     0,     0,     0,
     458,   458,     0,     0,     0,     0,     0,     0,  1318,   891,
       0,   295,  1396,     0,    22,     0,     0,     0,   892,   893,
       0,    15,     0,     0,     0,     0,     0,  1333,  1334,     0,
       0,     0,     0,     0,     0,  1347,     0,     0,     1,     2,
       0,    23,  1352,  1353,    16,    24,     0,     0,     0,     0,
       0,     0,   458,     0,     0,     0,     0,     0,  1361,  1362,
     459,   459,     0,     0,     0,     0,    14,     0,  1370,     0,
       0,     0,    18,     0,  1375,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2191,  2193,     0,     0,     0,     0,
       0,     0,     0,     0,   298,  2203,   376,   377,   378,   379,
     380,   381,   382,   383,     0,    25,     0,    15,    20,     0,
       0,     0,   459,     0,     0,     0,     0,     0,  1431,     0,
       0,     0,     0,     0,  1219,     0,   458,   302,   302,   302,
      16,     0,  1447,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,  1461,     0, -1099,  1465,     0,     0,     0,
       0,  1217,     0,  1217,   699,   699,     0,  1886,    18,  1347,
       0,  -221,     0,     0,     0,  1480,  1217,     0,     0,     0,
    1483,   699,  1485,     0,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,   459,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,  2082,
    2082,     0,  2082,  2082,  2082,  2082,     0,     0,     0,  2082,
    2082,  2082,  2082,     0,     1,     2,     0,    23,     0,     0,
       0,    24,     0,     0,     0,     0,     0,     0,     0,     0,
    1347, -1099,     0,  1929,     0,  -306,  -306,  -306,  -306,  -306,
    -306,     0,     0,  -306,  -306,  -306,  -306,  -220,     0,  -306,
    -306,     0,     0,     0,   302,     0,     0,   302,     0,   302,
    -306,  1543,     0,     0,     0,     0,     0,     0,     0,    14,
       0,  1930,     0,     0,  -306,  -306,  -306,     0,     0,     0,
       0,  2345,  2346,     0,     0,     0,  1559,     0,     0,     0,
    1347,  1058,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     2,     0,    23,     0,  1358,     0,    24,  2335,     0,
    1574,  1822,  1823,     0,     0,     0,     0,     0,  -306,     0,
       0,     0,     0,     0,   354,   355,     0,   356,   357,   358,
     359,   360,   361,  2388,   362,   363,   364,     0,     0,     0,
       0,   365,  -306,  -306,  -306,   366,   367,   368,   369,   370,
       0,     0,     0,  1824,     0,     0,     0,     0,     0,  1600,
       0,     0,  -306,     0,     0,     0,     0,     0,     0,     0,
       0,  1610,     0,     0,     0,     0,     0,  1617,     0,     0,
    1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,     0,     0,
       0,  -306,  -306,     0,     0,     0,  1833,  1834,  1835,  1836,
       0,     0,  1837,  1838,  1839,  1840,   867,  2433,   171,   868,
       0,     0,     0,  1664,     0,     0,     0,     0,     0,     0,
       0,     0,   181,   182,     0,     0,     0,     0,  1347,     0,
    -306,  1347,  -306,     0,  1675,  1676,  1677,     0,     0,     0,
       0,  1679,     0,     0,     0,     0,     0,     0,     0,     0,
     869,     0,     0,     0,     0,   870,   871,     0,     0,     0,
     872,   873,   874,     0,   875,     0,     0,   876,  -306,     0,
       0,     0,     0,     0,  -306,     0,     0,     0,  -306,   877,
     878,   879,   880,     0,     0,     0,   881,     0,     0,     0,
       0,     0,     0,  -306,  -306,     0,     0,  -306,     0,  -306,
       0,  -306,  1802,     0,     0,     0,  1809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   882,   883,
       0,     0,     0,     0,   901,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     371,     0,     0,     0,  -306,     0,   884,     0,  -306,  -306,
     885,     0,     0,     0,  -306,  -306,  -306,  -306,  -306,     0,
    -306,     0,     0,     0,     0,  -306,  -306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -306,
       0,     0,  -306,     0,     0,     0,  -306,     0,     0,     0,
       0,     0,     0,  1347,     0,     0,     0,   886,  -306,  -306,
    -306,  1911,  -306,     0,   887,     0,     0,     0,  -306,     0,
    -306,  -306,     0,     0,  -306,  -306,  -306,     0,   888,     0,
       0,     0,     0,     0,     0,     0,     0,  1936,     0,     0,
       0,     0,     0,     0,   889,     0,     0,     0,  -306,  -306,
    -306,     0,     0,  -306,  -306,     0,     0,     0,  1841,     0,
    -306,     0,     0,     0,     0,  -844,  -306,     0,     0,  -844,
       0,  -306,     0,     0,   890,  -306,  -306,     0,     0,     0,
       0,     0,   191,     0,   192,     0,     0,     0,     0,     0,
       0,     0,   730,     0,  -227,     0,     0,     0,  -227,  -227,
       0,     0,     0,     0,     0,    79,    80,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,  2037,     0,     0,     0,  1347,     0,     0,     0,     0,
     298,   298,  2336,     0,     0,     0,     0,     0,     0,  2054,
       0,  2055,     0,     0,     0,     0,  1936,     0,     0,     0,
       0,     0,     0,  1805,     0,     0,     0,     0,     0,     0,
       0,  2071,     0,     0,     0,   563,   564,  -227,     0,     0,
       0,     0,     0,     0,    81,     0,     0,   901,     0,     0,
       0,   566,     0,   901,     0,     0,     0,     0,     0,     0,
       0,  -227,  -227,  -227,     0,     0,     0,     0,    82,    83,
      84,     0,     0,     0,     0,     0,     0,   901,   901,   901,
     901,  -227,   699,     0,     0,     0,     0,     0,    85,     0,
       0,     0,     0,     0,     0,  2134,  2135,     0,     0,   295,
       0,     0,     0,     0,     0,   298,   892,   893,     0,     0,
    -227,  -227,     0,     0,     0,     0,     0,    86,    87,     0,
       0,  -227,  -227,     0,     0,     0,     0,     0,   106,   107,
       0,     0,     0,     0,  2163,     0,   298,   302,     0,     0,
    1690,  1805,  -139,     0,     0,     0,  -139,  -139,     0,  -227,
       0,  -227,  2179,     0,     0,     0,    88,     0,    62,  2184,
    2186,     0,     0,     0,     0,  2190,  2192,     0,     0,     0,
       0,     0,     0,  -227,     0,     0,     0,     0,     0,     0,
     108,     0,     0,     0,     0,     0,     0,  -227,     0,     0,
       0,     0,     0,  -227,    63,     0,     0,     0,     0,     0,
      64,     0,     0,  1404,     0,     0,     0,     0,     0,   571,
       0,     0,  -227,  -227,     0,     0,  -227,  -227,     0,    65,
      91,     0,     0,    92,   111,  -139,  -227,     0,     0,     0,
       0,     0,     0,   112,     0,     0,     0,   126,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -139,
    -139,  -139,   302,     0,  2250,     0,     0,     0,  1805,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -139,
    2259,     0,     0,     0,     0,     0,     0,     0,     0,  2264,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     461,   461,   461,   461,   461,   461,   461,   461,  -139,  -139,
      50,     0,     0,   461,   461,   461,   461,     0,     0,  -139,
    -139,     0,  2305,     0,  2061,     0,  -306,  -306,  -306,  -306,
    -306,  -306,     0,     0,  -306,  -306,  -306,  -306,     0,     0,
    -306,  -306,     0,     0,     0,     0,  2320,  -139,     0,  -139,
       0,  -306,     0,  2327,     0,     0,     0,  2331,  2332,     0,
      14,     0,  1930,     0,     0,  -306,  -306,  -306,     0,     0,
       0,  -139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -139,  -227,     0,     0,     0,
       0,  -139,     0,   113,     0,     0,   298,  2372,     0,     0,
       0,     0,     0,     0,     0,     0,  2379,     0,     0,  -306,
    -139,  -139,     0,    51,  -139,  -139,     0,     0,     0,     0,
       0,     0,     0,  2387,  -139,     0,     0,     0,  -139,     0,
       0,     0,     0,  -306,  -306,  -306,   461,     0,     0,  2400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2417,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2421,  -306,  -306,     0,     0,     0,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,     0,     0,     0,   365,  2440,  2441,     0,   366,   367,
     368,   369,   370,  2445,     0,  2446,     0,     0,  2447,     0,
       0,  -306,     0,  -306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2460,  2461,     0,     0,     0,     0,  2466,
     461,   461,     0,   461,   461,   461,   461,     0,     0,     0,
     461,   461,   461,   461,     0,     0,   -89,     0,   -89,  -306,
       0,     0,    79,    80,     0,  -306,     0,     0,     0,  -306,
       0,     0,     0,     0,  -139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -306,  -306,     0,     0,  -306,     0,
    -306,     0,  -306,     0,     0,     0,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,   461,   461,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -306,     0,     0,     0,  -306,
    -306,    81,     0,     0,     0,  -306,  -306,  -306,  -306,  -306,
       0,  -306,     0,     0,     0,     0,  -306,  -306,     0,     0,
       0,     0,     0,     0,     0,    82,    83,    84,     0,     0,
    -306,     0,     0,  -306,   461,     0,     0,  -306,     0,     0,
       0,  2392,     0,     0,     0,    85,     0,     0,     0,  -306,
    -306,  -306,     0,  -306,     0,     0,     0,     0,     0,  -306,
       0,  -306,  -306,   371,     0,  -306,  -306,  -306,     0,     0,
       0,     0,     0,     0,    86,    87,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,     0,     0,  -306,
    -306,  -306,     0,     0,  -306,  -306,     0,     0,     0,  2427,
       0,  -306,     0,     0,     0,     0,  -844,  -306,   461,     0,
    -844,     0,  -306,    88,     0,    62,  -306,  -306,  1211,     0,
     171,   172,   173,   174,   175,   176,     0,     0,   177,   178,
     179,   180,     0,     0,   181,   182,     0,   108,     0,     0,
    1190,     0,   171,     0,     0,   183,    79,    80,     0,     0,
       0,    63,     0,     0,     0,     0,     0,    64,     0,   184,
     185,   186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   371,     0,     0,     0,    65,    91,     0,     0,
      92,   111,     0,     0,     0,     0,     0,     0,     0,     0,
     112,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   187,     0,     0,     0,     0,     0,     0,
    1212,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1213,     0,     0,     0,     0,    81,     0,    82,    83,    84,
       0,     0,   372,   493,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,     0,     0,   188,     0,    82,
      83,    84,     0,     0,     0,  2328,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    85,
       0,     0,     0,     0,     0,     0,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    86,    87,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    88,     0,    62,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    88,     0,    62,
     113,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,    63,     0,     0,     0,     0,     0,    64,
       0,   108,     0,   189,   632,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    63,     0,     0,    65,    91,
       0,    64,   190,     0,   191,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      65,    91,     0,     0,    92,   111,   191,     0,   192,     0,
       0,     0,     0,     0,   112,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
       0,     0,     0,   194,   195,     0,     0,     0,     0,   196,
     197,   198,   199,   200,     0,   201,     0,     0,     0,     0,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   205,     0,   600,
       0,   206,    14,     0,     0,  -306,  -306,     0,     0,     0,
       0,     0,     0,   207,   208,   209,     0,   210,     0,     0,
       0,     0,     0,   211,     0,   212,   213,     0,     0,   214,
     215,   216,     0,     0,  1518,    14,   171,   172,   173,   174,
     175,   176,     0,    15,   177,   178,   179,   180,     0,     0,
     181,   182,     0,   217,   218,   219,     0,     0,   220,   221,
    1214,   183,     0,     0,     0,   222,    16,     0,     0,    17,
       0,   223,     0,     0,     0,   184,   185,   186,     0,     0,
     226,   227,     0,     0,  -306,     0,     0,     0,     0,     0,
       0,     0,     0,   295,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -306,  -306,
    -306,     0,     0,     0,  1341,     0,     0,     0,     0,   187,
       0,     0,     0,    19,     0,     0,     0,     0,  -306,     0,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,    82,    83,    84,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -306,  -306,     0,
       0,     0,     0,   188,     0,     0,     0, -1099,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,    86,    87,     0,   365,  -306,     0,  -306,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,     0,
       0,  1221,    22,   171,   172,   173,   174,   175,   176,     0,
    -306,   177,   178,   179,   180,     0,     0,   181,   182,     0,
       0,    88,     0,    62,  -306,     0,     1,     2,   183,    23,
    -306,     0,     0,    24,     0,     0,     0,     0,     0,     0,
       0,     0,   184,   185,   186,     0,     0,     0,     0,  -306,
    -306,     0,  1342,  -306,  -306,     0,     0,     0,     0,    63,
       0,     0,     0,  -306,     0,    64,     0,     0,     0,   189,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    65,    91,   187,     0,   190,     0,
     191,     0,   192,    25,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,    83,    84,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
     188,     0,     0,     0,     0,   193,     0,     0,     0,   194,
     195,     0,     0,     0,     0,   196,   197,   198,   199,   200,
       0,   201,     0,     0,     0,     0,   202,   203,     0,    86,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,     0,   205,     0,     0,     0,   206,     0,     0,
       0,     0,     0,     0,   371,     0,     0,     0,     0,   207,
     208,   209,     0,   210,     0,     0,     0,     0,    88,   211,
      62,   212,   213,     0,     0,   214,   215,   216,     0,   601,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,     0,     0,     0,
       0,     0,  2097,  2098,  2099,  2100,     0,     0,     0,   217,
     218,   219,     0,     0,   220,   221,    63,     0,     0,     0,
       0,   222,    64,     0,   -59,     0,   189,   223,     0,     0,
       0,     0,     0,     0,     0,     0,   226,   227,     0,     0,
       0,    65,    91,     0,     0,   190,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1211,     0,
     171,   172,   173,   174,   175,   176,     0,     0,   177,   178,
     179,   180,     0,     0,   181,   182,     0,     0,     0,     0,
       0,     0,   193,     0,     0,   183,   194,   195,     0,     0,
       0,     0,   196,   197,   198,   199,   200,     0,   201,   184,
     185,   186,     0,   202,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,     0,     0,
     205,     0,     0,   372,   206,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   207,   208,   209,     0,
     210,     0,     0,   187,     0,   682,   211,     0,   212,   213,
    1212,     0,   214,   215,   216,     0,     0,     0,     0,     0,
    1213,     0,     0,     0,     0,     0,     0,    82,    83,    84,
       0,     0,     0,     0,     0,     0,   217,   218,   219,     0,
       0,   220,   221,     0,     0,     0,     0,   188,   222,     0,
       0,     0,     0,  -508,   223,     0,     0,  -508,     0,     0,
       0,     0,     0,   226,   227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    86,    87,     0,  2265,
    2266,     0,  2268,  2269,  2270,  2271,     0,     0,     0,  2279,
    2280,  2281,  2282,     0,     0,  1535,     0,   171,   172,   173,
     174,   175,   176,     0,     0,   177,   178,   179,   180,     0,
       0,   181,   182,     0,     0,    88,     0,    62,     0,     0,
       0,     0,   183,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   184,   185,   186,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    63,  1437,     0,     0,     0,     0,    64,
    1536,     0,     0,   189,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    65,    91,
     187,     0,   190,     0,   191,     0,   192,     0,     0,     0,
       0,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,    82,    83,    84,     0,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,     0,     0,   188,     0,     0,     0,     0,   193,
       0,     0,     0,   194,   195,     0,     0,     0,     0,   196,
     197,   198,   199,   200,     0,   201,     0,     0,     0,     0,
     202,   203,     0,    86,    87,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   205,     0,     0,
       0,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   207,   208,   209,     0,   210,     0,     0,
       0,     0,    88,   211,    62,   212,   213,     0,     0,   214,
     215,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,   218,   219,     0,     0,   220,   221,
      63,     0,     0,     0,     0,   222,    64,     0,     0,     0,
     189,   223,     0,     0,     0,     0,     0,     0,     0,     0,
     226,   227,     0,     0,     0,    65,    91,     0,     0,   190,
       0,   191,     0,   192,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,     0,   367,   368,   369,   370,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   371,     0,     0,
     194,   195,     0,     0,     0,     0,   196,   197,   198,   199,
     200,     0,   201,     0,     0,     0,     0,   202,   203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,   205,   600,     0,     0,   206,     0,
       0,  -306,  -306,     0,     0,     0,     0,     0,     0,     0,
     207,   208,   209,     0,   210,     0,     0,     0,     0,     0,
     211,     0,   212,   213,     0,     0,   214,   215,   216,     0,
    1535,    14,   171,   172,   173,   174,   175,   176,     0,     0,
     177,   178,   179,   180,     0,     0,   181,   182,     0,     0,
     217,   218,   219,     0,     0,   220,   221,   183,     0,     0,
       0,     0,   222,     0,     0,     0,     0,     0,   223,     0,
       0,   184,   185,   186,     0,     0,     0,   226,   227,     0,
    -306,     0,     0,     0,     0,     0,     0,     0,     0,  1437,
       0,     0,     0,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,     0,  -306,  -306,  -306,     0,     0,     0,
       0,     0,     0,     0,     0,   187,     0,     0,     0,     0,
       0,     0,     0,     0,  -306,     0,   372,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,    82,
      83,    84,     0,     0,     0,     0,     0,     0,     0,   639,
       0,     0,     0,  -306,  -306,     0,     0,     0,     0,   188,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,    86,    87,
       0,   365,  -306,     0,  -306,   366,   367,   368,   369,   370,
       0,     0,     0,     0,     0,     0,     0,  1535,     0,   171,
     172,   173,   174,   175,   176,     0,  -306,   177,   178,   179,
     180,     0,     0,   181,   182,     0,     0,    88,     0,    62,
    -306,     0,     0,     0,   183,     0,  -306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   184,   185,
     186,     0,     0,     0,     0,  -306,  -306,     0,     0,  -306,
    -306,     0,     0,     0,     0,    63,  1437,     0,     0,  -306,
       0,    64,  1542,     0,     0,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      65,    91,   187,     0,   190,     0,   191,     0,   192,     0,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,    82,    83,    84,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,     0,     0,     0,
       0,   193,     0,     0,     0,   194,   195,     0,     0,     0,
       0,   196,   197,   198,   199,   200,     0,   201,     0,     0,
       0,     0,   202,   203,     0,    86,    87,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   204,     0,     0,   205,
       0,     0,     0,   206,     0,     0,     0,     0,     0,     0,
     371,     0,     0,     0,     0,   207,   208,   209,     0,   210,
       0,     0,     0,     0,    88,   211,    62,   212,   213,     0,
       0,   214,   215,   216,     0,   604,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   217,   218,   219,     0,     0,
     220,   221,    63,     0,     0,     0,     0,   222,    64,     0,
       0,     0,   189,   223,     0,     0,     0,     0,     0,     0,
       0,     0,   226,   227,     0,     0,     0,    65,    91,     0,
       0,   190,     0,   191,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2232,     0,  -446,  -446,  -446,  -446,
    -446,  -446,     0,     0,  -446,  -446,  -446,  -446,     0,     0,
    -446,  -446,     0,     0,     0,     0,     0,     0,   193,     0,
       0,  -446,   194,   195,     0,     0,     0,     0,   196,   197,
     198,   199,   200,     0,   201,  -446,  -446,  -446,     0,   202,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,  -446,   205,     0,     0,   372,
     206,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   207,   208,   209,     0,   210,     0,     0,  -446,
       0,   944,   211,     0,   212,   213,     0,     0,   214,   215,
     216,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -446,  -446,  -446,     0,     0,     0,     0,
       0,     0,   217,   218,   219,     0,     0,   220,   221,     0,
       0,     0,     0,  -446,   222,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,   226,
     227,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -446,  -446,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1436,     0,   171,   172,   173,   174,   175,   176,     0,
       0,   177,   178,   179,   180,     0,     0,   181,   182,     0,
       0,  -446,     0,  -446,     0,     0,     0,     0,   183,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   184,   185,   186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -446,
    1437,     0,     0,     0,     0,  -446,     0,     0,     0,  -446,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -446,  -446,   187,     0,  -446,     0,
    -446,     0,  -446,     0,     0,     0,     0,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
      82,    83,    84,     0,   365,     0,     0,     0,   366,   367,
     368,   369,   370,     0,     0,     0,     0,     0,     0,     0,
     188,     0,     0,     0,     0,  -446,     0,     0,     0,  -446,
    -446,     0,     0,     0,     0,  -446,  -446,  -446,  -446,  -446,
       0,  -446,     0,     0,     0,     0,  -446,  -446,     0,    86,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -446,     0,     0,  -446,     0,     0,     0,  -446,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -446,
    -446,  -446,     0,  -446,     0,     0,     0,     0,    88,  -446,
      62,  -446,  -446,     0,     0,  -446,  -446,  -446,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -446,
    -446,  -446,     0,     0,  -446,  -446,    63,     0,     0,     0,
       0,  -446,    64,     0,  1121,     0,   189,  -446,    79,    80,
       0,     0,     0,     0,     0,  1226,  -446,  -446,     0,     0,
       0,    65,    91,     0,     0,   190,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   371,     0,     0,   194,   195,     0,     0,
       0,     0,   196,   197,   198,   199,   200,    81,   201,     0,
       0,     0,     0,   202,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,     0,     0,
     205,    82,    83,    84,   206,     0,     0,    79,    80,     0,
       0,     0,     0,     0,     0,     0,   207,   208,   209,     0,
     210,    85,     0,     0,     0,     0,   211,     0,   212,   213,
       0,     0,   214,   215,   216,     0,  1441,     0,   171,   172,
     173,   174,   175,   176,     0,     0,   177,   178,   179,   180,
      86,    87,   181,   182,     0,     0,   217,   218,   219,     0,
       0,   220,   221,   183,     0,     0,     0,     0,   222,     0,
       0,     0,     0,     0,   223,     0,     0,   184,   185,   186,
       0,     0,     0,   226,   227,     0,    81,     0,     0,    88,
       0,    62,     0,     0,     0,  1437,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,    83,    84,   108,     0,     0,     0,     0,     0,     0,
       0,   187,     0,     0,     0,     0,     0,    63,     0,     0,
      85,     0,   372,    64,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,    82,    83,    84,     0,     0,
       0,     0,    65,    91,     0,   642,    92,   111,     0,    86,
      87,     0,     0,     0,     0,   188,   112,     0,     0,     0,
     106,   107,     0,     0,     0,     0,     0,     0,     0,     0,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,    86,    87,     0,   365,    88,     0,
      62,   366,   367,   368,   369,   370,     0,     0,     0,     0,
       0,     0,     0,  1443,     0,   171,   172,   173,   174,   175,
     176,     0,   108,   177,   178,   179,   180,     0,     0,   181,
     182,     0,     0,    88,     0,    62,    63,     0,     0,     0,
     183,     0,    64,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   184,   185,   186,     0,     0,     0,
       0,    65,    91,     0,     0,    92,   111,     0,     0,     0,
       0,    63,  1437,     0,     0,   112,     0,    64,     0,   126,
       0,   189,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    65,    91,   187,     0,
     190,     0,   191,     0,   192,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,    83,    84,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   188,     0,     0,     0,     0,   193,     0,     0,
       0,   194,   195,     0,     0,     0,     0,   196,   197,   198,
     199,   200,     0,   201,     0,     0,     0,     0,   202,   203,
       0,    86,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   204,     0,     0,   205,     0,     0,     0,   206,
       0,     0,     0,     0,     0,     0,   371,     0,     0,     0,
       0,   207,   208,   209,     0,   210,     0,     0,     0,     0,
      88,   211,    62,   212,   213,     0,     0,   214,   215,   216,
       0,     0,     0,     0,     0,   113,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,   218,   219,     0,     0,   220,   221,    63,     0,
       0,     0,     0,   222,    64,     0,     0,     0,   189,   223,
       0,     0,     0,     0,     0,     0,     0,     0,   226,   227,
       0,     0,     0,    65,    91,     0,     0,   190,     0,   191,
       0,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2318,     0,   171,   172,   173,   174,   175,   176,     0,     0,
     177,   178,   179,   180,     0,     0,   181,   182,     0,     0,
       0,     0,     0,     0,   193,     0,     0,   183,   194,   195,
       0,     0,     0,     0,   196,   197,   198,   199,   200,     0,
     201,   184,   185,   186,     0,   202,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,   205,     0,     0,   372,   206,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   207,   208,
     209,     0,   210,     0,     0,   187,     0,   945,   211,     0,
     212,   213,     0,     0,   214,   215,   216,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
      83,    84,     0,     0,     0,     0,     0,     0,   217,   218,
     219,     0,     0,   220,   221,     0,     0,     0,     0,   188,
     222,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,   226,   227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    86,    87,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   354,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,     0,     0,     0,   365,     0,     0,     0,
     366,   367,   368,   369,   370,     0,     0,    88,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    63,     0,     0,     0,     0,
       0,    64,     0,     0,     0,   189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      65,    91,     0,     0,   190,     0,   191,     0,   192,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1196,     0,   171,
     172,   173,   174,   175,   176,     0,     0,   177,   178,   179,
     180,     0,     0,   181,   182,     0,     0,     0,     0,     0,
       0,   193,     0,     0,   183,   194,   195,     0,     0,     0,
       0,   196,   197,   198,   199,   200,     0,   201,   184,   185,
     186,     0,   202,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   204,     0,     0,   205,
       0,     0,     0,   206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   207,   208,   209,     0,   210,
       0,     0,   187,     0,     0,   211,     0,   212,   213,     0,
       0,   214,   215,   216,     0,   371,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,    83,    84,     0,
       0,     0,     0,     0,     0,   217,   218,   219,     0,     0,
     220,   221,     0,     0,     0,     0,   188,   222,     0,     0,
       0,     0,  2319,   223,     0,     0,     0,     0,     0,     0,
       0,     0,   226,   227,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    86,    87,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1202,     0,   171,   172,   173,   174,
     175,   176,     0,     0,   177,   178,   179,   180,     0,     0,
     181,   182,     0,     0,    88,     0,    62,     0,     0,     0,
       0,   183,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,   185,   186,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    63,     0,     0,     0,     0,     0,    64,     0,
       0,     0,   189,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    65,    91,   187,
       0,   190,     0,   191,   372,   192,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,     0,     0,     0,
       0,     0,     0,    82,    83,    84,     0,   643,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   188,     0,     0,     0,     0,   193,     0,
       0,     0,   194,   195,     0,     0,     0,     0,   196,   197,
     198,   199,   200,     0,   201,     0,     0,     0,     0,   202,
     203,     0,    86,    87,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,     0,   205,     0,     0,     0,
     206,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   207,   208,   209,     0,   210,     0,     0,     0,
       0,    88,   211,    62,   212,   213,     0,     0,   214,   215,
     216,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,   218,   219,     0,     0,   220,   221,    63,
       0,     0,     0,     0,   222,    64,     0,     0,     0,   189,
     223,     0,     0,     0,     0,     0,     0,     0,     0,   226,
     227,     0,     0,     0,    65,    91,     0,     0,   190,     0,
     191,     0,   192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1374,     0,   171,   172,   173,   174,   175,   176,     0,
       0,   177,   178,   179,   180,     0,     0,   181,   182,     0,
       0,     0,     0,     0,     0,   193,     0,     0,   183,   194,
     195,     0,     0,     0,     0,   196,   197,   198,   199,   200,
       0,   201,   184,   185,   186,     0,   202,   203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,     0,   205,     0,     0,     0,   206,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
     208,   209,     0,   210,     0,     0,   187,     0,     0,   211,
       0,   212,   213,     0,     0,   214,   215,   216,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,    83,    84,     0,     0,     0,     0,     0,     0,   217,
     218,   219,     0,     0,   220,   221,     0,     0,     0,     0,
     188,   222,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,     0,     0,     0,     0,   226,   227,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    86,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1460,     0,
     171,   172,   173,   174,   175,   176,     0,     0,   177,   178,
     179,   180,     0,     0,   181,   182,     0,     0,    88,     0,
      62,     0,     0,     0,     0,   183,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   184,
     185,   186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    63,     0,     0,     0,
       0,     0,    64,     0,     0,     0,   189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    65,    91,   187,     0,   190,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,    83,    84,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   188,     0,     0,
       0,     0,   193,     0,     0,     0,   194,   195,     0,     0,
       0,     0,   196,   197,   198,   199,   200,     0,   201,     0,
       0,     0,     0,   202,   203,     0,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,     0,     0,
     205,     0,     0,     0,   206,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,   208,   209,     0,
     210,     0,     0,     0,     0,    88,   211,    62,   212,   213,
       0,     0,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,   218,   219,     0,
       0,   220,   221,    63,     0,     0,     0,     0,   222,    64,
       0,     0,     0,   189,   223,     0,     0,     0,     0,     0,
       0,     0,     0,   226,   227,     0,     0,     0,    65,    91,
       0,     0,   190,     0,   191,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1599,     0,   171,   172,   173,
     174,   175,   176,     0,     0,   177,   178,   179,   180,     0,
       0,   181,   182,     0,     0,     0,     0,     0,     0,   193,
       0,     0,   183,   194,   195,     0,     0,     0,     0,   196,
     197,   198,   199,   200,     0,   201,   184,   185,   186,     0,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   205,     0,     0,
       0,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   207,   208,   209,     0,   210,     0,     0,
     187,     0,     0,   211,     0,   212,   213,     0,     0,   214,
     215,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,    83,    84,     0,     0,     0,
       0,     0,     0,   217,   218,   219,     0,     0,   220,   221,
       0,     0,     0,     0,   188,   222,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,     0,     0,     0,     0,
     226,   227,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    86,    87,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2214,     0,   171,   172,   173,   174,   175,   176,
       0,     0,   177,   178,   179,   180,     0,     0,   181,   182,
       0,     0,    88,     0,    62,     0,     0,     0,     0,   183,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   184,   185,   186,     0,     0,     0,     0,
       0,   354,   355,     0,   356,   357,   358,   359,   360,   361,
      63,   362,   363,   364,     0,     0,    64,     0,   365,     0,
     189,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,     0,     0,     0,    65,    91,   187,     0,   190,
       0,   191,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,    83,    84,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   188,     0,     0,     0,     0,   193,     0,     0,     0,
     194,   195,     0,     0,     0,     0,   196,   197,   198,   199,
     200,     0,   201,     0,     0,     0,     0,   202,   203,     0,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,   205,     0,     0,     0,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     207,   208,   209,     0,   210,     0,     0,     0,     0,    88,
     211,    62,   212,   213,     0,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,   218,   219,     0,     0,   220,   221,    63,     0,     0,
       0,     0,   222,    64,     0,     0,     0,   189,   223,     0,
       0,     0,     0,     0,     0,     0,     0,   226,   227,     0,
       0,     0,    65,    91,     0,     0,   190,   371,   191,     0,
     192,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,     0,   695,   696,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   193,     0,     0,     0,   194,   195,     0,
       0,     0,     0,   196,   197,   198,   199,   200,     0,   201,
       0,     0,     0,     0,   202,   203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   204,     0,
       0,   205,     0,     0,     0,   206,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,   208,   209,
       0,   210,     0,     0,     0,     0,     0,   211,     0,   212,
     213,     0,     0,   214,   215,   216,     0,     0,     0,   171,
     172,   173,   174,   175,   176,     0,     0,   177,   178,   179,
     180,     0,     0,   181,   182,     0,     0,   217,   218,   219,
       0,     0,   220,   221,   183,   339,   340,     0,     0,   222,
       0,     0,     0,     0,     0,   223,     0,     0,   184,   185,
     186,     0,     0,     0,   226,   227,   372,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   644,
       0,     0,     0,     0,     0,     0,     0,  1341,     0,     0,
       0,     0,   187,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   371,     0,     0,
       0,     0,     0,     0,     0,     0,    82,    83,    84,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,     0,   171,   172,
     173,   174,   175,   176,     0,     0,   177,   178,   179,   180,
       0,     0,   181,   182,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   183,     0,    86,    87,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   184,   185,   186,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,    88,     0,    62,   365,     0,     0,
       0,   366,   367,   368,   369,   370,     0,     0,     0,     0,
       0,   187,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,     0,    63,     0,     0,    82,    83,    84,    64,  1239,
       0,     0,   189,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   188,     0,    65,    91,     0,
       0,   190,     0,   191,     0,   192,   372,   697,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,     0,
       0,     0,     0,     0,    86,    87,     0,     0,   698,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   193,     0,
       0,     0,   194,   195,     0,     0,     0,     0,   196,   197,
     198,   199,   200,    88,   201,    62,     0,     0,     0,   202,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,     0,   205,     0,     0,     0,
     206,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    63,   207,   208,   209,     0,   210,    64,     0,     0,
    1240,   189,   211,     0,   212,   213,     0,     0,   214,   215,
     216,     0,     0,     0,     0,     0,    65,    91,     0,     0,
     190,     0,   191,     0,   192,     0,   371,     0,     0,     0,
       0,     0,   217,   218,   219,     0,     0,   220,   221,     0,
       0,     0,     0,     0,   222,     0,     0,   341,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,   226,
     227,     0,     0,     0,     0,     0,     0,   193,     0,     0,
       0,   194,   195,     0,     0,     0,     0,   196,   197,   198,
     199,   200,     0,   201,     0,     0,     0,     0,   202,   203,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   204,     0,     0,   205,     0,     0,     0,   206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   207,   208,   209,     0,   210,     0,     0,     0,     0,
       0,   211,     0,   212,   213,     0,     0,   214,   215,   216,
       0,     0,     0,   171,   172,   173,   174,   175,   176,     0,
       0,   177,   178,   179,   180,     0,     0,   181,   182,     0,
       0,   217,   218,   219,     0,     0,   220,   221,   183,   339,
     340,     0,     0,   222,     0,     0,     0,     0,     0,   223,
       0,     0,   184,   185,   186,     0,   892,  1226,   226,   227,
       0,     0,     0,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   384,     0,     0,
       0,     0,     0,     0,     0,     0,   187,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
      82,    83,    84,     0,   365,     0,     0,     0,   366,   367,
     368,   369,   370,     0,     0,     0,     0,     0,     0,     0,
     188,     0,   171,   172,   173,   174,   175,   176,     0,     0,
     177,   178,   179,   180,     0,     0,   181,   182,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   183,     0,    86,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   184,   185,   186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,    88,     0,
      62,   365,     0,     0,     0,   366,   367,   368,   369,   370,
       0,     0,     0,     0,     0,   187,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    63,     0,     0,    82,
      83,    84,    64,  1225,     0,     0,   189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   188,
       0,    65,    91,     0,     0,   190,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    86,    87,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   371,     0,     0,   194,   195,     0,     0,
       0,     0,   196,   197,   198,   199,   200,    88,   201,    62,
       0,     0,     0,   202,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,     0,     0,
     205,     0,     0,     0,   206,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    63,   207,   208,   209,     0,
     210,    64,     0,     0,     0,   189,   211,     0,   212,   213,
       0,     0,   214,   215,   216,     0,     0,     0,     0,     0,
      65,    91,     0,     0,   190,     0,   191,     0,   192,     0,
     371,     0,     0,     0,     0,     0,   217,   218,   219,     0,
       0,   220,   221,     0,     0,     0,     0,     0,   222,     0,
       0,   341,     0,     0,   223,     0,     0,     0,     0,     0,
       0,     0,     0,   226,   227,     0,     0,     0,     0,     0,
       0,   193,     0,     0,     0,   194,   195,     0,     0,     0,
       0,   196,   197,   198,   199,   200,     0,   201,     0,     0,
       0,     0,   202,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   204,     0,     0,   205,
       0,     0,   372,   206,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,   207,   208,   209,     0,   210,
       0,     0,     0,     0,   946,   211,     0,   212,   213,     0,
       0,   214,   215,   216,     0,     0,     0,   171,   172,   173,
     174,   175,   176,     0,     0,   177,   178,   179,   180,     0,
       0,   181,   182,     0,     0,   217,   218,   219,     0,     0,
     220,   221,   183,     0,     0,     0,     0,   222,     0,     0,
       0,     0,     0,   223,     0,     0,   184,   185,   186,     0,
     892,  1226,   226,   227,     0,     0,     0,     0,     0,   372,
    1495,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1496,     0,     0,     0,  1341,     0,     0,     0,     0,
     187,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,    82,    83,    84,     0,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,     0,     0,   188,     0,   171,   172,   173,   174,
     175,   176,     0,     0,   177,   178,   179,   180,     0,     0,
     181,   182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   183,     0,    86,    87,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,   185,   186,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,    88,     0,    62,   365,     0,     0,     0,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
      63,     0,     0,    82,    83,    84,    64,     0,     0,     0,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   188,     0,    65,    91,     0,     0,   190,
       0,   191,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    86,    87,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   371,     0,     0,
     194,   195,     0,     0,     0,     0,   196,   197,   198,   199,
     200,    88,   201,    62,     0,     0,     0,   202,   203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,   205,     0,     0,     0,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    63,
     207,   208,   209,     0,   210,    64,     0,     0,     0,   189,
     211,     0,   212,   213,     0,     0,   214,   215,   216,     0,
       0,     0,     0,     0,    65,    91,     0,     0,   190,     0,
     191,     0,   192,     0,   371,     0,     0,     0,     0,     0,
     217,   218,   219,     0,     0,   220,   221,     0,     0,     0,
       0,     0,   222,     0,     0,  1672,     0,     0,   223,     0,
       0,     0,     0,     0,     0,     0,     0,   226,   227,     0,
       0,     0,     0,     0,     0,   193,     0,     0,     0,   194,
     195,     0,     0,     0,     0,   196,   197,   198,   199,   200,
       0,   201,     0,     0,     0,     0,   202,   203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,     0,   205,     0,     0,   372,   206,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,   207,
     208,   209,     0,   210,     0,     0,     0,     0,  1254,   211,
       0,   212,   213,     0,     0,   214,   215,   216,     0,     0,
       0,   171,   172,   173,   174,   175,   176,     0,     0,   177,
     178,   179,   180,     0,     0,   181,   182,     0,     0,   217,
     218,   219,     0,     0,   220,   221,   183,   339,   340,     0,
       0,   222,     0,     0,     0,     0,     0,   223,     0,   224,
     184,   185,   186,   225,     0,     0,   226,   227,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1569,     0,     0,     0,     0,
       0,     0,     0,     0,   187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   354,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,    82,    83,
      84,     0,   365,     0,     0,     0,   366,   367,   368,   369,
     370,     0,     0,     0,     0,     0,     0,     0,   188,     0,
     171,   172,   173,   174,   175,   176,     0,     0,   177,   178,
     179,   180,     0,     0,   181,   182,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   183,     0,    86,    87,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   184,
     185,   186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,    88,     0,    62,   365,
       0,     0,     0,   366,   367,   368,   369,   370,  1341,     0,
       0,     0,     0,   187,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    82,    83,    84,
      64,     0,     0,     0,   189,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   188,     0,    65,
      91,     0,     0,   190,     0,   191,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   371,     0,     0,   194,   195,     0,     0,     0,     0,
     196,   197,   198,   199,   200,    88,   201,    62,     0,     0,
       0,   202,   203,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   204,     0,     0,   205,     0,
       0,     0,   206,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,    63,   207,   208,   209,     0,   210,    64,
       0,     0,     0,   189,   211,     0,   212,   213,     0,     0,
     214,   215,   216,     0,     0,     0,     0,     0,    65,    91,
       0,     0,   190,     0,   191,     0,   192,     0,   371,     0,
       0,     0,     0,     0,   217,   218,   219,     0,     0,   220,
     221,     0,     0,     0,     0,     0,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
       0,   226,   227,     0,     0,     0,     0,     0,     0,   193,
       0,     0,     0,   194,   195,     0,     0,     0,     0,   196,
     197,   198,   199,   200,     0,   201,     0,     0,     0,     0,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   205,     0,     0,
     372,   206,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,   207,   208,   209,     0,   210,     0,     0,
       0,     0,  1622,   211,     0,   212,   213,     0,     0,   214,
     215,   216,     0,     0,     0,   171,   172,   173,   174,   175,
     176,     0,     0,   177,   178,   179,   180,     0,     0,   181,
     182,     0,     0,   217,   218,   219,     0,     0,   220,   221,
     183,     0,     0,     0,     0,   222,     0,     0,     0,     0,
       0,   223,     0,     0,   184,   185,   186,     0,     0,     0,
     226,   227,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,     0,   496,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   187,     0,
       0,     0,     0,     0,     0,  1212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1213,     0,     0,     0,     0,
       0,     0,    82,    83,    84,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   188,     0,   171,   172,   173,   174,   175,   176,
       0,     0,   177,   178,   179,   180,     0,     0,   181,   182,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   183,
       0,    86,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   184,   185,   186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      88,     0,    62,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,   187,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    63,     0,
       0,    82,    83,    84,    64,     0,     0,     0,   189,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   188,     0,    65,    91,     0,     0,   190,     0,   191,
       0,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   193,     0,     0,     0,   194,   195,
       0,     0,     0,     0,   196,   197,   198,   199,   200,    88,
     201,    62,     0,     0,     0,   202,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,   205,     0,     0,     0,   206,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,     0,    63,   207,   208,
     209,     0,   210,    64,     0,     0,     0,   189,   211,     0,
     212,   213,     0,     0,   214,   215,   216,     0,     0,     0,
       0,     0,    65,    91,     0,     0,   190,     0,   191,     0,
     192,     0,     0,     0,     0,     0,     0,     0,   217,   218,
     219,     0,     0,   220,   221,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,   226,   227,     0,     0,     0,
       0,     0,     0,   193,     0,     0,     0,   194,   195,     0,
       0,     0,     0,   196,   197,   198,   199,   200,     0,   201,
       0,     0,     0,     0,   202,   203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   204,     0,
       0,   205,     0,     0,     0,   206,     0,     0,     0,     0,
       0,    79,    80,     0,     0,     0,     0,   207,   208,   209,
       0,   210,     0,     0,     0,     0,     0,   211,     0,   212,
     213,     0,     0,   214,   215,   216,     0,     0,     0,   171,
     172,   173,   174,   175,   176,     0,     0,   177,   178,   179,
     180,     0,     0,   181,   182,     0,     0,   217,   218,   219,
       0,     0,   220,   221,   183,     0,     0,     0,     0,   222,
       0,     0,     0,     0,     0,  1562,     0,     0,   184,   185,
     186,     0,     0,     0,   226,   227,     0,     0,     0,     0,
      81,     0,     0,     0,     0,     0,  2165,     0,     0,     0,
       0,     0,  2248,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,    83,    84,     0,     0,     0,
       0,     0,   187,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    85,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,    83,    84,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    86,    87,     0,   188,     0,   171,   172,
     173,   174,   175,   176,   106,   107,   177,   178,   179,   180,
       0,     0,   181,   182,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   183,     0,    86,    87,     0,     0,     0,
       0,     0,    88,     0,    62,     0,     0,   184,   185,   186,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   108,     0,     0,     0,
       0,     0,     0,     0,    88,     0,    62,     0,     0,     0,
      63,     0,     0,     0,     0,     0,    64,     0,     0,     0,
       0,   187,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    65,    91,     0,     0,    92,
     111,     0,    63,     0,     0,    82,    83,    84,    64,   112,
       0,     0,   189,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   188,     0,    65,    91,     0,
       0,   190,     0,   191,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    86,    87,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   193,     0,
       0,     0,   194,   195,     0,     0,     0,     0,   196,   197,
     198,   199,   200,    88,   201,    62,     0,     0,     0,   202,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,     0,   205,     0,     0,     0,
     206,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    63,   207,   208,   209,     0,   210,    64,     0,     0,
       0,   189,   211,     0,   212,   213,     0,     0,   214,   215,
     216,     0,     0,     0,     0,     0,    65,    91,     0,   113,
     190,     0,   191,     0,   192,     0,     0,     0,     0,     0,
       0,     0,   217,   218,   219,     0,     0,   220,   221,     0,
       0,     0,     0,     0,   222,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,   226,
     227,     0,     0,     0,     0,     0,     0,   193,     0,     0,
       0,   194,   195,     0,     0,     0,     0,   196,   197,   198,
     199,   200,     0,   201,     0,     0,     0,     0,   202,   203,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   204,     0,     0,   205,     0,     0,     0,   206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   207,   208,   209,     0,   210,     0,     0,     0,     0,
       0,   211,     0,   212,   213,     0,     0,   214,   215,   216,
       0,     0,     0,   171,   172,   173,   174,   175,   176,     0,
       0,   177,   178,   179,   180,     0,     0,   181,   182,     0,
       0,   217,   218,   219,     0,     0,   220,   221,   183,     0,
       0,     0,     0,   222,     0,     0,   301,     0,     0,   223,
       0,     0,   184,   185,   186,     0,     0,     0,   226,   227,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   187,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
      82,    83,    84,     0,   365,     0,     0,     0,   366,   367,
     368,   369,   370,  1475,     0,     0,     0,     0,     0,     0,
     188,     0,   171,   172,   173,   174,   175,   176,     0,     0,
     177,   178,   179,   180,     0,     0,   181,   182,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   183,     0,    86,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   184,   185,   186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,    88,     0,
      62,   365,     0,     0,     0,   366,   367,   368,   369,   370,
       0,     0,     0,     0,     0,   187,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    63,     0,     0,    82,
      83,    84,    64,     0,     0,     0,   189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   188,
       0,    65,    91,     0,     0,   190,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    86,    87,
    1476,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   371,     0,     0,   194,   195,     0,     0,
       0,     0,   196,   197,   198,   199,   200,    88,   201,    62,
       0,     0,     0,   202,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,     0,     0,
     205,     0,     0,     0,   206,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    63,   207,   208,   209,     0,
     210,    64,     0,     0,     0,   189,   211,     0,   212,   213,
       0,     0,   214,   215,   216,     0,     0,     0,     0,     0,
      65,    91,     0,     0,   190,     0,   191,     0,   192,     0,
     371,     0,     0,     0,     0,     0,   217,   218,   219,     0,
       0,   220,   221,     0,     0,     0,     0,     0,   222,     0,
       0,     0,     0,   447,   223,     0,     0,     0,     0,     0,
       0,     0,     0,   226,   227,     0,     0,     0,     0,     0,
       0,   193,     0,     0,     0,   194,   195,     0,     0,     0,
       0,   196,   197,   198,   199,   200,     0,   201,     0,     0,
       0,     0,   202,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   204,     0,     0,   205,
       0,     0,   372,   206,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,   207,   208,   209,     0,   210,
    1477,     0,   496,     0,     0,   211,     0,   212,   213,     0,
       0,   214,   215,   216,     0,     0,     0,   171,   172,   173,
     174,   175,   176,     0,     0,   177,   178,   179,   180,     0,
       0,   181,   182,     0,     0,   217,   218,   219,     0,     0,
     220,   221,   183,     0,     0,     0,     0,   222,     0,     0,
       0,     0,     0,   223,     0,     0,   184,   185,   186,   536,
       0,     0,   226,   227,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,   626,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     187,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,    82,    83,    84,     0,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,     0,     0,   188,     0,   171,   172,   173,   174,
     175,   176,     0,     0,   177,   178,   179,   180,     0,     0,
     181,   182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   183,     0,    86,    87,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,   185,   186,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,    88,     0,    62,   365,     0,     0,     0,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      63,     0,     0,    82,    83,    84,    64,     0,     0,   540,
     189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   188,     0,    65,    91,     0,     0,   190,
       0,   191,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    86,    87,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   371,     0,     0,
     194,   195,     0,     0,     0,     0,   196,   197,   198,   199,
     200,    88,   201,    62,     0,     0,     0,   202,   203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,   205,     0,     0,     0,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    63,
     207,   208,   209,     0,   210,    64,     0,     0,     0,   189,
     211,     0,   212,   213,     0,     0,   214,   215,   216,     0,
       0,     0,     0,     0,    65,    91,     0,     0,   190,     0,
     191,     0,   192,     0,   371,     0,     0,     0,     0,     0,
     217,   218,   219,     0,     0,   220,   221,     0,     0,     0,
       0,     0,   222,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,     0,     0,     0,     0,   226,   227,     0,
       0,     0,     0,     0,     0,   193,     0,     0,     0,   194,
     195,     0,     0,     0,     0,   196,   197,   198,   199,   200,
       0,   201,     0,     0,     0,     0,   202,   203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,     0,   205,     0,     0,   372,   206,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,   207,
     208,   209,     0,   210,     0,   627,     0,     0,     0,   211,
       0,   212,   213,     0,     0,   214,   215,   216,     0,     0,
       0,   171,   172,   173,   174,   175,   176,     0,     0,   177,
     178,   179,   180,     0,     0,   181,   182,     0,     0,   217,
     218,   219,     0,     0,   220,   221,   183,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,   223,   677,     0,
     184,   185,   186,     0,     0,     0,   226,   227,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,   628,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   354,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,    82,    83,
      84,     0,   365,     0,     0,     0,   366,   367,   368,   369,
     370,     0,     0,     0,     0,     0,     0,     0,   188,     0,
     171,   172,   173,   174,   175,   176,     0,     0,   177,   178,
     179,   180,     0,     0,   181,   182,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   183,     0,    86,    87,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   184,
     185,   186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,    88,     0,    62,   365,
       0,     0,     0,   366,   367,   368,   369,   370,     0,     0,
       0,     0,     0,   187,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    82,    83,    84,
      64,     0,     0,     0,   189,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   188,     0,    65,
      91,     0,     0,   190,     0,   191,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   371,     0,     0,   194,   195,     0,     0,     0,     0,
     196,   197,   198,   199,   200,    88,   201,    62,     0,     0,
       0,   202,   203,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   204,     0,     0,   205,     0,
       0,     0,   206,     0,     0,     0,   821,     0,     0,     0,
       0,     0,     0,    63,   207,   208,   209,     0,   210,    64,
       0,     0,     0,   189,   211,     0,   212,   213,     0,     0,
     214,   215,   216,     0,     0,     0,     0,     0,    65,    91,
       0,     0,   190,     0,   191,     0,   192,     0,   371,     0,
       0,     0,     0,     0,   217,   218,   219,     0,     0,   822,
     823,     0,     0,     0,     0,     0,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
       0,   226,   227,     0,     0,     0,     0,     0,     0,   193,
       0,     0,     0,   194,   195,     0,     0,     0,     0,   196,
     197,   198,   199,   200,     0,   201,     0,     0,     0,     0,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   205,     0,     0,
     372,   206,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,   207,   208,   209,     0,   210,     0,   629,
       0,     0,     0,   211,     0,   212,   213,     0,     0,   214,
     215,   216,     0,     0,     0,   171,   172,   173,   174,   175,
     176,     0,     0,   177,   178,   179,   180,     0,     0,   181,
     182,     0,     0,   217,   218,   219,     0,     0,   220,   221,
     183,     0,     0,     0,     0,   222,     0,     0,     0,  1048,
       0,   223,     0,     0,   184,   185,   186,     0,     0,     0,
     226,   227,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,   630,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   187,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   354,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,    82,    83,    84,     0,   365,     0,     0,     0,
     366,   367,   368,   369,   370,     0,     0,     0,     0,     0,
       0,     0,   188,     0,   171,   172,   173,   174,   175,   176,
       0,     0,   177,   178,   179,   180,     0,     0,   181,   182,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   183,
       0,    86,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   184,   185,   186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      88,     0,    62,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,   187,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,     0,     0,     0,     0,    63,     0,
       0,    82,    83,    84,    64,     0,     0,     0,   189,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   188,     0,    65,    91,     0,     0,   190,     0,   191,
       0,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   193,   371,     0,     0,   194,   195,
       0,     0,     0,     0,   196,   197,   198,   199,   200,    88,
     201,    62,     0,     0,     0,   202,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,   205,     0,     0,     0,   206,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,   207,   208,
     209,     0,   210,    64,     0,     0,     0,   189,   211,     0,
     212,   213,     0,     0,   214,   215,   216,     0,     0,     0,
       0,     0,    65,    91,     0,     0,   190,     0,   191,     0,
     192,     0,     0,     0,     0,     0,     0,     0,   217,   218,
     219,     0,     0,   220,   221,     0,     0,     0,     0,     0,
     222,     0,     0,     0,   371,     0,   223,     0,     0,     0,
       0,  2057,     0,     0,     0,   226,   227,     0,     0,     0,
       0,     0,     0,   193,     0,     0,     0,   194,   195,     0,
       0,     0,     0,   196,   197,   198,   199,   200,     0,   201,
       0,     0,     0,     0,   202,   203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   204,     0,
       0,   205,     0,     0,   372,   206,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,   207,   208,   209,
       0,   210,     0,   631,     0,     0,     0,   211,     0,   212,
     213,     0,     0,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,   218,   219,
       0,     0,   220,   221,     0,     0,     0,     0,     0,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
    2116,     0,     0,     0,   226,   227,   171,   172,   173,   174,
     175,   176,     0,     0,   177,   178,   179,   180,     0,     0,
     181,   182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   183,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   184,   185,   186,     0,     0,
       0,     0,   633,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2165,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,    82,    83,    84,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,     0,     0,     0,     0,
       0,     0,     0,   188,     0,   171,   172,   173,   174,   175,
     176,     0,     0,   177,   178,   179,   180,     0,     0,   181,
     182,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     183,     0,    86,    87,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   184,   185,   186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,    88,     0,    62,   365,     0,     0,     0,   366,   367,
     368,   369,   370,     0,     0,     0,     0,     0,   187,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    63,
       0,     0,    82,    83,    84,    64,     0,     0,     0,   189,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   188,     0,    65,    91,     0,     0,   190,     0,
     191,     0,   192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    86,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   371,     0,     0,   194,
     195,     0,     0,     0,     0,   196,   197,   198,   199,   200,
      88,   201,    62,     0,     0,     0,   202,   203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,     0,   205,     0,     0,     0,   206,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    63,   207,
     208,   209,     0,   210,    64,     0,     0,     0,   189,   211,
       0,   212,   213,     0,     0,   214,   215,   216,     0,     0,
       0,     0,     0,    65,    91,     0,     0,   190,     0,   191,
       0,   192,     0,   371,     0,     0,     0,     0,     0,   217,
     218,   219,     0,     0,   220,   221,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,     0,     0,     0,     0,   226,   227,     0,     0,
       0,     0,     0,     0,   193,     0,     0,     0,   194,   195,
       0,     0,     0,     0,   196,   197,   198,   199,   200,     0,
     201,     0,     0,     0,     0,   202,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,   205,     0,     0,   372,   206,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,   207,   208,
     209,     0,   210,     0,   634,     0,     0,     0,   211,     0,
     212,   213,     0,     0,   214,   215,   216,     0,     0,     0,
     171,   172,   173,   174,   175,   176,     0,     0,   177,   178,
     179,   180,     0,     0,   181,   182,     0,     0,   217,   218,
     219,     0,     0,   220,   221,   183,     0,     0,     0,     0,
     222,     0,     0,     0,     0,  2371,   223,     0,     0,   184,
     185,   186,     0,     0,     0,   226,   227,     0,     0,     0,
       0,     0,   372,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,     0,     0,     0,     0,     0,
       0,   635,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   187,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,    82,    83,    84,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
       0,     0,     0,     0,     0,     0,     0,   188,     0,   171,
     172,   173,   174,   175,   176,     0,     0,   177,   178,   179,
     180,     0,     0,   181,   182,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   183,     0,    86,    87,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   184,   185,
     186,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,    88,     0,    62,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,   187,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    63,     0,     0,    82,    83,    84,    64,
       0,     0,     0,   189,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,     0,    65,    91,
       0,     0,   190,     0,   191,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    86,    87,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     371,     0,     0,   194,   195,     0,     0,     0,     0,   196,
     197,   198,   199,   200,    88,   201,    62,     0,     0,     0,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,   205,     0,     0,
       0,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    63,   207,   208,   209,     0,   210,    64,     0,
       0,     0,   189,   211,     0,   212,   213,     0,     0,   214,
     215,   216,     0,     0,     0,     0,     0,    65,    91,     0,
       0,   190,     0,   191,     0,   192,     0,   371,     0,     0,
       0,     0,     0,   217,   218,   219,     0,     0,   220,   221,
       0,     0,     0,     0,     0,   222,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,     0,     0,     0,     0,
     226,   227,     0,     0,     0,     0,     0,     0,   193,     0,
       0,     0,   194,   195,     0,     0,     0,     0,   196,   197,
     198,   199,   200,     0,   201,     0,     0,     0,     0,   202,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,     0,   205,     0,     0,   372,
     206,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   207,   208,   209,     0,   210,     0,   636,     0,
       0,     0,   211,     0,   212,   213,     0,     0,   214,   215,
     216,     0,     0,     0,   171,   172,   173,   174,   175,   176,
       0,     0,   177,   178,   179,   180,     0,     0,   181,   182,
       0,     0,   217,   218,   219,    79,    80,   220,   221,   183,
       0,     0,     0,     0,  2185,     0,     0,     0,     0,     0,
     223,     0,     0,   184,   185,   186,     0,     0,     0,   226,
     227,     0,     0,     0,     0,     0,   372,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,     0,
       0,     0,     0,     0,     0,   637,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   354,   355,   187,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,     0,
       0,     0,   365,     0,    81,     0,   366,   367,   368,   369,
     370,    82,    83,    84,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,    83,
      84,   188,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    85,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    86,    87,   332,
       0,  -306,  -306,  -306,  -306,  -306,  -306,     0,     0,  -306,
    -306,  -306,  -306,     0,     0,     0,     0,     0,     0,    88,
       0,    62,     0,     0,     0,     0,  -306,     0,     0,     0,
       0,     0,     0,     0,     0,    14,    88,     0,    62,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,     0,     0,
     108,     0,     0,    64,     0,     0,     0,   189,     0,     0,
       0,     0,     0,     0,    63,     0,     0,     0,     0,     0,
      64,     0,    65,    91,  -306,     0,   190,     0,   191,     0,
     192,     0,     0,     0,     0,     0,     0,     0,     0,    65,
      91,     0,     0,    92,   111,     0,     0,     0,  -306,  -306,
    -306,     0,     0,   112,     0,     0,     0,     0,     0,     0,
       0,   371,     0,     0,     0,     0,     0,     0,  -306,     0,
       0,     0,     0,   193,     0,     0,     0,   194,   195,     0,
       0,     0,     0,   196,   197,   198,   199,   200,     0,   201,
       0,     0,     0,     0,   202,   203,     0,  -306,  -306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   204,     0,
       0,   205,     0,     0,     0,   206,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,   208,   209,
       0,   210,     0,     0,     0,     0,  -306,   211,  -306,   212,
     213,     0,     0,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,   218,   219,
       0,     0,   220,   221,  -306,     0,     0,     0,    79,    80,
    -306,     0,     0,     0,  -306,   223,     0,     0,     0,     0,
       0,     0,     0,     0,   226,   227,     0,     0,     0,  -306,
    -306,     0,     0,  -306,     0,  -306,     0,  -306,     0,     0,
       0,     0,     0,     0,     0,   350,     0,  -306,  -306,  -306,
    -306,  -306,  -306,     0,     0,  -306,  -306,  -306,  -306,     0,
     372,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,  -306,     0,     0,     0,     0,     0,     0,   638,
    -306,    14,     0,     0,  -306,  -306,     0,    81,     0,     0,
    -306,  -306,  -306,  -306,  -306,     0,  -306,     0,     0,     0,
       0,  -306,  -306,     0,     0,     0,     0,     0,     0,     0,
       0,    82,    83,   754,     0,  -306,     0,     0,  -306,     0,
       0,     0,  -306,     0,     0,     0,     0,     0,     0,     0,
    -306,    85,     0,     0,  -306,  -306,  -306,     0,  -306,     0,
       0,     0,     0,     0,  -306,     0,  -306,  -306,     0,     0,
    -306,  -306,  -306,     0,  -306,  -306,  -306,     0,     0,     0,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -306,     0,     0,     0,
       0,     0,  -306,     0,     0,     0,     0,     0,     0,    88,
       0,    62,     0,  -306,  -306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   108,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,     0,     0,
       0,     0,  -306,    64,  -306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    65,    91,     0,     0,    92,   111,     0,     0,
       0,     0,     0,     0,     0,     0,   112,     0,     0,     0,
    -306,     0,     0,     0,     0,     0,  -306,     0,     0,     0,
    -306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -306,  -306,     0,     0,  -306,
       0,  -306,     0,  -306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -306,     0,     0,     0,
    -306,  -306,     0,     0,     0,     0,  -306,  -306,  -306,  -306,
    -306,     0,  -306,     0,     0,     0,     0,  -306,  -306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -306,     0,  1629,  -306,  -306,     0,     0,  -306,  -306,
    -306,  1630,     0,     0,     0,     0,     0,     0,     0,     0,
    -306,  -306,  -306,     0,  -306,     0,     0,     0,     0,     0,
    -306,     0,  -306,  -306,     0,     0,  -306,  -306,  -306,    14,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -306,  -306,  1631,  1761,  -306,  -306,  -306,  1632,     0,     0,
    -306,     0,     0,  1633,     0,     0,     0,     0,     0,     0,
       0,     0,  -306,     0,     0,  -306,  1634,     0,  -306,     0,
    1635,     0,     0,  1636,     0,  -306,  -306,  -306,  -306,     0,
       0,  -306,     0,  -306,  -306,     0,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,     0,     0,     0,     0,  1637,
    1638,  -306,  -306,  -306,  -306,     0,     0,  -306,  -306,  -306,
    -306,  -306,     0,     0,  1639,  -306,     0,     0,  -306,  -306,
       0,    18,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  1640,     0,     0,  -306,     0,     0,     0,  -306,  -306,
    -306,  -306,     0,     0,     0,     0,     0,     0,     0,     0,
    1641,  -306,  -306,  -306,     0,  1642,  1643,  -306,     0,     0,
       0,     0,   955,     0,  -235,     0,     0,     0,  -235,  -235,
       0,     0,     0,     0,     0,     0,     0,     0,  -306,  -306,
       0,  -306,  -306,  -306,  -306,     0,     0,     0,     0,     0,
    -306,     0,  -306,     0, -1099,   171,   172,   173,   174,   456,
     176,     0,     0,   177,   178,   179,   180,     0,     0,     0,
       0,     0,     0,     0,  -306,     0,     0,     0,     0,  -306,
     183,     0,     0,     0,     0,     0,   702,     0,  -306,  -306,
       0,     0,     0,     0,  -306,     0,  1644,     0,     0,  -165,
       0,     0,  -306,     0,     0,     0,     0,  -235,     0,     0,
    -306,     0,     0,  -306,  -306,  2079,  -306,  -306,  -306,     0,
       0,     0,     0,     1,     2,     0,  -306,  -306,     0,     0,
      24,  -235,  -235,  -235,     0,     0,     0,     0,   187,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,     0,     0,
    -165,  -235,     0,     0,     0,  2081,     0,     0,     0,     0,
       0,     0,    82,    83,    84,     0,     0,     0,     0,     0,
       0,     0,  -306,     0,     0,     0,     0,     0,     0,     0,
    -235,  -235,   188,     0,   171,   172,   173,   174,   456,   176,
       0,     0,   177,   178,   179,   180,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   183,
       0,    86,    87,     0,     0,     0,     0,     0,     0,  -235,
       0,  -235,     0,     0,     0,   956, -1097,     0,     0,     0,
       0,     0,     0,     0,     0,   -24,     0,     0,     0,     0,
       0,  -306,     0,  -235,     0,     0,     0,   957,     0,     0,
      88,     0,    62,     0,     0,     0,     0,  -235,     0,     0,
       0,     0,   958,  -235,     0,     0,     0,   187,     0,     0,
       0,     0,     0,   959,  1762,   960,   961,     0,     0,     0,
       0,     0,  -235,  -235,     0,   962,  -235,  -235,    63,     0,
       0,    82,    83,    84,    64,     0,  -235,     0,   189,   963,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   188,     0,    65,    91,     0,     0,   190,     0,   191,
       0,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      86,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   193,     0,     0,     0,   194,   195,
       0,     0,     0,     0,   196,   197,   198,   199,   200,    88,
     201,    62,     0,     0,     0,   202,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,   205,     0,     0,     0,   206,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,   207,   208,
     209,     0,   210,    64,     0,     0,     0,   189,   211,     0,
     212,   213,     0,     0,   214,   215,   216,     0,     0,     0,
       0,     0,    65,    91,     0,     0,   190,     0,   191,     0,
     192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,     0,   457,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   193,     0,     0,     0,   194,   195,     0,
       0,     0,     0,   196,   197,   198,   199,   200,     0,   201,
       0,     0,     0,     0,   202,   203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   204,     0,
    1629,   205,  -306,     0,     0,   206,  -306,  -306,  1630,     0,
       0,     0,     0,     0,     0,     0,     0,   207,   208,   209,
       0,   210,     0,     0,     0,     0,     0,   211,     0,   212,
     213,     0,     0,   214,   215,   216,    14,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -306,  -306,  1631,
    1704,  -306,  -306,  -306,  1632,     0,     0,  -306,     0,     0,
    1633,     0,     0,     0,  -766,     0,     0,     0,     0,   222,
       0,     0,  -306,  1634,     0,   457,     0,  1635,     0,     0,
    1636,     0,  -306,  -306,  -306,  -306,     0,     0,  -306,     0,
    -306,  -306,     0,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,     0,     0,     0,     0,  1637,  1638,  -306,  -306,
    -306,  -306,     0,     0,  -306,  -306,  -306,  -306,  -306,     0,
       0,  1639,  -306,     0,     0,  -306,  -306,     0,    18,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  1640,     0,
       0,  -306,     0,     0,     0,  -306,  -306,  -306,  -306,     0,
       0,     0,     0,     0,     0,     0,     0,  1641,  -306,  -306,
    -306,     0,  1642,  1643,  -306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -306,  -306,     0,  -306,  -306,
    -306,  -306,     0,     0,     0,     0,     0,  -306,     0,  -306,
       0, -1099,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -306,     0,     0,     0,     0,  -306,     0,     0,     0,
       0,     0,  1629,   702,  -306,  -306,  -306,     0,  -306,  -306,
    1630,  -306,     0,  1644,     0,     0,     0,     0,     0,  -306,
       0,     0,     0,     0,     0,     0,     0,  -306,     0,     0,
    -306,  -306,     0,  -306,  -306,  -306,     0,     0,    14,     0,
       1,     2,     0,  -306,  -306,     0,     0,    24,     0,  -306,
    -306,  1631,  1704,  -306,  -306,  -306,  1632,     0,     0,  -306,
       0,     0,  1633,     0,     0,     0,  -766,     0,     0,     0,
       0,     0,     0,     0,  -306,  1634,     0,     0,     0,  1635,
       0,     0,  1636,     0,  -306,  -306,  -306,  -306,     0,  -306,
    -306,     0,  -306,  -306,     0,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,     0,     0,     0,     0,  1637,  1638,
    -306,  -306,  -306,  -306,     0,     0,  -306,  -306,  -306,  -306,
    -306,     0,     0,  1639,  -306,     0,     0,  -306,  -306,     0,
      18,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    1640,     0,     0,  -306,     0,     0,     0,  -306,  -306,  -306,
    -306,     0,     0,     0,     0,     0,     0,     0,  -306,  1641,
    -306,  -306,  -306,     0,  1642,  1643,  -306,     0,     0,     0,
       0,     0,     0,     0,  1855,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -306,  -306,     0,
    -306,  -306,  -306,  -306,     0,     0,     0,     0,     0,  -306,
       0,  -306,     0, -1099,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,  -306,     0,   365,     0,     0,  -306,   366,
     367,   368,   369,   370,     0,   702,     0,  -306,  -306,     0,
       0,     0,     0,  -306,     0,  1644,     0,     0,     0,     0,
       0,  -306,     0,     0,     0,     0,     0,     0,     0,  -306,
       0,     0,  -306,  -306,     0,  -306,  -306,  -306,     0,     0,
       0,     0,     1,     2,     0,  -306,  -306,   354,   355,    24,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,     0,     0,     0,   365,     0,     0,     0,   366,   367,
     368,   369,   370,   354,   355,     0,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,     0,     0,     0,
     365,  -306,     0,     0,   366,   367,   368,   369,   370,   354,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,     0,     0,     0,   365,     0,     0,     0,
     366,   367,   368,   369,   370,   354,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,     0,
       0,     0,   365,     0,     0,     0,   366,   367,   368,   369,
     370,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -306,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,     0,  1898,     0,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,   354,   355,   371,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,     0,   366,   367,   368,   369,   370,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,   371,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
     354,   355,     0,   356,   357,   358,   359,   360,   361,   371,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,   371,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   371,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,   371,     0,     0,
       0,     0,   640,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,   371,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   372,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   371,     0,     0,     0,     0,     0,
       0,   641,     0,     0,     0,     0,     0,     0,   372,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     371,     0,     0,     0,     0,     0,     0,   645,     0,     0,
       0,     0,     0,     0,   372,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   371,     0,     0,     0,
       0,     0,     0,   646,     0,     0,     0,     0,     0,     0,
     372,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   371,     0,     0,     0,     0,     0,     0,   647,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   372,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,     0,
       0,     0,     0,     0,     0,   648,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,   649,     0,     0,     0,
       0,     0,     0,     0,   371,     0,     0,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,   797,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,   802,     0,
       0,     0,     0,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,   930,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,   354,   355,
     931,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
     354,   355,   932,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,     0,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
       0,     0,     0,     0,   371,     0,     0,     0,     0,     0,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
     371,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,     0,     0,     0,     0,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,   371,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,   371,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,   371,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,   371,   366,   367,   368,   369,   370,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
     371,     0,   933,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,   934,     0,
       0,     0,     0,     0,     0,     0,   371,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   371,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,  1312,     0,     0,     0,     0,     0,
       0,   372,   371,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,     0,
    1313,     0,     0,     0,     0,     0,     0,   372,   371,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,  1314,     0,     0,     0,
       0,     0,     0,   372,   371,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,  1322,     0,     0,     0,     0,     0,     0,   372,
     371,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,  1323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,  1324,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,     0,
    1326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,     0,
    1327,     0,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,  1552,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,  1566,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,   354,   355,  1567,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,     0,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,     0,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,     0,
       0,     0,   371,     0,     0,     0,     0,     0,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,   371,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,   371,   366,   367,   368,   369,   370,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
     371,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,   371,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,   371,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,   371,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,   371,     0,     0,     0,     0,     0,
    1613,     0,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,  1782,     0,     0,     0,
       0,     0,     0,   372,   371,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,  1921,     0,     0,     0,     0,     0,     0,   372,
     371,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,  1928,     0,
       0,     0,     0,     0,     0,   372,   371,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,  2183,     0,     0,     0,     0,     0,
       0,   372,   371,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,     0,
    2385,     0,     0,     0,     0,     0,     0,   372,   371,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,  2416,     0,     0,     0,
       0,     0,     0,   372,   371,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,  2422,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,  2462,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,  2463,     0,
       0,     0,     0,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,  2467,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,     0,
    2468,     0,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,  2480,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
     354,   355,  2481,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,  1475,   354,   355,     0,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,     0,     0,     0,
     365,     0,     0,     0,   366,   367,   368,   369,   370,   354,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,     0,     0,     0,   365,     0,     0,     0,
     366,   367,   368,   369,   370,   354,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,     0,
       0,     0,   365,     0,     0,     0,   366,   367,   368,   369,
     370,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,     0,     0,     0,   365,     0,
       0,     0,   366,   367,   368,   369,   370,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,     0,     0,     0,   365,     0,     0,     0,   366,   367,
     368,   369,   370,   354,   355,     0,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,     0,     0,     0,
     365,     0,     0,     0,   366,   367,   368,   369,   370,     0,
       0,     0,     0,     0,     0,     0,   371,     0,     0,  1476,
       0,     0,     0,   354,   355,     0,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,     0,     0,     0,
     365,     0,   371,     0,   366,   367,   368,   369,   370,   354,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,     0,     0,     0,     0,   365,     0,     0,   371,
     366,   367,   368,   369,   370,   354,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,     0,
       0,     0,   365,     0,     0,   371,   366,   367,   368,   369,
     370,   354,   355,     0,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,     0,     0,     0,     0,   365,     0,
       0,   371,   366,   367,   368,   369,   370,   354,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
       0,     0,     0,     0,   365,     0,     0,   371,   366,   367,
     368,   369,   370,   354,   355,     0,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,     0,     0,     0,     0,
     365,     0,     0,   371,   366,   367,   368,   369,   370,     0,
       0,     0,     0,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,   371,
       0,     0,     0,     0,  2486,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,  1477,
       0,     0,     0,     0,     0,     0,     0,     0,   372,   371,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
       0,     0,     0,     0,     0,     0,   924,     0,     0,     0,
       0,     0,     0,     0,   372,   371,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,     0,     0,     0,
       0,     0,  1207,     0,     0,     0,     0,     0,     0,     0,
     372,   371,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,     0,     0,     0,     0,     0,  1306,     0,
       0,     0,     0,     0,     0,     0,   372,   371,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,     0,
       0,     0,     0,     0,  1307,     0,     0,     0,     0,     0,
       0,     0,   372,   371,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,     0,     0,     0,     0,   372,   371,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
       0,     0,     0,     0,     0,     0,  1363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   372,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
       0,     0,     0,     0,     0,     0,  1433,     0,     0,     0,
       0,     0,     0,     0,   372,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,     0,     0,     0,
       0,     0,  1448,     0,     0,     0,     0,     0,     0,     0,
     372,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,     0,     0,     0,     0,     0,  1481,     0,
       0,     0,     0,     0,     0,     0,   372,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,     0,     0,
       0,     0,     0,     0,  1482,     0,     0,     0,     0,     0,
       0,     0,   372,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,     0,     0,     0,     0,     0,     0,
    1486,     0,     0,     0,     0,     0,     0,     0,   372,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
       0,     0,     0,     0,   354,   355,  1487,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,     0,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,     0,     0,     0,     0,     0,     0,   354,   355,
     371,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,   371,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
       0,     0,   371,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   354,
     355,     0,   356,   357,   358,   359,   360,   361,   371,   362,
     363,   364,     0,     0,     0,     0,   365,     0,     0,     0,
     366,   367,   368,   369,   370,   354,   355,     0,   356,   357,
     358,   359,   360,   361,   371,   362,   363,   364,     0,     0,
       0,     0,   365,     0,     0,     0,   366,   367,   368,   369,
     370,   354,   355,     0,   356,   357,   358,   359,   360,   361,
     371,   362,   363,   364,     0,     0,     0,     0,   365,     0,
       0,     0,   366,   367,   368,   369,   370,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   371,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,   371,     0,     0,     0,     0,  1544,     0,     0,
       0,     0,     0,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,  1598,   371,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,  1666,
     371,     0,     0,     0,     0,     0,     0,   372,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,  1770,     0,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   371,     0,     0,     0,     0,
       0,  1780,     0,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   371,     0,     0,     0,     0,     0,  1781,     0,     0,
       0,     0,     0,     0,     0,   372,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   371,     0,     0,
       0,     0,     0,  2041,     0,     0,     0,     0,     0,     0,
       0,   372,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,     0,  2169,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   372,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,   549,     0,     0,     0,
       0,  2231,   550,     0,     0,     0,     0,     0,     0,   372,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,   354,   355,  2317,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,     0,     0,
       0,     0,   365,     0,     0,     0,   366,   367,   368,   369,
     370,     0,     0,     0,   372,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     372,   493,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   372,   792,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,   354,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,     0,     0,     0,
       0,   365,     0,     0,     0,   366,   367,   368,   369,   370,
     354,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,     0,     0,     0,     0,   365,     0,     0,
       0,   366,   367,   368,   369,   370,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   354,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,     0,
       0,     0,     0,   365,     0,     0,     0,   366,   367,   368,
     369,   370,   354,   355,     0,   356,   357,   358,   359,   360,
     361,   371,   362,   363,   364,     0,     0,     0,     0,   365,
       0,     0,     0,   366,   367,   368,   369,   370,   354,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,     0,     0,     0,     0,   365,     0,     0,     0,   366,
     367,   368,   369,   370,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   371,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     371,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   371,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     372,   801,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   371,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   371,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   371,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   372,   941,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   372,
    1331,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   372,  1556,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   372,  2258,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,     0,     0,     0,     0,     0,  1629,     0,
    -306,     0,     0,     0,  -306,  -306,  1630,   372,  2386,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   372,    14,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,  -306,  -306,  1631,     0,  -306,
    -306,  -306,  1632,     0,     0,  -306,     0,     0,  1633,     0,
       0,     0,     0,     0,     0,  -751,     0,     0,     0,     0,
    -306,  1634,     0,     0,     0,  1635,     0,     0,  1636,     0,
    -306,  -306,  -306,  -306,     0,     0,  -306,     0,  -306,  -306,
       0,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
       0,     0,     0,     0,  1637,  1638,  -306,  -306,  -306,  -306,
       0,     0,  -306,  -306,  -306,  -306,  -306,     0,     0,  1639,
    -306,     0,     0,  -306,  -306,     0,    18,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  1640,     0,     0,  -306,
       0,     0,     0,  -306,  -306,  -306,  -306,     0,     0,     0,
       0,     0,     0,     0,     0,  1641,  -306,  -306,  -306,     0,
    1642,  1643,  -306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -306,  -306,     0,  -306,  -306,  -306,  -306,
       0,     0,     0,     0,     0,  -306,     0,  -306,     0, -1099,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -751,     0,  -751,     0,     0,  -306,
       0,     0,     0,     0,  -306,     0,     0,     0,     0,     0,
    1629,   702,  -306,  -306,  -306,     0,  -306,  -306,  1630,  -306,
       0,  1644,     0,     0,     0,     0,     0,  -306,     0,     0,
       0,     0,     0,     0,     0,  -306,     0,     0,  -306,  -306,
       0,  -306,  -306,  -306,     0,     0,    14,     0,     1,     2,
       0,  -306,  -306,     0,     0,    24,     0,  -306,  -306,  1631,
       0,  -306,  -306,  -306,  1632,     0,     0,  -306,     0,     0,
    1633,     0,     0,     0,     0,     0,     0,  -750,     0,     0,
       0,     0,  -306,  1634,     0,     0,     0,  1635,     0,     0,
    1636,     0,  -306,  -306,  -306,  -306,     0,  -306,  -306,     0,
    -306,  -306,     0,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,     0,     0,     0,     0,  1637,  1638,  -306,  -306,
    -306,  -306,     0,     0,  -306,  -306,  -306,  -306,  -306,     0,
       0,  1639,  -306,     0,     0,  -306,  -306,     0,    18,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  1640,     0,
       0,  -306,     0,     0,     0,  -306,  -306,  -306,  -306,     0,
       0,     0,     0,     0,     0,     0,  -306,  1641,  -306,  -306,
    -306,     0,  1642,  1643,  -306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -306,  -306,     0,  -306,  -306,
    -306,  -306,     0,     0,     0,     0,     0,  -306,     0,  -306,
       0, -1099,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -750,     0,  -750,     0,
       0,  -306,     0,     0,     0,     0,  -306,     0,     0,     0,
       0,     0,  1629,   702,  -306,  -306,  -306,     0,  -306,  -306,
    1630,  -306,     0,  1644,     0,     0,     0,     0,     0,  -306,
       0,     0,     0,     0,     0,     0,     0,  -306,     0,     0,
    -306,  -306,     0,  -306,  -306,  -306,     0,     0,    14,     0,
       1,     2,     0,  -306,  -306,     0,     0,    24,     0,  -306,
    -306,  1631,  1704,  -306,  -306,  -306,  1632,     0,     0,  -306,
       0,     0,  1633,     0,     0,     0,  -765,     0,     0,     0,
       0,     0,     0,     0,  -306,  1634,     0,     0,     0,  1635,
       0,     0,  1636,     0,  -306,  -306,  -306,  -306,     0,  -306,
    -306,     0,  -306,  -306,     0,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,     0,     0,     0,     0,  1637,  1638,
    -306,  -306,  -306,  -306,     0,     0,  -306,  -306,  -306,  -306,
    -306,     0,     0,  1639,  -306,     0,     0,  -306,  -306,     0,
      18,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    1640,     0,     0,  -306,     0,     0,     0,  -306,  -306,  -306,
    -306,     0,     0,     0,     0,     0,     0,     0,  -306,  1641,
    -306,  -306,  -306,  -765,  1642,  1643,  -306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -306,  -306,     0,
    -306,  -306,  -306,  -306,     0,     0,     0,     0,     0,  -306,
       0,  -306,     0, -1099,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -306,     0,     0,     0,     0,  -306,     0,
       0,     0,     0,     0,  1629,   702,  -306,  -306,  -306,     0,
    -306,  -306,  1630,  -306,     0,  1644,     0,     0,     0,     0,
       0,  -306,     0,     0,     0,     0,     0,     0,     0,  -306,
       0,     0,  -306,  -306,     0,  -306,  -306,  -306,     0,     0,
      14,     0,     1,     2,     0,  -306,  -306,     0,     0,    24,
       0,  -306,  -306,  1631,  1704,  -306,  -306,  -306,  1632,     0,
       0,  -306,     0,     0,  1633,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -306,  1634,     0,     0,
       0,  1635,     0,     0,  1636,     0,  -306,  -306,  -306,  -306,
       0,  -306,  -306,     0,  -306,  -306,     0,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,     0,     0,     0,     0,
    1637,  1638,  -306,  -306,  -306,  -306,     0,     0,  -306,  -306,
    -306,  -306,  -306,     0,     0,  1639,  -306,     0,     0,  -306,
    -306,     0,    18,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  1640,     0,     0,  -306,     0,     0,     0,  -306,
    -306,  -306,  -306,     0,     0,     0,     0,     0,     0,     0,
    -306,  1641,  -306,  -306,  -306,  -766,  1642,  1643,  -306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -306,
    -306,     0,  -306,  -306,  -306,  -306,     0,     0,     0,     0,
       0,  -306,     0,  -306,     0, -1099,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -306,     0,     0,     0,     0,
    -306,     0,     0,     0,     0,     0,  1629,   702,  -306,  -306,
    -306,     0,  -306,  -306,  1630,  -306,     0,  1644,     0,     0,
       0,     0,     0,  -306,     0,     0,     0,     0,     0,     0,
       0,  -306,     0,     0,  -306,  -306,     0,  -306,  -306,  -306,
       0,     0,    14,     0,     1,     2,     0,  -306,  -306,     0,
       0,    24,     0,  -306,  -306,  1631,  1704,  -306,  -306,  -306,
    1632,     0,     0,  -306,     0,     0,  1633,     0,     0,     0,
    -766,     0,     0,     0,     0,     0,     0,     0,  -306,  1634,
       0,     0,     0,  1635,     0,     0,  1636,     0,  -306,  -306,
    -306,  -306,     0,  -306,  -306,     0,  -306,  -306,     0,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,     0,     0,
       0,     0,  1637,  1638,  -306,  -306,  -306,  -306,     0,     0,
    -306,  -306,  -306,  -306,  -306,     0,     0,  1639,  -306,     0,
       0,  -306,  -306,     0,    18,  -306,  -306,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  1640,     0,     0,  -306,     0,     0,
       0,  -306,  -306,  -306,  -306,     0,     0,     0,     0,     0,
       0,     0,  -306,  1641,  -306,  -306,  -306,     0,  1642,  1643,
    -306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -306,  -306,     0,  -306,  -306,  -306,  -306,     0,     0,
       0,     0,     0,  -306,     0,  -306,     0, -1099,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -306,     0,     0,
       0,     0,  -306,     0,     0,     0,     0,     0,  1629,   702,
    -306,  -306,  -306,     0,  -306,  -306,  1630,  -306,     0,  1644,
       0,     0,     0,     0,     0,  -306,     0,     0,     0,     0,
       0,     0,     0,  -306,     0,     0,  -306,  -306,     0,  -306,
    -306,  -306,     0,     0,    14,     0,     1,     2,     0,  -306,
    -306,     0,     0,    24,     0,  -306,  -306,  1631,  1761,  -306,
    -306,  -306,  1632,     0,     0,  -306,     0,     0,  1633,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -306,  1634,     0,     0,     0,  1635,     0,     0,  1636,     0,
    -306,  -306,  -306,  -306,     0,  -306,  -306,     0,  -306,  -306,
       0,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,  -306,
       0,     0,     0,     0,  1637,  1638,  -306,  -306,  -306,  -306,
       0,     0,  -306,  -306,  -306,  -306,  -306,     0,     0,  1639,
    -306,     0,     0,  -306,  -306,     0,    18,  -306,  -306,  -306,
    -306,  -306,  -306,  -306,  -306,  -306,  1640,     0,     0,  -306,
       0,     0,     0,  -306,  -306,  -306,  -306,     0,     0,     0,
       0,     0,     0,     0,  -306,  1641,  -306,  -306,  -306,     0,
    1642,  1643,  -306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -306,  -306,     0,  -306,  -306,  -306,  -306,
       0,     0,     0,     0,     0,  -306,     0,  -306,     0, -1099,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -306,
       0,     0,     0,     0,  -306,     0,     0,     0,     0,     0,
       0,   702,  1711,  -306,  -306,     0,     0,     0,     0,  -306,
       0,  1644,     0,     0,     0,     0,     0,  -306,     0,     0,
       0,     0,     0,     0,     0,  -306,     0,     0,  -306,  -306,
       0,  -306,  -306,  -306,     0,     0,     0,     0,     1,     2,
       0,  -306,  -306,     0,     0,    24,     0,  1712,  1713,     0,
       0,  1714,  1715,  1716,     0,     0,     0,  1717,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   955,     0,  -235,     0,     0,     0,  -235,  -235,
       0,     0,  1718,  1719,  1720,     0,     0,  -306,   104,     0,
     105,  1721,     0,  1722,  1723,  1724,  1725,  1726,  1727,  1728,
       0,  1729,     0,     0,     0,     0,     0,     0,  1730,     0,
       0,     0,     0,     0,  1731,  1732,  1733,  1734,  1735,     0,
       0,     0,  1736,     0,     0,  1379,  1380,     0,     0,     0,
    1737,  1738,  1739,  1381,  1382,  1383,  1384,  1385,     0,     0,
       0,  1386,     0,     0,     0,  1387,  1388,  1740,  1741,  -165,
       0,     0,     0,     0,     0,     0,  -306,  -235,     0,     0,
       0,     0,     0,    77,     0,    78,     0,     0,     0,    79,
      80,   428,     0,     0,     0,     0,     0,  -306,  -306,     0,
       0,  -235,  -235,  -235,     0,  1389,  1390,     0,  1742,  1743,
    1744,    -9,     0,     0,     0,     0,     0,     0,     0,     0,
    -165,  -235,     0,     0,     0,     0,     0,    14,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1745,     0,     0,     0,
    -235,  -235,     0,     0,     0,     0,   109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    81,   110,
       0,     0,     0,     0,     0,     0,  -306,   571,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -235,
       0,  -235,    82,    83,    84,   956, -1097,     0,     0,     0,
    -306,  -306,  -306,     0,   432,   -23,     0,     0,     0,     0,
    -306,  -306,    85,  -235,     0,     0,     0,   957,     0,     0,
    -306,     0,     0,     0,     0,     0,     0,  -235,     0,     0,
       0,     0,   958,  -235,     0,     0,     0,     0,     0,  1746,
      14,    86,    87,   959,     0,   960,   961,     0,     0,  -306,
    -306,     0,  -235,  -235,     0,   962,  -235,  -235,     0,     0,
       0,     0,     0,     0,     0,     0,  -235,     0,     0,   963,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      88,     0,    62,     0,    89,     0,     0,     0,  -306,  -306,
    -306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    79,    80,     0,    90,     0,     0,     0,  1747,     0,
       0,     0,  -306,  -306,  -306,  -306,     0,     0,    63,     0,
       0,     0,     0,     0,    64,     0,  -306,     0,     0,     0,
       0,    14,  -306,  -306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    65,    91,     0,     0,    92,    93,     0,
       0,  -306,  -306,     0,     0,  -306,  -306,    94,     0,     0,
       0, -1019,  -306,  -306,     0,  -306,     0,   562,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   563,   564,
     565,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   566,   567,    79,    80,     0,     0,
       0,  -306,     0,  -306,    82,    83,   568,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   569,  -306,     0,     0,     0,     0,
      79,    80,     0,     0,     0,     0,     0,     0,     0,  -306,
       0,     0,     0,     0,     0,  -306,     0,     0,     0,     0,
       0,     0,     0,    86,    87,    50,     0,     0,     0,   570,
       0,     0,   562,     0,  -306,  -306,     0,     0,  -306,  -306,
       0,     0,     0,   563,   564,   565,     0,     0,  -306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   566,
     567,     0,    88,     0,    62,     0,   562,     0,     0,    82,
      83,   568,     0,     0,     0,     0,     0,     0,     0,   565,
       0,     0,     0,     0,     0,     0,   108,     0,     0,   569,
       0,     0,     0,     0,   567,     0,     0,     0,     0,     0,
      63,     0,     0,    82,    83,   568,    64,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    86,    87,
      50,     0,   571,   569,   570,    65,    91,     0,    51,    92,
     111,     0,     0,     0,     0,     0,     0,     0,    23,   112,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    86,    87,    50,     0,     0,    88,   570,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    88,     0,    62,     0,    63,     0,     0,     0,     0,
       0,    64,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   108,     0,   571,     0,     0,
      65,    91,     0,    51,    92,   111,     0,     0,     0,    63,
       0,     0,     0,    23,   112,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    65,    91,     0,    51,    92,   111,
       0,     0,     0,     0,     0,     0,     0,    23,   112
};

static const yytype_int16 yycheck[] =
{
      10,   561,    16,   119,    36,   258,    20,   183,   711,    23,
     711,    15,   412,  1275,    18,    23,   181,   182,    22,   599,
      30,    53,    36,    20,    10,   658,   759,   423,    36,    96,
     146,  1068,   417,    23,    36,   708,   841,  2033,     0,    53,
      23,  1078,     4,     3,    30,    53,    36,   223,    10,  1581,
       1,    10,     3,    36,    10,   748,    79,   750,   751,   752,
     842,     3,    10,    53,  1509,     3,     3,  1512,    30,     3,
      53,    30,  1517,     1,    30,  1638,    90,     3,     3,    19,
      38,     3,    30,    12,    37,    65,    37,   154,   155,   156,
    1834,  1835,  1836,   116,   108,     3,     3,  1841,     3,  1823,
       3,     3,     3,     3,  1823,  1613,     1,    10,   131,     1,
      99,     1,    37,     3,   118,   291,     1,   121,     1,   295,
       3,     1,  1654,     3,  1656,     0,     3,    17,    18,     1,
       3,  1054,     3,    84,    85,    37,     3,     3,  1583,     3,
       3,   164,    38,   166,     1,    77,    66,   547,     3,   100,
       3,    17,    18,    78,     3,    12,     3,    14,    37,     6,
       3,     3,     3,     6,     6,    12,     3,    14,     3,    12,
      12,    14,    14,  1167,   184,   185,   186,    66,   543,  1869,
     580,  1097,   815,     3,   718,     3,     6,  1810,  1327,  1752,
    1753,   765,    12,    37,    14,   591,  1886,   979,    17,    18,
      60,    17,    18,    37,   129,  1799,    37,   217,   218,   219,
     220,   221,    86,  1880,    37,     1,   226,   227,    37,  1752,
     243,  1704,    11,    12,    13,  1806,    12,   412,  1666,    68,
     240,  1975,    34,    35,    34,    35,   110,   111,   112,  1450,
    1022,    34,    35,  1651,   956,   957,  1852,     3,   910,    66,
       3,     7,   275,   276,   277,  1037,   130,   241,   741,    36,
      29,    30,    31,   975,    87,     3,   419,    36,   252,   394,
    1778,    37,   755,   283,   427,   285,    84,    85,  1761,   422,
     264,   457,   394,   843,   427,    71,   846,  1665,  1666,  1220,
    1896,   405,   100,    37,   278,   996,    37,    19,    20,    36,
      38,  1295,  1865,  1297,  1298,   161,   761,    29,    30,    31,
     435,   711,  1935,   427,    36,   161,   176,  1010,  1457,   179,
     496,     3,   182,   435,    65,    78,  1889,  1890,    72,     0,
    1893,  2021,  1770,   267,  1545,   269,   346,   347,   348,   704,
       3,   915,  1923,  1751,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,  2028,   372,  1896,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,  1937,   771,   129,   267,   217,   269,
     219,  1944,   865,  1016,   248,     6,  1980,   267,  1982,   269,
      37,   265,  1770,    84,    85,   580,   271,   272,   412,   245,
    1112,   267,  1910,   269,   412,    78,    78,  1080,   264,   100,
     245,  1550,  1085,  1344,    77,   429,   239,   240,   264,   101,
     430,   429,   412,   433,   879,   405,  1127,  1421,     3,     6,
     248,  1064,   405,   888,   423,   588,   589,   590,   427,   429,
     840,    37,    37,   619,   899,   900,   429,    37,   982,   983,
     258,   461,   418,  1126,   427,   417,   129,   129,   418,  2183,
    2023,  1377,  1378,    38,  2183,   431,  2210,  2211,    64,   427,
     423,   431,   423,   424,   427,    65,   427,    72,   429,   358,
     418,    78,   422,   412,  1415,   405,   418,   424,   428,   431,
     424,  2487,   429,   431,   422,   423,  1169,   425,   423,   427,
     428,  2033,   427,   429,   429,   427,  1311,   436,   437,   438,
     418,   418,     1,   413,     3,  1320,   405,   425,     7,   424,
     422,   423,   425,   418,   425,   427,   418,   422,  1310,  1566,
    1567,   427,   129,   547,   424,   418,   421,  1319,   418,   547,
     995,  2285,  1122,  2287,   424,   422,   418,   418,  2031,   422,
     422,   431,     3,   567,   568,   422,   570,   547,   424,   422,
     568,   418,   576,   418,   413,   418,   580,   258,   576,   418,
     567,   418,   580,   570,   405,   418,   418,   418,   568,   423,
      10,   418,  1498,   427,   418,   568,   576,  1249,   405,  1251,
     580,   425,   358,   576,   759,   429,   422,    86,   418,   418,
      30,  1056,   418,   405,     3,   405,   425,  2351,  2352,   425,
     429,   426,   405,   429,  2177,  2178,    87,  2180,   404,  2182,
     435,   110,   111,   412,   426,   411,   426,   413,  1301,   415,
    2113,  1562,    12,   435,   427,   435,   413,   414,   415,    37,
       3,   130,   411,   412,   413,   414,   415,   405,   418,   100,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,    67,
     159,   160,     6,   431,   411,   412,   413,   414,   415,    37,
    1693,   170,   171,  1696,   394,  1616,   753,   409,   410,   411,
     412,   413,   414,   415,  1274,   332,     3,   711,   100,   183,
     732,   185,   339,   711,    18,   870,  1339,  1340,    22,   198,
     875,   200,   735,   878,   728,     3,    21,   882,   732,   426,
     728,   711,   745,  1356,   732,   435,  1459,    32,   435,    87,
     732,   422,   423,  1434,   181,   182,   427,   100,   728,  1135,
     754,   394,   732,     1,   421,     3,   754,   236,  1449,   732,
     427,   153,     1,   242,     3,   765,   158,  1430,    87,   406,
     407,   408,   340,    85,   754,   343,   340,     3,   239,   240,
      37,   754,   261,   351,    94,   421,   428,   351,   100,   765,
    1747,   427,   435,  2315,  2316,  1752,  1753,    37,   314,   315,
     112,   241,   112,    37,   181,   182,  1693,   375,    65,  1696,
      67,   375,   252,   765,   118,    72,   765,   121,   418,   765,
     336,  1068,   822,   823,   264,   425,    21,   765,   344,   429,
      87,  1078,    15,    16,    17,    18,   840,    32,   842,    79,
      80,   357,   840,  2346,   842,    15,    16,    17,    18,    19,
    2353,   864,  2355,   346,    93,   414,   202,  1520,  1521,   352,
     840,   405,   842,   422,   103,   105,   106,   304,   305,   306,
    1315,   387,    84,    85,  1029,   422,  1321,  1322,  1323,  1324,
    1325,  1326,   426,   421,   124,   125,   126,   127,   100,   427,
    1335,   239,   240,   418,   331,   917,   333,   334,   335,   336,
     425,   411,   412,   143,   144,  2408,  2409,     7,   422,  1912,
     424,  1914,   349,   917,   351,   915,    88,   427,    90,   917,
     239,   240,   170,   171,   421,   917,   421,   304,   305,   306,
     427,  1594,   427,  1890,    11,  1938,    13,   917,  1601,   915,
    1943,    86,  1665,  1666,   917,  1439,   425,  1630,  1442,   121,
    1444,   425,   952,     3,   331,   429,   333,   334,   335,   336,
    1643,   418,     1,   915,     3,  2487,   915,   112,   425,   915,
     974,    83,   349,    85,   351,   979,   974,   915,   421,   418,
     418,   979,   239,   240,   427,   998,    86,   425,   100,  1712,
    1435,   282,  1437,   422,   974,  1718,   972,     3,   427,   979,
     112,   974,     3,  1916,    10,  1450,   422,     3,  2443,   425,
     110,   111,  1255,   429,  1257,   160,    84,    85,  1022,  1742,
    1743,  1744,  1745,   972,  1022,  1029,  1913,  1402,  1915,  2464,
     130,  1029,   100,  1037,   404,   405,     1,   418,     3,  1037,
     422,   411,  1022,   413,   425,   415,   428,  1770,   429,  1029,
      12,   425,  1939,   198,   428,   200,  1029,  1037,  1945,   159,
     160,   498,   499,   500,   271,   272,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,    86,   405,  1532,  1533,  1093,
     421,   236,   422,  1538,    80,   425,   427,   242,   198,   429,
     200,  1651,  1547,  1548,   421,    12,  1093,   422,  2360,  1113,
     427,   112,   427,  2140,   422,  1113,   261,     3,    79,   427,
     106,   498,   499,   500,  1118,   314,   315,   418,    11,    12,
      13,   422,   106,  1113,   425,   203,   236,   421,   429,   125,
    1113,   127,   242,   427,   105,  1808,   421,   336,   304,   305,
     306,   125,   427,   127,   421,   183,   224,   185,   144,   160,
     427,   261,  1607,   124,     3,   126,   234,   105,   357,    12,
     144,   422,   423,    17,    18,   331,   427,   333,   334,   335,
     336,   422,   143,   423,   422,   421,   124,   427,   126,   427,
     258,   427,     3,   349,   421,   351,   421,   198,   387,   200,
     427,   421,   427,   422,   422,   143,   422,   427,   427,   427,
    1903,  1902,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     1,   422,     3,  1669,   395,   396,   397,   398,   399,
     400,   401,   402,   403,  1897,   236,  1712,     1,   422,     3,
       3,   242,  1718,   427,     7,   428,   425,   422,    37,  2162,
    1493,   241,   427,  1275,   422,     1,   422,     3,   428,   427,
     261,   427,   252,    46,   254,   255,  1742,  1743,  1744,  1745,
    1270,  1275,     3,   422,   264,   422,   422,  1275,   427,   424,
     427,   427,   422,   422,  2197,   422,   422,   427,   427,  2202,
     427,  2390,     1,   422,     3,  1275,  2395,  2396,   427,  2398,
     422,  2400,  1275,  1986,  1459,   427,  1310,  2406,  2407,   422,
     170,   171,  1310,   422,   427,  1319,   105,   106,   427,   422,
     422,  1319,   759,   422,   427,   427,   422,  1327,   427,   422,
    1310,   427,   170,   171,   427,   124,   125,   126,   127,  1319,
     422,   422,   498,   499,   500,   427,   427,   422,    17,    18,
    2449,   422,   427,  2452,   143,   144,   427,  2456,  2457,   423,
     422,   422,   422,   427,  1754,   427,   427,   427,  1372,   425,
    1392,   422,   428,  1395,  1997,  1397,   427,  2290,   422,  1769,
     248,   422,   759,   427,   422,  1372,   427,    12,  1392,   427,
     422,  1395,     3,  1397,  1392,   427,  1562,  1395,     3,  1397,
    1392,  2314,   422,  1395,   422,  1397,   422,   427,   422,   427,
     425,   427,  1392,   427,   429,  1395,     1,  1397,     3,  1392,
    2333,  2334,  1395,   424,  1397,   422,  2339,  2340,  2341,  2342,
     427,    17,    18,   870,  2347,  2348,  2349,  2350,   875,   422,
       3,   878,   404,   405,   427,   882,     1,   422,     3,   411,
    1402,   413,   427,   415,   422,   425,   422,  1457,   428,   427,
    1905,   427,  1907,  1908,   422,   422,   422,   422,   422,   427,
     427,   427,   427,   427,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   870,   422,   422,   428,   404,   875,   427,
     427,   878,   422,   427,   411,   882,   413,   427,   415,   422,
    1665,  1666,  2425,  1903,   427,   178,   425,  2430,   422,   428,
     429,  2434,  2435,   427,   423,    37,   428,    39,   427,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   423,   423,
    1550,   423,   427,   427,   418,   427,   423,  1712,   422,   422,
     427,   404,   405,  1718,  1577,  1578,  1579,   423,   411,   423,
     413,   427,   415,   427,   423,  1248,   423,  1250,   427,  2242,
     427,  1581,   423,  1336,     3,  1338,   427,  1742,  1743,  1744,
    1745,   422,  1029,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   418,    79,    80,  1770,   422,   422,   418,   422,
      19,    20,   422,    22,    23,    24,    25,    26,    27,     3,
      29,    30,    31,     7,   423,   421,   422,    36,   427,   105,
     106,  1635,  1642,    42,    43,    44,  1801,   423,   418,   423,
     422,   427,  1029,   427,  1654,   424,  1656,   424,   124,   125,
     126,   127,   435,   423,   418,   423,  1688,   427,   422,   427,
    1692,  2221,   421,   422,     1,   423,     3,   143,   144,   427,
       7,   423,   423,   423,   423,   427,   427,   427,   427,  1702,
     423,   423,   422,  1693,   427,   427,  1696,  1719,  1720,   423,
    1806,   426,   427,   427,  1704,  1811,  1728,  1707,   423,  2154,
     423,    46,   427,   423,   427,  1719,  1720,   427,    37,   423,
     426,  1719,  1720,   427,  1728,   423,   429,  1719,  1720,   427,
    1728,   423,     3,  1755,   423,   427,  1728,   423,   427,  1719,
    1720,   427,   426,   427,   435,   423,  1719,  1720,  1728,   427,
    1754,  1755,   426,   427,   418,  1728,  1754,  1755,   418,    86,
     418,  1761,   418,  1755,   423,  1769,   423,   426,   113,   426,
     425,  1769,   418,   428,  1754,  1755,   418,   843,   123,   404,
     846,   418,  1755,   110,   111,   418,   411,   412,   413,  1769,
     415,   430,  1313,  1314,   433,  1264,  1265,  2315,  2316,  2028,
    2029,   418,  1824,   130,  1164,  1165,   418,   435,   418,   418,
    1810,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     418,   418,   159,   160,     7,     8,   418,   418,   183,   418,
     418,   418,   418,   170,   171,  1951,   418,   418,   418,  1871,
     418,   112,    72,     5,   423,     3,     7,   424,   424,   423,
     422,     3,   418,  2308,  2309,  1887,   424,   424,   429,   418,
       3,   198,   418,   200,   225,    67,   418,   222,   223,     3,
       3,   422,   422,  1887,   427,   424,  2052,   424,  1888,  1887,
     424,     3,  1892,     3,   418,  1887,  2051,   428,   428,  1903,
     428,   428,   428,     7,   429,  1903,   426,  1887,   418,   236,
     234,   256,   423,    86,  1887,   242,    89,     7,    91,   422,
     428,   266,   405,  1903,   423,     3,     3,   429,   422,     5,
     422,   422,   422,   422,   261,  1935,     3,   110,   111,   112,
       3,  1941,     3,     5,    36,   423,   291,   431,     8,   418,
     295,   423,   427,     3,     3,     3,   427,   130,   422,   422,
     422,   422,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   159,   160,  2001,   422,
      72,   423,     3,  2006,   428,   422,   422,   170,   171,   422,
     422,  2167,    46,   421,   418,   418,   422,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   405,   405,    85,
      67,   422,  1459,     3,   422,   198,     3,   200,   373,   128,
       3,  2031,   428,  2033,   418,   418,   418,   418,   418,   418,
     418,   386,   418,   418,   429,   422,   391,   183,     3,   222,
     422,   422,   218,   426,   421,   101,    37,   422,   205,  2059,
     214,   205,     3,   236,   237,     3,   422,   428,    69,   242,
     428,     3,   422,   422,   428,     3,   422,   250,   422,   424,
     145,     3,  1459,   424,   423,   428,   181,   182,   261,   262,
       3,   425,   265,   266,     3,     3,   422,     1,   425,   422,
       3,    85,   275,    71,    71,   423,    72,   428,     3,   423,
     455,   428,   457,  2113,  2114,   423,   418,   423,   425,   423,
     423,    19,    20,   418,    22,    23,    24,    25,    26,    27,
     423,    29,    30,    31,   418,   418,   422,   422,    36,   418,
      86,     3,   405,    67,    42,    43,    44,   422,   493,   422,
     495,   496,     3,   422,   422,   421,   428,   422,   418,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   418,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   422,   405,   426,   539,     3,     3,   292,     3,     3,
       3,    67,   418,   422,   549,    69,   405,   422,   422,   304,
     305,   306,   422,  2226,   422,  2228,    64,    64,    64,   423,
     426,     3,   422,   424,   177,   422,   422,     3,  1665,  1666,
     423,     3,     3,   428,   405,   421,   331,   421,   333,   334,
     335,   336,    65,   405,   422,   422,     3,   423,   423,   432,
     422,   425,   425,   422,   349,     5,   351,   352,   421,   418,
     245,     3,   423,   423,    64,   423,   611,     1,   423,   422,
      38,     3,   422,   422,   619,  1712,   422,   422,   418,   418,
     418,  1718,   423,   418,   418,   422,    67,   632,  1665,  1666,
     422,   422,    70,   162,   639,     3,  2296,   642,   643,   644,
       3,   431,   192,    64,   422,  1742,  1743,  1744,  1745,   423,
     126,   127,   423,   658,   423,  2315,  2316,   423,   134,   135,
     136,   137,   138,   428,   427,   427,   142,   427,     3,   427,
     146,   147,   677,  1770,   427,  1712,    70,   418,  2360,   427,
      70,  1718,   422,   418,   418,   418,   418,    81,    82,   418,
     695,   696,   697,   423,   418,   423,  2360,   428,   453,   418,
     418,   418,  2360,   418,  1801,  1742,  1743,  1744,  1745,   422,
     186,   187,   717,   718,   719,   418,   418,   418,     3,    65,
    2360,   418,    33,   428,   423,   423,     3,  2360,   251,   123,
     126,   127,   427,  1770,     3,     3,    65,   423,   134,   135,
     136,   137,   138,   498,   499,   500,   142,   428,   423,   422,
     146,   147,   422,   422,   428,   427,   150,   151,   152,   153,
     154,   155,   156,   157,  1801,   428,   425,   423,     1,   422,
       3,     4,   166,   167,   168,   169,     5,     3,   172,   173,
     174,   175,   418,   422,    17,    18,     3,   792,   422,   794,
     186,   187,   422,   422,   418,   800,   801,   422,     3,     3,
      67,   423,   807,   423,   423,   423,   423,   423,     3,   423,
     815,   423,    45,   423,   423,   423,   427,    50,    51,     3,
     425,     3,    55,    56,    57,   427,    59,  2487,   427,    62,
     427,   427,   427,   427,   427,     3,   427,   427,   427,   405,
     427,    74,    75,    76,    77,   428,   427,   422,    81,   407,
     408,   409,   410,   411,   412,   413,   414,   415,  1955,  1956,
    1957,  1958,  1959,  1960,  1961,  1962,   428,    65,   429,   418,
     625,  1968,  1969,  1970,  1971,    47,   423,   425,     5,    65,
     113,   114,   418,   429,     3,   890,   423,    19,    20,   423,
      22,    23,    24,    25,    26,    27,    62,    29,    30,    31,
     427,   422,   422,   418,    36,     3,   423,   231,   141,   427,
      42,   427,   145,   389,   427,   427,   418,   922,  1955,  1956,
    1957,  1958,  1959,  1960,  1961,  1962,   427,   427,   427,   126,
     127,  1968,  1969,  1970,  1971,   427,   941,   134,   135,   136,
     137,   138,   427,   423,   428,   142,     3,     0,   423,   146,
     147,    47,   423,   427,  2051,     3,   422,     3,   428,   192,
     422,   418,   423,   422,    19,    20,   199,    22,    23,    24,
      25,    26,    27,   427,    29,    30,    31,   982,   983,   427,
     213,    36,   427,   427,    37,     3,   423,   422,   418,   186,
     187,   418,    30,   389,  2091,   966,   229,   423,   423,  1004,
     423,   423,   418,   423,   759,   423,  2153,   422,  1013,   422,
    1015,  1016,   423,   422,  2051,   422,   422,   422,  1023,  1024,
    1025,  1415,   423,   423,   418,    78,   259,   394,   423,  1614,
     423,  1344,   423,  1038,   267,  1040,   269,  1042,  1043,  1044,
     423,   423,   423,   423,   422,   422,   422,   422,   101,   957,
    1993,   104,  1057,  2296,  2091,   950,   975,  2301,  2300,  1064,
     574,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,   126,   127,   129,   411,   794,   120,
     125,   771,   134,   135,   136,   137,   138,   426,   800,   285,
     142,  2108,   102,   438,   146,   147,   445,  1769,  2195,  2196,
    1817,  2198,  2199,  2200,  2201,   158,  1369,  2167,  2205,  2206,
    2207,  2208,   165,  1270,   869,   870,  1707,  2051,   268,  2016,
     875,   876,  1267,   878,   177,  1935,  2059,   882,   552,  2225,
    1498,  1843,  2077,   740,   186,   187,  2018,  2076,   893,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,   580,   859,   202,
    2102,  1164,  1968,  1969,  1970,  1971,   849,   912,  2195,  2196,
      37,  2198,  2199,  2200,  2201,   744,  1871,  1165,  2205,  2206,
    2207,  2208,  1289,  1526,   725,    -1,  1181,    -1,    -1,    -1,
    2277,  2278,    -1,    -1,    -1,    -1,    -1,    -1,  1193,   422,
      -1,   424,   389,    -1,   247,    -1,    -1,    -1,   431,   432,
      -1,    78,    -1,    -1,    -1,    -1,    -1,  1212,  1213,    -1,
      -1,    -1,    -1,    -1,    -1,  1220,    -1,    -1,   271,   272,
      -1,   274,  1227,  1228,   101,   278,    -1,    -1,    -1,    -1,
      -1,    -1,  2329,    -1,    -1,    -1,    -1,    -1,  1243,  1244,
    2277,  2278,    -1,    -1,    -1,    -1,    37,    -1,  1253,    -1,
      -1,    -1,   129,    -1,  1259,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2080,  2081,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1029,  2091,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   338,    -1,    78,   165,    -1,
      -1,    -1,  2329,    -1,    -1,    -1,    -1,    -1,  1303,    -1,
      -1,    -1,    -1,    -1,  1059,    -1,  2403,  1312,  1313,  1314,
     101,    -1,  1317,    -1,    -1,    -1,    -1,    -1,   371,    -1,
      -1,    -1,    -1,  1328,    -1,   202,  1331,    -1,    -1,    -1,
      -1,  1336,    -1,  1338,  1339,  1340,    -1,   389,   129,  1344,
      -1,   218,    -1,    -1,    -1,  1350,  1351,    -1,    -1,    -1,
    1355,  1356,  1357,    -1,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,  2403,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,  2195,
    2196,    -1,  2198,  2199,  2200,  2201,    -1,    -1,    -1,  2205,
    2206,  2207,  2208,    -1,   271,   272,    -1,   274,    -1,    -1,
      -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1415,   202,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,   218,    -1,    17,
      18,    -1,    -1,    -1,  1439,    -1,    -1,  1442,    -1,  1444,
      28,  1446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    39,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
      -1,  2277,  2278,    -1,    -1,    -1,  1471,    -1,    -1,    -1,
    1475,  1226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     271,   272,    -1,   274,    -1,  1240,    -1,   278,     3,    -1,
    1495,    81,    82,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,  2329,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,   110,   111,   112,    40,    41,    42,    43,    44,
      -1,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,  1544,
      -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1556,    -1,    -1,    -1,    -1,    -1,  1562,    -1,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,    -1,    -1,
      -1,   159,   160,    -1,    -1,    -1,   166,   167,   168,   169,
      -1,    -1,   172,   173,   174,   175,     1,  2403,     3,     4,
      -1,    -1,    -1,  1598,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    -1,    -1,    -1,    -1,  1613,    -1,
     198,  1616,   200,    -1,  1619,  1620,  1621,    -1,    -1,    -1,
      -1,  1626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      55,    56,    57,    -1,    59,    -1,    -1,    62,   236,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   246,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,   267,
      -1,   269,  1687,    -1,    -1,    -1,  1691,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,    -1,    -1,    -1,  1459,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    -1,   312,    -1,   141,    -1,   316,   317,
     145,    -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,
     328,    -1,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,
      -1,    -1,    -1,  1778,    -1,    -1,    -1,   192,   366,   367,
     368,  1786,   370,    -1,   199,    -1,    -1,    -1,   376,    -1,
     378,   379,    -1,    -1,   382,   383,   384,    -1,   213,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1812,    -1,    -1,
      -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,   406,   407,
     408,    -1,    -1,   411,   412,    -1,    -1,    -1,   418,    -1,
     418,    -1,    -1,    -1,    -1,   423,   424,    -1,    -1,   427,
      -1,   429,    -1,    -1,   259,   433,   434,    -1,    -1,    -1,
      -1,    -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,    -1,    -1,    -1,     7,     8,
      -1,    -1,    -1,    -1,    -1,     7,     8,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,  1906,    -1,    -1,    -1,  1910,    -1,    -1,    -1,    -1,
    1665,  1666,   427,    -1,    -1,    -1,    -1,    -1,    -1,  1924,
      -1,  1926,    -1,    -1,    -1,    -1,  1931,    -1,    -1,    -1,
      -1,    -1,    -1,  1688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1946,    -1,    -1,    -1,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,  1712,    -1,    -1,
      -1,   100,    -1,  1718,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,  1742,  1743,  1744,
    1745,   130,  1997,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,  2010,  2011,    -1,    -1,   424,
      -1,    -1,    -1,    -1,    -1,  1770,   431,   432,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,   159,   160,    -1,
      -1,   170,   171,    -1,    -1,    -1,    -1,    -1,   170,   171,
      -1,    -1,    -1,    -1,  2049,    -1,  1801,  2052,    -1,    -1,
       1,  1806,     3,    -1,    -1,    -1,     7,     8,    -1,   198,
      -1,   200,  2067,    -1,    -1,    -1,   198,    -1,   200,  2074,
    2075,    -1,    -1,    -1,    -1,  2080,  2081,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
     222,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,    -1,   242,   236,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,   258,
      -1,    -1,   261,   262,    -1,    -1,   265,   266,    -1,   261,
     262,    -1,    -1,   265,   266,    86,   275,    -1,    -1,    -1,
      -1,    -1,    -1,   275,    -1,    -1,    -1,   279,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,  2167,    -1,  2169,    -1,    -1,    -1,  1923,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,
    2185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,   159,   160,
     161,    -1,    -1,  1968,  1969,  1970,  1971,    -1,    -1,   170,
     171,    -1,  2227,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,  2251,   198,    -1,   200,
      -1,    28,    -1,  2258,    -1,    -1,    -1,  2262,  2263,    -1,
      37,    -1,    39,    -1,    -1,    42,    43,    44,    -1,    -1,
      -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,   425,    -1,    -1,    -1,
      -1,   242,    -1,   425,    -1,    -1,  2051,  2302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2311,    -1,    -1,    86,
     261,   262,    -1,   264,   265,   266,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2328,   275,    -1,    -1,    -1,   279,    -1,
      -1,    -1,    -1,   110,   111,   112,  2091,    -1,    -1,  2344,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2373,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2386,   159,   160,    -1,    -1,    -1,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,  2410,  2411,    -1,    40,    41,
      42,    43,    44,  2418,    -1,  2420,    -1,    -1,  2423,    -1,
      -1,   198,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2438,  2439,    -1,    -1,    -1,    -1,  2444,
    2195,  2196,    -1,  2198,  2199,  2200,  2201,    -1,    -1,    -1,
    2205,  2206,  2207,  2208,    -1,    -1,     1,    -1,     3,   236,
      -1,    -1,     7,     8,    -1,   242,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,   425,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,
     267,    -1,   269,    -1,    -1,    -1,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,  2277,  2278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
     317,    86,    -1,    -1,    -1,   322,   323,   324,   325,   326,
      -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
     347,    -1,    -1,   350,  2329,    -1,    -1,   354,    -1,    -1,
      -1,  2336,    -1,    -1,    -1,   130,    -1,    -1,    -1,   366,
     367,   368,    -1,   370,    -1,    -1,    -1,    -1,    -1,   376,
      -1,   378,   379,   235,    -1,   382,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,   159,   160,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   170,   171,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,    -1,    -1,    -1,  2394,
      -1,   418,    -1,    -1,    -1,    -1,   423,   424,  2403,    -1,
     427,    -1,   429,   198,    -1,   200,   433,   434,     1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,   222,    -1,    -1,
       1,    -1,     3,    -1,    -1,    28,     7,     8,    -1,    -1,
      -1,   236,    -1,    -1,    -1,    -1,    -1,   242,    -1,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,    -1,   261,   262,    -1,    -1,
     265,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     103,    -1,    -1,    -1,    -1,    86,    -1,   110,   111,   112,
      -1,    -1,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,    -1,    -1,   130,    -1,   110,
     111,   112,    -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      -1,    -1,    -1,    -1,    -1,    -1,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   198,    -1,   200,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,    -1,   200,
     425,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   236,    -1,    -1,    -1,    -1,    -1,   242,
      -1,   222,    -1,   246,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   261,   262,
      -1,   242,   265,    -1,   267,    -1,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     261,   262,    -1,    -1,   265,   266,   267,    -1,   269,    -1,
      -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,
     323,   324,   325,   326,    -1,   328,    -1,    -1,    -1,    -1,
     333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,     1,
      -1,   354,    37,    -1,    -1,     7,     8,    -1,    -1,    -1,
      -1,    -1,    -1,   366,   367,   368,    -1,   370,    -1,    -1,
      -1,    -1,    -1,   376,    -1,   378,   379,    -1,    -1,   382,
     383,   384,    -1,    -1,     1,    37,     3,     4,     5,     6,
       7,     8,    -1,    78,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,   406,   407,   408,    -1,    -1,   411,   412,
     413,    28,    -1,    -1,    -1,   418,   101,    -1,    -1,   104,
      -1,   424,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,
     433,   434,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,   129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,   130,    -1,
     165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   177,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,    -1,
      -1,    -1,    -1,   130,    -1,    -1,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,   159,   160,    -1,    36,   198,    -1,   200,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,   247,     3,     4,     5,     6,     7,     8,    -1,
     222,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,   198,    -1,   200,   236,    -1,   271,   272,    28,   274,
     242,    -1,    -1,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,   261,
     262,    -1,   229,   265,   266,    -1,    -1,    -1,    -1,   236,
      -1,    -1,    -1,   275,    -1,   242,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,   262,    86,    -1,   265,    -1,
     267,    -1,   269,   338,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,    -1,    -1,
     130,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
     317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,
      -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,   159,
     160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,   366,
     367,   368,    -1,   370,    -1,    -1,    -1,    -1,   198,   376,
     200,   378,   379,    -1,    -1,   382,   383,   384,    -1,   421,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,    -1,    -1,    -1,
      -1,    -1,  1968,  1969,  1970,  1971,    -1,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,   236,    -1,    -1,    -1,
      -1,   418,   242,    -1,   421,    -1,   246,   424,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   433,   434,    -1,    -1,
      -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    28,   316,   317,    -1,    -1,
      -1,    -1,   322,   323,   324,   325,   326,    -1,   328,    42,
      43,    44,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,
     350,    -1,    -1,   404,   354,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   366,   367,   368,    -1,
     370,    -1,    -1,    86,    -1,   426,   376,    -1,   378,   379,
      93,    -1,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,
     103,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,
      -1,   411,   412,    -1,    -1,    -1,    -1,   130,   418,    -1,
      -1,    -1,    -1,   423,   424,    -1,    -1,   427,    -1,    -1,
      -1,    -1,    -1,   433,   434,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,   160,    -1,  2195,
    2196,    -1,  2198,  2199,  2200,  2201,    -1,    -1,    -1,  2205,
    2206,  2207,  2208,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,   198,    -1,   200,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    60,    -1,    -1,    -1,    -1,   242,
      66,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   261,   262,
      86,    -1,   265,    -1,   267,    -1,   269,    -1,    -1,    -1,
      -1,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,   110,   111,   112,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,
     323,   324,   325,   326,    -1,   328,    -1,    -1,    -1,    -1,
     333,   334,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,
      -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   366,   367,   368,    -1,   370,    -1,    -1,
      -1,    -1,   198,   376,   200,   378,   379,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,
     236,    -1,    -1,    -1,    -1,   418,   242,    -1,    -1,    -1,
     246,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     433,   434,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,
      -1,   267,    -1,   269,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,   235,    -1,    -1,
     316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,
     326,    -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,    -1,   350,     1,    -1,    -1,   354,    -1,
      -1,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     366,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,    -1,
     376,    -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,
       1,    37,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,
     406,   407,   408,    -1,    -1,   411,   412,    28,    -1,    -1,
      -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,   424,    -1,
      -1,    42,    43,    44,    -1,    -1,    -1,   433,   434,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
      -1,    -1,    -1,   159,   160,    -1,    -1,    -1,    -1,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,   159,   160,
      -1,    36,   198,    -1,   200,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,    -1,   222,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,   198,    -1,   200,
     236,    -1,    -1,    -1,    28,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    -1,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,
     266,    -1,    -1,    -1,    -1,   236,    60,    -1,    -1,   275,
      -1,   242,    66,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     261,   262,    86,    -1,   265,    -1,   267,    -1,   269,    -1,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   316,   317,    -1,    -1,    -1,
      -1,   322,   323,   324,   325,   326,    -1,   328,    -1,    -1,
      -1,    -1,   333,   334,    -1,   159,   160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,   350,
      -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    -1,    -1,   366,   367,   368,    -1,   370,
      -1,    -1,    -1,    -1,   198,   376,   200,   378,   379,    -1,
      -1,   382,   383,   384,    -1,   421,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,    -1,
     411,   412,   236,    -1,    -1,    -1,    -1,   418,   242,    -1,
      -1,    -1,   246,   424,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   433,   434,    -1,    -1,    -1,   261,   262,    -1,
      -1,   265,    -1,   267,    -1,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    28,   316,   317,    -1,    -1,    -1,    -1,   322,   323,
     324,   325,   326,    -1,   328,    42,    43,    44,    -1,   333,
     334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   347,    -1,    62,   350,    -1,    -1,   404,
     354,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   366,   367,   368,    -1,   370,    -1,    -1,    86,
      -1,   426,   376,    -1,   378,   379,    -1,    -1,   382,   383,
     384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,    -1,
      -1,    -1,    -1,   130,   418,    -1,    -1,    -1,    -1,    -1,
     424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,   198,    -1,   200,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      60,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,   262,    86,    -1,   265,    -1,
     267,    -1,   269,    -1,    -1,    -1,    -1,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
     110,   111,   112,    -1,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
     317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,
      -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,   159,
     160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,
     367,   368,    -1,   370,    -1,    -1,    -1,    -1,   198,   376,
     200,   378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,   236,    -1,    -1,    -1,
      -1,   418,   242,    -1,     3,    -1,   246,   424,     7,     8,
      -1,    -1,    -1,    -1,    -1,   432,   433,   434,    -1,    -1,
      -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,   235,    -1,    -1,   316,   317,    -1,    -1,
      -1,    -1,   322,   323,   324,   325,   326,    86,   328,    -1,
      -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,
     350,   110,   111,   112,   354,    -1,    -1,     7,     8,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   366,   367,   368,    -1,
     370,   130,    -1,    -1,    -1,    -1,   376,    -1,   378,   379,
      -1,    -1,   382,   383,   384,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,    14,
     159,   160,    17,    18,    -1,    -1,   406,   407,   408,    -1,
      -1,   411,   412,    28,    -1,    -1,    -1,    -1,   418,    -1,
      -1,    -1,    -1,    -1,   424,    -1,    -1,    42,    43,    44,
      -1,    -1,    -1,   433,   434,    -1,    86,    -1,    -1,   198,
      -1,   200,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     130,    -1,   404,   242,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,   261,   262,    -1,   427,   265,   266,    -1,   159,
     160,    -1,    -1,    -1,    -1,   130,   275,    -1,    -1,    -1,
     170,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,   159,   160,    -1,    36,   198,    -1,
     200,    40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,    -1,   222,    11,    12,    13,    14,    -1,    -1,    17,
      18,    -1,    -1,   198,    -1,   200,   236,    -1,    -1,    -1,
      28,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
      -1,   261,   262,    -1,    -1,   265,   266,    -1,    -1,    -1,
      -1,   236,    60,    -1,    -1,   275,    -1,   242,    -1,   279,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   261,   262,    86,    -1,
     265,    -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,
     325,   326,    -1,   328,    -1,    -1,    -1,    -1,   333,   334,
      -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,   350,    -1,    -1,    -1,   354,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,   366,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,
     198,   376,   200,   378,   379,    -1,    -1,   382,   383,   384,
      -1,    -1,    -1,    -1,    -1,   425,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   406,   407,   408,    -1,    -1,   411,   412,   236,    -1,
      -1,    -1,    -1,   418,   242,    -1,    -1,    -1,   246,   424,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,   434,
      -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,   267,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    28,   316,   317,
      -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,
     328,    42,    43,    44,    -1,   333,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,   350,    -1,    -1,   404,   354,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   366,   367,
     368,    -1,   370,    -1,    -1,    86,    -1,   426,   376,    -1,
     378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,
     408,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,   130,
     418,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   433,   434,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    -1,    -1,   198,    -1,   200,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    28,   316,   317,    -1,    -1,    -1,
      -1,   322,   323,   324,   325,   326,    -1,   328,    42,    43,
      44,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,   350,
      -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   366,   367,   368,    -1,   370,
      -1,    -1,    86,    -1,    -1,   376,    -1,   378,   379,    -1,
      -1,   382,   383,   384,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,    -1,
     411,   412,    -1,    -1,    -1,    -1,   130,   418,    -1,    -1,
      -1,    -1,   423,   424,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   433,   434,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,   160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,   198,    -1,   200,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   261,   262,    86,
      -1,   265,    -1,   267,   404,   269,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,    -1,   427,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,
     324,   325,   326,    -1,   328,    -1,    -1,    -1,    -1,   333,
     334,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,    -1,
     354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   366,   367,   368,    -1,   370,    -1,    -1,    -1,
      -1,   198,   376,   200,   378,   379,    -1,    -1,   382,   383,
     384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,   236,
      -1,    -1,    -1,    -1,   418,   242,    -1,    -1,    -1,   246,
     424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,
     434,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,
     267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    28,   316,
     317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,
      -1,   328,    42,    43,    44,    -1,   333,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,
     367,   368,    -1,   370,    -1,    -1,    86,    -1,    -1,   376,
      -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,
     130,   418,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   433,   434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,
     160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,   198,    -1,
     200,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   261,   262,    86,    -1,   265,    -1,   267,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,   316,   317,    -1,    -1,
      -1,    -1,   322,   323,   324,   325,   326,    -1,   328,    -1,
      -1,    -1,    -1,   333,   334,    -1,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,
     350,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   366,   367,   368,    -1,
     370,    -1,    -1,    -1,    -1,   198,   376,   200,   378,   379,
      -1,    -1,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,
      -1,   411,   412,   236,    -1,    -1,    -1,    -1,   418,   242,
      -1,    -1,    -1,   246,   424,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   433,   434,    -1,    -1,    -1,   261,   262,
      -1,    -1,   265,    -1,   267,    -1,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    28,   316,   317,    -1,    -1,    -1,    -1,   322,
     323,   324,   325,   326,    -1,   328,    42,    43,    44,    -1,
     333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,
      -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   366,   367,   368,    -1,   370,    -1,    -1,
      86,    -1,    -1,   376,    -1,   378,   379,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,
      -1,    -1,    -1,    -1,   130,   418,    -1,    -1,    -1,    -1,
      -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     433,   434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,    18,
      -1,    -1,   198,    -1,   200,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
     236,    29,    30,    31,    -1,    -1,   242,    -1,    36,    -1,
     246,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   261,   262,    86,    -1,   265,
      -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
     316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,
     326,    -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     366,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,   198,
     376,   200,   378,   379,    -1,    -1,   382,   383,   384,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     406,   407,   408,    -1,    -1,   411,   412,   236,    -1,    -1,
      -1,    -1,   418,   242,    -1,    -1,    -1,   246,   424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,   434,    -1,
      -1,    -1,   261,   262,    -1,    -1,   265,   235,   267,    -1,
     269,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    34,    35,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,    -1,
      -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,   328,
      -1,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,
      -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,   367,   368,
      -1,   370,    -1,    -1,    -1,    -1,    -1,   376,    -1,   378,
     379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,   406,   407,   408,
      -1,    -1,   411,   412,    28,    29,    30,    -1,    -1,   418,
      -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    42,    43,
      44,    -1,    -1,    -1,   433,   434,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,    14,
      -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,   159,   160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,   198,    -1,   200,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,   110,   111,   112,   242,   114,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   130,    -1,   261,   262,    -1,
      -1,   265,    -1,   267,    -1,   269,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,   159,   160,    -1,    -1,   426,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,
     324,   325,   326,   198,   328,   200,    -1,    -1,    -1,   333,
     334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,    -1,
     354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   236,   366,   367,   368,    -1,   370,   242,    -1,    -1,
     245,   246,   376,    -1,   378,   379,    -1,    -1,   382,   383,
     384,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,    -1,
     265,    -1,   267,    -1,   269,    -1,   235,    -1,    -1,    -1,
      -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,    -1,
      -1,    -1,    -1,    -1,   418,    -1,    -1,   421,    -1,    -1,
     424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,
     325,   326,    -1,   328,    -1,    -1,    -1,    -1,   333,   334,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,   350,    -1,    -1,    -1,   354,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   366,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,
      -1,   376,    -1,   378,   379,    -1,    -1,   382,   383,   384,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,   406,   407,   408,    -1,    -1,   411,   412,    28,    29,
      30,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,   424,
      -1,    -1,    42,    43,    44,    -1,   431,   432,   433,   434,
      -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
     110,   111,   112,    -1,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,   159,
     160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,   198,    -1,
     200,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   110,
     111,   112,   242,   114,    -1,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,   235,    -1,    -1,   316,   317,    -1,    -1,
      -1,    -1,   322,   323,   324,   325,   326,   198,   328,   200,
      -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,
     350,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,   366,   367,   368,    -1,
     370,   242,    -1,    -1,    -1,   246,   376,    -1,   378,   379,
      -1,    -1,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,
     261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,    -1,
     235,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,
      -1,   411,   412,    -1,    -1,    -1,    -1,    -1,   418,    -1,
      -1,   421,    -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   433,   434,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   316,   317,    -1,    -1,    -1,
      -1,   322,   323,   324,   325,   326,    -1,   328,    -1,    -1,
      -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,   350,
      -1,    -1,   404,   354,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   366,   367,   368,    -1,   370,
      -1,    -1,    -1,    -1,   426,   376,    -1,   378,   379,    -1,
      -1,   382,   383,   384,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,   406,   407,   408,    -1,    -1,
     411,   412,    28,    -1,    -1,    -1,    -1,   418,    -1,    -1,
      -1,    -1,    -1,   424,    -1,    -1,    42,    43,    44,    -1,
     431,   432,   433,   434,    -1,    -1,    -1,    -1,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,   110,   111,   112,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,   198,    -1,   200,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   110,   111,   112,   242,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   130,    -1,   261,   262,    -1,    -1,   265,
      -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,   235,    -1,    -1,
     316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,
     326,   198,   328,   200,    -1,    -1,    -1,   333,   334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
     366,   367,   368,    -1,   370,   242,    -1,    -1,    -1,   246,
     376,    -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,
      -1,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,
     267,    -1,   269,    -1,   235,    -1,    -1,    -1,    -1,    -1,
     406,   407,   408,    -1,    -1,   411,   412,    -1,    -1,    -1,
      -1,    -1,   418,    -1,    -1,   421,    -1,    -1,   424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,   434,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
     317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,
      -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,   350,    -1,    -1,   404,   354,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   366,
     367,   368,    -1,   370,    -1,    -1,    -1,    -1,   426,   376,
      -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,    28,    29,    30,    -1,
      -1,   418,    -1,    -1,    -1,    -1,    -1,   424,    -1,   426,
      42,    43,    44,   430,    -1,    -1,   433,   434,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,   110,   111,
     112,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,   159,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,   198,    -1,   200,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    81,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,   110,   111,   112,
     242,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,   261,
     262,    -1,    -1,   265,    -1,   267,    -1,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,   235,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,
     322,   323,   324,   325,   326,   198,   328,   200,    -1,    -1,
      -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,
      -1,    -1,   354,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,   236,   366,   367,   368,    -1,   370,   242,
      -1,    -1,    -1,   246,   376,    -1,   378,   379,    -1,    -1,
     382,   383,   384,    -1,    -1,    -1,    -1,    -1,   261,   262,
      -1,    -1,   265,    -1,   267,    -1,   269,    -1,   235,    -1,
      -1,    -1,    -1,    -1,   406,   407,   408,    -1,    -1,   411,
     412,    -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,
      -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   433,   434,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,
     323,   324,   325,   326,    -1,   328,    -1,    -1,    -1,    -1,
     333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,
     404,   354,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   366,   367,   368,    -1,   370,    -1,    -1,
      -1,    -1,   426,   376,    -1,   378,   379,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,
      18,    -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,
      28,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,
      -1,   424,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
     433,   434,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,    18,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     198,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,
      -1,   110,   111,   112,   242,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,   261,   262,    -1,    -1,   265,    -1,   267,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,
      -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,   198,
     328,   200,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,   236,   366,   367,
     368,    -1,   370,   242,    -1,    -1,    -1,   246,   376,    -1,
     378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,
     408,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,
     418,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   433,   434,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,    -1,
      -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,   328,
      -1,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,
      -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,
      -1,     7,     8,    -1,    -1,    -1,    -1,   366,   367,   368,
      -1,   370,    -1,    -1,    -1,    -1,    -1,   376,    -1,   378,
     379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,   406,   407,   408,
      -1,    -1,   411,   412,    28,    -1,    -1,    -1,    -1,   418,
      -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    42,    43,
      44,    -1,    -1,    -1,   433,   434,    -1,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   159,   160,    -1,   130,    -1,     3,     4,
       5,     6,     7,     8,   170,   171,    11,    12,    13,    14,
      -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,   159,   160,    -1,    -1,    -1,
      -1,    -1,   198,    -1,   200,    -1,    -1,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   198,    -1,   200,    -1,    -1,    -1,
     236,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,
     266,    -1,   236,    -1,    -1,   110,   111,   112,   242,   275,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   130,    -1,   261,   262,    -1,
      -1,   265,    -1,   267,    -1,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   159,   160,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,
     324,   325,   326,   198,   328,   200,    -1,    -1,    -1,   333,
     334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,    -1,
     354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   236,   366,   367,   368,    -1,   370,   242,    -1,    -1,
      -1,   246,   376,    -1,   378,   379,    -1,    -1,   382,   383,
     384,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   425,
     265,    -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,    -1,
      -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,
     424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,
     325,   326,    -1,   328,    -1,    -1,    -1,    -1,   333,   334,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,   350,    -1,    -1,    -1,   354,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   366,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,
      -1,   376,    -1,   378,   379,    -1,    -1,   382,   383,   384,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    -1,    -1,    17,    18,    -1,
      -1,   406,   407,   408,    -1,    -1,   411,   412,    28,    -1,
      -1,    -1,    -1,   418,    -1,    -1,   421,    -1,    -1,   424,
      -1,    -1,    42,    43,    44,    -1,    -1,    -1,   433,   434,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
     110,   111,   112,    -1,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
     130,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,   159,
     160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,   198,    -1,
     200,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   110,
     111,   112,   242,    -1,    -1,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,
     212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,   235,    -1,    -1,   316,   317,    -1,    -1,
      -1,    -1,   322,   323,   324,   325,   326,   198,   328,   200,
      -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,
     350,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,   366,   367,   368,    -1,
     370,   242,    -1,    -1,    -1,   246,   376,    -1,   378,   379,
      -1,    -1,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,
     261,   262,    -1,    -1,   265,    -1,   267,    -1,   269,    -1,
     235,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,
      -1,   411,   412,    -1,    -1,    -1,    -1,    -1,   418,    -1,
      -1,    -1,    -1,   423,   424,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   433,   434,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   316,   317,    -1,    -1,    -1,
      -1,   322,   323,   324,   325,   326,    -1,   328,    -1,    -1,
      -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,   350,
      -1,    -1,   404,   354,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,   366,   367,   368,    -1,   370,
     422,    -1,   424,    -1,    -1,   376,    -1,   378,   379,    -1,
      -1,   382,   383,   384,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    -1,
      -1,    17,    18,    -1,    -1,   406,   407,   408,    -1,    -1,
     411,   412,    28,    -1,    -1,    -1,    -1,   418,    -1,    -1,
      -1,    -1,    -1,   424,    -1,    -1,    42,    43,    44,   430,
      -1,    -1,   433,   434,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,   110,   111,   112,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,   198,    -1,   200,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   110,   111,   112,   242,    -1,    -1,   245,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   130,    -1,   261,   262,    -1,    -1,   265,
      -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,   235,    -1,    -1,
     316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,
     326,   198,   328,   200,    -1,    -1,    -1,   333,   334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
     366,   367,   368,    -1,   370,   242,    -1,    -1,    -1,   246,
     376,    -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,
      -1,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,
     267,    -1,   269,    -1,   235,    -1,    -1,    -1,    -1,    -1,
     406,   407,   408,    -1,    -1,   411,   412,    -1,    -1,    -1,
      -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,   424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   433,   434,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,
     317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,
      -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,   350,    -1,    -1,   404,   354,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,   366,
     367,   368,    -1,   370,    -1,   423,    -1,    -1,    -1,   376,
      -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    -1,    -1,    17,    18,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,    28,    -1,    -1,    -1,
      -1,   418,    -1,    -1,    -1,    -1,    -1,   424,   425,    -1,
      42,    43,    44,    -1,    -1,    -1,   433,   434,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,   110,   111,
     112,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,   159,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,   198,    -1,   200,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,   110,   111,   112,
     242,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,   261,
     262,    -1,    -1,   265,    -1,   267,    -1,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,   235,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,
     322,   323,   324,   325,   326,   198,   328,   200,    -1,    -1,
      -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,
      -1,    -1,   354,    -1,    -1,    -1,   358,    -1,    -1,    -1,
      -1,    -1,    -1,   236,   366,   367,   368,    -1,   370,   242,
      -1,    -1,    -1,   246,   376,    -1,   378,   379,    -1,    -1,
     382,   383,   384,    -1,    -1,    -1,    -1,    -1,   261,   262,
      -1,    -1,   265,    -1,   267,    -1,   269,    -1,   235,    -1,
      -1,    -1,    -1,    -1,   406,   407,   408,    -1,    -1,   411,
     412,    -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,
      -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   433,   434,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,
     323,   324,   325,   326,    -1,   328,    -1,    -1,    -1,    -1,
     333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,
     404,   354,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,   366,   367,   368,    -1,   370,    -1,   423,
      -1,    -1,    -1,   376,    -1,   378,   379,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,
      18,    -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,
      28,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,   422,
      -1,   424,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
     433,   434,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,   110,   111,   112,    -1,    36,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,    18,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     198,    -1,   200,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    86,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,   236,    -1,
      -1,   110,   111,   112,   242,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,   261,   262,    -1,    -1,   265,    -1,   267,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,   235,    -1,    -1,   316,   317,
      -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,   198,
     328,   200,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,   366,   367,
     368,    -1,   370,   242,    -1,    -1,    -1,   246,   376,    -1,
     378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,
     408,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,
     418,    -1,    -1,    -1,   235,    -1,   424,    -1,    -1,    -1,
      -1,   429,    -1,    -1,    -1,   433,   434,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,    -1,
      -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,   328,
      -1,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,
      -1,   350,    -1,    -1,   404,   354,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   366,   367,   368,
      -1,   370,    -1,   423,    -1,    -1,    -1,   376,    -1,   378,
     379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,
      -1,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,   418,
      -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,    -1,
     429,    -1,    -1,    -1,   433,   434,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    42,    43,    44,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,   110,   111,   112,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   130,    -1,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,
      18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,   198,    -1,   200,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   110,   111,   112,   242,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,   261,   262,    -1,    -1,   265,    -1,
     267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,   235,    -1,    -1,   316,
     317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,
     198,   328,   200,    -1,    -1,    -1,   333,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,   366,
     367,   368,    -1,   370,   242,    -1,    -1,    -1,   246,   376,
      -1,   378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,    -1,   265,    -1,   267,
      -1,   269,    -1,   235,    -1,    -1,    -1,    -1,    -1,   406,
     407,   408,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,
      -1,   418,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   433,   434,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,
      -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,
     328,    -1,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,   350,    -1,    -1,   404,   354,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,   366,   367,
     368,    -1,   370,    -1,   423,    -1,    -1,    -1,   376,    -1,
     378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,   406,   407,
     408,    -1,    -1,   411,   412,    28,    -1,    -1,    -1,    -1,
     418,    -1,    -1,    -1,    -1,   423,   424,    -1,    -1,    42,
      43,    44,    -1,    -1,    -1,   433,   434,    -1,    -1,    -1,
      -1,    -1,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,   110,   111,   112,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,   198,    -1,   200,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,    -1,   110,   111,   112,   242,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,   261,   262,
      -1,    -1,   265,    -1,   267,    -1,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,   160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
     235,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,
     323,   324,   325,   326,   198,   328,   200,    -1,    -1,    -1,
     333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,
      -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   236,   366,   367,   368,    -1,   370,   242,    -1,
      -1,    -1,   246,   376,    -1,   378,   379,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,
      -1,   265,    -1,   267,    -1,   269,    -1,   235,    -1,    -1,
      -1,    -1,    -1,   406,   407,   408,    -1,    -1,   411,   412,
      -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,
      -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     433,   434,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   316,   317,    -1,    -1,    -1,    -1,   322,   323,
     324,   325,   326,    -1,   328,    -1,    -1,    -1,    -1,   333,
     334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   347,    -1,    -1,   350,    -1,    -1,   404,
     354,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   366,   367,   368,    -1,   370,    -1,   423,    -1,
      -1,    -1,   376,    -1,   378,   379,    -1,    -1,   382,   383,
     384,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    14,    -1,    -1,    17,    18,
      -1,    -1,   406,   407,   408,     7,     8,   411,   412,    28,
      -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,
     424,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,   433,
     434,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    86,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    86,    -1,    40,    41,    42,    43,
      44,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,     1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      -1,   200,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,   198,    -1,   200,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     222,    -1,    -1,   242,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,    -1,
     242,    -1,   261,   262,    86,    -1,   265,    -1,   267,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   261,
     262,    -1,    -1,   265,   266,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,    -1,
      -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,   328,
      -1,    -1,    -1,    -1,   333,   334,    -1,   159,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,
      -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,   367,   368,
      -1,   370,    -1,    -1,    -1,    -1,   198,   376,   200,   378,
     379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,
      -1,    -1,   411,   412,   236,    -1,    -1,    -1,     7,     8,
     242,    -1,    -1,    -1,   246,   424,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   433,   434,    -1,    -1,    -1,   261,
     262,    -1,    -1,   265,    -1,   267,    -1,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    -1,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    28,    -1,    -1,    -1,    -1,    -1,    -1,   423,
     312,    37,    -1,    -1,   316,   317,    -1,    86,    -1,    -1,
     322,   323,   324,   325,   326,    -1,   328,    -1,    -1,    -1,
      -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,    -1,   347,    -1,    -1,   350,    -1,
      -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      86,   130,    -1,    -1,   366,   367,   368,    -1,   370,    -1,
      -1,    -1,    -1,    -1,   376,    -1,   378,   379,    -1,    -1,
     382,   383,   384,    -1,   110,   111,   112,    -1,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,
      -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      -1,   200,    -1,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   198,   242,   200,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,    -1,   265,   266,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,
     236,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   261,   262,    -1,    -1,   265,
      -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
     316,   317,    -1,    -1,    -1,    -1,   322,   323,   324,   325,
     326,    -1,   328,    -1,    -1,    -1,    -1,   333,   334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,     1,   350,     3,    -1,    -1,   354,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     366,   367,   368,    -1,   370,    -1,    -1,    -1,    -1,    -1,
     376,    -1,   378,   379,    -1,    -1,   382,   383,   384,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   418,    -1,    -1,    73,    74,    -1,   424,    -1,
      78,    -1,    -1,    81,    -1,    83,    84,    85,    86,    -1,
      -1,    89,    -1,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,   107,
     108,   109,   110,   111,   112,    -1,    -1,   115,   116,   117,
     118,   119,    -1,    -1,   122,   123,    -1,    -1,   126,   127,
      -1,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,    -1,   142,    -1,    -1,    -1,   146,   147,
     148,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     158,   159,   160,   161,    -1,   163,   164,   165,    -1,    -1,
      -1,    -1,     1,    -1,     3,    -1,    -1,    -1,     7,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,
      -1,   189,   190,   191,   192,    -1,    -1,    -1,    -1,    -1,
     198,    -1,   200,    -1,   202,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,   227,
      28,    -1,    -1,    -1,    -1,    -1,   234,    -1,   236,   237,
      -1,    -1,    -1,    -1,   242,    -1,   244,    -1,    -1,    78,
      -1,    -1,   250,    -1,    -1,    -1,    -1,    86,    -1,    -1,
     258,    -1,    -1,   261,   262,    63,   264,   265,   266,    -1,
      -1,    -1,    -1,   271,   272,    -1,   274,   275,    -1,    -1,
     278,   110,   111,   112,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
     129,   130,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,   130,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      -1,   200,    -1,    -1,    -1,   204,   205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   214,    -1,    -1,    -1,    -1,
      -1,   389,    -1,   222,    -1,    -1,    -1,   226,    -1,    -1,
     198,    -1,   200,    -1,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   241,   242,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,   252,   422,   254,   255,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,   264,   265,   266,   236,    -1,
      -1,   110,   111,   112,   242,    -1,   275,    -1,   246,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,   261,   262,    -1,    -1,   265,    -1,   267,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,
      -1,    -1,    -1,    -1,   322,   323,   324,   325,   326,   198,
     328,   200,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
      -1,    -1,   350,    -1,    -1,    -1,   354,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,   366,   367,
     368,    -1,   370,   242,    -1,    -1,    -1,   246,   376,    -1,
     378,   379,    -1,    -1,   382,   383,   384,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,    -1,   265,    -1,   267,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,    -1,
      -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,   328,
      -1,    -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,
       1,   350,     3,    -1,    -1,   354,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,   367,   368,
      -1,   370,    -1,    -1,    -1,    -1,    -1,   376,    -1,   378,
     379,    -1,    -1,   382,   383,   384,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    -1,    -1,
      61,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,   418,
      -1,    -1,    73,    74,    -1,   424,    -1,    78,    -1,    -1,
      81,    -1,    83,    84,    85,    86,    -1,    -1,    89,    -1,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,    -1,    -1,    -1,   107,   108,   109,   110,
     111,   112,    -1,    -1,   115,   116,   117,   118,   119,    -1,
      -1,   122,   123,    -1,    -1,   126,   127,    -1,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
      -1,   142,    -1,    -1,    -1,   146,   147,   148,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,    -1,   189,   190,
     191,   192,    -1,    -1,    -1,    -1,    -1,   198,    -1,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,     1,   234,     3,   236,   237,    -1,     7,     8,
       9,   242,    -1,   244,    -1,    -1,    -1,    -1,    -1,   250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,
     261,   262,    -1,   264,   265,   266,    -1,    -1,    37,    -1,
     271,   272,    -1,   274,   275,    -1,    -1,   278,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      -1,    -1,    61,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,    78,
      -1,    -1,    81,    -1,    83,    84,    85,    86,    -1,   320,
      89,    -1,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,    -1,    -1,    -1,   107,   108,
     109,   110,   111,   112,    -1,    -1,   115,   116,   117,   118,
     119,    -1,    -1,   122,   123,    -1,    -1,   126,   127,    -1,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,    -1,   142,    -1,    -1,    -1,   146,   147,   148,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,   158,
     159,   160,   161,    -1,   163,   164,   165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,    -1,
     189,   190,   191,   192,    -1,    -1,    -1,    -1,    -1,   198,
      -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,   222,    -1,    36,    -1,    -1,   227,    40,
      41,    42,    43,    44,    -1,   234,    -1,   236,   237,    -1,
      -1,    -1,    -1,   242,    -1,   244,    -1,    -1,    -1,    -1,
      -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,
      -1,    -1,   261,   262,    -1,   264,   265,   266,    -1,    -1,
      -1,    -1,   271,   272,    -1,   274,   275,    19,    20,   278,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,   320,    -1,    -1,    40,    41,    42,    43,    44,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     389,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,   405,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    19,    20,   235,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,   235,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,   235,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,   235,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,   235,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,   235,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,
      -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   235,    -1,    -1,    -1,    -1,    -1,    -1,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    19,    20,
     423,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      19,    20,   423,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
     235,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,   235,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,   235,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,   235,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,   235,    40,    41,    42,    43,    44,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
     235,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,   404,   235,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,   404,   235,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   235,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     235,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    19,    20,   423,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,   235,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,   235,    40,    41,    42,    43,    44,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
     235,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,   235,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,   235,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,   235,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,   235,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   235,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     235,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,   404,   235,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,   404,   235,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,   404,   235,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   235,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      19,    20,   423,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    45,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    40,    41,    42,    43,    44,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,   212,
      -1,    -1,    -1,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,   235,    -1,    40,    41,    42,    43,    44,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,   235,
      40,    41,    42,    43,    44,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,   235,    40,    41,    42,    43,
      44,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,   235,    40,    41,    42,    43,    44,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,   235,    40,    41,
      42,    43,    44,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,   235,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,   235,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,   422,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,   235,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   404,   235,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,
      -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     404,   235,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   235,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,   235,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,
     422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,   235,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,
      -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,
     422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
      -1,    -1,    -1,    -1,    19,    20,   422,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
     235,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,   235,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,   235,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,   235,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
     235,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,   235,    -1,    -1,    -1,    -1,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,   422,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   235,    -1,    -1,    -1,    -1,
      -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   235,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   235,    -1,    -1,
      -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,   422,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,   346,    -1,    -1,    -1,
      -1,   422,   352,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    19,    20,   422,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
      43,    44,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,   235,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,    -1,    -1,    -1,     7,     8,     9,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,    37,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    -1,    58,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      73,    74,    -1,    -1,    -1,    78,    -1,    -1,    81,    -1,
      83,    84,    85,    86,    -1,    -1,    89,    -1,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,   108,   109,   110,   111,   112,
      -1,    -1,   115,   116,   117,   118,   119,    -1,    -1,   122,
     123,    -1,    -1,   126,   127,    -1,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,    -1,   142,
      -1,    -1,    -1,   146,   147,   148,   149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,    -1,   189,   190,   191,   192,
      -1,    -1,    -1,    -1,    -1,   198,    -1,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,    -1,   219,    -1,    -1,   222,
      -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,
       1,   234,     3,   236,   237,    -1,     7,     8,     9,   242,
      -1,   244,    -1,    -1,    -1,    -1,    -1,   250,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,   261,   262,
      -1,   264,   265,   266,    -1,    -1,    37,    -1,   271,   272,
      -1,   274,   275,    -1,    -1,   278,    -1,    48,    49,    50,
      -1,    52,    53,    54,    55,    -1,    -1,    58,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    73,    74,    -1,    -1,    -1,    78,    -1,    -1,
      81,    -1,    83,    84,    85,    86,    -1,   320,    89,    -1,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,    -1,    -1,    -1,   107,   108,   109,   110,
     111,   112,    -1,    -1,   115,   116,   117,   118,   119,    -1,
      -1,   122,   123,    -1,    -1,   126,   127,    -1,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
      -1,   142,    -1,    -1,    -1,   146,   147,   148,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   389,   158,   159,   160,
     161,    -1,   163,   164,   165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,   187,    -1,   189,   190,
     191,   192,    -1,    -1,    -1,    -1,    -1,   198,    -1,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,   219,    -1,
      -1,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,     1,   234,     3,   236,   237,    -1,     7,     8,
       9,   242,    -1,   244,    -1,    -1,    -1,    -1,    -1,   250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,
     261,   262,    -1,   264,   265,   266,    -1,    -1,    37,    -1,
     271,   272,    -1,   274,   275,    -1,    -1,   278,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      -1,    -1,    61,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,    78,
      -1,    -1,    81,    -1,    83,    84,    85,    86,    -1,   320,
      89,    -1,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,    -1,    -1,    -1,   107,   108,
     109,   110,   111,   112,    -1,    -1,   115,   116,   117,   118,
     119,    -1,    -1,   122,   123,    -1,    -1,   126,   127,    -1,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,    -1,   142,    -1,    -1,    -1,   146,   147,   148,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,   158,
     159,   160,   161,   162,   163,   164,   165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,   187,    -1,
     189,   190,   191,   192,    -1,    -1,    -1,    -1,    -1,   198,
      -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,   227,    -1,
      -1,    -1,    -1,    -1,     1,   234,     3,   236,   237,    -1,
       7,     8,     9,   242,    -1,   244,    -1,    -1,    -1,    -1,
      -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,
      -1,    -1,   261,   262,    -1,   264,   265,   266,    -1,    -1,
      37,    -1,   271,   272,    -1,   274,   275,    -1,    -1,   278,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    -1,
      -1,    78,    -1,    -1,    81,    -1,    83,    84,    85,    86,
      -1,   320,    89,    -1,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
     107,   108,   109,   110,   111,   112,    -1,    -1,   115,   116,
     117,   118,   119,    -1,    -1,   122,   123,    -1,    -1,   126,
     127,    -1,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,    -1,   142,    -1,    -1,    -1,   146,
     147,   148,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     389,   158,   159,   160,   161,   162,   163,   164,   165,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
     187,    -1,   189,   190,   191,   192,    -1,    -1,    -1,    -1,
      -1,   198,    -1,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,     1,   234,     3,   236,
     237,    -1,     7,     8,     9,   242,    -1,   244,    -1,    -1,
      -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   258,    -1,    -1,   261,   262,    -1,   264,   265,   266,
      -1,    -1,    37,    -1,   271,   272,    -1,   274,   275,    -1,
      -1,   278,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,
      -1,    -1,    -1,    78,    -1,    -1,    81,    -1,    83,    84,
      85,    86,    -1,   320,    89,    -1,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,    -1,
      -1,    -1,   107,   108,   109,   110,   111,   112,    -1,    -1,
     115,   116,   117,   118,   119,    -1,    -1,   122,   123,    -1,
      -1,   126,   127,    -1,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,    -1,   142,    -1,    -1,
      -1,   146,   147,   148,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   389,   158,   159,   160,   161,    -1,   163,   164,
     165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   187,    -1,   189,   190,   191,   192,    -1,    -1,
      -1,    -1,    -1,   198,    -1,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,     1,   234,
       3,   236,   237,    -1,     7,     8,     9,   242,    -1,   244,
      -1,    -1,    -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   258,    -1,    -1,   261,   262,    -1,   264,
     265,   266,    -1,    -1,    37,    -1,   271,   272,    -1,   274,
     275,    -1,    -1,   278,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    74,    -1,    -1,    -1,    78,    -1,    -1,    81,    -1,
      83,    84,    85,    86,    -1,   320,    89,    -1,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,   108,   109,   110,   111,   112,
      -1,    -1,   115,   116,   117,   118,   119,    -1,    -1,   122,
     123,    -1,    -1,   126,   127,    -1,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,    -1,   142,
      -1,    -1,    -1,   146,   147,   148,   149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   389,   158,   159,   160,   161,    -1,
     163,   164,   165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,   187,    -1,   189,   190,   191,   192,
      -1,    -1,    -1,    -1,    -1,   198,    -1,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,
      -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,
      -1,   234,     3,   236,   237,    -1,    -1,    -1,    -1,   242,
      -1,   244,    -1,    -1,    -1,    -1,    -1,   250,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,   261,   262,
      -1,   264,   265,   266,    -1,    -1,    -1,    -1,   271,   272,
      -1,   274,   275,    -1,    -1,   278,    -1,    48,    49,    -1,
      -1,    52,    53,    54,    -1,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,    -1,    -1,    -1,     7,     8,
      -1,    -1,    83,    84,    85,    -1,    -1,   320,    89,    -1,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
      -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,   115,   116,   117,   118,   119,    -1,
      -1,    -1,   123,    -1,    -1,   126,   127,    -1,    -1,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,    -1,
      -1,   142,    -1,    -1,    -1,   146,   147,   148,   149,    78,
      -1,    -1,    -1,    -1,    -1,    -1,   389,    86,    -1,    -1,
      -1,    -1,    -1,     1,    -1,     3,    -1,    -1,    -1,     7,
       8,     1,    -1,    -1,    -1,    -1,    -1,     7,     8,    -1,
      -1,   110,   111,   112,    -1,   186,   187,    -1,   189,   190,
     191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,   130,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
     159,   160,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,   250,
      -1,    -1,    -1,    -1,    -1,    -1,    86,   258,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      -1,   200,   110,   111,   112,   204,   205,    -1,    -1,    -1,
     110,   111,   112,    -1,     1,   214,    -1,    -1,    -1,    -1,
       7,     8,   130,   222,    -1,    -1,    -1,   226,    -1,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   241,   242,    -1,    -1,    -1,    -1,    -1,   320,
      37,   159,   160,   252,    -1,   254,   255,    -1,    -1,   159,
     160,    -1,   261,   262,    -1,   264,   265,   266,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,    -1,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     198,    -1,   200,    -1,   202,    -1,    -1,    -1,   198,    86,
     200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     7,     8,    -1,   222,    -1,    -1,    -1,   389,    -1,
      -1,    -1,   222,   110,   111,   112,    -1,    -1,   236,    -1,
      -1,    -1,    -1,    -1,   242,    -1,   236,    -1,    -1,    -1,
      -1,    37,   242,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,    -1,   265,   266,    -1,
      -1,   261,   262,    -1,    -1,   265,   266,   275,    -1,    -1,
      -1,    67,   159,   160,    -1,   275,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,     7,     8,    -1,    -1,
      -1,   198,    -1,   200,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,   222,    -1,    -1,    -1,    -1,
       7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   159,   160,   161,    -1,    -1,    -1,   165,
      -1,    -1,    73,    -1,   261,   262,    -1,    -1,   265,   266,
      -1,    -1,    -1,    84,    85,    86,    -1,    -1,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,    -1,   198,    -1,   200,    -1,    73,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,   130,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   110,   111,   112,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,
     161,    -1,   258,   130,   165,   261,   262,    -1,   264,   265,
     266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,   160,   161,    -1,    -1,   198,   165,   200,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   198,    -1,   200,    -1,   236,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   222,    -1,   258,    -1,    -1,
     261,   262,    -1,   264,   265,   266,    -1,    -1,    -1,   236,
      -1,    -1,    -1,   274,   275,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,   262,    -1,   264,   265,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,   275
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   271,   272,   456,   575,   576,     6,     6,     0,   575,
     457,   422,   414,   422,    37,    78,   101,   104,   129,   158,
     165,   177,   247,   274,   278,   338,   371,   461,   485,   490,
     491,   495,   530,   538,   561,   575,   580,   581,   587,   608,
     612,   616,   659,   776,   780,     6,     3,    38,   582,   583,
     161,   264,   508,   509,     7,    86,   110,   111,   130,   159,
     160,   198,   200,   236,   242,   261,   551,   655,   694,   695,
     697,     3,   509,   418,   697,     3,   509,     1,     3,     7,
       8,    86,   110,   111,   112,   130,   159,   160,   198,   202,
     222,   262,   265,   266,   275,   486,   505,   527,   588,   592,
     655,     3,     3,   490,    89,    91,   170,   171,   222,   237,
     250,   266,   275,   425,   486,   488,   552,   578,   664,   718,
      37,   202,   422,   428,    38,   427,   279,   488,   489,   170,
     171,   653,     3,   698,   700,   418,     3,     3,     3,   699,
     701,   422,     3,   422,   422,   717,   718,    46,   170,   171,
     654,     3,     3,    86,   112,   160,   198,   424,   655,     3,
     248,   777,     3,   777,     3,     7,   653,   654,   422,   607,
     607,     3,     4,     5,     6,     7,     8,    11,    12,    13,
      14,    17,    18,    28,    42,    43,    44,    86,   130,   246,
     265,   267,   269,   312,   316,   317,   322,   323,   324,   325,
     326,   328,   333,   334,   347,   350,   354,   366,   367,   368,
     370,   376,   378,   379,   382,   383,   384,   406,   407,   408,
     411,   412,   418,   424,   426,   430,   433,   434,   459,   502,
     503,   504,   505,   527,   528,   553,   560,   632,   636,   637,
     645,   655,   656,     3,   513,   514,   717,   509,   578,    38,
     582,   509,   632,   583,     3,   717,   428,   422,   427,     3,
     100,   772,     1,   418,   422,   427,   428,   422,   427,   178,
     422,   487,   422,   422,   654,   653,   653,   653,     3,   589,
     591,   654,   422,   424,   422,   424,   717,   422,   717,   609,
     613,   418,    46,    11,    13,   424,   502,   560,   645,   656,
     656,   421,   632,   635,   580,   580,   580,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   580,     1,   580,   580,   580,   580,   632,   633,    29,
      30,   421,   559,   632,   635,   426,   406,   407,   408,   580,
       1,   580,   429,   435,    19,    20,    22,    23,    24,    25,
      26,    27,    29,    30,    31,    36,    40,    41,    42,    43,
      44,   235,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   426,   435,   425,   429,   580,    17,
      18,   428,   717,   422,   427,     3,    38,     3,     7,   465,
       1,   422,   498,   632,   700,   112,   773,   423,   427,    72,
     423,   564,   562,     5,   632,   701,   617,   531,     7,   424,
     717,   717,   717,   425,   428,   421,   427,   424,     1,   580,
     593,   594,     1,   593,   422,   340,   351,   375,   610,   611,
     314,   315,   336,   357,   387,   614,   615,   423,   635,     3,
     554,   645,   635,   429,   421,   427,     7,   424,   502,   560,
     637,   645,   637,   637,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   637,   637,
     637,   637,   637,   405,   423,   424,   424,   421,   580,   580,
     580,   637,   637,   645,   418,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   580,   580,   580,
     580,   580,   424,   580,   632,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   418,   430,   632,     3,   418,
     245,   632,   514,   660,   225,   467,    67,   496,   418,   346,
     352,   702,   703,   704,   706,     3,   422,     3,   568,   422,
     572,   573,    73,    84,    85,    86,   100,   101,   112,   130,
     165,   258,   486,   508,   541,   569,   579,   584,   587,   755,
     756,   757,   427,     3,   422,   621,   576,   589,   424,   424,
     424,   412,   528,   590,   632,   591,   589,   421,   422,   486,
       1,   421,   594,   421,   421,   332,   339,     3,     3,   343,
     611,   428,   428,   428,   428,   428,   344,   615,   423,   418,
       7,   421,   645,   632,   635,   429,   423,   423,   423,   423,
     423,   423,   427,   423,   423,   423,   423,   423,   423,   427,
     423,   423,   427,   427,   427,   423,   423,   423,   423,   423,
     632,   557,   558,   632,   635,   637,   637,   637,   418,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   425,   529,   577,
     632,   632,   426,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   426,    34,    35,   405,   426,   632,
     634,   418,   234,   533,   534,   535,     7,   422,   500,   569,
     584,   639,   640,   572,   758,   632,   704,   418,   425,   428,
     774,    85,   100,   112,   770,   771,   405,   666,   566,   423,
       1,   541,   542,   570,   574,     3,   723,   724,     1,     1,
     697,   486,     1,     1,   697,     3,   719,   720,    86,   112,
     130,   265,   551,   778,   112,   486,   755,   555,   556,   580,
     752,   753,     5,   429,   618,   532,   421,   589,   589,   589,
     528,   405,   426,   421,   513,   422,   422,   422,   422,   632,
       3,     3,     3,     5,   635,   421,   645,   632,   632,   632,
     632,   632,   405,   421,   427,   421,   634,   423,   632,   421,
     427,   405,   423,   632,   632,   632,   423,   427,   423,     8,
     536,   537,   431,   669,   535,   418,   462,   666,   640,   752,
     423,   358,   411,   412,   632,   705,   705,   632,   427,     3,
     646,     3,     3,   100,    83,   765,   766,   770,     3,   584,
     585,   586,   422,   427,   488,   422,   427,   717,   422,   427,
     422,   422,   698,   720,   422,   422,   699,   717,   422,   427,
     646,   646,   646,   646,   653,   486,   720,     1,     4,    45,
      50,    51,    55,    56,    57,    59,    62,    74,    75,    76,
      77,    81,   113,   114,   141,   145,   192,   199,   213,   229,
     259,   422,   431,   432,   502,   503,   507,   510,   544,   601,
     628,   645,   656,   744,   751,    72,   556,   423,     3,    60,
     176,   179,   182,   619,   538,   539,   540,   580,   421,   421,
     421,   590,   428,   422,   422,   422,   422,   422,   422,   423,
     423,   423,   423,   423,   423,   632,   421,   557,     1,   421,
     423,   405,   577,   632,   426,   426,   426,   632,    46,   422,
     427,   418,   418,   668,   634,     1,   204,   226,   241,   252,
     254,   255,   264,   278,   464,   468,   469,   470,   472,   480,
     483,   516,   517,   545,   546,   547,   550,   779,    67,   422,
     358,   358,   405,   405,    85,   775,   422,   427,   422,   422,
       3,     3,   128,   759,   584,   753,   586,   570,     3,   570,
     723,   422,   422,   422,   428,   719,   422,   422,   422,   422,
     717,   720,   422,    19,   422,   428,   418,   422,   645,   656,
      65,   405,   745,   418,   418,   418,   656,    77,   645,   418,
     656,   556,    87,   239,   240,   405,   506,   748,   418,   656,
     418,    77,   418,   418,   418,   422,   556,   418,   422,   632,
       3,     6,    12,    14,   418,   606,   413,   418,   645,   429,
     422,   556,   556,   282,   418,   422,    15,    16,    19,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   428,   422,
     563,   183,   621,   645,   538,   218,   426,   632,   421,   632,
       3,   413,   536,   101,   670,     1,     3,   424,   429,   580,
     649,   650,   651,   710,   711,   715,    37,   667,   423,   422,
     264,   472,   473,   474,   472,   517,   214,   470,    78,   495,
     561,     3,   486,   472,   545,   205,   497,   586,   705,   705,
       3,   423,   427,     3,   422,   428,     1,    12,    71,   404,
     411,   413,   415,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   760,   761,   762,   763,   764,   767,   768,    69,
      72,   752,     1,   717,   632,   646,   422,   632,   632,   634,
     422,   428,     3,   586,   632,   632,   632,   422,   422,   422,
       1,   486,   656,   428,     3,   586,     1,   632,   422,   632,
     422,   632,     1,   632,   632,   145,     3,   422,   605,   632,
     556,     1,    93,   103,   413,   629,   630,   632,   245,   645,
     424,     1,   634,   632,   632,   114,   432,   601,   628,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   114,
     245,   475,   493,   601,   628,   632,   666,   622,   183,   185,
     183,   185,   666,   428,   426,   697,   423,   427,   423,   425,
     715,   716,     3,    84,    85,   100,   423,   427,   422,   423,
     427,     3,   422,   472,   486,    78,   129,   463,   245,     1,
       1,   513,     3,   666,   752,   423,   426,   423,   426,   422,
      85,   528,    71,    71,   761,   767,   764,   767,   405,   768,
     666,   567,    72,   428,   571,   422,   422,   422,   423,   632,
     747,   746,   423,   423,   423,   423,     3,   428,   632,   750,
     749,   423,   423,   423,   423,   423,   423,   423,   418,   425,
     423,   405,   423,   632,   632,   423,    99,   423,   427,   418,
     418,    81,   229,   477,   478,   479,   481,   632,   423,   423,
     418,   418,   632,   632,   422,   418,   418,   425,   645,   422,
     422,   632,   632,   422,     3,   422,   622,   621,   622,   621,
     632,   700,   101,   700,     1,   632,   421,   427,   418,   126,
     127,   134,   135,   136,   137,   138,   142,   146,   147,   186,
     187,   389,   652,   696,   389,   652,   389,   652,   711,     3,
     651,    86,   661,   513,   245,   489,     3,   405,   466,     1,
     471,   422,   422,   422,   422,   424,    67,   759,     3,   422,
     405,   405,    12,   412,   436,   437,   438,   768,   769,   666,
     565,   632,   422,   422,   586,   753,     1,    60,   595,   596,
     635,     1,   596,     1,   596,   556,   428,   632,   422,   586,
     753,   556,   556,   556,   556,   556,   556,    64,   555,   580,
       1,   632,     1,     3,   515,   632,   556,   630,   630,   634,
     634,   418,   418,   477,   421,    45,   212,   422,   422,   422,
     632,   422,   422,   632,   634,   632,   422,   422,   422,   405,
     620,   422,   620,   697,   426,   405,   426,   715,   424,   715,
       3,   488,     3,   488,     3,   488,     3,   576,   422,   418,
     422,     3,   418,   422,     3,     7,    67,   418,     1,   479,
     499,    69,    12,   436,   437,   438,   405,   422,   666,   752,
      65,    66,   405,   405,   556,     1,    66,   595,   405,    66,
      66,    66,    66,   632,   422,   752,   506,    64,    64,   555,
      64,   423,   423,   426,   426,   427,   405,   423,   423,   632,
       3,   422,   424,   481,   484,   424,   423,   423,   423,   426,
     177,   422,   422,   700,   632,   716,   423,     3,     3,     3,
     428,   662,   758,   418,   422,   758,   405,   492,   758,   421,
     421,   666,   666,   769,    65,   556,   556,   556,   422,     1,
     632,   506,   556,   556,   555,   422,   422,   423,   423,     3,
     632,   422,   422,   423,   425,   481,   482,   632,   421,   628,
     628,   418,   426,   421,   717,   717,   428,   717,     5,     1,
       9,    50,    55,    61,    74,    78,    81,   107,   108,   122,
     139,   158,   163,   164,   244,   461,   495,   518,   535,   561,
     575,   580,   659,   671,   679,   680,   681,   423,   758,   423,
     245,   423,   422,   666,   632,   422,   422,   666,   556,   512,
     484,   515,   421,   481,   422,   632,   632,   632,   423,   632,
     422,   422,   646,     1,   418,   623,   624,   418,   673,   418,
       1,   418,     3,   418,   641,   642,   418,   642,     1,   678,
     418,   597,   598,   418,    51,   671,   686,   688,   689,   646,
     519,     3,    48,    49,    52,    53,    54,    58,    83,    84,
      85,    92,    94,    95,    96,    97,    98,    99,   100,   102,
     109,   115,   116,   117,   118,   119,   123,   131,   132,   133,
     148,   149,   189,   190,   191,   227,   320,   389,   458,   460,
     476,   541,   643,   644,   672,   696,   671,    68,   217,   219,
     665,    51,   422,   671,   690,   691,   422,   423,   422,   422,
     422,   494,   503,   656,   751,     1,   494,   556,    64,   426,
     422,   422,   423,    38,   422,   422,   428,    79,    80,   105,
     106,   124,   125,   126,   127,   143,   144,   625,   626,   431,
     602,   603,   632,   599,   600,   645,   718,     3,    67,   632,
     418,   718,   580,   625,   626,   714,   422,   427,   625,   626,
     422,    70,    81,    82,   123,   150,   151,   152,   153,   154,
     155,   156,   157,   166,   167,   168,   169,   172,   173,   174,
     175,   418,   725,   726,   727,   728,   730,   732,   733,    88,
      90,   121,   717,     1,     3,   405,   689,   686,   162,   422,
       3,   520,   521,   405,   431,   707,   744,   744,   488,   488,
     488,   677,   744,   744,   744,   744,     3,   631,   754,     3,
     602,   692,   693,   721,   722,   192,   389,   696,   418,   602,
     623,   642,   418,   602,   642,   584,   488,   663,   405,   689,
      64,   422,   638,   639,   494,   423,   428,   423,   423,   484,
     423,   632,   427,   427,   427,   427,   418,   606,   656,   657,
     658,   423,   422,   427,   428,   599,   428,   666,   423,     1,
      39,   580,   712,   713,   714,   418,   632,   423,   427,   427,
     423,   427,   641,   427,   423,   427,   418,   728,   732,     3,
      10,   718,   735,   736,   737,   418,   418,   418,   418,   418,
     418,   418,   418,     3,   734,   734,   734,   734,   418,   418,
     418,   418,     1,    93,   103,   729,   734,   725,    70,   422,
     428,   422,   428,   423,   423,   423,   603,   423,   427,     3,
      65,   522,   422,   427,     1,    12,    14,   418,     1,   642,
       1,     3,   647,     1,   647,     1,     3,   648,   737,   418,
      33,   428,   717,     3,   722,   422,   427,   422,   427,   251,
     647,   488,   642,   602,   642,   422,   642,   422,   603,   623,
     666,     3,    65,   675,   752,   423,   556,   632,   556,   556,
     484,   422,   626,   625,    80,   626,    79,   625,   605,   428,
     422,   427,   676,   599,   632,   632,   423,   429,   423,   427,
     423,     1,   713,   714,   642,   626,   625,   580,   626,   642,
     625,   632,   422,   422,   428,   428,   738,   427,   422,    63,
      93,   103,   637,   740,   740,   740,   740,   740,   740,   740,
     740,   425,   422,   427,   422,   422,   422,   740,   740,   740,
     740,   423,   734,   411,   412,   739,   418,   606,   418,   606,
     646,   422,     5,   687,   418,   521,   429,   634,   708,   709,
     422,   422,   422,   717,   422,   427,   422,   422,   422,   717,
     422,   427,   422,     3,   632,   632,   422,     3,   692,   721,
     418,   422,     1,   647,   422,   642,   422,   422,   693,   722,
     693,   689,   690,    67,   511,   423,   423,   423,   423,   423,
     423,   423,   427,   632,   657,    60,   635,   682,   683,   422,
       3,   580,   712,   423,   423,   423,   422,   423,   423,   632,
     423,   422,   423,   423,   632,   418,   632,   736,   735,   425,
     632,   637,   632,   637,   394,   427,   427,   427,   427,   427,
     427,   427,   427,   637,     3,   427,   427,   427,   427,   739,
      21,    32,   604,   605,     1,   604,   422,   427,   689,   523,
     524,   580,     3,   423,   423,   427,     3,   428,     3,   423,
     427,   422,     1,   548,   627,   628,   422,   422,   422,   422,
     422,   422,    65,   492,   556,   605,   405,   405,    66,   683,
     632,   418,   642,   642,   642,   642,   728,   732,   405,   632,
      47,   741,   394,   394,   632,   740,   740,   605,   740,   740,
     740,   740,   605,    34,    35,   405,   426,   731,   425,   740,
     740,   740,   740,    21,    32,   418,   734,   418,   734,   423,
     427,   423,   423,     5,    65,   423,   427,   203,   224,   234,
     501,   541,   418,   708,   717,   632,   717,     3,   423,   423,
      62,   549,   666,   423,   427,   685,   684,   422,     1,   423,
     632,   422,   422,   422,   422,   422,   422,   632,   427,   426,
     427,   632,   632,   427,   427,     3,   427,   742,   743,   427,
     427,   427,   427,   423,   427,   637,   637,   427,   427,   427,
     427,   418,   418,   734,   423,   734,   423,   605,   423,     3,
      78,   129,   429,   524,   525,   526,     3,     3,   526,     3,
     525,   423,   632,   428,   423,   556,   556,   231,   543,   632,
     605,   691,   691,     3,   423,   423,   405,   632,   637,    47,
     605,   605,   645,   423,   427,   605,   605,   605,   605,   422,
     632,   426,   426,   731,   605,   605,   605,   605,   734,   734,
     731,   731,   422,   489,     3,     3,   423,   632,   418,   423,
     428,   632,   423,   394,   742,   427,   422,   645,   742,   742,
     427,   742,   742,   637,   427,   427,   742,   742,   731,   731,
     632,   632,     3,   418,   418,   632,   632,   632,   423,   605,
     423,   423,   605,   423,   423,   426,   605,   605,   423,   423,
     632,   632,   423,   423,   418,   758,   632,   423,   423,   422,
     742,   422,   422,   742,   422,   422,   742,   742,   422,   422,
     423,   423,   423,   423,   758,   423,   423,   674,   423,   423,
     423,   423,   423,   423,   423,   690,   422,   422,   422,   422
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   455,   457,   456,   456,   458,   459,   459,   460,   460,
     462,   463,   461,   464,   464,   465,   465,   466,   466,   466,
     467,   467,   467,   468,   468,   469,   469,   471,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   472,   472,   472,   473,   473,   474,
     474,   475,   475,   475,   476,   476,   477,   478,   478,   479,
     479,   480,   480,   481,   481,   481,   481,   481,   481,   482,
     482,   483,   484,   484,   485,   486,   486,   486,   486,   486,
     486,   486,   486,   487,   486,   486,   488,   488,   488,   488,
     489,   489,   490,   490,   490,   490,   490,   490,   490,   490,
     491,   491,   492,   492,   493,   493,   494,   494,   494,   496,
     497,   495,   498,   499,   495,   500,   495,   501,   501,   502,
     502,   503,   503,   503,   503,   504,   505,   505,   505,   505,
     506,   506,   506,   507,   507,   507,   508,   508,   509,   509,
     510,   511,   510,   510,   510,   510,   510,   512,   510,   510,
     510,   510,   510,   510,   510,   513,   513,   514,   514,   514,
     515,   515,   516,   516,   517,   517,   519,   518,   520,   520,
     522,   521,   523,   523,   523,   523,   523,   523,   524,   524,
     524,   524,   524,   525,   526,   526,   526,   526,   527,   527,
     527,   528,   528,   528,   528,   528,   529,   529,   531,   532,
     530,   533,   533,   534,   534,   535,   536,   536,   537,   537,
     538,   538,   538,   538,   538,   538,   538,   538,   539,   539,
     540,   540,   541,   541,   541,   541,   542,   542,   543,   544,
     544,   544,   545,   545,   546,   546,   547,   547,   548,   549,
     549,   550,   550,   551,   551,   552,   552,   553,   553,   553,
     553,   553,   553,   554,   553,   553,   555,   556,   556,   557,
     558,   558,   559,   559,   560,   562,   563,   561,   564,   565,
     561,   566,   567,   561,   568,   561,   569,   569,   569,   569,
     569,   570,   570,   571,   571,   573,   572,   574,   574,   574,
     574,   574,   575,   575,   575,   576,   576,   576,   577,   577,
     578,   578,   578,   578,   579,   580,   580,   581,   581,   581,
     581,   582,   582,   583,   583,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   585,   585,   586,
     586,   587,   587,   587,   587,   587,   587,   587,   587,   588,
     588,   588,   588,   588,   588,   589,   589,   590,   590,   591,
     591,   591,   591,   591,   591,   592,   592,   592,   592,   593,
     593,   594,   594,   595,   595,   595,   595,   596,   596,   597,
     597,   597,   598,   598,   599,   600,   600,   600,   601,   601,
     602,   602,   602,   602,   603,   603,   604,   604,   605,   605,
     606,   606,   606,   606,   607,   607,   609,   608,   610,   610,
     611,   611,   611,   611,   613,   612,   614,   614,   615,   615,
     615,   615,   615,   616,   617,   617,   618,   618,   619,   619,
     619,   619,   619,   620,   620,   621,   621,   622,   622,   623,
     623,   623,   623,   623,   623,   624,   624,   625,   625,   625,
     625,   626,   626,   626,   626,   627,   627,   628,   628,   628,
     629,   629,   629,   630,   630,   630,   631,   631,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   633,   633,   634,   634,   634,   634,
     635,   635,   636,   636,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   638,   638,   639,   639,   640,   640,   641,   641,
     641,   641,   641,   641,   641,   641,   642,   642,   643,   643,
     643,   643,   643,   643,   643,   643,   643,   643,   643,   643,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   645,   645,   645,   645,   645,   645,   645,   646,
     646,   647,   647,   648,   648,   648,   648,   649,   649,   650,
     650,   650,   650,   650,   651,   651,   651,   651,   651,   651,
     651,   652,   652,   653,   653,   653,   654,   654,   654,   655,
     655,   655,   655,   656,   656,   656,   656,   657,   658,   658,
     660,   661,   662,   663,   659,   664,   664,   664,   664,   665,
     665,   665,   666,   666,   667,   667,   668,   668,   668,   668,
     669,   669,   670,   670,   670,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   672,   671,   673,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   674,   671,
     675,   671,   671,   676,   671,   671,   671,   677,   671,   678,
     671,   671,   671,   671,   671,   671,   671,   671,   679,   679,
     680,   680,   681,   682,   682,   684,   683,   685,   683,   686,
     686,   687,   686,   688,   688,   689,   689,   690,   690,   690,
     691,   691,   692,   693,   693,   694,   694,   694,   695,   695,
     696,   696,   696,   696,   696,   696,   696,   696,   696,   696,
     696,   696,   697,   697,   697,   697,   697,   697,   698,   698,
     699,   699,   700,   701,   702,   702,   703,   703,   704,   704,
     704,   704,   704,   705,   705,   705,   705,   706,   706,   707,
     707,   707,   707,   707,   707,   708,   708,   709,   709,   710,
     710,   710,   710,   711,   711,   712,   712,   712,   712,   712,
     713,   713,   714,   714,   714,   714,   715,   715,   715,   715,
     716,   716,   717,   717,   718,   718,   719,   719,   720,   720,
     721,   722,   722,   723,   724,   724,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     726,   726,   727,   727,   728,   728,   729,   729,   730,   730,
     730,   730,   731,   731,   731,   732,   732,   732,   733,   733,
     733,   734,   734,   734,   734,   734,   734,   735,   735,   735,
     735,   736,   736,   737,   738,   737,   739,   739,   739,   740,
     740,   740,   740,   740,   740,   740,   740,   741,   741,   742,
     742,   743,   743,   743,   743,   743,   744,   744,   744,   744,
     744,   745,   746,   744,   747,   744,   744,   748,   749,   744,
     750,   744,   744,   744,   744,   744,   744,   744,   744,   744,
     744,   744,   744,   744,   744,   744,   744,   744,   744,   744,
     744,   744,   744,   744,   744,   744,   744,   744,   744,   744,
     744,   744,   744,   744,   744,   744,   744,   744,   744,   744,
     744,   744,   744,   744,   744,   744,   744,   751,   751,   751,
     751,   751,   751,   751,   751,   751,   751,   751,   752,   752,
     753,   753,   754,   755,   755,   756,   756,   757,   757,   758,
     758,   759,   759,   759,   760,   760,   761,   762,   762,   763,
     763,   764,   765,   766,   766,   767,   767,   768,   768,   768,
     768,   768,   768,   768,   768,   768,   768,   768,   768,   768,
     768,   768,   768,   768,   768,   768,   768,   768,   768,   768,
     768,   769,   769,   769,   769,   769,   770,   770,   770,   770,
     771,   771,   772,   772,   773,   773,   774,   774,   775,   775,
     776,   776,   777,   777,   778,   778,   779,   779,   780,   780
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     0,     1,     3,     2,     2,     0,
       0,     0,    11,     1,     1,     1,     1,     2,     2,     0,
       2,     5,     0,     1,     0,     2,     1,     0,    12,     4,
       5,     2,     2,     5,     8,     6,     9,     5,     8,     1,
       4,     4,     6,     2,     1,     1,     1,     2,     1,     1,
       0,     4,     2,     1,     7,     7,     1,     2,     1,     0,
       1,     6,     6,     2,     5,     3,     5,     7,     8,     2,
       1,     4,     1,     3,     4,     3,     1,     1,     1,     2,
       2,     1,     2,     0,     4,     1,     1,     2,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     8,
       1,     2,     2,     0,     4,     7,     3,     1,     1,     0,
       0,    11,     0,     0,    14,     0,     8,     1,     1,     1,
       1,     2,     2,     2,     2,     5,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     3,     1,     1,     1,     0,
      11,     0,    13,     2,     5,     5,     7,     0,     9,    11,
      11,     5,     5,     7,     8,     1,     3,     2,     3,     5,
       3,     1,     1,     1,     1,     0,     0,     4,     1,     3,
       0,     5,     1,     3,     3,     3,     3,     2,     3,     3,
       3,     3,     3,     5,     2,     5,     3,     6,     1,     1,
       1,     1,     1,     2,     1,     2,     3,     1,     0,     0,
      10,     0,     1,     1,     2,     3,     3,     3,     3,     1,
       1,     4,     4,     1,     1,     1,     1,     1,     2,     1,
       1,     0,     1,     1,     1,     1,     1,     0,     1,     5,
       6,     7,     1,     1,     1,     0,     2,     1,     3,     5,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     4,     1,     2,     1,     2,     1,
       3,     1,     1,     1,     6,     0,     0,    10,     0,     0,
      13,     0,     0,    12,     0,     7,     6,     4,     4,     4,
       4,     5,     4,     2,     0,     0,     2,     3,     1,     3,
       2,     2,     3,     5,     3,     0,     1,     2,     1,     5,
       5,     3,     2,     3,     1,     1,     0,     2,     3,     3,
       4,     3,     1,     1,     3,     3,     4,     4,     5,     3,
       4,     4,     1,     3,     3,     3,     3,     1,     2,     1,
       0,     5,     4,     4,     4,     4,     4,     3,     3,     4,
       6,     6,     7,     7,     7,     1,     3,     1,     2,     1,
       4,     6,     3,     6,     8,     5,     5,     5,     5,     2,
       1,     4,     2,     3,     3,     2,     3,     2,     1,     3,
       3,     3,     1,     0,     3,     1,     2,     3,     2,     4,
       2,     4,     6,     8,     1,     0,     1,     3,     1,     5,
       1,     1,     1,     1,     1,     0,     0,     6,     2,     1,
       3,     3,     3,     3,     0,     6,     2,     1,     4,     4,
       4,     4,     4,     8,     0,     2,     0,     2,     4,     5,
       6,     5,     6,     0,     2,     1,     3,     0,     2,     5,
       5,     5,     5,     5,     5,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     4,     4,
       1,     3,     3,     2,     2,     1,     6,     4,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     4,     4,
       4,     3,     3,     3,     2,     2,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     6,     1,     5,     3,     1,     0,     2,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     5,     6,     4,     6,     3,     1,     3,     4,     4,
       4,     4,     4,     4,     6,     4,     4,     4,     4,     4,
       6,     4,     4,     6,     4,     4,     4,     4,     4,     4,
       6,     6,     3,     3,     6,     7,     2,     5,     5,     1,
       1,     1,     1,     0,     1,     2,     1,     1,     4,     5,
       3,     2,     4,     5,     4,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     4,     4,     6,     6,     6,     1,
       3,     2,     4,     2,     4,     4,     6,     1,     3,     1,
       3,     3,     2,     2,     6,     4,     6,     4,     6,     4,
       7,     1,     0,     1,     1,     0,     1,     1,     0,     1,
       1,     1,     1,     1,     3,     3,     1,     3,     3,     1,
       0,     0,     0,     0,    17,     1,     1,     1,     1,     1,
       1,     1,     2,     0,     8,     0,     3,     3,     0,     3,
       0,     4,     3,     3,     5,     1,     6,     5,     4,     6,
       6,     4,     6,     6,     5,     5,     5,     5,     6,     5,
       5,     5,     3,     0,     3,     0,     4,     4,     5,     5,
       6,     4,     5,     3,     3,     6,     8,     8,     6,     8,
       8,     5,     5,     5,     3,     3,     3,     3,     3,     3,
       3,     2,     1,     1,     1,     1,     3,     3,     0,    14,
       0,     5,     2,     0,     7,     1,     1,     0,     5,     0,
       4,     3,     2,     5,     3,     4,     9,     5,     2,     1,
       1,     0,     4,     2,     1,     0,     4,     0,     4,     1,
       3,     0,     6,     2,     1,     1,     0,     1,     3,     6,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     4,     3,     1,     0,     2,     1,     6,     6,
       6,     6,     2,     1,     1,     2,     2,     1,     1,     4,
       4,     2,     2,     2,     0,     5,     4,     1,     3,     1,
       5,     3,     7,     1,     0,     6,     6,     5,     3,     1,
       3,     1,     4,     2,     0,     2,     1,     6,     4,     4,
       1,     3,     0,     1,     1,     2,     2,     4,     1,     3,
       2,     1,     3,     2,     1,     3,     3,     2,     2,     6,
       6,     3,     3,    12,    10,    12,     8,    10,    12,    10,
      10,    12,    10,    10,    10,     7,     3,     3,     3,     3,
       1,     2,     0,     1,     5,     3,     1,     1,    10,    11,
      10,    11,     1,     1,     1,     5,     3,     5,     6,     6,
       3,     1,     4,     6,     3,     6,     8,     3,     7,     3,
       7,     1,     3,     1,     0,     3,     1,     1,     0,     2,
       2,     4,     4,     5,     7,     3,     1,     3,     1,     0,
       1,     1,     2,     2,     3,     1,     5,     3,     5,     3,
       2,     0,     0,     6,     0,     8,     2,     0,     0,     6,
       0,     8,     3,     3,     3,     1,     1,     1,     6,     6,
       6,     6,     6,     6,     5,     7,     5,     7,     2,     2,
       2,     2,     3,     5,     4,     4,     4,     4,     5,     5,
       5,     9,     5,     9,     4,     4,     5,     3,     5,     2,
       5,     6,     7,     2,     7,     5,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     0,
       2,     1,     4,     1,     1,     2,     1,     1,     0,     1,
       0,     3,     2,     3,     1,     1,     4,     1,     2,     1,
       2,     6,     5,     1,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     4,
       1,     2,     1,     3,     1,     0,     2,     0,     2,     4,
      11,    14,     1,     0,     1,     0,     1,     0,     1,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 712 "parse.y" /* yacc.c:1646  */
    { pform_set_scope_timescale(yyloc); }
#line 8273 "parse.cc" /* yacc.c:1646  */
    break;

  case 6:
#line 723 "parse.y" /* yacc.c:1646  */
    { PEAssignPattern*tmp = new PEAssignPattern(*(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-2]));
	delete (yyvsp[-1].exprs);
	(yyval.expr) = tmp;
      }
#line 8283 "parse.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 729 "parse.y" /* yacc.c:1646  */
    { PEAssignPattern*tmp = new PEAssignPattern;
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.expr) = tmp;
      }
#line 8292 "parse.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 744 "parse.y" /* yacc.c:1646  */
    { pform_start_class_declaration((yylsp[-4]), (yyvsp[-2].class_type), (yyvsp[-1].class_declaration_extends).type, (yyvsp[-1].class_declaration_extends).exprs, (yyvsp[-3].lifetime)); }
#line 8298 "parse.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 746 "parse.y" /* yacc.c:1646  */
    { // Process a class.
	pform_end_class_declaration((yylsp[0]));
      }
#line 8306 "parse.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 750 "parse.y" /* yacc.c:1646  */
    { // Wrap up the class.
	if ((yyvsp[0].text) && (yyvsp[-7].class_type) && (yyvsp[-7].class_type)->name != (yyvsp[0].text)) {
	      yyerror((yylsp[0]), "error: Class end label doesn't match class name.");
	      delete[](yyvsp[0].text);
	}
      }
#line 8317 "parse.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 765 "parse.y" /* yacc.c:1646  */
    { // Create a synthetic typedef for the class name so that the
	// lexor detects the name as a type.
	perm_string name = lex_strings.make((yyvsp[0].text));
	class_type_t*tmp = new class_type_t(name);
	FILE_NAME(tmp, (yylsp[0]));
	pform_set_typedef(name, tmp, NULL);
	delete[](yyvsp[0].text);
	(yyval.class_type) = tmp;
      }
#line 8331 "parse.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 775 "parse.y" /* yacc.c:1646  */
    { class_type_t*tmp = dynamic_cast<class_type_t*>((yyvsp[0].type_identifier).type);
	if (tmp == 0) {
	      yyerror((yylsp[0]), "Type name \"%s\"is not a predeclared class name.", (yyvsp[0].type_identifier).text);
	}
	delete[](yyvsp[0].type_identifier).text;
	(yyval.class_type) = tmp;
      }
#line 8343 "parse.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 789 "parse.y" /* yacc.c:1646  */
    { class_type_t*tmp = dynamic_cast<class_type_t*> ((yyvsp[0].type_identifier).type);
	if (tmp == 0) {
	      yyerror((yylsp[0]), "error: class declaration endlabel \"%s\" is not a class name\n", (yyvsp[0].type_identifier).text);
	      (yyval.text) = 0;
	} else {
	      (yyval.text) = strdupnew(tmp->name.str());
	}
	delete[](yyvsp[0].type_identifier).text;
      }
#line 8357 "parse.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 799 "parse.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 8363 "parse.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 801 "parse.y" /* yacc.c:1646  */
    { (yyval.text) = 0; }
#line 8369 "parse.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 814 "parse.y" /* yacc.c:1646  */
    { (yyval.class_declaration_extends).type = (yyvsp[0].type_identifier).type;
	(yyval.class_declaration_extends).exprs= 0;
	delete[](yyvsp[0].type_identifier).text;
      }
#line 8378 "parse.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 819 "parse.y" /* yacc.c:1646  */
    { (yyval.class_declaration_extends).type  = (yyvsp[-3].type_identifier).type;
	(yyval.class_declaration_extends).exprs = (yyvsp[-1].exprs);
	delete[](yyvsp[-3].type_identifier).text;
      }
#line 8387 "parse.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 824 "parse.y" /* yacc.c:1646  */
    { (yyval.class_declaration_extends).type = 0; (yyval.class_declaration_extends).exprs = 0; }
#line 8393 "parse.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 844 "parse.y" /* yacc.c:1646  */
    { assert(current_function==0);
	current_function = pform_push_constructor_scope((yylsp[0]));
      }
#line 8401 "parse.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 851 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-6].tf_ports));
	pform_set_constructor_return(current_function);
	pform_set_this_class((yylsp[-9]), current_function);
	current_function_set_statement((yylsp[-9]), (yyvsp[-2].statement_list));
	pform_pop_scope();
	current_function = 0;
      }
#line 8413 "parse.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 862 "parse.y" /* yacc.c:1646  */
    { pform_class_property((yylsp[-2]), (yyvsp[-3].property_qualifier), (yyvsp[-2].data_type), (yyvsp[-1].decl_assignments)); }
#line 8419 "parse.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 865 "parse.y" /* yacc.c:1646  */
    { pform_class_property((yylsp[-4]), (yyvsp[-3].property_qualifier) | property_qualifier_t::make_const(), (yyvsp[-2].data_type), (yyvsp[-1].decl_assignments)); }
#line 8425 "parse.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 870 "parse.y" /* yacc.c:1646  */
    { /* The task_declaration rule puts this into the class */ }
#line 8431 "parse.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 873 "parse.y" /* yacc.c:1646  */
    { /* The function_declaration rule puts this into the class */ }
#line 8437 "parse.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 878 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "sorry: External constructors are not yet supported."); }
#line 8443 "parse.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 880 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-7]), "sorry: External constructors are not yet supported."); }
#line 8449 "parse.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 883 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "sorry: External methods are not yet supported.");
	delete[] (yyvsp[-1].text);
      }
#line 8457 "parse.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 888 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-8]), "sorry: External methods are not yet supported.");
	delete[] (yyvsp[-4].text);
      }
#line 8465 "parse.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 892 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "sorry: External methods are not yet supported.");
	delete[] (yyvsp[-1].text);
      }
#line 8473 "parse.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 896 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-7]), "sorry: External methods are not yet supported.");
	delete[] (yyvsp[-4].text);
      }
#line 8481 "parse.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 908 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Errors in variable names after data type.");
	yyerrok;
      }
#line 8489 "parse.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 913 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: %s doesn't name a type.", (yyvsp[-2].text));
	yyerrok;
      }
#line 8497 "parse.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 918 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "error: I give up on this class constructor declaration.");
	yyerrok;
      }
#line 8505 "parse.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 923 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: invalid class item.");
	yyerrok;
      }
#line 8513 "parse.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 930 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_static(); }
#line 8519 "parse.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 931 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_protected(); }
#line 8525 "parse.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 932 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_local(); }
#line 8531 "parse.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 936 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = (yyvsp[-1].property_qualifier) | (yyvsp[0].property_qualifier); }
#line 8537 "parse.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 937 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = (yyvsp[0].property_qualifier); }
#line 8543 "parse.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 941 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = (yyvsp[0].property_qualifier); }
#line 8549 "parse.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 942 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_none(); }
#line 8555 "parse.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 947 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*expr_list = (yyvsp[-1].exprs);
	strip_tail_items(expr_list);
	PENewClass*tmp = new PENewClass(*expr_list);
	FILE_NAME(tmp, (yylsp[-3]));
	delete (yyvsp[-1].exprs);
	(yyval.expr) = tmp;
      }
#line 8567 "parse.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 955 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmpi = new PEIdent(*(yyvsp[0].pform_name));
	FILE_NAME(tmpi, (yylsp[0]));
	PENewCopy*tmp = new PENewCopy(tmpi);
	FILE_NAME(tmp, (yylsp[-1]));
	delete (yyvsp[0].pform_name);
	(yyval.expr) = tmp;
      }
#line 8579 "parse.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 963 "parse.y" /* yacc.c:1646  */
    { PENewClass*tmp = new PENewClass;
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 8588 "parse.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 974 "parse.y" /* yacc.c:1646  */
    { /* */
	if (gn_assertions_flag) {
	      yyerror((yylsp[-5]), "sorry: concurrent_assertion_item not supported."
		      " Try -gno-assertion to turn this message off.");
	}
      }
#line 8599 "parse.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 981 "parse.y" /* yacc.c:1646  */
    { yyerrok;
        yyerror((yylsp[-5]), "error: Error in property_spec of concurrent assertion item.");
      }
#line 8607 "parse.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 1002 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "sorry: Constraint declarations not supported."); }
#line 8613 "parse.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 1007 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: Errors in the constraint block item list."); }
#line 8619 "parse.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 1026 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "sorry: Constraint prototypes not supported."); }
#line 8625 "parse.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 1036 "parse.y" /* yacc.c:1646  */
    { data_type_t*data_type = (yyvsp[-2].data_type);
	if (data_type == 0) {
	      data_type = new vector_type_t(IVL_VT_LOGIC, false, 0);
	      FILE_NAME(data_type, (yylsp[-2]));
	}
	pform_makewire((yylsp[-2]), 0, str_strength, (yyvsp[-1].decl_assignments), NetNet::IMPLICIT_REG, data_type);
      }
#line 8637 "parse.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 1047 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t use_vtype = (yyvsp[-2].vartype);
	bool reg_flag = false;
	if (use_vtype == IVL_VT_NO_TYPE) {
	      use_vtype = IVL_VT_LOGIC;
	      reg_flag = true;
	}
	vector_type_t*tmp = new vector_type_t(use_vtype, (yyvsp[-1].flag), (yyvsp[0].ranges));
	tmp->reg_flag = reg_flag;
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.data_type) = tmp;
      }
#line 8653 "parse.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 1059 "parse.y" /* yacc.c:1646  */
    { real_type_t*tmp = new real_type_t((yyvsp[0].real_type));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 8662 "parse.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 1064 "parse.y" /* yacc.c:1646  */
    { if (!(yyvsp[0].struct_type)->packed_flag) {
	      yyerror((yylsp[0]), "sorry: Unpacked structs not supported.");
	}
	(yyval.data_type) = (yyvsp[0].struct_type);
      }
#line 8672 "parse.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 1070 "parse.y" /* yacc.c:1646  */
    { (yyval.data_type) = (yyvsp[0].enum_type); }
#line 8678 "parse.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 1072 "parse.y" /* yacc.c:1646  */
    { atom2_type_t*tmp = new atom2_type_t((yyvsp[-1].int_val), (yyvsp[0].flag));
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.data_type) = tmp;
      }
#line 8687 "parse.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 1077 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t>*pd = make_range_from_width(integer_width);
	vector_type_t*tmp = new vector_type_t(IVL_VT_LOGIC, (yyvsp[0].flag), pd);
	tmp->reg_flag = true;
	tmp->integer_flag = true;
	(yyval.data_type) = tmp;
      }
#line 8698 "parse.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 1084 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t>*pd = make_range_from_width(64);
	vector_type_t*tmp = new vector_type_t(IVL_VT_LOGIC, false, pd);
	tmp->reg_flag = !gn_system_verilog();
	(yyval.data_type) = tmp;
      }
#line 8708 "parse.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 1090 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[0].ranges)) {
	      parray_type_t*tmp = new parray_type_t((yyvsp[-1].type_identifier).type, (yyvsp[0].ranges));
	      FILE_NAME(tmp, (yylsp[-1]));
	      (yyval.data_type) = tmp;
	} else (yyval.data_type) = (yyvsp[-1].type_identifier).type;
	delete[](yyvsp[-1].type_identifier).text;
      }
#line 8720 "parse.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 1098 "parse.y" /* yacc.c:1646  */
    { lex_in_package_scope((yyvsp[-1].package)); }
#line 8726 "parse.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 1100 "parse.y" /* yacc.c:1646  */
    { lex_in_package_scope(0);
	(yyval.data_type) = (yyvsp[0].type_identifier).type;
	delete[](yyvsp[0].type_identifier).text;
      }
#line 8735 "parse.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 1105 "parse.y" /* yacc.c:1646  */
    { string_type_t*tmp = new string_type_t;
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 8744 "parse.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 1119 "parse.y" /* yacc.c:1646  */
    { (yyval.data_type) = (yyvsp[0].data_type); }
#line 8750 "parse.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 1121 "parse.y" /* yacc.c:1646  */
    { vector_type_t*tmp = new vector_type_t(IVL_VT_LOGIC, (yyvsp[-1].flag), (yyvsp[0].ranges));
	tmp->implicit_flag = true;
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.data_type) = tmp;
      }
#line 8760 "parse.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 1127 "parse.y" /* yacc.c:1646  */
    { vector_type_t*tmp = new vector_type_t(IVL_VT_LOGIC, false, (yyvsp[0].ranges));
	tmp->implicit_flag = true;
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 8770 "parse.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 1133 "parse.y" /* yacc.c:1646  */
    { (yyval.data_type) = 0; }
#line 8776 "parse.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 1139 "parse.y" /* yacc.c:1646  */
    { (yyval.data_type) = (yyvsp[0].data_type); }
#line 8782 "parse.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 1141 "parse.y" /* yacc.c:1646  */
    { void_type_t*tmp = new void_type_t;
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 8791 "parse.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 1160 "parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-5].text));
	pform_set_type_attrib(tmp3, (yyvsp[-3].text), (yyvsp[-1].text));
	delete[] (yyvsp[-5].text);
	delete[] (yyvsp[-3].text);
      }
#line 8801 "parse.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 1182 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = new PENewArray((yyvsp[-1].expr), 0);
	FILE_NAME((yyval.expr), (yylsp[-3]));
      }
#line 8809 "parse.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 1186 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = new PENewArray((yyvsp[-4].expr), (yyvsp[-1].expr));
	FILE_NAME((yyval.expr), (yylsp[-6]));
      }
#line 8817 "parse.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 1193 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr),(yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 8826 "parse.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 1198 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = pform_compressed_assign_from_inc_dec((yylsp[0]), (yyvsp[0].expr)); }
#line 8832 "parse.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 1200 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 8838 "parse.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 1210 "parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-4]), (yyvsp[-1].text), (yyvsp[-3].lifetime));
      }
#line 8846 "parse.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 1215 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-2].tf_ports));
	current_function->set_return((yyvsp[-6].data_type));
	current_function_set_statement((yyvsp[-1].statement_list)? (yylsp[-1]) : (yylsp[-5]), (yyvsp[-1].statement_list));
	pform_set_this_class((yylsp[-5]), current_function);
	pform_pop_scope();
	current_function = 0;
      }
#line 8858 "parse.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 1223 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-7].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match "
		                 "function name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Function end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-7].text);
      }
#line 8877 "parse.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 1239 "parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-3]), (yyvsp[0].text), (yyvsp[-2].lifetime));
      }
#line 8885 "parse.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 1246 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-5].tf_ports));
	current_function->set_return((yyvsp[-9].data_type));
	current_function_set_statement((yyvsp[-1].statement_list)? (yylsp[-1]) : (yylsp[-8]), (yyvsp[-1].statement_list));
	pform_set_this_class((yylsp[-8]), current_function);
	pform_pop_scope();
	current_function = 0;
	if ((yyvsp[-5].tf_ports)==0 && !gn_system_verilog()) {
	      yyerror((yylsp[-8]), "error: Empty parenthesis syntax requires SystemVerilog.");
	}
      }
#line 8900 "parse.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 1257 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-10].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match "
		                 "function name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Function end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-10].text);
      }
#line 8919 "parse.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 1275 "parse.y" /* yacc.c:1646  */
    { /* */
	if (current_function) {
	      pform_pop_scope();
	      current_function = 0;
	}
	assert(current_function == 0);
	yyerror((yylsp[-5]), "error: Syntax error defining function.");
	yyerrok;
      }
#line 8933 "parse.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1285 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-4].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match function name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Function end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-4].text);
      }
#line 8951 "parse.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 1302 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 8957 "parse.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 1303 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 8963 "parse.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 1307 "parse.y" /* yacc.c:1646  */
    { (yyval.pform_name) = pform_create_this(); }
#line 8969 "parse.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1308 "parse.y" /* yacc.c:1646  */
    { (yyval.pform_name) = pform_create_super(); }
#line 8975 "parse.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1319 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('I', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 8984 "parse.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1324 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('i', (yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.expr) = tmp;
      }
#line 8993 "parse.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1329 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('D', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 9002 "parse.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1334 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('d', (yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.expr) = tmp;
      }
#line 9011 "parse.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1342 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "sorry: \"inside\" expressions not supported yet.");
	(yyval.expr) = 0;
      }
#line 9019 "parse.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1348 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_NO_TYPE; }
#line 9025 "parse.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1349 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_BOOL; }
#line 9031 "parse.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 1350 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_LOGIC; }
#line 9037 "parse.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 1351 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_BOOL; }
#line 9043 "parse.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 1356 "parse.y" /* yacc.c:1646  */
    { (yyval.join_keyword) = PBlock::BL_PAR; }
#line 9049 "parse.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 1358 "parse.y" /* yacc.c:1646  */
    { (yyval.join_keyword) = PBlock::BL_JOIN_NONE; }
#line 9055 "parse.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1360 "parse.y" /* yacc.c:1646  */
    { (yyval.join_keyword) = PBlock::BL_JOIN_ANY; }
#line 9061 "parse.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1365 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "sorry: break statements not supported.");
	(yyval.statement) = 0;
      }
#line 9069 "parse.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 1369 "parse.y" /* yacc.c:1646  */
    { PReturn*tmp = new PReturn(0);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9078 "parse.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 1374 "parse.y" /* yacc.c:1646  */
    { PReturn*tmp = new PReturn((yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 9087 "parse.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 1381 "parse.y" /* yacc.c:1646  */
    { (yyval.lifetime) = LexicalScope::AUTOMATIC; }
#line 9093 "parse.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 1382 "parse.y" /* yacc.c:1646  */
    { (yyval.lifetime) = LexicalScope::STATIC; }
#line 9099 "parse.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 1386 "parse.y" /* yacc.c:1646  */
    { (yyval.lifetime) = (yyvsp[0].lifetime); }
#line 9105 "parse.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 1387 "parse.y" /* yacc.c:1646  */
    { (yyval.lifetime) = LexicalScope::INHERITED; }
#line 9111 "parse.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1395 "parse.y" /* yacc.c:1646  */
    { PForStatement*tmp = new PForStatement((yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr), (yyvsp[-2].statement), (yyvsp[0].statement));
	FILE_NAME(tmp, (yylsp[-10]));
	(yyval.statement) = tmp;
      }
#line 9120 "parse.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 1405 "parse.y" /* yacc.c:1646  */
    { static unsigned for_counter = 0;
	char for_block_name [64];
	snprintf(for_block_name, sizeof for_block_name, "$ivl_for_loop%u", for_counter);
	for_counter += 1;
	PBlock*tmp = pform_push_block_scope(for_block_name, PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-10]));
	current_block_stack.push(tmp);

	list<decl_assignment_t*>assign_list;
	decl_assignment_t*tmp_assign = new decl_assignment_t;
	tmp_assign->name = lex_strings.make((yyvsp[-7].text));
	assign_list.push_back(tmp_assign);
	pform_makewire((yylsp[-7]), 0, str_strength, &assign_list, NetNet::REG, (yyvsp[-8].data_type));
      }
#line 9139 "parse.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 1420 "parse.y" /* yacc.c:1646  */
    { pform_name_t tmp_hident;
	tmp_hident.push_back(name_component_t(lex_strings.make((yyvsp[-9].text))));

	PEIdent*tmp_ident = pform_new_ident(tmp_hident);
	FILE_NAME(tmp_ident, (yylsp[-9]));

	PForStatement*tmp_for = new PForStatement(tmp_ident, (yyvsp[-7].expr), (yyvsp[-5].expr), (yyvsp[-3].statement), (yyvsp[0].statement));
	FILE_NAME(tmp_for, (yylsp[-12]));

	pform_pop_scope();
	vector<Statement*>tmp_for_list (1);
	tmp_for_list[0] = tmp_for;
	PBlock*tmp_blk = current_block_stack.top();
	current_block_stack.pop();
	tmp_blk->set_statement(tmp_for_list);
	(yyval.statement) = tmp_blk;
	delete[](yyvsp[-9].text);
      }
#line 9162 "parse.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 1440 "parse.y" /* yacc.c:1646  */
    { PForever*tmp = new PForever((yyvsp[0].statement));
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9171 "parse.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 1446 "parse.y" /* yacc.c:1646  */
    { PRepeat*tmp = new PRepeat((yyvsp[-2].expr), (yyvsp[0].statement));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.statement) = tmp;
      }
#line 9180 "parse.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1452 "parse.y" /* yacc.c:1646  */
    { PWhile*tmp = new PWhile((yyvsp[-2].expr), (yyvsp[0].statement));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.statement) = tmp;
      }
#line 9189 "parse.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1458 "parse.y" /* yacc.c:1646  */
    { PDoWhile*tmp = new PDoWhile((yyvsp[-2].expr), (yyvsp[-5].statement));
	FILE_NAME(tmp, (yylsp[-6]));
	(yyval.statement) = tmp;
      }
#line 9198 "parse.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1466 "parse.y" /* yacc.c:1646  */
    { static unsigned foreach_counter = 0;
	char for_block_name[64];
	snprintf(for_block_name, sizeof for_block_name, "$ivl_foreach%u", foreach_counter);
	foreach_counter += 1;

	PBlock*tmp = pform_push_block_scope(for_block_name, PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-6]));
	current_block_stack.push(tmp);

	pform_make_foreach_declarations((yylsp[-6]), (yyvsp[-2].perm_strings));
      }
#line 9214 "parse.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1478 "parse.y" /* yacc.c:1646  */
    { PForeach*tmp_for = pform_make_foreach((yylsp[-8]), (yyvsp[-6].text), (yyvsp[-4].perm_strings), (yyvsp[0].statement));

	pform_pop_scope();
	vector<Statement*>tmp_for_list(1);
	tmp_for_list[0] = tmp_for;
	PBlock*tmp_blk = current_block_stack.top();
	current_block_stack.pop();
	tmp_blk->set_statement(tmp_for_list);
	(yyval.statement) = tmp_blk;
      }
#line 9229 "parse.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1493 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
	yyerror((yylsp[-10]), "error: Error in for loop step assignment.");
      }
#line 9237 "parse.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1499 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
	yyerror((yylsp[-10]), "error: Error in for loop condition expression.");
      }
#line 9245 "parse.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1504 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
	yyerror((yylsp[-4]), "error: Incomprehensible for loop.");
      }
#line 9253 "parse.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1509 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
	yyerror((yylsp[-4]), "error: Error in while loop condition.");
      }
#line 9261 "parse.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1514 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
	yyerror((yylsp[-6]), "error: Error in do/while loop condition.");
      }
#line 9269 "parse.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1519 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
        yyerror((yylsp[-4]), "error: Errors in foreach loop variables list.");
      }
#line 9277 "parse.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1528 "parse.y" /* yacc.c:1646  */
    { list<decl_assignment_t*>*tmp = new list<decl_assignment_t*>;
	tmp->push_back((yyvsp[0].decl_assignment));
	(yyval.decl_assignments) = tmp;
      }
#line 9286 "parse.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1533 "parse.y" /* yacc.c:1646  */
    { list<decl_assignment_t*>*tmp = (yyvsp[-2].decl_assignments);
	tmp->push_back((yyvsp[0].decl_assignment));
	(yyval.decl_assignments) = tmp;
      }
#line 9295 "parse.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1541 "parse.y" /* yacc.c:1646  */
    { decl_assignment_t*tmp = new decl_assignment_t;
	tmp->name = lex_strings.make((yyvsp[-1].text));
	if ((yyvsp[0].ranges)) {
	      tmp->index = *(yyvsp[0].ranges);
	      delete (yyvsp[0].ranges);
	}
	delete[](yyvsp[-1].text);
	(yyval.decl_assignment) = tmp;
      }
#line 9309 "parse.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1551 "parse.y" /* yacc.c:1646  */
    { decl_assignment_t*tmp = new decl_assignment_t;
	tmp->name = lex_strings.make((yyvsp[-2].text));
	tmp->expr .reset((yyvsp[0].expr));
	delete[](yyvsp[-2].text);
	(yyval.decl_assignment) = tmp;
      }
#line 9320 "parse.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1558 "parse.y" /* yacc.c:1646  */
    { decl_assignment_t*tmp = new decl_assignment_t;
	tmp->name = lex_strings.make((yyvsp[-4].text));
	PENewClass*expr = new PENewClass;
	FILE_NAME(expr, (yylsp[-2]));
	tmp->expr .reset(expr);
	delete[](yyvsp[-4].text);
	(yyval.decl_assignment) = tmp;
      }
#line 9333 "parse.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1571 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 9343 "parse.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1577 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 9353 "parse.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1596 "parse.y" /* yacc.c:1646  */
    { if (!pform_in_interface())
	      yyerror((yylsp[0]), "error: modport declarations are only allowed "
			  "in interfaces.");
      }
#line 9362 "parse.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1609 "parse.y" /* yacc.c:1646  */
    { pform_start_modport_item((yylsp[0]), (yyvsp[0].text)); }
#line 9368 "parse.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1611 "parse.y" /* yacc.c:1646  */
    { pform_end_modport_item((yylsp[-4])); }
#line 9374 "parse.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1625 "parse.y" /* yacc.c:1646  */
    { if (last_modport_port.type == MP_SIMPLE) {
	      pform_add_modport_port((yylsp[0]), last_modport_port.direction,
				     (yyvsp[0].named_pexpr)->name, (yyvsp[0].named_pexpr)->parm);
	} else {
	      yyerror((yylsp[0]), "error: modport expression not allowed here.");
	}
	delete (yyvsp[0].named_pexpr);
      }
#line 9387 "parse.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1634 "parse.y" /* yacc.c:1646  */
    { if (last_modport_port.type != MP_TF)
	      yyerror((yylsp[0]), "error: task/function declaration not allowed here.");
      }
#line 9395 "parse.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1638 "parse.y" /* yacc.c:1646  */
    { if (last_modport_port.type == MP_SIMPLE) {
	      pform_add_modport_port((yylsp[0]), last_modport_port.direction,
				     lex_strings.make((yyvsp[0].text)), 0);
	} else if (last_modport_port.type != MP_TF) {
	      yyerror((yylsp[0]), "error: list of identifiers not allowed here.");
	}
	delete[] (yyvsp[0].text);
      }
#line 9408 "parse.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1647 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: NULL port declarations are not allowed"); }
#line 9414 "parse.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1652 "parse.y" /* yacc.c:1646  */
    { last_modport_port.type = MP_SIMPLE;
	last_modport_port.direction = (yyvsp[-1].porttype);
	pform_add_modport_port((yylsp[0]), (yyvsp[-1].porttype), lex_strings.make((yyvsp[0].text)), 0);
	delete[] (yyvsp[0].text);
	delete (yyvsp[-2].named_pexprs);
      }
#line 9425 "parse.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1659 "parse.y" /* yacc.c:1646  */
    { last_modport_port.type = MP_SIMPLE;
	last_modport_port.direction = (yyvsp[-1].porttype);
	pform_add_modport_port((yylsp[0]), (yyvsp[-1].porttype), (yyvsp[0].named_pexpr)->name, (yyvsp[0].named_pexpr)->parm);
	delete (yyvsp[0].named_pexpr);
	delete (yyvsp[-2].named_pexprs);
      }
#line 9436 "parse.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1666 "parse.y" /* yacc.c:1646  */
    { last_modport_port.type = MP_TF;
	last_modport_port.is_import = (yyvsp[-1].flag);
	yyerror((yylsp[0]), "sorry: modport task/function ports are not yet supported.");
	delete[] (yyvsp[0].text);
	delete (yyvsp[-2].named_pexprs);
      }
#line 9447 "parse.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1673 "parse.y" /* yacc.c:1646  */
    { last_modport_port.type = MP_TF;
	last_modport_port.is_import = (yyvsp[-1].flag);
	yyerror((yylsp[0]), "sorry: modport task/function ports are not yet supported.");
	delete (yyvsp[-2].named_pexprs);
      }
#line 9457 "parse.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1679 "parse.y" /* yacc.c:1646  */
    { last_modport_port.type = MP_CLOCKING;
	last_modport_port.direction = NetNet::NOT_A_PORT;
	yyerror((yylsp[0]), "sorry: modport clocking declaration is not yet supported.");
	delete[] (yyvsp[0].text);
	delete (yyvsp[-2].named_pexprs);
      }
#line 9468 "parse.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1689 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
	tmp->name = lex_strings.make((yyvsp[-3].text));
	tmp->parm = (yyvsp[-1].expr);
	delete[](yyvsp[-3].text);
	(yyval.named_pexpr) = tmp;
      }
#line 9479 "parse.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1705 "parse.y" /* yacc.c:1646  */
    { (yyval.real_type) = real_type_t::REAL; }
#line 9485 "parse.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1706 "parse.y" /* yacc.c:1646  */
    { (yyval.real_type) = real_type_t::REAL; }
#line 9491 "parse.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1707 "parse.y" /* yacc.c:1646  */
    { (yyval.real_type) = real_type_t::SHORTREAL; }
#line 9497 "parse.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1711 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 9503 "parse.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1713 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 9509 "parse.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1715 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = pform_verinum_with_size((yyvsp[-1].number),(yyvsp[0].number), (yylsp[0]).text, (yylsp[0]).first_line);
	       based_size = 0; }
#line 9516 "parse.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1718 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 9522 "parse.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1720 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Unbased SystemVerilog literal cannot have "
	                   "a size.");
	       (yyval.number) = (yyvsp[-1].number); based_size = 0;}
#line 9530 "parse.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1732 "parse.y" /* yacc.c:1646  */
    { pform_start_package_declaration((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].lifetime)); }
#line 9536 "parse.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1734 "parse.y" /* yacc.c:1646  */
    { pform_set_scope_timescale((yylsp[-5])); }
#line 9542 "parse.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1737 "parse.y" /* yacc.c:1646  */
    { pform_end_package_declaration((yylsp[-9]));
	// If an end label is present make sure it match the package name.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-7].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match package name");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-7].text);
      }
#line 9557 "parse.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1761 "parse.y" /* yacc.c:1646  */
    { }
#line 9563 "parse.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1766 "parse.y" /* yacc.c:1646  */
    { pform_package_import((yylsp[-1]), (yyvsp[-2].package), (yyvsp[0].text));
	delete[](yyvsp[0].text);
      }
#line 9571 "parse.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1770 "parse.y" /* yacc.c:1646  */
    { pform_package_import((yylsp[-1]), (yyvsp[-2].package), 0);
      }
#line 9578 "parse.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1798 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINPUT; }
#line 9584 "parse.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1799 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::POUTPUT; }
#line 9590 "parse.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1800 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINOUT; }
#line 9596 "parse.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1802 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PREF;
        if (!gn_system_verilog()) {
	      yyerror((yylsp[0]), "error: Reference ports (ref) require SystemVerilog.");
	      (yyval.porttype) = NetNet::PINPUT;
	}
      }
#line 9607 "parse.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1815 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = (yyvsp[0].porttype); }
#line 9613 "parse.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1816 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PIMPLICIT; }
#line 9619 "parse.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1825 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "sorry: Simple immediate assertion statements not implemented.");
	(yyval.statement) = 0;
      }
#line 9627 "parse.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1829 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "sorry: Simple immediate assertion statements not implemented.");
	(yyval.statement) = 0;
      }
#line 9635 "parse.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1833 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-6]), "sorry: Simple immediate assertion statements not implemented.");
	(yyval.statement) = 0;
      }
#line 9643 "parse.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1848 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = (yyvsp[0].property_qualifier); }
#line 9649 "parse.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1849 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_none(); }
#line 9655 "parse.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1853 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = (yyvsp[-1].property_qualifier) | (yyvsp[0].property_qualifier); }
#line 9661 "parse.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1854 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = (yyvsp[0].property_qualifier); }
#line 9667 "parse.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1872 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_rand(); }
#line 9673 "parse.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1873 "parse.y" /* yacc.c:1646  */
    { (yyval.property_qualifier) = property_qualifier_t::make_randc(); }
#line 9679 "parse.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1884 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 9685 "parse.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1885 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 9691 "parse.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1890 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t use_vtype = (yyvsp[0].vartype);
	bool reg_flag = false;
	if (use_vtype == IVL_VT_NO_TYPE) {
	      use_vtype = IVL_VT_LOGIC;
	      reg_flag = true;
	}
	vector_type_t*tmp = new vector_type_t(use_vtype, false, 0);
	tmp->reg_flag = reg_flag;
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 9707 "parse.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1902 "parse.y" /* yacc.c:1646  */
    { real_type_t*tmp = new real_type_t((yyvsp[0].real_type));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 9716 "parse.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1907 "parse.y" /* yacc.c:1646  */
    { atom2_type_t*tmp = new atom2_type_t((yyvsp[0].int_val), true);
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 9725 "parse.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1912 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t>*pd = make_range_from_width(integer_width);
	vector_type_t*tmp = new vector_type_t(IVL_VT_LOGIC, true, pd);
	tmp->reg_flag = true;
	tmp->integer_flag = true;
	(yyval.data_type) = tmp;
      }
#line 9736 "parse.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1919 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t>*pd = make_range_from_width(64);
	vector_type_t*tmp = new vector_type_t(IVL_VT_LOGIC, false, pd);
	tmp->reg_flag = !gn_system_verilog();
	(yyval.data_type) = tmp;
      }
#line 9746 "parse.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1925 "parse.y" /* yacc.c:1646  */
    { (yyval.data_type) = (yyvsp[0].type_identifier).type;
	delete[](yyvsp[0].type_identifier).text;
      }
#line 9754 "parse.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1929 "parse.y" /* yacc.c:1646  */
    { lex_in_package_scope((yyvsp[-1].package)); }
#line 9760 "parse.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1931 "parse.y" /* yacc.c:1646  */
    { lex_in_package_scope(0);
	(yyval.data_type) = (yyvsp[0].type_identifier).type;
	delete[](yyvsp[0].type_identifier).text;
      }
#line 9769 "parse.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1936 "parse.y" /* yacc.c:1646  */
    { string_type_t*tmp = new string_type_t;
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.data_type) = tmp;
      }
#line 9778 "parse.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1944 "parse.y" /* yacc.c:1646  */
    { pform_bind_attributes((yyvsp[0].statement)->attributes, (yyvsp[-1].named_pexprs));
	(yyval.statement) = (yyvsp[0].statement);
      }
#line 9786 "parse.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1954 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 9792 "parse.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1956 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 9798 "parse.cc" /* yacc.c:1646  */
    break;

  case 264:
#line 1975 "parse.y" /* yacc.c:1646  */
    { /* streaming concatenation is a SystemVerilog thing. */
	if (gn_system_verilog()) {
	      yyerror((yylsp[-4]), "sorry: Streaming concatenation not supported.");
	      (yyval.expr) = 0;
	} else {
	      yyerror((yylsp[-4]), "error: Streaming concatenation requires SystemVerilog");
	      (yyval.expr) = 0;
	}
      }
#line 9812 "parse.cc" /* yacc.c:1646  */
    break;

  case 265:
#line 1994 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].lifetime));
      }
#line 9820 "parse.cc" /* yacc.c:1646  */
    break;

  case 266:
#line 2000 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-2].tf_ports));
	current_task_set_statement((yylsp[-5]), (yyvsp[-1].statement_list));
	pform_set_this_class((yylsp[-5]), current_task);
	pform_pop_scope();
	current_task = 0;
	if ((yyvsp[-1].statement_list) && (yyvsp[-1].statement_list)->size() > 1 && !gn_system_verilog()) {
	      yyerror((yylsp[-1]), "error: Task body with multiple statements requires SystemVerilog.");
	}
	delete (yyvsp[-1].statement_list);
      }
#line 9835 "parse.cc" /* yacc.c:1646  */
    break;

  case 267:
#line 2011 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name. This is done late so
	// that the parser can look ahead to detect the present
	// endlabel_opt but still have the pform_endmodule() called
	// early enough that the lexor can know we are outside the
	// module.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-7].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match task name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Task end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-7].text);
      }
#line 9857 "parse.cc" /* yacc.c:1646  */
    break;

  case 268:
#line 2030 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].lifetime));
      }
#line 9865 "parse.cc" /* yacc.c:1646  */
    break;

  case 269:
#line 2037 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-5].tf_ports));
	current_task_set_statement((yylsp[-8]), (yyvsp[-1].statement_list));
	pform_set_this_class((yylsp[-8]), current_task);
	pform_pop_scope();
	current_task = 0;
	if ((yyvsp[-1].statement_list)) delete (yyvsp[-1].statement_list);
      }
#line 9877 "parse.cc" /* yacc.c:1646  */
    break;

  case 270:
#line 2045 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name. This is done late so
	// that the parser can look ahead to detect the present
	// endlabel_opt but still have the pform_endmodule() called
	// early enough that the lexor can know we are outside the
	// module.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-10].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match task name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Task end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-10].text);
      }
#line 9899 "parse.cc" /* yacc.c:1646  */
    break;

  case 271:
#line 2064 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-5]), (yyvsp[-3].text), (yyvsp[-4].lifetime));
      }
#line 9907 "parse.cc" /* yacc.c:1646  */
    break;

  case 272:
#line 2070 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports(0);
	current_task_set_statement((yylsp[-7]), (yyvsp[-1].statement_list));
	pform_set_this_class((yylsp[-7]), current_task);
	if (! current_task->method_of()) {
	      cerr << (yylsp[-7]) << ": warning: task definition for \"" << (yyvsp[-7].text)
		   << "\" has an empty port declaration list!" << endl;
	}
	pform_pop_scope();
	current_task = 0;
	if ((yyvsp[-1].statement_list)->size() > 1 && !gn_system_verilog()) {
	      yyerror((yylsp[-1]), "error: Task body with multiple statements requires SystemVerilog.");
	}
	delete (yyvsp[-1].statement_list);
      }
#line 9926 "parse.cc" /* yacc.c:1646  */
    break;

  case 273:
#line 2085 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name. This is done late so
	// that the parser can look ahead to detect the present
	// endlabel_opt but still have the pform_endmodule() called
	// early enough that the lexor can know we are outside the
	// module.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-9].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match task name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Task end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-9].text);
      }
#line 9948 "parse.cc" /* yacc.c:1646  */
    break;

  case 274:
#line 2104 "parse.y" /* yacc.c:1646  */
    {
	if (current_task) {
	      pform_pop_scope();
	      current_task = 0;
	}
      }
#line 9959 "parse.cc" /* yacc.c:1646  */
    break;

  case 275:
#line 2111 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name. This is done late so
	// that the parser can look ahead to detect the present
	// endlabel_opt but still have the pform_endmodule() called
	// early enough that the lexor can know we are outside the
	// module.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-4].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match task name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Task end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-4].text);
      }
#line 9981 "parse.cc" /* yacc.c:1646  */
    break;

  case 276:
#line 2134 "parse.y" /* yacc.c:1646  */
    { vector<pform_tf_port_t>*tmp = pform_make_task_ports((yylsp[-5]), (yyvsp[-5].porttype),
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].ranges), (yyvsp[-1].perm_strings));
	(yyval.tf_ports) = tmp;
      }
#line 9992 "parse.cc" /* yacc.c:1646  */
    break;

  case 277:
#line 2145 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t>*range_stub = make_range_from_width(integer_width);
	vector<pform_tf_port_t>*tmp = pform_make_task_ports((yylsp[-3]), (yyvsp[-3].porttype), IVL_VT_LOGIC, true,
						    range_stub, (yyvsp[-1].perm_strings), true);
	(yyval.tf_ports) = tmp;
      }
#line 10002 "parse.cc" /* yacc.c:1646  */
    break;

  case 278:
#line 2154 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t>*range_stub = make_range_from_width(64);
	vector<pform_tf_port_t>*tmp = pform_make_task_ports((yylsp[-3]), (yyvsp[-3].porttype), IVL_VT_LOGIC, false,
						   range_stub, (yyvsp[-1].perm_strings));
	(yyval.tf_ports) = tmp;
      }
#line 10012 "parse.cc" /* yacc.c:1646  */
    break;

  case 279:
#line 2163 "parse.y" /* yacc.c:1646  */
    { vector<pform_tf_port_t>*tmp = pform_make_task_ports((yylsp[-3]), (yyvsp[-3].porttype), IVL_VT_REAL, true,
						   0, (yyvsp[-1].perm_strings));
	(yyval.tf_ports) = tmp;
      }
#line 10021 "parse.cc" /* yacc.c:1646  */
    break;

  case 280:
#line 2172 "parse.y" /* yacc.c:1646  */
    { vector<pform_tf_port_t>*tmp = pform_make_task_ports((yylsp[-3]), (yyvsp[-3].porttype), IVL_VT_STRING, true,
						   0, (yyvsp[-1].perm_strings));
	(yyval.tf_ports) = tmp;
      }
#line 10030 "parse.cc" /* yacc.c:1646  */
    break;

  case 281:
#line 2191 "parse.y" /* yacc.c:1646  */
    { vector<pform_tf_port_t>*tmp;
	NetNet::PortType use_port_type = (yyvsp[-4].porttype);
        if ((use_port_type == NetNet::PIMPLICIT) && (gn_system_verilog() || ((yyvsp[-3].data_type) == 0)))
              use_port_type = port_declaration_context.port_type;
	perm_string name = lex_strings.make((yyvsp[-2].text));
	list<perm_string>* ilist = list_from_identifier((yyvsp[-2].text));

	if (use_port_type == NetNet::PIMPLICIT) {
	      yyerror((yylsp[-4]), "error: missing task/function port direction.");
	      use_port_type = NetNet::PINPUT; // for error recovery
	}
	if (((yyvsp[-3].data_type) == 0) && ((yyvsp[-4].porttype)==NetNet::PIMPLICIT)) {
		// Detect special case this is an undecorated
		// identifier and we need to get the declaration from
		// left context.
	      if ((yyvsp[-1].ranges) != 0) {
		    yyerror((yylsp[-1]), "internal error: How can there be an unpacked range here?\n");
	      }
	      tmp = pform_make_task_ports((yylsp[-2]), use_port_type,
					  port_declaration_context.data_type,
					  ilist);

	} else {
		// Otherwise, the decorations for this identifier
		// indicate the type. Save the type for any right
		// context that may come later.
	      port_declaration_context.port_type = use_port_type;
	      if ((yyvsp[-3].data_type) == 0) {
		    (yyvsp[-3].data_type) = new vector_type_t(IVL_VT_LOGIC, false, 0);
		    FILE_NAME((yyvsp[-3].data_type), (yylsp[-2]));
	      }
	      port_declaration_context.data_type = (yyvsp[-3].data_type);
	      tmp = pform_make_task_ports((yylsp[-2]), use_port_type, (yyvsp[-3].data_type), ilist);
	}
	if ((yyvsp[-1].ranges) != 0) {
	      if (gn_system_verilog()) {
		    pform_set_reg_idx(name, (yyvsp[-1].ranges));
	      } else {
		    yyerror((yylsp[-1]), "error: Task/function port with unpacked dimensions requires SystemVerilog.");
	      }
	}

	(yyval.tf_ports) = tmp;
	if ((yyvsp[0].expr)) {
	      assert(tmp->size()==1);
	      tmp->front().defe = (yyvsp[0].expr);
	}
      }
#line 10083 "parse.cc" /* yacc.c:1646  */
    break;

  case 282:
#line 2243 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Error in task/function port item after port name %s.", (yyvsp[-1].text));
	yyerrok;
	(yyval.tf_ports) = 0;
      }
#line 10092 "parse.cc" /* yacc.c:1646  */
    break;

  case 283:
#line 2253 "parse.y" /* yacc.c:1646  */
    { if (! gn_system_verilog()) {
	      yyerror((yylsp[-1]), "error: Task/function default arguments require "
	                  "SystemVerilog.");
	}
	(yyval.expr) = (yyvsp[0].expr);
      }
#line 10103 "parse.cc" /* yacc.c:1646  */
    break;

  case 284:
#line 2259 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 10109 "parse.cc" /* yacc.c:1646  */
    break;

  case 285:
#line 2263 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = gn_system_verilog() ? NetNet::PINPUT : NetNet::PIMPLICIT;
	port_declaration_context.data_type = 0;
      }
#line 10117 "parse.cc" /* yacc.c:1646  */
    break;

  case 286:
#line 2267 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 10123 "parse.cc" /* yacc.c:1646  */
    break;

  case 287:
#line 2272 "parse.y" /* yacc.c:1646  */
    { vector<pform_tf_port_t>*tmp;
	if ((yyvsp[-2].tf_ports) && (yyvsp[0].tf_ports)) {
	      size_t s1 = (yyvsp[-2].tf_ports)->size();
	      tmp = (yyvsp[-2].tf_ports);
	      tmp->resize(tmp->size()+(yyvsp[0].tf_ports)->size());
	      for (size_t idx = 0 ; idx < (yyvsp[0].tf_ports)->size() ; idx += 1)
		    tmp->at(s1+idx) = (yyvsp[0].tf_ports)->at(idx);
	      delete (yyvsp[0].tf_ports);
	} else if ((yyvsp[-2].tf_ports)) {
	      tmp = (yyvsp[-2].tf_ports);
	} else {
	      tmp = (yyvsp[0].tf_ports);
	}
	(yyval.tf_ports) = tmp;
      }
#line 10143 "parse.cc" /* yacc.c:1646  */
    break;

  case 288:
#line 2289 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 10149 "parse.cc" /* yacc.c:1646  */
    break;

  case 289:
#line 2294 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Syntax error in task/function port declaration.");
	(yyval.tf_ports) = (yyvsp[0].tf_ports);
      }
#line 10157 "parse.cc" /* yacc.c:1646  */
    break;

  case 290:
#line 2298 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: NULL port declarations are not allowed.");
	(yyval.tf_ports) = (yyvsp[-1].tf_ports);
      }
#line 10165 "parse.cc" /* yacc.c:1646  */
    break;

  case 291:
#line 2302 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: ';' is an invalid port declaration separator.");
	(yyval.tf_ports) = (yyvsp[-1].tf_ports);
      }
#line 10173 "parse.cc" /* yacc.c:1646  */
    break;

  case 292:
#line 2309 "parse.y" /* yacc.c:1646  */
    { pform_set_timeunit((yyvsp[-1].text), allow_timeunit_decl); }
#line 10179 "parse.cc" /* yacc.c:1646  */
    break;

  case 293:
#line 2311 "parse.y" /* yacc.c:1646  */
    { bool initial_decl = allow_timeunit_decl && allow_timeprec_decl;
        pform_set_timeunit((yyvsp[-3].text), initial_decl);
        pform_set_timeprec((yyvsp[-1].text), initial_decl);
      }
#line 10188 "parse.cc" /* yacc.c:1646  */
    break;

  case 294:
#line 2316 "parse.y" /* yacc.c:1646  */
    { pform_set_timeprec((yyvsp[-1].text), allow_timeprec_decl); }
#line 10194 "parse.cc" /* yacc.c:1646  */
    break;

  case 298:
#line 2329 "parse.y" /* yacc.c:1646  */
    { }
#line 10200 "parse.cc" /* yacc.c:1646  */
    break;

  case 299:
#line 2331 "parse.y" /* yacc.c:1646  */
    { }
#line 10206 "parse.cc" /* yacc.c:1646  */
    break;

  case 300:
#line 2336 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t> *tmp = new list<pform_range_t>;
	pform_range_t index ((yyvsp[-3].expr),(yyvsp[-1].expr));
	tmp->push_back(index);
	(yyval.ranges) = tmp;
      }
#line 10216 "parse.cc" /* yacc.c:1646  */
    break;

  case 301:
#line 2342 "parse.y" /* yacc.c:1646  */
    { // SystemVerilog canonical range
	if (!gn_system_verilog()) {
	      warn_count += 1;
	      cerr << (yylsp[-1]) << ": warning: Use of SystemVerilog [size] dimension. "
		   << "Use at least -g2005-sv to remove this warning." << endl;
	}
	list<pform_range_t> *tmp = new list<pform_range_t>;
	pform_range_t index;
	index.first = new PENumber(new verinum((uint64_t)0, integer_width));
	index.second = new PEBinary('-', (yyvsp[-1].expr), new PENumber(new verinum((uint64_t)1, integer_width)));
	tmp->push_back(index);
	(yyval.ranges) = tmp;
      }
#line 10234 "parse.cc" /* yacc.c:1646  */
    break;

  case 302:
#line 2356 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t> *tmp = new list<pform_range_t>;
	pform_range_t index (0,0);
	tmp->push_back(index);
	(yyval.ranges) = tmp;
      }
#line 10244 "parse.cc" /* yacc.c:1646  */
    break;

  case 303:
#line 2362 "parse.y" /* yacc.c:1646  */
    { // SystemVerilog queue
	list<pform_range_t> *tmp = new list<pform_range_t>;
	pform_range_t index (new PENull,0);
	if (!gn_system_verilog()) {
	      yyerror("error: Queue declarations require SystemVerilog.");
	}
	tmp->push_back(index);
	(yyval.ranges) = tmp;
      }
#line 10258 "parse.cc" /* yacc.c:1646  */
    break;

  case 304:
#line 2375 "parse.y" /* yacc.c:1646  */
    { if (!gn_system_verilog()) {
	      yyerror((yylsp[0]), "error: overriding the default variable lifetime "
			  "requires SystemVerilog.");
	} else if ((yyvsp[0].lifetime) != pform_peek_scope()->default_lifetime) {
	      yyerror((yylsp[0]), "sorry: overriding the default variable lifetime "
			  "is not yet supported.");
	}
	var_lifetime = (yyvsp[0].lifetime);
      }
#line 10272 "parse.cc" /* yacc.c:1646  */
    break;

  case 305:
#line 2391 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[0].named_pexprs); }
#line 10278 "parse.cc" /* yacc.c:1646  */
    break;

  case 306:
#line 2393 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 10284 "parse.cc" /* yacc.c:1646  */
    break;

  case 307:
#line 2397 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 10290 "parse.cc" /* yacc.c:1646  */
    break;

  case 308:
#line 2398 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-1].named_pexprs); }
#line 10296 "parse.cc" /* yacc.c:1646  */
    break;

  case 309:
#line 2399 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-2].named_pexprs); }
#line 10302 "parse.cc" /* yacc.c:1646  */
    break;

  case 310:
#line 2401 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = (yyvsp[-3].named_pexprs);
	if (tmp) {
	    tmp->splice(tmp->end(), *(yyvsp[-1].named_pexprs));
	    delete (yyvsp[-1].named_pexprs);
	    (yyval.named_pexprs) = tmp;
	} else (yyval.named_pexprs) = (yyvsp[-1].named_pexprs);
      }
#line 10314 "parse.cc" /* yacc.c:1646  */
    break;

  case 311:
#line 2412 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = (yyvsp[-2].named_pexprs);
        tmp->push_back(*(yyvsp[0].named_pexpr));
	delete (yyvsp[0].named_pexpr);
	(yyval.named_pexprs) = tmp;
      }
#line 10324 "parse.cc" /* yacc.c:1646  */
    break;

  case 312:
#line 2418 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = new list<named_pexpr_t>;
        tmp->push_back(*(yyvsp[0].named_pexpr));
	delete (yyvsp[0].named_pexpr);
	(yyval.named_pexprs) = tmp;
      }
#line 10334 "parse.cc" /* yacc.c:1646  */
    break;

  case 313:
#line 2428 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[0].text));
		  tmp->parm = 0;
		  delete[](yyvsp[0].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 10345 "parse.cc" /* yacc.c:1646  */
    break;

  case 314:
#line 2435 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[-2].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp2;
		}
#line 10357 "parse.cc" /* yacc.c:1646  */
    break;

  case 315:
#line 2457 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].data_type)) pform_set_data_type((yylsp[-2]), (yyvsp[-2].data_type), (yyvsp[-1].perm_strings), NetNet::REG, attributes_in_context);
      }
#line 10364 "parse.cc" /* yacc.c:1646  */
    break;

  case 316:
#line 2461 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].data_type)) pform_set_data_type((yylsp[-2]), (yyvsp[-2].data_type), (yyvsp[-1].perm_strings), NetNet::REG, attributes_in_context);
	var_lifetime = LexicalScope::INHERITED;
      }
#line 10372 "parse.cc" /* yacc.c:1646  */
    break;

  case 317:
#line 2466 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].data_type)) pform_set_data_type((yylsp[-2]), (yyvsp[-2].data_type), (yyvsp[-1].perm_strings), NetNet::REG, attributes_in_context);
      }
#line 10379 "parse.cc" /* yacc.c:1646  */
    break;

  case 318:
#line 2470 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].data_type)) pform_set_data_type((yylsp[-2]), (yyvsp[-2].data_type), (yyvsp[-1].perm_strings), NetNet::REG, attributes_in_context);
	var_lifetime = LexicalScope::INHERITED;
      }
#line 10387 "parse.cc" /* yacc.c:1646  */
    break;

  case 319:
#line 2475 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].perm_strings)) pform_make_events((yyvsp[-1].perm_strings), (yylsp[-2]).text, (yylsp[-2]).first_line);
      }
#line 10394 "parse.cc" /* yacc.c:1646  */
    break;

  case 323:
#line 2489 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in integer variable list.");
	yyerrok;
      }
#line 10402 "parse.cc" /* yacc.c:1646  */
    break;

  case 324:
#line 2494 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in time variable list.");
	yyerrok;
      }
#line 10410 "parse.cc" /* yacc.c:1646  */
    break;

  case 325:
#line 2499 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in parameter list.");
	yyerrok;
      }
#line 10418 "parse.cc" /* yacc.c:1646  */
    break;

  case 326:
#line 2503 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error localparam list.");
	yyerrok;
      }
#line 10426 "parse.cc" /* yacc.c:1646  */
    break;

  case 329:
#line 2514 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 10432 "parse.cc" /* yacc.c:1646  */
    break;

  case 330:
#line 2515 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 10438 "parse.cc" /* yacc.c:1646  */
    break;

  case 331:
#line 2522 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-2].text));
	pform_set_typedef(name, (yyvsp[-3].data_type), (yyvsp[-1].ranges));
	delete[](yyvsp[-2].text);
      }
#line 10447 "parse.cc" /* yacc.c:1646  */
    break;

  case 332:
#line 2531 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].type_identifier).text);
	if (pform_test_type_identifier_local(name)) {
	      yyerror((yylsp[-1]), "error: Typedef identifier \"%s\" is already a type name.", (yyvsp[-1].type_identifier).text);

	} else {
	      pform_set_typedef(name, (yyvsp[-2].data_type), NULL);
	}
	delete[](yyvsp[-1].type_identifier).text;
      }
#line 10461 "parse.cc" /* yacc.c:1646  */
    break;

  case 333:
#line 2544 "parse.y" /* yacc.c:1646  */
    { // Create a synthetic typedef for the class name so that the
	// lexor detects the name as a type.
	perm_string name = lex_strings.make((yyvsp[-1].text));
	class_type_t*tmp = new class_type_t(name);
	FILE_NAME(tmp, (yylsp[-1]));
	pform_set_typedef(name, tmp, NULL);
	delete[](yyvsp[-1].text);
      }
#line 10474 "parse.cc" /* yacc.c:1646  */
    break;

  case 334:
#line 2553 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "sorry: Enum forward declarations not supported yet."); }
#line 10480 "parse.cc" /* yacc.c:1646  */
    break;

  case 335:
#line 2555 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "sorry: Struct forward declarations not supported yet."); }
#line 10486 "parse.cc" /* yacc.c:1646  */
    break;

  case 336:
#line 2557 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "sorry: Union forward declarations not supported yet."); }
#line 10492 "parse.cc" /* yacc.c:1646  */
    break;

  case 337:
#line 2559 "parse.y" /* yacc.c:1646  */
    { // Create a synthetic typedef for the class name so that the
	// lexor detects the name as a type.
	perm_string name = lex_strings.make((yyvsp[-1].text));
	class_type_t*tmp = new class_type_t(name);
	FILE_NAME(tmp, (yylsp[-1]));
	pform_set_typedef(name, tmp, NULL);
	delete[](yyvsp[-1].text);
      }
#line 10505 "parse.cc" /* yacc.c:1646  */
    break;

  case 338:
#line 2569 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Syntax error in typedef clause.");
	yyerrok;
      }
#line 10513 "parse.cc" /* yacc.c:1646  */
    break;

  case 339:
#line 2582 "parse.y" /* yacc.c:1646  */
    { enum_type_t*enum_type = new enum_type_t;
	FILE_NAME(enum_type, (yylsp[-3]));
	enum_type->names .reset((yyvsp[-1].named_pexprs));
	enum_type->base_type = IVL_VT_BOOL;
	enum_type->signed_flag = true;
	enum_type->integer_flag = false;
	enum_type->range.reset(make_range_from_width(32));
	(yyval.enum_type) = enum_type;
      }
#line 10527 "parse.cc" /* yacc.c:1646  */
    break;

  case 340:
#line 2592 "parse.y" /* yacc.c:1646  */
    { enum_type_t*enum_type = new enum_type_t;
	FILE_NAME(enum_type, (yylsp[-5]));
	enum_type->names .reset((yyvsp[-1].named_pexprs));
	enum_type->base_type = IVL_VT_BOOL;
	enum_type->signed_flag = (yyvsp[-3].flag);
	enum_type->integer_flag = false;
	enum_type->range.reset(make_range_from_width((yyvsp[-4].int_val)));
	(yyval.enum_type) = enum_type;
      }
#line 10541 "parse.cc" /* yacc.c:1646  */
    break;

  case 341:
#line 2602 "parse.y" /* yacc.c:1646  */
    { enum_type_t*enum_type = new enum_type_t;
	FILE_NAME(enum_type, (yylsp[-5]));
	enum_type->names .reset((yyvsp[-1].named_pexprs));
	enum_type->base_type = IVL_VT_LOGIC;
	enum_type->signed_flag = (yyvsp[-3].flag);
	enum_type->integer_flag = true;
	enum_type->range.reset(make_range_from_width(integer_width));
	(yyval.enum_type) = enum_type;
      }
#line 10555 "parse.cc" /* yacc.c:1646  */
    break;

  case 342:
#line 2612 "parse.y" /* yacc.c:1646  */
    { enum_type_t*enum_type = new enum_type_t;
	FILE_NAME(enum_type, (yylsp[-6]));
	enum_type->names .reset((yyvsp[-1].named_pexprs));
	enum_type->base_type = IVL_VT_LOGIC;
	enum_type->signed_flag = (yyvsp[-4].flag);
	enum_type->integer_flag = false;
	enum_type->range.reset((yyvsp[-3].ranges) ? (yyvsp[-3].ranges) : make_range_from_width(1));
	(yyval.enum_type) = enum_type;
      }
#line 10569 "parse.cc" /* yacc.c:1646  */
    break;

  case 343:
#line 2622 "parse.y" /* yacc.c:1646  */
    { enum_type_t*enum_type = new enum_type_t;
	FILE_NAME(enum_type, (yylsp[-6]));
	enum_type->names .reset((yyvsp[-1].named_pexprs));
	enum_type->base_type = IVL_VT_LOGIC;
	enum_type->signed_flag = (yyvsp[-4].flag);
	enum_type->integer_flag = false;
	enum_type->range.reset((yyvsp[-3].ranges) ? (yyvsp[-3].ranges) : make_range_from_width(1));
	(yyval.enum_type) = enum_type;
      }
#line 10583 "parse.cc" /* yacc.c:1646  */
    break;

  case 344:
#line 2632 "parse.y" /* yacc.c:1646  */
    { enum_type_t*enum_type = new enum_type_t;
	FILE_NAME(enum_type, (yylsp[-6]));
	enum_type->names .reset((yyvsp[-1].named_pexprs));
	enum_type->base_type = IVL_VT_BOOL;
	enum_type->signed_flag = (yyvsp[-4].flag);
	enum_type->integer_flag = false;
	enum_type->range.reset((yyvsp[-3].ranges) ? (yyvsp[-3].ranges) : make_range_from_width(1));
	(yyval.enum_type) = enum_type;
      }
#line 10597 "parse.cc" /* yacc.c:1646  */
    break;

  case 345:
#line 2645 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[0].named_pexprs);
      }
#line 10604 "parse.cc" /* yacc.c:1646  */
    break;

  case 346:
#line 2648 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*lst = (yyvsp[-2].named_pexprs);
	lst->splice(lst->end(), *(yyvsp[0].named_pexprs));
	delete (yyvsp[0].named_pexprs);
	(yyval.named_pexprs) = lst;
      }
#line 10614 "parse.cc" /* yacc.c:1646  */
    break;

  case 347:
#line 2657 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number);
      }
#line 10621 "parse.cc" /* yacc.c:1646  */
    break;

  case 348:
#line 2660 "parse.y" /* yacc.c:1646  */
    { verinum tmp = -(*((yyvsp[0].number)));
	*((yyvsp[0].number)) = tmp;
	(yyval.number) = (yyvsp[0].number);
      }
#line 10630 "parse.cc" /* yacc.c:1646  */
    break;

  case 349:
#line 2668 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[0].text));
	delete[](yyvsp[0].text);
	(yyval.named_pexprs) = make_named_number(name);
      }
#line 10639 "parse.cc" /* yacc.c:1646  */
    break;

  case 350:
#line 2673 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-3].text));
	long count = check_enum_seq_value((yylsp[-3]), (yyvsp[-1].number), false);
	delete[](yyvsp[-3].text);
	(yyval.named_pexprs) = make_named_numbers(name, 0, count-1);
	delete (yyvsp[-1].number);
      }
#line 10650 "parse.cc" /* yacc.c:1646  */
    break;

  case 351:
#line 2680 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-5].text));
	(yyval.named_pexprs) = make_named_numbers(name, check_enum_seq_value((yylsp[-5]), (yyvsp[-3].number), true),
	                              check_enum_seq_value((yylsp[-5]), (yyvsp[-1].number), true));
	delete[](yyvsp[-5].text);
	delete (yyvsp[-3].number);
	delete (yyvsp[-1].number);
      }
#line 10662 "parse.cc" /* yacc.c:1646  */
    break;

  case 352:
#line 2688 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-2].text));
	delete[](yyvsp[-2].text);
	(yyval.named_pexprs) = make_named_number(name, (yyvsp[0].expr));
      }
#line 10671 "parse.cc" /* yacc.c:1646  */
    break;

  case 353:
#line 2693 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-5].text));
	long count = check_enum_seq_value((yylsp[-5]), (yyvsp[-3].number), false);
	(yyval.named_pexprs) = make_named_numbers(name, 0, count-1, (yyvsp[0].expr));
	delete[](yyvsp[-5].text);
	delete (yyvsp[-3].number);
      }
#line 10682 "parse.cc" /* yacc.c:1646  */
    break;

  case 354:
#line 2700 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-7].text));
	(yyval.named_pexprs) = make_named_numbers(name, check_enum_seq_value((yylsp[-7]), (yyvsp[-5].number), true),
	                              check_enum_seq_value((yylsp[-7]), (yyvsp[-3].number), true), (yyvsp[0].expr));
	delete[](yyvsp[-7].text);
	delete (yyvsp[-5].number);
	delete (yyvsp[-3].number);
      }
#line 10694 "parse.cc" /* yacc.c:1646  */
    break;

  case 355:
#line 2711 "parse.y" /* yacc.c:1646  */
    { struct_type_t*tmp = new struct_type_t;
	FILE_NAME(tmp, (yylsp[-4]));
	tmp->packed_flag = (yyvsp[-3].flag);
	tmp->union_flag = false;
	tmp->members .reset((yyvsp[-1].struct_members));
	(yyval.struct_type) = tmp;
      }
#line 10706 "parse.cc" /* yacc.c:1646  */
    break;

  case 356:
#line 2719 "parse.y" /* yacc.c:1646  */
    { struct_type_t*tmp = new struct_type_t;
	FILE_NAME(tmp, (yylsp[-4]));
	tmp->packed_flag = (yyvsp[-3].flag);
	tmp->union_flag = true;
	tmp->members .reset((yyvsp[-1].struct_members));
	(yyval.struct_type) = tmp;
      }
#line 10718 "parse.cc" /* yacc.c:1646  */
    break;

  case 357:
#line 2727 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: Errors in struct member list.");
	yyerrok;
	struct_type_t*tmp = new struct_type_t;
	FILE_NAME(tmp, (yylsp[-4]));
	tmp->packed_flag = (yyvsp[-3].flag);
	tmp->union_flag = false;
	(yyval.struct_type) = tmp;
      }
#line 10731 "parse.cc" /* yacc.c:1646  */
    break;

  case 358:
#line 2736 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: Errors in union member list.");
	yyerrok;
	struct_type_t*tmp = new struct_type_t;
	FILE_NAME(tmp, (yylsp[-4]));
	tmp->packed_flag = (yyvsp[-3].flag);
	tmp->union_flag = true;
	(yyval.struct_type) = tmp;
      }
#line 10744 "parse.cc" /* yacc.c:1646  */
    break;

  case 359:
#line 2752 "parse.y" /* yacc.c:1646  */
    { list<struct_member_t*>*tmp = (yyvsp[-1].struct_members);
	tmp->push_back((yyvsp[0].struct_member));
	(yyval.struct_members) = tmp;
      }
#line 10753 "parse.cc" /* yacc.c:1646  */
    break;

  case 360:
#line 2757 "parse.y" /* yacc.c:1646  */
    { list<struct_member_t*>*tmp = new list<struct_member_t*>;
	tmp->push_back((yyvsp[0].struct_member));
	(yyval.struct_members) = tmp;
      }
#line 10762 "parse.cc" /* yacc.c:1646  */
    break;

  case 361:
#line 2765 "parse.y" /* yacc.c:1646  */
    { struct_member_t*tmp = new struct_member_t;
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->type  .reset((yyvsp[-2].data_type));
	tmp->names .reset((yyvsp[-1].decl_assignments));
	(yyval.struct_member) = tmp;
      }
#line 10773 "parse.cc" /* yacc.c:1646  */
    break;

  case 362:
#line 2772 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "Error in struct/union member.");
	yyerrok;
	(yyval.struct_member) = 0;
      }
#line 10782 "parse.cc" /* yacc.c:1646  */
    break;

  case 363:
#line 2780 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[-2].exprs);
		  tmp->stat = (yyvsp[0].statement);
		  delete (yyvsp[-2].exprs);
		  (yyval.citem) = tmp;
		}
#line 10793 "parse.cc" /* yacc.c:1646  */
    break;

  case 364:
#line 2787 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 10802 "parse.cc" /* yacc.c:1646  */
    break;

  case 365:
#line 2792 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 10811 "parse.cc" /* yacc.c:1646  */
    break;

  case 366:
#line 2797 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Incomprehensible case expression.");
		  yyerrok;
		}
#line 10819 "parse.cc" /* yacc.c:1646  */
    break;

  case 367:
#line 2804 "parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[-1].citems), (yyvsp[0].citem));
		  delete (yyvsp[-1].citems);
		  (yyval.citems) = tmp;
		}
#line 10829 "parse.cc" /* yacc.c:1646  */
    break;

  case 368:
#line 2810 "parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[0].citem);
		  (yyval.citems) = tmp;
		}
#line 10838 "parse.cc" /* yacc.c:1646  */
    break;

  case 374:
#line 2829 "parse.y" /* yacc.c:1646  */
    { pform_set_defparam(*(yyvsp[-2].pform_name), (yyvsp[0].expr));
		  delete (yyvsp[-2].pform_name);
		}
#line 10846 "parse.cc" /* yacc.c:1646  */
    break;

  case 376:
#line 2837 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: defparam may not include a range.");
	delete (yyvsp[-1].ranges);
      }
#line 10854 "parse.cc" /* yacc.c:1646  */
    break;

  case 378:
#line 2845 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[0].expr));
		  (yyval.exprs) = tmp;
		}
#line 10863 "parse.cc" /* yacc.c:1646  */
    break;

  case 379:
#line 2850 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[-1].expr));
		  (yyval.exprs) = tmp;
		}
#line 10872 "parse.cc" /* yacc.c:1646  */
    break;

  case 380:
#line 2858 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[0].expr));
		  (yyval.exprs) = tmp;
		}
#line 10881 "parse.cc" /* yacc.c:1646  */
    break;

  case 381:
#line 2863 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[-1].expr));
		  (yyval.exprs) = tmp;
		}
#line 10890 "parse.cc" /* yacc.c:1646  */
    break;

  case 382:
#line 2868 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[-3].expr));
		  tmp->push_back((yyvsp[-1].expr));
		  (yyval.exprs) = tmp;
		}
#line 10900 "parse.cc" /* yacc.c:1646  */
    break;

  case 383:
#line 2874 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[-5].expr));
		  tmp->push_back((yyvsp[-3].expr));
		  tmp->push_back((yyvsp[-1].expr));
		  (yyval.exprs) = tmp;
		}
#line 10911 "parse.cc" /* yacc.c:1646  */
    break;

  case 384:
#line 2883 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 10917 "parse.cc" /* yacc.c:1646  */
    break;

  case 385:
#line 2884 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 10923 "parse.cc" /* yacc.c:1646  */
    break;

  case 386:
#line 2889 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
	tmp->push_back((yyvsp[0].expr));
	(yyval.exprs) = tmp;
      }
#line 10932 "parse.cc" /* yacc.c:1646  */
    break;

  case 387:
#line 2894 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-2].exprs);
	tmp->push_back((yyvsp[0].expr));
	(yyval.exprs) = tmp;
      }
#line 10941 "parse.cc" /* yacc.c:1646  */
    break;

  case 388:
#line 2902 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  (yyval.expr) = tmp;
		}
#line 10949 "parse.cc" /* yacc.c:1646  */
    break;

  case 389:
#line 2906 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 10955 "parse.cc" /* yacc.c:1646  */
    break;

  case 390:
#line 2912 "parse.y" /* yacc.c:1646  */
    { verinum*tmp = (yyvsp[0].number);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		  based_size = 0;
		}
#line 10970 "parse.cc" /* yacc.c:1646  */
    break;

  case 391:
#line 2923 "parse.y" /* yacc.c:1646  */
    { verireal*tmp = (yyvsp[0].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		}
#line 10984 "parse.cc" /* yacc.c:1646  */
    break;

  case 392:
#line 2933 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[0].text)));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10994 "parse.cc" /* yacc.c:1646  */
    break;

  case 393:
#line 2939 "parse.y" /* yacc.c:1646  */
    { int unit;

		  based_size = 0;
		  (yyval.expr)         = 0;
		  if ((yyvsp[0].text) == 0 || !get_time_unit((yyvsp[0].text), unit))
			yyerror((yylsp[0]), "internal error: delay.");
		  else {
			double p = pow(10.0,
			               (double)(unit - pform_get_timeunit()));
			double time = atof((yyvsp[0].text)) * p;

			verireal *v = new verireal(time);
			(yyval.expr) = new PEFNumber(v);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		}
#line 11015 "parse.cc" /* yacc.c:1646  */
    break;

  case 396:
#line 2965 "parse.y" /* yacc.c:1646  */
    { pform_start_discipline((yyvsp[-1].text)); }
#line 11021 "parse.cc" /* yacc.c:1646  */
    break;

  case 397:
#line 2967 "parse.y" /* yacc.c:1646  */
    { pform_end_discipline((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 11027 "parse.cc" /* yacc.c:1646  */
    break;

  case 400:
#line 2977 "parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_DISCRETE); }
#line 11033 "parse.cc" /* yacc.c:1646  */
    break;

  case 401:
#line 2979 "parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_CONTINUOUS); }
#line 11039 "parse.cc" /* yacc.c:1646  */
    break;

  case 402:
#line 2981 "parse.y" /* yacc.c:1646  */
    { pform_discipline_potential((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 11045 "parse.cc" /* yacc.c:1646  */
    break;

  case 403:
#line 2983 "parse.y" /* yacc.c:1646  */
    { pform_discipline_flow((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 11051 "parse.cc" /* yacc.c:1646  */
    break;

  case 404:
#line 2988 "parse.y" /* yacc.c:1646  */
    { pform_start_nature((yyvsp[-1].text)); }
#line 11057 "parse.cc" /* yacc.c:1646  */
    break;

  case 405:
#line 2991 "parse.y" /* yacc.c:1646  */
    { pform_end_nature((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 11063 "parse.cc" /* yacc.c:1646  */
    break;

  case 408:
#line 3001 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 11069 "parse.cc" /* yacc.c:1646  */
    break;

  case 410:
#line 3004 "parse.y" /* yacc.c:1646  */
    { pform_nature_access((yylsp[-3]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 11075 "parse.cc" /* yacc.c:1646  */
    break;

  case 411:
#line 3006 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 11081 "parse.cc" /* yacc.c:1646  */
    break;

  case 412:
#line 3008 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 11087 "parse.cc" /* yacc.c:1646  */
    break;

  case 413:
#line 3016 "parse.y" /* yacc.c:1646  */
    { cerr << (yylsp[-7]) << ": sorry: config declarations are not supported and "
                "will be skipped." << endl;
	delete[] (yyvsp[-6].text);
      }
#line 11096 "parse.cc" /* yacc.c:1646  */
    break;

  case 419:
#line 3036 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].pform_name); }
#line 11102 "parse.cc" /* yacc.c:1646  */
    break;

  case 420:
#line 3038 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-4].pform_name); }
#line 11108 "parse.cc" /* yacc.c:1646  */
    break;

  case 425:
#line 3050 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 11114 "parse.cc" /* yacc.c:1646  */
    break;

  case 426:
#line 3052 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-2].text); delete[] (yyvsp[0].text); }
#line 11120 "parse.cc" /* yacc.c:1646  */
    break;

  case 428:
#line 3058 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 11126 "parse.cc" /* yacc.c:1646  */
    break;

  case 429:
#line 3063 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 11134 "parse.cc" /* yacc.c:1646  */
    break;

  case 430:
#line 3067 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 11142 "parse.cc" /* yacc.c:1646  */
    break;

  case 431:
#line 3071 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = IVL_DR_HiZ;
		}
#line 11150 "parse.cc" /* yacc.c:1646  */
    break;

  case 432:
#line 3075 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_HiZ;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 11158 "parse.cc" /* yacc.c:1646  */
    break;

  case 433:
#line 3079 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = IVL_DR_HiZ;
		}
#line 11166 "parse.cc" /* yacc.c:1646  */
    break;

  case 434:
#line 3083 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_HiZ;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 11174 "parse.cc" /* yacc.c:1646  */
    break;

  case 435:
#line 3089 "parse.y" /* yacc.c:1646  */
    { (yyval.drive) = (yyvsp[0].drive); }
#line 11180 "parse.cc" /* yacc.c:1646  */
    break;

  case 436:
#line 3090 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_STRONG; (yyval.drive).str1 = IVL_DR_STRONG; }
#line 11186 "parse.cc" /* yacc.c:1646  */
    break;

  case 437:
#line 3094 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_SUPPLY; }
#line 11192 "parse.cc" /* yacc.c:1646  */
    break;

  case 438:
#line 3095 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_STRONG; }
#line 11198 "parse.cc" /* yacc.c:1646  */
    break;

  case 439:
#line 3096 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_PULL; }
#line 11204 "parse.cc" /* yacc.c:1646  */
    break;

  case 440:
#line 3097 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = IVL_DR_WEAK; }
#line 11210 "parse.cc" /* yacc.c:1646  */
    break;

  case 441:
#line 3101 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = IVL_DR_SUPPLY; }
#line 11216 "parse.cc" /* yacc.c:1646  */
    break;

  case 442:
#line 3102 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = IVL_DR_STRONG; }
#line 11222 "parse.cc" /* yacc.c:1646  */
    break;

  case 443:
#line 3103 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = IVL_DR_PULL; }
#line 11228 "parse.cc" /* yacc.c:1646  */
    break;

  case 444:
#line 3104 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = IVL_DR_WEAK; }
#line 11234 "parse.cc" /* yacc.c:1646  */
    break;

  case 447:
#line 3114 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmpi = new PEIdent(*(yyvsp[0].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[-1]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[0].pform_name);
		}
#line 11246 "parse.cc" /* yacc.c:1646  */
    break;

  case 448:
#line 3122 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[-1].event_expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-1].event_expr);
		  (yyval.event_statement) = tmp;
		}
#line 11256 "parse.cc" /* yacc.c:1646  */
    break;

  case 449:
#line 3128 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		}
#line 11264 "parse.cc" /* yacc.c:1646  */
    break;

  case 450:
#line 3135 "parse.y" /* yacc.c:1646  */
    { (yyval.event_expr) = (yyvsp[0].event_expr); }
#line 11270 "parse.cc" /* yacc.c:1646  */
    break;

  case 451:
#line 3137 "parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 11280 "parse.cc" /* yacc.c:1646  */
    break;

  case 452:
#line 3143 "parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 11290 "parse.cc" /* yacc.c:1646  */
    break;

  case 453:
#line 3152 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 11301 "parse.cc" /* yacc.c:1646  */
    break;

  case 454:
#line 3159 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 11312 "parse.cc" /* yacc.c:1646  */
    break;

  case 455:
#line 3166 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 11323 "parse.cc" /* yacc.c:1646  */
    break;

  case 456:
#line 3180 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-5]), (yyvsp[-5].text), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 11329 "parse.cc" /* yacc.c:1646  */
    break;

  case 457:
#line 3182 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-3]), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 11335 "parse.cc" /* yacc.c:1646  */
    break;

  case 458:
#line 3187 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 11341 "parse.cc" /* yacc.c:1646  */
    break;

  case 459:
#line 3189 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 11347 "parse.cc" /* yacc.c:1646  */
    break;

  case 460:
#line 3191 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 11353 "parse.cc" /* yacc.c:1646  */
    break;

  case 461:
#line 3193 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 11359 "parse.cc" /* yacc.c:1646  */
    break;

  case 462:
#line 3195 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('-', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11368 "parse.cc" /* yacc.c:1646  */
    break;

  case 463:
#line 3200 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('~', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11377 "parse.cc" /* yacc.c:1646  */
    break;

  case 464:
#line 3205 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('&', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11386 "parse.cc" /* yacc.c:1646  */
    break;

  case 465:
#line 3210 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('!', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11395 "parse.cc" /* yacc.c:1646  */
    break;

  case 466:
#line 3215 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('|', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11404 "parse.cc" /* yacc.c:1646  */
    break;

  case 467:
#line 3220 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('^', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11413 "parse.cc" /* yacc.c:1646  */
    break;

  case 468:
#line 3225 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: '~' '&'  is not a valid expression. "
		"Please use operator '~&' instead.");
	(yyval.expr) = 0;
      }
#line 11422 "parse.cc" /* yacc.c:1646  */
    break;

  case 469:
#line 3230 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: '~' '|'  is not a valid expression. "
		"Please use operator '~|' instead.");
	(yyval.expr) = 0;
      }
#line 11431 "parse.cc" /* yacc.c:1646  */
    break;

  case 470:
#line 3235 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: '~' '^'  is not a valid expression. "
		"Please use operator '~^' instead.");
	(yyval.expr) = 0;
      }
#line 11440 "parse.cc" /* yacc.c:1646  */
    break;

  case 471:
#line 3240 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('A', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11449 "parse.cc" /* yacc.c:1646  */
    break;

  case 472:
#line 3245 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('N', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11458 "parse.cc" /* yacc.c:1646  */
    break;

  case 473:
#line 3250 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('X', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11467 "parse.cc" /* yacc.c:1646  */
    break;

  case 474:
#line 3255 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of unary ! "
		"is not a primary expression.");
	(yyval.expr) = 0;
      }
#line 11476 "parse.cc" /* yacc.c:1646  */
    break;

  case 475:
#line 3260 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of reduction ^ "
		"is not a primary expression.");
	(yyval.expr) = 0;
      }
#line 11485 "parse.cc" /* yacc.c:1646  */
    break;

  case 476:
#line 3265 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('^', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11494 "parse.cc" /* yacc.c:1646  */
    break;

  case 477:
#line 3270 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBPower('p', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11503 "parse.cc" /* yacc.c:1646  */
    break;

  case 478:
#line 3275 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('*', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11512 "parse.cc" /* yacc.c:1646  */
    break;

  case 479:
#line 3280 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('/', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11521 "parse.cc" /* yacc.c:1646  */
    break;

  case 480:
#line 3285 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('%', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11530 "parse.cc" /* yacc.c:1646  */
    break;

  case 481:
#line 3290 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('+', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11539 "parse.cc" /* yacc.c:1646  */
    break;

  case 482:
#line 3295 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('-', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11548 "parse.cc" /* yacc.c:1646  */
    break;

  case 483:
#line 3300 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('&', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11557 "parse.cc" /* yacc.c:1646  */
    break;

  case 484:
#line 3305 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('|', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11566 "parse.cc" /* yacc.c:1646  */
    break;

  case 485:
#line 3310 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('A', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11575 "parse.cc" /* yacc.c:1646  */
    break;

  case 486:
#line 3315 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('O', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11584 "parse.cc" /* yacc.c:1646  */
    break;

  case 487:
#line 3320 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('X', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11593 "parse.cc" /* yacc.c:1646  */
    break;

  case 488:
#line 3325 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('<', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11602 "parse.cc" /* yacc.c:1646  */
    break;

  case 489:
#line 3330 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('>', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11611 "parse.cc" /* yacc.c:1646  */
    break;

  case 490:
#line 3335 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('l', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11620 "parse.cc" /* yacc.c:1646  */
    break;

  case 491:
#line 3340 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('r', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11629 "parse.cc" /* yacc.c:1646  */
    break;

  case 492:
#line 3345 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('R', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11638 "parse.cc" /* yacc.c:1646  */
    break;

  case 493:
#line 3350 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('e', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11647 "parse.cc" /* yacc.c:1646  */
    break;

  case 494:
#line 3355 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('E', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11656 "parse.cc" /* yacc.c:1646  */
    break;

  case 495:
#line 3360 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('w', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11665 "parse.cc" /* yacc.c:1646  */
    break;

  case 496:
#line 3365 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('L', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11674 "parse.cc" /* yacc.c:1646  */
    break;

  case 497:
#line 3370 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('G', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11683 "parse.cc" /* yacc.c:1646  */
    break;

  case 498:
#line 3375 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('n', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11692 "parse.cc" /* yacc.c:1646  */
    break;

  case 499:
#line 3380 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('N', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11701 "parse.cc" /* yacc.c:1646  */
    break;

  case 500:
#line 3385 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('W', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11710 "parse.cc" /* yacc.c:1646  */
    break;

  case 501:
#line 3390 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11719 "parse.cc" /* yacc.c:1646  */
    break;

  case 502:
#line 3395 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[-3].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
      }
#line 11728 "parse.cc" /* yacc.c:1646  */
    break;

  case 503:
#line 3400 "parse.y" /* yacc.c:1646  */
    { PETernary*tmp = new PETernary((yyvsp[-5].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.expr) = tmp;
      }
#line 11737 "parse.cc" /* yacc.c:1646  */
    break;

  case 504:
#line 3408 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 11743 "parse.cc" /* yacc.c:1646  */
    break;

  case 505:
#line 3410 "parse.y" /* yacc.c:1646  */
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			(yyval.expr) = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			(yyval.expr) = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		}
#line 11782 "parse.cc" /* yacc.c:1646  */
    break;

  case 506:
#line 3457 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-2].exprs);
	tmp->push_back((yyvsp[0].expr));
	(yyval.exprs) = tmp;
      }
#line 11791 "parse.cc" /* yacc.c:1646  */
    break;

  case 507:
#line 3462 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
	tmp->push_back((yyvsp[0].expr));
	(yyval.exprs) = tmp;
      }
#line 11800 "parse.cc" /* yacc.c:1646  */
    break;

  case 508:
#line 3467 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
        tmp->push_back(0);
	(yyval.exprs) = tmp;
      }
#line 11809 "parse.cc" /* yacc.c:1646  */
    break;

  case 509:
#line 3472 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-1].exprs);
	tmp->push_back(0);
	(yyval.exprs) = tmp;
      }
#line 11818 "parse.cc" /* yacc.c:1646  */
    break;

  case 510:
#line 3480 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-2].exprs);
        tmp->push_back((yyvsp[0].expr));
        (yyval.exprs) = tmp;
      }
#line 11827 "parse.cc" /* yacc.c:1646  */
    break;

  case 511:
#line 3485 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
	tmp->push_back((yyvsp[0].expr));
	(yyval.exprs) = tmp;
      }
#line 11836 "parse.cc" /* yacc.c:1646  */
    break;

  case 513:
#line 3497 "parse.y" /* yacc.c:1646  */
    { PETypename*tmp = new PETypename((yyvsp[0].type_identifier).type);
	FILE_NAME(tmp,(yylsp[0]));
	(yyval.expr) = tmp;
	delete[](yyvsp[0].type_identifier).text;
      }
#line 11846 "parse.cc" /* yacc.c:1646  */
    break;

  case 514:
#line 3507 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
	PENumber*tmp = new PENumber((yyvsp[0].number));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11856 "parse.cc" /* yacc.c:1646  */
    break;

  case 515:
#line 3513 "parse.y" /* yacc.c:1646  */
    { PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11865 "parse.cc" /* yacc.c:1646  */
    break;

  case 516:
#line 3518 "parse.y" /* yacc.c:1646  */
    { PEString*tmp = new PEString((yyvsp[0].text));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 11874 "parse.cc" /* yacc.c:1646  */
    break;

  case 517:
#line 3523 "parse.y" /* yacc.c:1646  */
    { int unit;

          based_size = 0;
          (yyval.expr)         = 0;
          if ((yyvsp[0].text) == 0 || !get_time_unit((yyvsp[0].text), unit))
              yyerror((yylsp[0]), "internal error: delay.");
          else {
              double p = pow(10.0, (double)(unit - pform_get_timeunit()));
              double time = atof((yyvsp[0].text)) * p;

              verireal *v = new verireal(time);
              (yyval.expr) = new PEFNumber(v);
              FILE_NAME((yyval.expr), (yylsp[0]));
          }
      }
#line 11894 "parse.cc" /* yacc.c:1646  */
    break;

  case 518:
#line 3539 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[0].text));
	PECallFunction*tmp = new PECallFunction(tn);
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
	delete[](yyvsp[0].text);
      }
#line 11905 "parse.cc" /* yacc.c:1646  */
    break;

  case 519:
#line 3550 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = pform_new_ident(*(yyvsp[0].pform_name));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
	delete (yyvsp[0].pform_name);
      }
#line 11915 "parse.cc" /* yacc.c:1646  */
    break;

  case 520:
#line 3557 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_package_ident((yylsp[-1]), (yyvsp[-2].package), (yyvsp[0].pform_name));
	delete (yyvsp[0].pform_name);
      }
#line 11923 "parse.cc" /* yacc.c:1646  */
    break;

  case 521:
#line 3566 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*expr_list = (yyvsp[-1].exprs);
	strip_tail_items(expr_list);
	PECallFunction*tmp = pform_make_call_function((yylsp[-4]), *(yyvsp[-4].pform_name), *expr_list);
	delete (yyvsp[-4].pform_name);
	delete (yyvsp[-3].named_pexprs);
	(yyval.expr) = tmp;
      }
#line 11935 "parse.cc" /* yacc.c:1646  */
    break;

  case 522:
#line 3574 "parse.y" /* yacc.c:1646  */
    { pform_name_t*t_name = (yyvsp[-5].pform_name);
	while (! (yyvsp[-3].pform_name)->empty()) {
	      t_name->push_back((yyvsp[-3].pform_name)->front());
	      (yyvsp[-3].pform_name)->pop_front();
	}
	list<PExpr*>*expr_list = (yyvsp[-1].exprs);
	strip_tail_items(expr_list);
	PECallFunction*tmp = pform_make_call_function((yylsp[-5]), *t_name, *expr_list);
	delete (yyvsp[-5].pform_name);
	delete (yyvsp[-3].pform_name);
	(yyval.expr) = tmp;
      }
#line 11952 "parse.cc" /* yacc.c:1646  */
    break;

  case 523:
#line 3587 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[-3].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-3].text);
	(yyval.expr) = tmp;
      }
#line 11963 "parse.cc" /* yacc.c:1646  */
    break;

  case 524:
#line 3594 "parse.y" /* yacc.c:1646  */
    { perm_string use_name = lex_strings.make((yyvsp[-3].text));
	PECallFunction*tmp = new PECallFunction((yyvsp[-5].package), use_name, *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-3].text);
	(yyval.expr) = tmp;
      }
#line 11974 "parse.cc" /* yacc.c:1646  */
    break;

  case 525:
#line 3601 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[-2].text));
	const vector<PExpr*>empty;
	PECallFunction*tmp = new PECallFunction(tn, empty);
	FILE_NAME(tmp, (yylsp[-2]));
	delete[](yyvsp[-2].text);
	(yyval.expr) = tmp;
	if (!gn_system_verilog()) {
	      yyerror((yylsp[-2]), "error: Empty function argument list requires SystemVerilog.");
	}
      }
#line 11989 "parse.cc" /* yacc.c:1646  */
    break;

  case 526:
#line 3613 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	FILE_NAME(tmp,(yylsp[0]));
	delete (yyvsp[0].pform_name);
	(yyval.expr) = tmp;
      }
#line 11999 "parse.cc" /* yacc.c:1646  */
    break;

  case 527:
#line 3620 "parse.y" /* yacc.c:1646  */
    { pform_name_t*t_name = (yyvsp[-2].pform_name);
	while (! (yyvsp[0].pform_name)->empty()) {
	      t_name->push_back((yyvsp[0].pform_name)->front());
	      (yyvsp[0].pform_name)->pop_front();
	}
	PEIdent*tmp = new PEIdent(*t_name);
	FILE_NAME(tmp,(yylsp[-2]));
	delete (yyvsp[-2].pform_name);
	delete (yyvsp[0].pform_name);
	(yyval.expr) = tmp;
      }
#line 12015 "parse.cc" /* yacc.c:1646  */
    break;

  case 528:
#line 3636 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12025 "parse.cc" /* yacc.c:1646  */
    break;

  case 529:
#line 3643 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12035 "parse.cc" /* yacc.c:1646  */
    break;

  case 530:
#line 3650 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12045 "parse.cc" /* yacc.c:1646  */
    break;

  case 531:
#line 3657 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12055 "parse.cc" /* yacc.c:1646  */
    break;

  case 532:
#line 3664 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12065 "parse.cc" /* yacc.c:1646  */
    break;

  case 533:
#line 3671 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12075 "parse.cc" /* yacc.c:1646  */
    break;

  case 534:
#line 3678 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 12085 "parse.cc" /* yacc.c:1646  */
    break;

  case 535:
#line 3685 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12095 "parse.cc" /* yacc.c:1646  */
    break;

  case 536:
#line 3692 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12105 "parse.cc" /* yacc.c:1646  */
    break;

  case 537:
#line 3699 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12115 "parse.cc" /* yacc.c:1646  */
    break;

  case 538:
#line 3706 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12125 "parse.cc" /* yacc.c:1646  */
    break;

  case 539:
#line 3713 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12135 "parse.cc" /* yacc.c:1646  */
    break;

  case 540:
#line 3720 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 12145 "parse.cc" /* yacc.c:1646  */
    break;

  case 541:
#line 3727 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12155 "parse.cc" /* yacc.c:1646  */
    break;

  case 542:
#line 3734 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12165 "parse.cc" /* yacc.c:1646  */
    break;

  case 543:
#line 3741 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 12175 "parse.cc" /* yacc.c:1646  */
    break;

  case 544:
#line 3748 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12185 "parse.cc" /* yacc.c:1646  */
    break;

  case 545:
#line 3755 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12195 "parse.cc" /* yacc.c:1646  */
    break;

  case 546:
#line 3762 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12205 "parse.cc" /* yacc.c:1646  */
    break;

  case 547:
#line 3769 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12215 "parse.cc" /* yacc.c:1646  */
    break;

  case 548:
#line 3776 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12225 "parse.cc" /* yacc.c:1646  */
    break;

  case 549:
#line 3787 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('m', (yyvsp[-1].expr));
        FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 12234 "parse.cc" /* yacc.c:1646  */
    break;

  case 550:
#line 3793 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('M', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 12243 "parse.cc" /* yacc.c:1646  */
    break;

  case 551:
#line 3799 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('m', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 12252 "parse.cc" /* yacc.c:1646  */
    break;

  case 552:
#line 3807 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 12258 "parse.cc" /* yacc.c:1646  */
    break;

  case 553:
#line 3812 "parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-2]));
	delete (yyvsp[-1].exprs);
	(yyval.expr) = tmp;
      }
#line 12268 "parse.cc" /* yacc.c:1646  */
    break;

  case 554:
#line 3818 "parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-4].expr);
	PEConcat*tmp = new PEConcat(*(yyvsp[-2].exprs), rep);
	FILE_NAME(tmp, (yylsp[-5]));
	delete (yyvsp[-2].exprs);
	(yyval.expr) = tmp;
      }
#line 12279 "parse.cc" /* yacc.c:1646  */
    break;

  case 555:
#line 3825 "parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-5].expr);
	PEConcat*tmp = new PEConcat(*(yyvsp[-3].exprs), rep);
	FILE_NAME(tmp, (yylsp[-6]));
	delete (yyvsp[-3].exprs);
	(yyval.expr) = tmp;
	yyerror((yylsp[-2]), "error: Syntax error between internal '}' "
		"and closing '}' of repeat concatenation.");
	yyerrok;
      }
#line 12293 "parse.cc" /* yacc.c:1646  */
    break;

  case 556:
#line 3836 "parse.y" /* yacc.c:1646  */
    { // This is the empty queue syntax.
	if (gn_system_verilog()) {
	      list<PExpr*> empty_list;
	      PEConcat*tmp = new PEConcat(empty_list);
	      FILE_NAME(tmp, (yylsp[-1]));
	      (yyval.expr) = tmp;
	} else {
	      yyerror((yylsp[-1]), "error: Concatenations are not allowed to be empty.");
	      (yyval.expr) = 0;
	}
      }
#line 12309 "parse.cc" /* yacc.c:1646  */
    break;

  case 557:
#line 3851 "parse.y" /* yacc.c:1646  */
    { PExpr*base = (yyvsp[-1].expr);
	if (gn_system_verilog()) {
	      PECastSize*tmp = new PECastSize((yyvsp[-4].expr), base);
	      FILE_NAME(tmp, (yylsp[-4]));
	      (yyval.expr) = tmp;
	} else {
	      yyerror((yylsp[-4]), "error: Size cast requires SystemVerilog.");
	      (yyval.expr) = base;
	}
      }
#line 12324 "parse.cc" /* yacc.c:1646  */
    break;

  case 558:
#line 3863 "parse.y" /* yacc.c:1646  */
    { PExpr*base = (yyvsp[-1].expr);
	if (gn_system_verilog()) {
	      PECastType*tmp = new PECastType((yyvsp[-4].data_type), base);
	      FILE_NAME(tmp, (yylsp[-4]));
	      (yyval.expr) = tmp;
	} else {
	      yyerror((yylsp[-4]), "error: Type cast requires SystemVerilog.");
	      (yyval.expr) = base;
	}
      }
#line 12339 "parse.cc" /* yacc.c:1646  */
    break;

  case 559:
#line 3877 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 12345 "parse.cc" /* yacc.c:1646  */
    break;

  case 560:
#line 3881 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 12351 "parse.cc" /* yacc.c:1646  */
    break;

  case 561:
#line 3884 "parse.y" /* yacc.c:1646  */
    { PENull*tmp = new PENull;
	    FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
      }
#line 12360 "parse.cc" /* yacc.c:1646  */
    break;

  case 562:
#line 3896 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 12366 "parse.cc" /* yacc.c:1646  */
    break;

  case 563:
#line 3897 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = 0; }
#line 12372 "parse.cc" /* yacc.c:1646  */
    break;

  case 564:
#line 3902 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 12378 "parse.cc" /* yacc.c:1646  */
    break;

  case 565:
#line 3904 "parse.y" /* yacc.c:1646  */
    { /* */
	if ((yyvsp[-1].tf_ports) && (yyvsp[0].tf_ports)) {
	      vector<pform_tf_port_t>*tmp = (yyvsp[-1].tf_ports);
	      size_t s1 = tmp->size();
	      tmp->resize(s1 + (yyvsp[0].tf_ports)->size());
	      for (size_t idx = 0 ; idx < (yyvsp[0].tf_ports)->size() ; idx += 1)
		    tmp->at(s1+idx) = (yyvsp[0].tf_ports)->at(idx);
	      delete (yyvsp[0].tf_ports);
	      (yyval.tf_ports) = tmp;
	} else if ((yyvsp[-1].tf_ports)) {
	      (yyval.tf_ports) = (yyvsp[-1].tf_ports);
	} else {
	      (yyval.tf_ports) = (yyvsp[0].tf_ports);
	}
      }
#line 12398 "parse.cc" /* yacc.c:1646  */
    break;

  case 566:
#line 3923 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 12404 "parse.cc" /* yacc.c:1646  */
    break;

  case 567:
#line 3925 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = 0; }
#line 12410 "parse.cc" /* yacc.c:1646  */
    break;

  case 568:
#line 3932 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 12423 "parse.cc" /* yacc.c:1646  */
    break;

  case 569:
#line 3942 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
	list<pform_range_t>*rng = (yyvsp[-3].ranges);
	tmp->name = (yyvsp[-4].text);
	tmp->parms = (yyvsp[-1].exprs);
	tmp->range = rng->front();
	rng->pop_front();
	assert(rng->empty());
	tmp->file  = (yylsp[-4]).text;
	tmp->lineno = (yylsp[-4]).first_line;
	delete[](yyvsp[-4].text);
	delete rng;
	(yyval.gate) = tmp;
      }
#line 12441 "parse.cc" /* yacc.c:1646  */
    break;

  case 570:
#line 3957 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-2]).text;
		  tmp->lineno = (yylsp[-2]).first_line;
		  (yyval.gate) = tmp;
		}
#line 12453 "parse.cc" /* yacc.c:1646  */
    break;

  case 571:
#line 3968 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
	list<pform_range_t>*rng = (yyvsp[0].ranges);
	tmp->name = (yyvsp[-1].text);
	tmp->parms = 0;
	tmp->parms_by_name = 0;
	tmp->range = rng->front();
	rng->pop_front();
	assert(rng->empty());
	tmp->file  = (yylsp[-1]).text;
	tmp->lineno = (yylsp[-1]).first_line;
	delete[](yyvsp[-1].text);
	delete rng;
	(yyval.gate) = tmp;
      }
#line 12472 "parse.cc" /* yacc.c:1646  */
    break;

  case 572:
#line 3986 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
	tmp->name = (yyvsp[-3].text);
	tmp->parms = 0;
	tmp->parms_by_name = (yyvsp[-1].named_pexprs);
	tmp->file  = (yylsp[-3]).text;
	tmp->lineno = (yylsp[-3]).first_line;
	delete[](yyvsp[-3].text);
	(yyval.gate) = tmp;
      }
#line 12486 "parse.cc" /* yacc.c:1646  */
    break;

  case 573:
#line 3997 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
	list<pform_range_t>*rng = (yyvsp[-3].ranges);
	tmp->name = (yyvsp[-4].text);
	tmp->parms = 0;
	tmp->parms_by_name = (yyvsp[-1].named_pexprs);
	tmp->range = rng->front();
	rng->pop_front();
	assert(rng->empty());
	tmp->file  = (yylsp[-4]).text;
	tmp->lineno = (yylsp[-4]).first_line;
	delete[](yyvsp[-4].text);
	delete rng;
	(yyval.gate) = tmp;
      }
#line 12505 "parse.cc" /* yacc.c:1646  */
    break;

  case 574:
#line 4013 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 12521 "parse.cc" /* yacc.c:1646  */
    break;

  case 575:
#line 4026 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-4].text);
		  (yyval.gate) = tmp;
		}
#line 12537 "parse.cc" /* yacc.c:1646  */
    break;

  case 576:
#line 4041 "parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp1 = (yyvsp[-2].gates);
		  lgate*tmp2 = (yyvsp[0].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		}
#line 12549 "parse.cc" /* yacc.c:1646  */
    break;

  case 577:
#line 4049 "parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[0].gate);
		  delete (yyvsp[0].gate);
		  (yyval.gates) = tmp;
		}
#line 12559 "parse.cc" /* yacc.c:1646  */
    break;

  case 578:
#line 4057 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::AND; }
#line 12565 "parse.cc" /* yacc.c:1646  */
    break;

  case 579:
#line 4058 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NAND; }
#line 12571 "parse.cc" /* yacc.c:1646  */
    break;

  case 580:
#line 4059 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::OR; }
#line 12577 "parse.cc" /* yacc.c:1646  */
    break;

  case 581:
#line 4060 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOR; }
#line 12583 "parse.cc" /* yacc.c:1646  */
    break;

  case 582:
#line 4061 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XOR; }
#line 12589 "parse.cc" /* yacc.c:1646  */
    break;

  case 583:
#line 4062 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XNOR; }
#line 12595 "parse.cc" /* yacc.c:1646  */
    break;

  case 584:
#line 4063 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUF; }
#line 12601 "parse.cc" /* yacc.c:1646  */
    break;

  case 585:
#line 4064 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF0; }
#line 12607 "parse.cc" /* yacc.c:1646  */
    break;

  case 586:
#line 4065 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF1; }
#line 12613 "parse.cc" /* yacc.c:1646  */
    break;

  case 587:
#line 4066 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOT; }
#line 12619 "parse.cc" /* yacc.c:1646  */
    break;

  case 588:
#line 4067 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF0; }
#line 12625 "parse.cc" /* yacc.c:1646  */
    break;

  case 589:
#line 4068 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF1; }
#line 12631 "parse.cc" /* yacc.c:1646  */
    break;

  case 590:
#line 4072 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NMOS; }
#line 12637 "parse.cc" /* yacc.c:1646  */
    break;

  case 591:
#line 4073 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RNMOS; }
#line 12643 "parse.cc" /* yacc.c:1646  */
    break;

  case 592:
#line 4074 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::PMOS; }
#line 12649 "parse.cc" /* yacc.c:1646  */
    break;

  case 593:
#line 4075 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RPMOS; }
#line 12655 "parse.cc" /* yacc.c:1646  */
    break;

  case 594:
#line 4076 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::CMOS; }
#line 12661 "parse.cc" /* yacc.c:1646  */
    break;

  case 595:
#line 4077 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RCMOS; }
#line 12667 "parse.cc" /* yacc.c:1646  */
    break;

  case 596:
#line 4078 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRAN; }
#line 12673 "parse.cc" /* yacc.c:1646  */
    break;

  case 597:
#line 4079 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRAN; }
#line 12679 "parse.cc" /* yacc.c:1646  */
    break;

  case 598:
#line 4080 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF0; }
#line 12685 "parse.cc" /* yacc.c:1646  */
    break;

  case 599:
#line 4081 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF1; }
#line 12691 "parse.cc" /* yacc.c:1646  */
    break;

  case 600:
#line 4082 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; }
#line 12697 "parse.cc" /* yacc.c:1646  */
    break;

  case 601:
#line 4083 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; }
#line 12703 "parse.cc" /* yacc.c:1646  */
    break;

  case 602:
#line 4094 "parse.y" /* yacc.c:1646  */
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	}
#line 12712 "parse.cc" /* yacc.c:1646  */
    break;

  case 603:
#line 4099 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-2].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	  (yyval.pform_name) = tmp;
	}
#line 12722 "parse.cc" /* yacc.c:1646  */
    break;

  case 604:
#line 4105 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-3].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 12735 "parse.cc" /* yacc.c:1646  */
    break;

  case 605:
#line 4114 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-3].pform_name);
	  name_component_t&tail = tmp->back();
	  if (! gn_system_verilog()) {
		yyerror((yylsp[-1]), "error: Last element expression ($) "
			"requires SystemVerilog. Try enabling SystemVerilog.");
	  }
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT_LAST;
	  itmp.msb = 0;
	  itmp.lsb = 0;
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 12753 "parse.cc" /* yacc.c:1646  */
    break;

  case 606:
#line 4128 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 12767 "parse.cc" /* yacc.c:1646  */
    break;

  case 607:
#line 4138 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 12781 "parse.cc" /* yacc.c:1646  */
    break;

  case 608:
#line 4148 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 12795 "parse.cc" /* yacc.c:1646  */
    break;

  case 609:
#line 4164 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[0].text)); }
#line 12801 "parse.cc" /* yacc.c:1646  */
    break;

  case 610:
#line 4166 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[-2].perm_strings), (yyvsp[0].text)); }
#line 12807 "parse.cc" /* yacc.c:1646  */
    break;

  case 611:
#line 4171 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-1].text), (yyvsp[0].ranges), 0); }
#line 12813 "parse.cc" /* yacc.c:1646  */
    break;

  case 612:
#line 4173 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-3].port_list), (yyvsp[-1].text), (yyvsp[0].ranges), 0); }
#line 12819 "parse.cc" /* yacc.c:1646  */
    break;

  case 613:
#line 4178 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-1].text), (yyvsp[0].ranges), 0); }
#line 12825 "parse.cc" /* yacc.c:1646  */
    break;

  case 614:
#line 4180 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-3].text), (yyvsp[-2].ranges), (yyvsp[0].expr)); }
#line 12831 "parse.cc" /* yacc.c:1646  */
    break;

  case 615:
#line 4182 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-3].port_list), (yyvsp[-1].text), (yyvsp[0].ranges), 0); }
#line 12837 "parse.cc" /* yacc.c:1646  */
    break;

  case 616:
#line 4184 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-5].port_list), (yyvsp[-3].text), (yyvsp[-2].ranges), (yyvsp[0].expr)); }
#line 12843 "parse.cc" /* yacc.c:1646  */
    break;

  case 617:
#line 4206 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 12853 "parse.cc" /* yacc.c:1646  */
    break;

  case 618:
#line 4212 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 12862 "parse.cc" /* yacc.c:1646  */
    break;

  case 619:
#line 4220 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 12872 "parse.cc" /* yacc.c:1646  */
    break;

  case 620:
#line 4226 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 12881 "parse.cc" /* yacc.c:1646  */
    break;

  case 621:
#line 4231 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[0].text));
		  ptmp = pform_module_port_reference(name, (yylsp[0]).text,
						     (yylsp[0]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[0]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.data_type, 0);
		  delete[](yyvsp[0].text);
		  (yyval.mports) = tmp;
		}
#line 12903 "parse.cc" /* yacc.c:1646  */
    break;

  case 622:
#line 4249 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 12912 "parse.cc" /* yacc.c:1646  */
    break;

  case 623:
#line 4254 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 12921 "parse.cc" /* yacc.c:1646  */
    break;

  case 624:
#line 4262 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-1].text));
	data_type_t*use_type = (yyvsp[-2].data_type);
	if ((yyvsp[0].ranges)) use_type = new uarray_type_t(use_type, (yyvsp[0].ranges));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text, (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINPUT, (yyvsp[-3].nettype), use_type, (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.data_type = (yyvsp[-2].data_type);
	delete[](yyvsp[-1].text);
	(yyval.mport) = ptmp;
      }
#line 12938 "parse.cc" /* yacc.c:1646  */
    break;

  case 625:
#line 4276 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-2]).text,
					   (yylsp[-2]).first_line);
	real_type_t*real_type = new real_type_t(real_type_t::REAL);
	FILE_NAME(real_type, (yylsp[-1]));
	pform_module_define_port((yylsp[-2]), name, NetNet::PINPUT,
				 NetNet::WIRE, real_type, (yyvsp[-3].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = NetNet::WIRE;
	port_declaration_context.data_type = real_type;
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 12957 "parse.cc" /* yacc.c:1646  */
    break;

  case 626:
#line 4291 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-1].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text, (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINOUT, (yyvsp[-3].nettype), (yyvsp[-2].data_type), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.data_type = (yyvsp[-2].data_type);
	delete[](yyvsp[-1].text);
	if ((yyvsp[0].ranges)) {
	      yyerror((yylsp[0]), "sorry: Inout ports with unpacked dimensions not supported.");
	      delete (yyvsp[0].ranges);
	}
	(yyval.mport) = ptmp;
      }
#line 12976 "parse.cc" /* yacc.c:1646  */
    break;

  case 627:
#line 4307 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-2]).text,
					   (yylsp[-2]).first_line);
	real_type_t*real_type = new real_type_t(real_type_t::REAL);
	FILE_NAME(real_type, (yylsp[-1]));
	pform_module_define_port((yylsp[-2]), name, NetNet::PINOUT,
				 NetNet::WIRE, real_type, (yyvsp[-3].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = NetNet::WIRE;
	port_declaration_context.data_type = real_type;
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 12995 "parse.cc" /* yacc.c:1646  */
    break;

  case 628:
#line 4322 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-1].text));
	data_type_t*use_dtype = (yyvsp[-2].data_type);
	if ((yyvsp[0].ranges)) use_dtype = new uarray_type_t(use_dtype, (yyvsp[0].ranges));
	NetNet::Type use_type = (yyvsp[-3].nettype);
	if (use_type == NetNet::IMPLICIT) {
	      if (vector_type_t*dtype = dynamic_cast<vector_type_t*> ((yyvsp[-2].data_type))) {
		    if (dtype->reg_flag)
			  use_type = NetNet::REG;
		    else if (dtype->implicit_flag)
			  use_type = NetNet::IMPLICIT;
		    else
			  use_type = NetNet::IMPLICIT_REG;

		      // The SystemVerilog types that can show up as
		      // output ports are implicitly (on the inside)
		      // variables because "reg" is not valid syntax
		      // here.
	      } else if (dynamic_cast<atom2_type_t*> ((yyvsp[-2].data_type))) {
		    use_type = NetNet::IMPLICIT_REG;
	      } else if (dynamic_cast<struct_type_t*> ((yyvsp[-2].data_type))) {
		    use_type = NetNet::IMPLICIT_REG;
	      } else if (enum_type_t*etype = dynamic_cast<enum_type_t*> ((yyvsp[-2].data_type))) {
		    if(etype->base_type == IVL_VT_LOGIC)
			use_type = NetNet::IMPLICIT_REG;
	      }
	}
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text, (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT, use_type, use_dtype, (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = use_type;
	port_declaration_context.data_type = (yyvsp[-2].data_type);
	delete[](yyvsp[-1].text);
	(yyval.mport) = ptmp;
      }
#line 13035 "parse.cc" /* yacc.c:1646  */
    break;

  case 629:
#line 4359 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-2]).text,
					   (yylsp[-2]).first_line);
	real_type_t*real_type = new real_type_t(real_type_t::REAL);
	FILE_NAME(real_type, (yylsp[-1]));
	pform_module_define_port((yylsp[-2]), name, NetNet::POUTPUT,
				 NetNet::WIRE, real_type, (yyvsp[-3].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = NetNet::WIRE;
	port_declaration_context.data_type = real_type;
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 13054 "parse.cc" /* yacc.c:1646  */
    break;

  case 630:
#line 4374 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-2].text));
	NetNet::Type use_type = (yyvsp[-4].nettype);
	if (use_type == NetNet::IMPLICIT) {
	      if (vector_type_t*dtype = dynamic_cast<vector_type_t*> ((yyvsp[-3].data_type))) {
		    if (dtype->reg_flag)
			  use_type = NetNet::REG;
		    else
			  use_type = NetNet::IMPLICIT_REG;
	      } else {
		    use_type = NetNet::IMPLICIT_REG;
	      }
	}
	ptmp = pform_module_port_reference(name, (yylsp[-5]).text, (yylsp[-5]).first_line);
	pform_module_define_port((yylsp[-5]), name, NetNet::POUTPUT, use_type, (yyvsp[-3].data_type), (yyvsp[-6].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = use_type;
	port_declaration_context.data_type = (yyvsp[-3].data_type);

	pform_make_var_init((yylsp[-2]), name, (yyvsp[0].expr));

	delete[](yyvsp[-2].text);
	(yyval.mport) = ptmp;
      }
#line 13083 "parse.cc" /* yacc.c:1646  */
    break;

  case 631:
#line 4403 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = (yyvsp[0].nettype); }
#line 13089 "parse.cc" /* yacc.c:1646  */
    break;

  case 632:
#line 4404 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::IMPLICIT; }
#line 13095 "parse.cc" /* yacc.c:1646  */
    break;

  case 633:
#line 4418 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 13101 "parse.cc" /* yacc.c:1646  */
    break;

  case 634:
#line 4419 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 13107 "parse.cc" /* yacc.c:1646  */
    break;

  case 635:
#line 4420 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 13113 "parse.cc" /* yacc.c:1646  */
    break;

  case 636:
#line 4424 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 13119 "parse.cc" /* yacc.c:1646  */
    break;

  case 637:
#line 4425 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 13125 "parse.cc" /* yacc.c:1646  */
    break;

  case 638:
#line 4426 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 13131 "parse.cc" /* yacc.c:1646  */
    break;

  case 639:
#line 4434 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = 8; }
#line 13137 "parse.cc" /* yacc.c:1646  */
    break;

  case 640:
#line 4435 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = 16; }
#line 13143 "parse.cc" /* yacc.c:1646  */
    break;

  case 641:
#line 4436 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = 32; }
#line 13149 "parse.cc" /* yacc.c:1646  */
    break;

  case 642:
#line 4437 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = 64; }
#line 13155 "parse.cc" /* yacc.c:1646  */
    break;

  case 643:
#line 4446 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = pform_new_ident(*(yyvsp[0].pform_name));
	FILE_NAME(tmp, (yylsp[0]));
	(yyval.expr) = tmp;
	delete (yyvsp[0].pform_name);
      }
#line 13165 "parse.cc" /* yacc.c:1646  */
    break;

  case 644:
#line 4453 "parse.y" /* yacc.c:1646  */
    { pform_name_t*t_name = (yyvsp[-2].pform_name);
	while (!(yyvsp[0].pform_name)->empty()) {
	      t_name->push_back((yyvsp[0].pform_name)->front());
	      (yyvsp[0].pform_name)->pop_front();
	}
	PEIdent*tmp = new PEIdent(*t_name);
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.expr) = tmp;
	delete (yyvsp[-2].pform_name);
	delete (yyvsp[0].pform_name);
      }
#line 13181 "parse.cc" /* yacc.c:1646  */
    break;

  case 645:
#line 4466 "parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-2]));
	delete (yyvsp[-1].exprs);
	(yyval.expr) = tmp;
      }
#line 13191 "parse.cc" /* yacc.c:1646  */
    break;

  case 646:
#line 4473 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "sorry: streaming concatenation not supported in l-values.");
	(yyval.expr) = 0;
      }
#line 13199 "parse.cc" /* yacc.c:1646  */
    break;

  case 647:
#line 4483 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
	tmp->push_back((yyvsp[-2].expr));
	tmp->push_back((yyvsp[0].expr));
	(yyval.exprs) = tmp;
      }
#line 13209 "parse.cc" /* yacc.c:1646  */
    break;

  case 648:
#line 4492 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-2].exprs);
	tmp->splice(tmp->end(), *(yyvsp[0].exprs));
	delete (yyvsp[0].exprs);
	(yyval.exprs) = tmp;
      }
#line 13219 "parse.cc" /* yacc.c:1646  */
    break;

  case 649:
#line 4498 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 13225 "parse.cc" /* yacc.c:1646  */
    break;

  case 650:
#line 4507 "parse.y" /* yacc.c:1646  */
    { pform_startmodule((yylsp[-2]), (yyvsp[0].text), (yyvsp[-2].int_val)==K_program, (yyvsp[-2].int_val)==K_interface, (yyvsp[-1].lifetime), (yyvsp[-3].named_pexprs)); }
#line 13231 "parse.cc" /* yacc.c:1646  */
    break;

  case 651:
#line 4512 "parse.y" /* yacc.c:1646  */
    { pform_module_set_ports((yyvsp[-2].mports)); }
#line 13237 "parse.cc" /* yacc.c:1646  */
    break;

  case 652:
#line 4514 "parse.y" /* yacc.c:1646  */
    { pform_set_scope_timescale((yylsp[-10])); }
#line 13243 "parse.cc" /* yacc.c:1646  */
    break;

  case 653:
#line 4517 "parse.y" /* yacc.c:1646  */
    { Module::UCDriveType ucd;
	  // The lexor detected `unconnected_drive directives and
	  // marked what it found in the uc_drive variable. Use that
	  // to generate a UCD flag for the module.
	switch (uc_drive) {
	    case UCD_NONE:
	    default:
	      ucd = Module::UCD_NONE;
	      break;
	    case UCD_PULL0:
	      ucd = Module::UCD_PULL0;
	      break;
	    case UCD_PULL1:
	      ucd = Module::UCD_PULL1;
	      break;
	}
	  // Check that program/endprogram and module/endmodule
	  // keywords match.
	if ((yyvsp[-13].int_val) != (yyvsp[0].int_val)) {
	      switch ((yyvsp[-13].int_val)) {
		  case K_module:
		    yyerror((yylsp[0]), "error: module not closed by endmodule.");
		    break;
		  case K_program:
		    yyerror((yylsp[0]), "error: program not closed by endprogram.");
		    break;
		  case K_interface:
		    yyerror((yylsp[0]), "error: interface not closed by endinterface.");
		    break;
		  default:
		    break;
	      }
	}
	pform_endmodule((yyvsp[-11].text), in_celldefine, ucd);
      }
#line 13283 "parse.cc" /* yacc.c:1646  */
    break;

  case 654:
#line 4553 "parse.y" /* yacc.c:1646  */
    { // Last step: check any closing name. This is done late so
	// that the parser can look ahead to detect the present
	// endlabel_opt but still have the pform_endmodule() called
	// early enough that the lexor can know we are outside the
	// module.
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-13].text),(yyvsp[0].text)) != 0) {
		    switch ((yyvsp[-15].int_val)) {
			case K_module:
			  yyerror((yylsp[0]), "error: End label doesn't match "
			               "module name.");
			  break;
			case K_program:
			  yyerror((yylsp[0]), "error: End label doesn't match "
			               "program name.");
			  break;
			case K_interface:
			  yyerror((yylsp[0]), "error: End label doesn't match "
			               "interface name.");
			  break;
			default:
			  break;
		    }
	      }
	      if (((yyvsp[-15].int_val) == K_module) && (! gn_system_verilog())) {
		    yyerror((yylsp[-9]), "error: Module end labels require "
		                 "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-13].text);
      }
#line 13320 "parse.cc" /* yacc.c:1646  */
    break;

  case 655:
#line 4592 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_module; }
#line 13326 "parse.cc" /* yacc.c:1646  */
    break;

  case 656:
#line 4593 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_module; }
#line 13332 "parse.cc" /* yacc.c:1646  */
    break;

  case 657:
#line 4594 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_program; }
#line 13338 "parse.cc" /* yacc.c:1646  */
    break;

  case 658:
#line 4595 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_interface; }
#line 13344 "parse.cc" /* yacc.c:1646  */
    break;

  case 659:
#line 4599 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_module; }
#line 13350 "parse.cc" /* yacc.c:1646  */
    break;

  case 660:
#line 4600 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_program; }
#line 13356 "parse.cc" /* yacc.c:1646  */
    break;

  case 661:
#line 4601 "parse.y" /* yacc.c:1646  */
    { (yyval.int_val) = K_interface; }
#line 13362 "parse.cc" /* yacc.c:1646  */
    break;

  case 662:
#line 4605 "parse.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 13368 "parse.cc" /* yacc.c:1646  */
    break;

  case 663:
#line 4606 "parse.y" /* yacc.c:1646  */
    { (yyval.text) = 0; }
#line 13374 "parse.cc" /* yacc.c:1646  */
    break;

  case 664:
#line 4610 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 13380 "parse.cc" /* yacc.c:1646  */
    break;

  case 665:
#line 4611 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 13386 "parse.cc" /* yacc.c:1646  */
    break;

  case 666:
#line 4615 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 13392 "parse.cc" /* yacc.c:1646  */
    break;

  case 667:
#line 4616 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 13398 "parse.cc" /* yacc.c:1646  */
    break;

  case 668:
#line 4617 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 13404 "parse.cc" /* yacc.c:1646  */
    break;

  case 669:
#line 4619 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "Errors in port declarations.");
	yyerrok;
	(yyval.mports) = 0;
      }
#line 13413 "parse.cc" /* yacc.c:1646  */
    break;

  case 676:
#line 4646 "parse.y" /* yacc.c:1646  */
    { data_type_t*data_type = (yyvsp[-3].data_type);
	if (data_type == 0) {
	      data_type = new vector_type_t(IVL_VT_LOGIC, false, 0);
	      FILE_NAME(data_type, (yylsp[-4]));
	}
	pform_set_data_type((yylsp[-4]), data_type, (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), (yyvsp[-5].named_pexprs));
	if ((yyvsp[-2].exprs) != 0) {
	      yyerror((yylsp[-4]), "sorry: net delays not supported.");
	      delete (yyvsp[-2].exprs);
	}
	delete (yyvsp[-5].named_pexprs);
      }
#line 13430 "parse.cc" /* yacc.c:1646  */
    break;

  case 677:
#line 4660 "parse.y" /* yacc.c:1646  */
    { real_type_t*tmpt = new real_type_t(real_type_t::REAL);
	pform_set_data_type((yylsp[-3]), tmpt, (yyvsp[-1].perm_strings), NetNet::WIRE, (yyvsp[-4].named_pexprs));
	if ((yyvsp[-2].exprs) != 0) {
	      yyerror((yylsp[-2]), "sorry: net delays not supported.");
	      delete (yyvsp[-2].exprs);
	}
	delete (yyvsp[-4].named_pexprs);
      }
#line 13443 "parse.cc" /* yacc.c:1646  */
    break;

  case 678:
#line 4670 "parse.y" /* yacc.c:1646  */
    { real_type_t*tmpt = new real_type_t(real_type_t::REAL);
	pform_set_data_type((yylsp[-2]), tmpt, (yyvsp[-1].perm_strings), NetNet::WIRE, (yyvsp[-3].named_pexprs));
	delete (yyvsp[-3].named_pexprs);
      }
#line 13452 "parse.cc" /* yacc.c:1646  */
    break;

  case 679:
#line 4680 "parse.y" /* yacc.c:1646  */
    { data_type_t*data_type = (yyvsp[-3].data_type);
	if (data_type == 0) {
	      data_type = new vector_type_t(IVL_VT_LOGIC, false, 0);
	      FILE_NAME(data_type, (yylsp[-4]));
	}
	pform_makewire((yylsp[-4]), (yyvsp[-2].exprs), str_strength, (yyvsp[-1].net_decl_assign), (yyvsp[-4].nettype), data_type);
	if ((yyvsp[-5].named_pexprs)) {
	      yywarn((yylsp[-4]), "Attributes are not supported on net declaration "
		     "assignments and will be discarded.");
	      delete (yyvsp[-5].named_pexprs);
	}
      }
#line 13469 "parse.cc" /* yacc.c:1646  */
    break;

  case 680:
#line 4697 "parse.y" /* yacc.c:1646  */
    { data_type_t*data_type = (yyvsp[-3].data_type);
	if (data_type == 0) {
	      data_type = new vector_type_t(IVL_VT_LOGIC, false, 0);
	      FILE_NAME(data_type, (yylsp[-4]));
	}
	pform_makewire((yylsp[-4]), 0, (yyvsp[-2].drive), (yyvsp[-1].net_decl_assign), (yyvsp[-4].nettype), data_type);
	if ((yyvsp[-5].named_pexprs)) {
	      yywarn((yylsp[-4]), "Attributes are not supported on net declaration "
		     "assignments and will be discarded.");
	      delete (yyvsp[-5].named_pexprs);
	}
      }
#line 13486 "parse.cc" /* yacc.c:1646  */
    break;

  case 681:
#line 4711 "parse.y" /* yacc.c:1646  */
    { real_type_t*data_type = new real_type_t(real_type_t::REAL);
        pform_makewire((yylsp[-2]), 0, str_strength, (yyvsp[-1].net_decl_assign), NetNet::WIRE, data_type);
	if ((yyvsp[-3].named_pexprs)) {
	      yywarn((yylsp[-2]), "Attributes are not supported on net declaration "
		     "assignments and will be discarded.");
	      delete (yyvsp[-3].named_pexprs);
	}
      }
#line 13499 "parse.cc" /* yacc.c:1646  */
    break;

  case 682:
#line 4721 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "sorry: trireg nets not supported.");
		  delete (yyvsp[-3].ranges);
		  delete (yyvsp[-2].exprs);
		}
#line 13508 "parse.cc" /* yacc.c:1646  */
    break;

  case 683:
#line 4732 "parse.y" /* yacc.c:1646  */
    { pform_module_define_port((yylsp[-4]), (yyvsp[-1].port_list), (yyvsp[-4].porttype), (yyvsp[-3].nettype), (yyvsp[-2].data_type), (yyvsp[-5].named_pexprs)); }
#line 13514 "parse.cc" /* yacc.c:1646  */
    break;

  case 684:
#line 4735 "parse.y" /* yacc.c:1646  */
    { real_type_t*real_type = new real_type_t(real_type_t::REAL);
	pform_module_define_port((yylsp[-3]), (yyvsp[-1].port_list), (yyvsp[-3].porttype), NetNet::WIRE, real_type, (yyvsp[-4].named_pexprs));
      }
#line 13522 "parse.cc" /* yacc.c:1646  */
    break;

  case 685:
#line 4746 "parse.y" /* yacc.c:1646  */
    { NetNet::Type use_type = (yyvsp[-2].data_type) ? NetNet::IMPLICIT : NetNet::NONE;
	if (vector_type_t*dtype = dynamic_cast<vector_type_t*> ((yyvsp[-2].data_type))) {
	      if (dtype->implicit_flag)
		    use_type = NetNet::NONE;
	}
	if (use_type == NetNet::NONE)
	      pform_set_port_type((yylsp[-3]), (yyvsp[-1].port_list), NetNet::PINOUT, (yyvsp[-2].data_type), (yyvsp[-4].named_pexprs));
	else
	      pform_module_define_port((yylsp[-3]), (yyvsp[-1].port_list), NetNet::PINOUT, use_type, (yyvsp[-2].data_type), (yyvsp[-4].named_pexprs));
      }
#line 13537 "parse.cc" /* yacc.c:1646  */
    break;

  case 686:
#line 4758 "parse.y" /* yacc.c:1646  */
    { NetNet::Type use_type = (yyvsp[-2].data_type) ? NetNet::IMPLICIT : NetNet::NONE;
	if (vector_type_t*dtype = dynamic_cast<vector_type_t*> ((yyvsp[-2].data_type))) {
	      if (dtype->implicit_flag)
		    use_type = NetNet::NONE;
	}
	if (use_type == NetNet::NONE)
	      pform_set_port_type((yylsp[-3]), (yyvsp[-1].port_list), NetNet::PINPUT, (yyvsp[-2].data_type), (yyvsp[-4].named_pexprs));
	else
	      pform_module_define_port((yylsp[-3]), (yyvsp[-1].port_list), NetNet::PINPUT, use_type, (yyvsp[-2].data_type), (yyvsp[-4].named_pexprs));
      }
#line 13552 "parse.cc" /* yacc.c:1646  */
    break;

  case 687:
#line 4770 "parse.y" /* yacc.c:1646  */
    { NetNet::Type use_type = (yyvsp[-2].data_type) ? NetNet::IMPLICIT : NetNet::NONE;
	if (vector_type_t*dtype = dynamic_cast<vector_type_t*> ((yyvsp[-2].data_type))) {
	      if (dtype->implicit_flag)
		    use_type = NetNet::NONE;
	      else if (dtype->reg_flag)
		    use_type = NetNet::REG;
	      else
		    use_type = NetNet::IMPLICIT_REG;

		// The SystemVerilog types that can show up as
		// output ports are implicitly (on the inside)
		// variables because "reg" is not valid syntax
		// here.
	} else if (dynamic_cast<atom2_type_t*> ((yyvsp[-2].data_type))) {
	      use_type = NetNet::IMPLICIT_REG;
	} else if (dynamic_cast<struct_type_t*> ((yyvsp[-2].data_type))) {
	      use_type = NetNet::IMPLICIT_REG;
	} else if (enum_type_t*etype = dynamic_cast<enum_type_t*> ((yyvsp[-2].data_type))) {
	      if(etype->base_type == IVL_VT_LOGIC)
		  use_type = NetNet::IMPLICIT_REG;
	}
	if (use_type == NetNet::NONE)
	      pform_set_port_type((yylsp[-3]), (yyvsp[-1].port_list), NetNet::POUTPUT, (yyvsp[-2].data_type), (yyvsp[-4].named_pexprs));
	else
	      pform_module_define_port((yylsp[-3]), (yyvsp[-1].port_list), NetNet::POUTPUT, use_type, (yyvsp[-2].data_type), (yyvsp[-4].named_pexprs));
      }
#line 13583 "parse.cc" /* yacc.c:1646  */
    break;

  case 688:
#line 4798 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Invalid variable list in port declaration.");
	if ((yyvsp[-5].named_pexprs)) delete (yyvsp[-5].named_pexprs);
	if ((yyvsp[-2].data_type)) delete (yyvsp[-2].data_type);
	yyerrok;
      }
#line 13593 "parse.cc" /* yacc.c:1646  */
    break;

  case 689:
#line 4805 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid variable list in port declaration.");
	if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
	if ((yyvsp[-2].data_type)) delete (yyvsp[-2].data_type);
	yyerrok;
      }
#line 13603 "parse.cc" /* yacc.c:1646  */
    break;

  case 690:
#line 4812 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid variable list in port declaration.");
	if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
	if ((yyvsp[-2].data_type)) delete (yyvsp[-2].data_type);
	yyerrok;
      }
#line 13613 "parse.cc" /* yacc.c:1646  */
    break;

  case 691:
#line 4819 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid variable list in port declaration.");
	if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
	if ((yyvsp[-2].data_type)) delete (yyvsp[-2].data_type);
	yyerrok;
      }
#line 13623 "parse.cc" /* yacc.c:1646  */
    break;

  case 692:
#line 4829 "parse.y" /* yacc.c:1646  */
    { pform_attach_discipline((yylsp[-2]), (yyvsp[-2].discipline), (yyvsp[-1].perm_strings)); }
#line 13629 "parse.cc" /* yacc.c:1646  */
    break;

  case 693:
#line 4834 "parse.y" /* yacc.c:1646  */
    { attributes_in_context = (yyvsp[0].named_pexprs); }
#line 13635 "parse.cc" /* yacc.c:1646  */
    break;

  case 694:
#line 4835 "parse.y" /* yacc.c:1646  */
    { delete attributes_in_context;
	attributes_in_context = 0;
      }
#line 13643 "parse.cc" /* yacc.c:1646  */
    break;

  case 695:
#line 4842 "parse.y" /* yacc.c:1646  */
    { if (pform_in_interface())
	      yyerror((yylsp[0]), "error: Parameter overrides are not allowed "
			  "in interfaces.");
      }
#line 13652 "parse.cc" /* yacc.c:1646  */
    break;

  case 697:
#line 4853 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-2]), (yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs)); }
#line 13658 "parse.cc" /* yacc.c:1646  */
    break;

  case 698:
#line 4856 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-3]), (yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs)); }
#line 13664 "parse.cc" /* yacc.c:1646  */
    break;

  case 699:
#line 4859 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-3]), (yyvsp[-3].gatetype), (yyvsp[-2].drive), 0, (yyvsp[-1].gates), (yyvsp[-4].named_pexprs)); }
#line 13670 "parse.cc" /* yacc.c:1646  */
    break;

  case 700:
#line 4862 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-4]), (yyvsp[-4].gatetype), (yyvsp[-3].drive), (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-5].named_pexprs)); }
#line 13676 "parse.cc" /* yacc.c:1646  */
    break;

  case 701:
#line 4866 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-2]), (yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs)); }
#line 13682 "parse.cc" /* yacc.c:1646  */
    break;

  case 702:
#line 4869 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-3]), (yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs)); }
#line 13688 "parse.cc" /* yacc.c:1646  */
    break;

  case 703:
#line 4875 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-2]), PGBuiltin::PULLUP, pull_strength, 0, (yyvsp[-1].gates), 0); }
#line 13694 "parse.cc" /* yacc.c:1646  */
    break;

  case 704:
#line 4877 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-2]), PGBuiltin::PULLDOWN, pull_strength, 0, (yyvsp[-1].gates), 0); }
#line 13700 "parse.cc" /* yacc.c:1646  */
    break;

  case 705:
#line 4880 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-5]), PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0); }
#line 13706 "parse.cc" /* yacc.c:1646  */
    break;

  case 706:
#line 4883 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-7]), PGBuiltin::PULLUP, (yyvsp[-5].drive), 0, (yyvsp[-1].gates), 0); }
#line 13712 "parse.cc" /* yacc.c:1646  */
    break;

  case 707:
#line 4886 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-7]), PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0); }
#line 13718 "parse.cc" /* yacc.c:1646  */
    break;

  case 708:
#line 4889 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-5]), PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0); }
#line 13724 "parse.cc" /* yacc.c:1646  */
    break;

  case 709:
#line 4892 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-7]), PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0); }
#line 13730 "parse.cc" /* yacc.c:1646  */
    break;

  case 710:
#line 4895 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yylsp[-7]), PGBuiltin::PULLDOWN, (yyvsp[-5].drive), 0, (yyvsp[-1].gates), 0); }
#line 13736 "parse.cc" /* yacc.c:1646  */
    break;

  case 711:
#line 4903 "parse.y" /* yacc.c:1646  */
    { perm_string tmp1 = lex_strings.make((yyvsp[-3].text));
		  pform_make_modgates((yylsp[-3]), tmp1, (yyvsp[-2].parmvalue), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		  delete[](yyvsp[-3].text);
		}
#line 13745 "parse.cc" /* yacc.c:1646  */
    break;

  case 712:
#line 4910 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid module instantiation");
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 13754 "parse.cc" /* yacc.c:1646  */
    break;

  case 713:
#line 4920 "parse.y" /* yacc.c:1646  */
    { pform_make_pgassign_list((yyvsp[-1].exprs), (yyvsp[-2].exprs), (yyvsp[-3].drive), (yylsp[-4]).text, (yylsp[-4]).first_line); }
#line 13760 "parse.cc" /* yacc.c:1646  */
    break;

  case 714:
#line 4925 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 13768 "parse.cc" /* yacc.c:1646  */
    break;

  case 715:
#line 4929 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS_COMB, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 13776 "parse.cc" /* yacc.c:1646  */
    break;

  case 716:
#line 4933 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS_FF, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 13784 "parse.cc" /* yacc.c:1646  */
    break;

  case 717:
#line 4937 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS_LATCH, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 13792 "parse.cc" /* yacc.c:1646  */
    break;

  case 718:
#line 4941 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 13800 "parse.cc" /* yacc.c:1646  */
    break;

  case 719:
#line 4945 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_FINAL, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 13808 "parse.cc" /* yacc.c:1646  */
    break;

  case 720:
#line 4950 "parse.y" /* yacc.c:1646  */
    { pform_make_analog_behavior((yylsp[-1]), IVL_PR_ALWAYS, (yyvsp[0].statement)); }
#line 13814 "parse.cc" /* yacc.c:1646  */
    break;

  case 726:
#line 4969 "parse.y" /* yacc.c:1646  */
    { // Test for bad nesting. I understand it, but it is illegal.
       if (pform_parent_generate()) {
	     cerr << (yylsp[-2]) << ": error: Generate/endgenerate regions cannot nest." << endl;
	     cerr << (yylsp[-2]) << ":      : Try removing optional generate/endgenerate keywords," << endl;
	     cerr << (yylsp[-2]) << ":      : or move them to surround the parent generate scheme." << endl;
	     error_count += 1;
	}
      }
#line 13827 "parse.cc" /* yacc.c:1646  */
    break;

  case 727:
#line 4979 "parse.y" /* yacc.c:1646  */
    { pform_genvars((yylsp[-2]), (yyvsp[-1].perm_strings)); }
#line 13833 "parse.cc" /* yacc.c:1646  */
    break;

  case 728:
#line 4984 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_for((yylsp[-11]), (yyvsp[-9].text), (yyvsp[-7].expr), (yyvsp[-5].expr), (yyvsp[-3].text), (yyvsp[-1].expr)); }
#line 13839 "parse.cc" /* yacc.c:1646  */
    break;

  case 729:
#line 4986 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 13845 "parse.cc" /* yacc.c:1646  */
    break;

  case 730:
#line 4991 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_else((yylsp[-2])); }
#line 13851 "parse.cc" /* yacc.c:1646  */
    break;

  case 731:
#line 4993 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 13857 "parse.cc" /* yacc.c:1646  */
    break;

  case 732:
#line 4997 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 13863 "parse.cc" /* yacc.c:1646  */
    break;

  case 733:
#line 5000 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_case((yylsp[-3]), (yyvsp[-1].expr)); }
#line 13869 "parse.cc" /* yacc.c:1646  */
    break;

  case 734:
#line 5003 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 13875 "parse.cc" /* yacc.c:1646  */
    break;

  case 737:
#line 5012 "parse.y" /* yacc.c:1646  */
    { if (pform_in_interface())
	      yyerror((yylsp[-1]), "error: specparam declarations are not allowed "
			  "in interfaces.");
      }
#line 13884 "parse.cc" /* yacc.c:1646  */
    break;

  case 739:
#line 5021 "parse.y" /* yacc.c:1646  */
    { if (pform_in_interface())
	      yyerror((yylsp[0]), "error: specify blocks are not allowed "
			  "in interfaces.");
      }
#line 13893 "parse.cc" /* yacc.c:1646  */
    break;

  case 741:
#line 5028 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in specify block");
	yyerrok;
      }
#line 13901 "parse.cc" /* yacc.c:1646  */
    break;

  case 742:
#line 5037 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: invalid module item.");
		  yyerrok;
		}
#line 13909 "parse.cc" /* yacc.c:1646  */
    break;

  case 743:
#line 5042 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		}
#line 13918 "parse.cc" /* yacc.c:1646  */
    break;

  case 744:
#line 5048 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		}
#line 13927 "parse.cc" /* yacc.c:1646  */
    break;

  case 745:
#line 5054 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: I give up on this "
			  "function definition.");
		  if ((yyvsp[0].text)) {
			if (!gn_system_verilog()) {
			      yyerror((yylsp[0]), "error: Function end names require "
			                  "SystemVerilog.");
			}
			delete[](yyvsp[0].text);
		  }
		  yyerrok;
		}
#line 13943 "parse.cc" /* yacc.c:1646  */
    break;

  case 746:
#line 5070 "parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-6].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[-4].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[-2].text));
		  delete[] (yyvsp[-6].text);
		  delete[] (yyvsp[-4].text);
		}
#line 13954 "parse.cc" /* yacc.c:1646  */
    break;

  case 747:
#line 5077 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed $attribute parameter list."); }
#line 13960 "parse.cc" /* yacc.c:1646  */
    break;

  case 752:
#line 5091 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_if((yylsp[-3]), (yyvsp[-1].expr)); }
#line 13966 "parse.cc" /* yacc.c:1646  */
    break;

  case 755:
#line 5099 "parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), (yyvsp[-1].exprs)); }
#line 13972 "parse.cc" /* yacc.c:1646  */
    break;

  case 756:
#line 5100 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 13978 "parse.cc" /* yacc.c:1646  */
    break;

  case 757:
#line 5101 "parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), 0); }
#line 13984 "parse.cc" /* yacc.c:1646  */
    break;

  case 758:
#line 5102 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 13990 "parse.cc" /* yacc.c:1646  */
    break;

  case 760:
#line 5109 "parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001 && warn_anachronisms) {
	      warn_count += 1;
	      cerr << (yylsp[-2]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      }
#line 14001 "parse.cc" /* yacc.c:1646  */
    break;

  case 761:
#line 5115 "parse.y" /* yacc.c:1646  */
    {
	pform_start_generate_nblock((yylsp[-2]), (yyvsp[0].text));
      }
#line 14009 "parse.cc" /* yacc.c:1646  */
    break;

  case 762:
#line 5118 "parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001 && warn_anachronisms) {
	      warn_count += 1;
	      cerr << (yylsp[-5]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      }
#line 14021 "parse.cc" /* yacc.c:1646  */
    break;

  case 769:
#line 5147 "parse.y" /* yacc.c:1646  */
    { pform_generate_block_name((yyvsp[-3].text));
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-3].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match "
				"begin name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Begin end labels require "
				"SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-3].text);
      }
#line 14040 "parse.cc" /* yacc.c:1646  */
    break;

  case 772:
#line 5175 "parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[-2].text));
	tmp->expr = (yyvsp[0].expr);
	delete[](yyvsp[-2].text);
	(yyval.net_decl_assign) = tmp;
      }
#line 14052 "parse.cc" /* yacc.c:1646  */
    break;

  case 773:
#line 5186 "parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = (yyvsp[-2].net_decl_assign);
		  (yyvsp[0].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[0].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		}
#line 14062 "parse.cc" /* yacc.c:1646  */
    break;

  case 774:
#line 5192 "parse.y" /* yacc.c:1646  */
    { (yyval.net_decl_assign) = (yyvsp[0].net_decl_assign);
		}
#line 14069 "parse.cc" /* yacc.c:1646  */
    break;

  case 775:
#line 5197 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_LOGIC; }
#line 14075 "parse.cc" /* yacc.c:1646  */
    break;

  case 776:
#line 5198 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_BOOL; /* Icarus misc */}
#line 14081 "parse.cc" /* yacc.c:1646  */
    break;

  case 777:
#line 5199 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_BOOL; /* IEEE1800 / IEEE1364-2009 */}
#line 14087 "parse.cc" /* yacc.c:1646  */
    break;

  case 779:
#line 5204 "parse.y" /* yacc.c:1646  */
    { (yyval.vartype) = IVL_VT_NO_TYPE; }
#line 14093 "parse.cc" /* yacc.c:1646  */
    break;

  case 780:
#line 5208 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WIRE; }
#line 14099 "parse.cc" /* yacc.c:1646  */
    break;

  case 781:
#line 5209 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI; }
#line 14105 "parse.cc" /* yacc.c:1646  */
    break;

  case 782:
#line 5210 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI1; }
#line 14111 "parse.cc" /* yacc.c:1646  */
    break;

  case 783:
#line 5211 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY0; }
#line 14117 "parse.cc" /* yacc.c:1646  */
    break;

  case 784:
#line 5212 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WAND; }
#line 14123 "parse.cc" /* yacc.c:1646  */
    break;

  case 785:
#line 5213 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIAND; }
#line 14129 "parse.cc" /* yacc.c:1646  */
    break;

  case 786:
#line 5214 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI0; }
#line 14135 "parse.cc" /* yacc.c:1646  */
    break;

  case 787:
#line 5215 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY1; }
#line 14141 "parse.cc" /* yacc.c:1646  */
    break;

  case 788:
#line 5216 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WOR; }
#line 14147 "parse.cc" /* yacc.c:1646  */
    break;

  case 789:
#line 5217 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIOR; }
#line 14153 "parse.cc" /* yacc.c:1646  */
    break;

  case 790:
#line 5218 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UNRESOLVED_WIRE;
		      cerr << (yylsp[0]).text << ":" << (yylsp[0]).first_line << ": warning: "
		              "'wone' is deprecated, please use 'uwire' "
		              "instead." << endl;
		    }
#line 14163 "parse.cc" /* yacc.c:1646  */
    break;

  case 791:
#line 5223 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UNRESOLVED_WIRE; }
#line 14169 "parse.cc" /* yacc.c:1646  */
    break;

  case 792:
#line 5228 "parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].ranges);
	param_active_signed = (yyvsp[-1].flag);
	if (((yyvsp[-2].vartype) == IVL_VT_NO_TYPE) && ((yyvsp[0].ranges) != 0))
	      param_active_type = IVL_VT_LOGIC;
	else
	      param_active_type = (yyvsp[-2].vartype);
      }
#line 14181 "parse.cc" /* yacc.c:1646  */
    break;

  case 793:
#line 5236 "parse.y" /* yacc.c:1646  */
    { param_active_range = make_range_from_width(integer_width);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 14190 "parse.cc" /* yacc.c:1646  */
    break;

  case 794:
#line 5241 "parse.y" /* yacc.c:1646  */
    { param_active_range = make_range_from_width(64);
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 14199 "parse.cc" /* yacc.c:1646  */
    break;

  case 795:
#line 5246 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
#line 14208 "parse.cc" /* yacc.c:1646  */
    break;

  case 796:
#line 5251 "parse.y" /* yacc.c:1646  */
    { param_active_range = make_range_from_width((yyvsp[0].int_val));
	param_active_signed = true;
	param_active_type = IVL_VT_BOOL;
      }
#line 14217 "parse.cc" /* yacc.c:1646  */
    break;

  case 797:
#line 5256 "parse.y" /* yacc.c:1646  */
    { pform_set_param_from_type((yylsp[0]), (yyvsp[0].type_identifier).type, (yyvsp[0].type_identifier).text, param_active_range,
	                          param_active_signed, param_active_type);
	delete[](yyvsp[0].type_identifier).text;
      }
#line 14226 "parse.cc" /* yacc.c:1646  */
    break;

  case 802:
#line 5279 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[-1].expr);
	pform_set_parameter((yylsp[-3]), lex_strings.make((yyvsp[-3].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[0].value_range));
	delete[](yyvsp[-3].text);
      }
#line 14236 "parse.cc" /* yacc.c:1646  */
    break;

  case 803:
#line 5288 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
	pform_set_localparam((yylsp[-2]), lex_strings.make((yyvsp[-2].text)), param_active_type,
			     param_active_signed, param_active_range, tmp);
	delete[](yyvsp[-2].text);
      }
#line 14246 "parse.cc" /* yacc.c:1646  */
    break;

  case 804:
#line 5295 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); }
#line 14252 "parse.cc" /* yacc.c:1646  */
    break;

  case 805:
#line 5295 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = 0; }
#line 14258 "parse.cc" /* yacc.c:1646  */
    break;

  case 806:
#line 5299 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = (yyvsp[-1].value_range); }
#line 14264 "parse.cc" /* yacc.c:1646  */
    break;

  case 807:
#line 5301 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = 0; }
#line 14270 "parse.cc" /* yacc.c:1646  */
    break;

  case 808:
#line 5306 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 14276 "parse.cc" /* yacc.c:1646  */
    break;

  case 809:
#line 5308 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 14282 "parse.cc" /* yacc.c:1646  */
    break;

  case 810:
#line 5310 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 14288 "parse.cc" /* yacc.c:1646  */
    break;

  case 811:
#line 5312 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 14294 "parse.cc" /* yacc.c:1646  */
    break;

  case 812:
#line 5314 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[0].expr), false, (yyvsp[0].expr)); }
#line 14300 "parse.cc" /* yacc.c:1646  */
    break;

  case 813:
#line 5318 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 14306 "parse.cc" /* yacc.c:1646  */
    break;

  case 814:
#line 5319 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 14312 "parse.cc" /* yacc.c:1646  */
    break;

  case 815:
#line 5320 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 14318 "parse.cc" /* yacc.c:1646  */
    break;

  case 816:
#line 5321 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 14324 "parse.cc" /* yacc.c:1646  */
    break;

  case 817:
#line 5324 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 14330 "parse.cc" /* yacc.c:1646  */
    break;

  case 818:
#line 5324 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 14336 "parse.cc" /* yacc.c:1646  */
    break;

  case 819:
#line 5344 "parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[-1].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		}
#line 14346 "parse.cc" /* yacc.c:1646  */
    break;

  case 820:
#line 5350 "parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[-1].named_pexprs);
		  (yyval.parmvalue) = tmp;
		}
#line 14356 "parse.cc" /* yacc.c:1646  */
    break;

  case 821:
#line 5356 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new list<PExpr*>;
		  lst->by_order->push_back(tmp);
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		}
#line 14372 "parse.cc" /* yacc.c:1646  */
    break;

  case 822:
#line 5368 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].realtime));
		  PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new list<PExpr*>;
		  lst->by_order->push_back(tmp);
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		}
#line 14387 "parse.cc" /* yacc.c:1646  */
    break;

  case 823:
#line 5379 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		}
#line 14396 "parse.cc" /* yacc.c:1646  */
    break;

  case 824:
#line 5384 "parse.y" /* yacc.c:1646  */
    { (yyval.parmvalue) = 0; }
#line 14402 "parse.cc" /* yacc.c:1646  */
    break;

  case 825:
#line 5389 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 14413 "parse.cc" /* yacc.c:1646  */
    break;

  case 826:
#line 5396 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 14424 "parse.cc" /* yacc.c:1646  */
    break;

  case 827:
#line 5406 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = new list<named_pexpr_t>;
	tmp->push_back(*(yyvsp[0].named_pexpr));
	delete (yyvsp[0].named_pexpr);
	(yyval.named_pexprs) = tmp;
      }
#line 14434 "parse.cc" /* yacc.c:1646  */
    break;

  case 828:
#line 5412 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = (yyvsp[-2].named_pexprs);
	tmp->push_back(*(yyvsp[0].named_pexpr));
	delete (yyvsp[0].named_pexpr);
	(yyval.named_pexprs) = tmp;
      }
#line 14444 "parse.cc" /* yacc.c:1646  */
    break;

  case 829:
#line 5435 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 14450 "parse.cc" /* yacc.c:1646  */
    break;

  case 830:
#line 5443 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  delete[](yyvsp[-3].text);
		  (yyval.mport) = tmp;
		}
#line 14460 "parse.cc" /* yacc.c:1646  */
    break;

  case 831:
#line 5454 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		}
#line 14469 "parse.cc" /* yacc.c:1646  */
    break;

  case 832:
#line 5463 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  tmp->name = lex_strings.make((yyvsp[-5].text));
		  delete[](yyvsp[-5].text);
		  (yyval.mport) = tmp;
		}
#line 14479 "parse.cc" /* yacc.c:1646  */
    break;

  case 833:
#line 5471 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 14485 "parse.cc" /* yacc.c:1646  */
    break;

  case 834:
#line 5472 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = 0; }
#line 14491 "parse.cc" /* yacc.c:1646  */
    break;

  case 835:
#line 5481 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  delete (yyvsp[-5].named_pexprs);
		  (yyval.named_pexpr) = tmp;
		}
#line 14503 "parse.cc" /* yacc.c:1646  */
    break;

  case 836:
#line 5489 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-3].text);
		  delete (yyvsp[-5].named_pexprs);
		  (yyval.named_pexpr) = tmp;
		}
#line 14516 "parse.cc" /* yacc.c:1646  */
    break;

  case 837:
#line 5498 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  delete (yyvsp[-4].named_pexprs);
		  (yyval.named_pexpr) = tmp;
		}
#line 14528 "parse.cc" /* yacc.c:1646  */
    break;

  case 838:
#line 5506 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[0].text));
		  tmp->parm = new PEIdent(lex_strings.make((yyvsp[0].text)), true);
		  FILE_NAME(tmp->parm, (yylsp[-2]));
		  delete[](yyvsp[0].text);
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexpr) = tmp;
		}
#line 14541 "parse.cc" /* yacc.c:1646  */
    break;

  case 839:
#line 5515 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make("*");
		  tmp->parm = 0;
		  (yyval.named_pexpr) = tmp;
		}
#line 14551 "parse.cc" /* yacc.c:1646  */
    break;

  case 840:
#line 5524 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = (yyvsp[-2].named_pexprs);
        tmp->push_back(*(yyvsp[0].named_pexpr));
	delete (yyvsp[0].named_pexpr);
	(yyval.named_pexprs) = tmp;
      }
#line 14561 "parse.cc" /* yacc.c:1646  */
    break;

  case 841:
#line 5530 "parse.y" /* yacc.c:1646  */
    { list<named_pexpr_t>*tmp = new list<named_pexpr_t>;
        tmp->push_back(*(yyvsp[0].named_pexpr));
	delete (yyvsp[0].named_pexpr);
	(yyval.named_pexprs) = tmp;
      }
#line 14571 "parse.cc" /* yacc.c:1646  */
    break;

  case 842:
#line 5539 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-3].exprs);
	tmp->push_back((yyvsp[0].expr));
	delete (yyvsp[-1].named_pexprs);
	(yyval.exprs) = tmp;
      }
#line 14581 "parse.cc" /* yacc.c:1646  */
    break;

  case 843:
#line 5545 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
	tmp->push_back((yyvsp[0].expr));
	delete (yyvsp[-1].named_pexprs);
	(yyval.exprs) = tmp;
      }
#line 14591 "parse.cc" /* yacc.c:1646  */
    break;

  case 844:
#line 5551 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
        tmp->push_back(0);
	(yyval.exprs) = tmp;
      }
#line 14600 "parse.cc" /* yacc.c:1646  */
    break;

  case 845:
#line 5556 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = (yyvsp[-1].exprs);
	tmp->push_back(0);
	(yyval.exprs) = tmp;
      }
#line 14609 "parse.cc" /* yacc.c:1646  */
    break;

  case 846:
#line 5575 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[0].text));
	  ptmp = pform_module_port_reference(name, (yylsp[0]).text, (yylsp[0]).first_line);
	  delete[](yyvsp[0].text);
	  (yyval.mport) = ptmp;
	}
#line 14620 "parse.cc" /* yacc.c:1646  */
    break;

  case 847:
#line 5583 "parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[-5].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[-5]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[-5].text);
	  (yyval.mport) = ptmp;
	}
#line 14646 "parse.cc" /* yacc.c:1646  */
    break;

  case 848:
#line 5606 "parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[-3].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[-3]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 14671 "parse.cc" /* yacc.c:1646  */
    break;

  case 849:
#line 5628 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
	  FILE_NAME(wtmp, (yylsp[-3]));
	  ptmp->name = lex_strings.make((yyvsp[-3].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 14685 "parse.cc" /* yacc.c:1646  */
    break;

  case 850:
#line 5642 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 14691 "parse.cc" /* yacc.c:1646  */
    break;

  case 851:
#line 5644 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  append(tmp->expr, (yyvsp[0].mport)->expr);
		  delete (yyvsp[0].mport);
		  (yyval.mport) = tmp;
		}
#line 14701 "parse.cc" /* yacc.c:1646  */
    break;

  case 852:
#line 5653 "parse.y" /* yacc.c:1646  */
    { (yyval.ranges) = 0; }
#line 14707 "parse.cc" /* yacc.c:1646  */
    break;

  case 853:
#line 5654 "parse.y" /* yacc.c:1646  */
    { (yyval.ranges) = (yyvsp[0].ranges); }
#line 14713 "parse.cc" /* yacc.c:1646  */
    break;

  case 854:
#line 5659 "parse.y" /* yacc.c:1646  */
    { (yyval.ranges) = (yyvsp[0].ranges); }
#line 14719 "parse.cc" /* yacc.c:1646  */
    break;

  case 855:
#line 5661 "parse.y" /* yacc.c:1646  */
    { list<pform_range_t> *tmp = (yyvsp[-1].ranges);
	if ((yyvsp[0].ranges)) {
	      tmp->splice(tmp->end(), *(yyvsp[0].ranges));
	      delete (yyvsp[0].ranges);
	}
	(yyval.ranges) = tmp;
      }
#line 14731 "parse.cc" /* yacc.c:1646  */
    break;

  case 856:
#line 5677 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_set_reg_idx(name, (yyvsp[0].ranges));
	(yyval.text) = (yyvsp[-1].text);
      }
#line 14742 "parse.cc" /* yacc.c:1646  */
    break;

  case 857:
#line 5684 "parse.y" /* yacc.c:1646  */
    { if (pform_peek_scope()->var_init_needs_explicit_lifetime()
	    && (var_lifetime == LexicalScope::INHERITED)) {
	      cerr << (yylsp[-1]) << ": warning: Static variable initialization requires "
			    "explicit lifetime in this context." << endl;
	      warn_count += 1;
	}
	perm_string name = lex_strings.make((yyvsp[-3].text));
	pform_makewire((yylsp[-3]), name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_set_reg_idx(name, (yyvsp[-2].ranges));
	pform_make_var_init((yylsp[-3]), name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-3].text);
      }
#line 14760 "parse.cc" /* yacc.c:1646  */
    break;

  case 858:
#line 5701 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 14770 "parse.cc" /* yacc.c:1646  */
    break;

  case 859:
#line 5707 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 14780 "parse.cc" /* yacc.c:1646  */
    break;

  case 860:
#line 5716 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_set_reg_idx(name, (yyvsp[0].ranges));
	(yyval.text) = (yyvsp[-1].text);
      }
#line 14791 "parse.cc" /* yacc.c:1646  */
    break;

  case 861:
#line 5726 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 14801 "parse.cc" /* yacc.c:1646  */
    break;

  case 862:
#line 5732 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 14811 "parse.cc" /* yacc.c:1646  */
    break;

  case 863:
#line 5741 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[0].ranges)) {
	      yyerror((yylsp[0]), "sorry: event arrays are not supported.");
	      delete (yyvsp[0].ranges);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 14822 "parse.cc" /* yacc.c:1646  */
    break;

  case 864:
#line 5751 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[0].text)); }
#line 14828 "parse.cc" /* yacc.c:1646  */
    break;

  case 865:
#line 5753 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[-2].perm_strings), (yyvsp[0].text)); }
#line 14834 "parse.cc" /* yacc.c:1646  */
    break;

  case 867:
#line 5759 "parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 14841 "parse.cc" /* yacc.c:1646  */
    break;

  case 868:
#line 5762 "parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 14848 "parse.cc" /* yacc.c:1646  */
    break;

  case 869:
#line 5765 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 14860 "parse.cc" /* yacc.c:1646  */
    break;

  case 870:
#line 5773 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 14872 "parse.cc" /* yacc.c:1646  */
    break;

  case 871:
#line 5781 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		}
#line 14884 "parse.cc" /* yacc.c:1646  */
    break;

  case 872:
#line 5789 "parse.y" /* yacc.c:1646  */
    { yywarn((yylsp[-2]), "Sorry: ifnone with an edge-sensitive path is "
		              "not supported.");
		  yyerrok;
		}
#line 14893 "parse.cc" /* yacc.c:1646  */
    break;

  case 873:
#line 5795 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 14901 "parse.cc" /* yacc.c:1646  */
    break;

  case 874:
#line 5800 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14908 "parse.cc" /* yacc.c:1646  */
    break;

  case 875:
#line 5804 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 14916 "parse.cc" /* yacc.c:1646  */
    break;

  case 876:
#line 5809 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14923 "parse.cc" /* yacc.c:1646  */
    break;

  case 877:
#line 5813 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14930 "parse.cc" /* yacc.c:1646  */
    break;

  case 878:
#line 5817 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 14938 "parse.cc" /* yacc.c:1646  */
    break;

  case 879:
#line 5822 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14945 "parse.cc" /* yacc.c:1646  */
    break;

  case 880:
#line 5826 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14952 "parse.cc" /* yacc.c:1646  */
    break;

  case 881:
#line 5830 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 14960 "parse.cc" /* yacc.c:1646  */
    break;

  case 882:
#line 5835 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14967 "parse.cc" /* yacc.c:1646  */
    break;

  case 883:
#line 5839 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 14974 "parse.cc" /* yacc.c:1646  */
    break;

  case 884:
#line 5843 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 14982 "parse.cc" /* yacc.c:1646  */
    break;

  case 885:
#line 5847 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
		}
#line 14989 "parse.cc" /* yacc.c:1646  */
    break;

  case 886:
#line 5850 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 14996 "parse.cc" /* yacc.c:1646  */
    break;

  case 887:
#line 5853 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 15003 "parse.cc" /* yacc.c:1646  */
    break;

  case 888:
#line 5856 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 15010 "parse.cc" /* yacc.c:1646  */
    break;

  case 889:
#line 5859 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 15017 "parse.cc" /* yacc.c:1646  */
    break;

  case 892:
#line 5870 "parse.y" /* yacc.c:1646  */
    {  }
#line 15023 "parse.cc" /* yacc.c:1646  */
    break;

  case 893:
#line 5872 "parse.y" /* yacc.c:1646  */
    {  }
#line 15029 "parse.cc" /* yacc.c:1646  */
    break;

  case 894:
#line 5876 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 15035 "parse.cc" /* yacc.c:1646  */
    break;

  case 895:
#line 5878 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[0].expr));
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 15044 "parse.cc" /* yacc.c:1646  */
    break;

  case 896:
#line 5884 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 15050 "parse.cc" /* yacc.c:1646  */
    break;

  case 897:
#line 5884 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 15056 "parse.cc" /* yacc.c:1646  */
    break;

  case 898:
#line 5889 "parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 15063 "parse.cc" /* yacc.c:1646  */
    break;

  case 899:
#line 5893 "parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr));}
#line 15070 "parse.cc" /* yacc.c:1646  */
    break;

  case 900:
#line 5897 "parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 15077 "parse.cc" /* yacc.c:1646  */
    break;

  case 901:
#line 5901 "parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 15084 "parse.cc" /* yacc.c:1646  */
    break;

  case 905:
#line 5913 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 15090 "parse.cc" /* yacc.c:1646  */
    break;

  case 906:
#line 5915 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>*tmp = new list<PExpr*>;
		  tmp->push_back((yyvsp[0].expr));
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 15099 "parse.cc" /* yacc.c:1646  */
    break;

  case 907:
#line 5920 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		}
#line 15108 "parse.cc" /* yacc.c:1646  */
    break;

  case 908:
#line 5929 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), false, (yyvsp[-1].perm_strings)); }
#line 15114 "parse.cc" /* yacc.c:1646  */
    break;

  case 909:
#line 5932 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), true, (yyvsp[-1].perm_strings)); }
#line 15120 "parse.cc" /* yacc.c:1646  */
    break;

  case 910:
#line 5934 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Invalid simple path");
		  yyerrok;
		}
#line 15128 "parse.cc" /* yacc.c:1646  */
    break;

  case 911:
#line 5941 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 15138 "parse.cc" /* yacc.c:1646  */
    break;

  case 912:
#line 5947 "parse.y" /* yacc.c:1646  */
    { if (gn_specify_blocks_flag) {
			yywarn((yylsp[0]), "Bit selects are not currently supported "
				   "in path declarations. The declaration "
				   "will be applied to the whole vector.");
		  }
		  list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 15153 "parse.cc" /* yacc.c:1646  */
    break;

  case 913:
#line 5958 "parse.y" /* yacc.c:1646  */
    { if (gn_specify_blocks_flag) {
			yywarn((yylsp[-2]), "Part selects are not currently supported "
				   "in path declarations. The declaration "
				   "will be applied to the whole vector.");
		  }
		  list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[-5].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-5].text);
		}
#line 15168 "parse.cc" /* yacc.c:1646  */
    break;

  case 914:
#line 5969 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 15178 "parse.cc" /* yacc.c:1646  */
    break;

  case 915:
#line 5975 "parse.y" /* yacc.c:1646  */
    { if (gn_specify_blocks_flag) {
			yywarn((yylsp[-2]), "Bit selects are not currently supported "
				   "in path declarations. The declaration "
				   "will be applied to the whole vector.");
		  }
		  list<perm_string>*tmp = (yyvsp[-5].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 15193 "parse.cc" /* yacc.c:1646  */
    break;

  case 916:
#line 5986 "parse.y" /* yacc.c:1646  */
    { if (gn_specify_blocks_flag) {
			yywarn((yylsp[-4]), "Part selects are not currently supported "
				   "in path declarations. The declaration "
				   "will be applied to the whole vector.");
		  }
		  list<perm_string>*tmp = (yyvsp[-7].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[-5].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-5].text);
		}
#line 15208 "parse.cc" /* yacc.c:1646  */
    break;

  case 917:
#line 6000 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  pform_set_specparam((yylsp[-2]), lex_strings.make((yyvsp[-2].text)),
		                      param_active_range, tmp);
		  delete[](yyvsp[-2].text);
		}
#line 15218 "parse.cc" /* yacc.c:1646  */
    break;

  case 918:
#line 6006 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			tmp = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			tmp = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam((yylsp[-6]), lex_strings.make((yyvsp[-6].text)),
		                      param_active_range, tmp);
		  delete[](yyvsp[-6].text);
		}
#line 15261 "parse.cc" /* yacc.c:1646  */
    break;

  case 919:
#line 6045 "parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-2].text);
		  delete (yyvsp[0].expr);
		}
#line 15269 "parse.cc" /* yacc.c:1646  */
    break;

  case 920:
#line 6049 "parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-6].text);
		  delete (yyvsp[-3].expr);
		  delete (yyvsp[-1].expr);
		}
#line 15278 "parse.cc" /* yacc.c:1646  */
    break;

  case 924:
#line 6063 "parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].ranges); }
#line 15284 "parse.cc" /* yacc.c:1646  */
    break;

  case 925:
#line 6065 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0; }
#line 15290 "parse.cc" /* yacc.c:1646  */
    break;

  case 926:
#line 6069 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 15296 "parse.cc" /* yacc.c:1646  */
    break;

  case 927:
#line 6070 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 15302 "parse.cc" /* yacc.c:1646  */
    break;

  case 928:
#line 6071 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 0;   }
#line 15308 "parse.cc" /* yacc.c:1646  */
    break;

  case 929:
#line 6076 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 15314 "parse.cc" /* yacc.c:1646  */
    break;

  case 930:
#line 6078 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 15320 "parse.cc" /* yacc.c:1646  */
    break;

  case 931:
#line 6080 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 15328 "parse.cc" /* yacc.c:1646  */
    break;

  case 932:
#line 6084 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 15336 "parse.cc" /* yacc.c:1646  */
    break;

  case 933:
#line 6088 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 15342 "parse.cc" /* yacc.c:1646  */
    break;

  case 934:
#line 6090 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 15350 "parse.cc" /* yacc.c:1646  */
    break;

  case 935:
#line 6094 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 15358 "parse.cc" /* yacc.c:1646  */
    break;

  case 936:
#line 6098 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 15364 "parse.cc" /* yacc.c:1646  */
    break;

  case 939:
#line 6112 "parse.y" /* yacc.c:1646  */
    {  }
#line 15370 "parse.cc" /* yacc.c:1646  */
    break;

  case 940:
#line 6114 "parse.y" /* yacc.c:1646  */
    {  }
#line 15376 "parse.cc" /* yacc.c:1646  */
    break;

  case 941:
#line 6118 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; }
#line 15382 "parse.cc" /* yacc.c:1646  */
    break;

  case 942:
#line 6120 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete (yyvsp[0].pform_name); }
#line 15388 "parse.cc" /* yacc.c:1646  */
    break;

  case 943:
#line 6122 "parse.y" /* yacc.c:1646  */
    {  args_after_notifier += 1; }
#line 15394 "parse.cc" /* yacc.c:1646  */
    break;

  case 944:
#line 6124 "parse.y" /* yacc.c:1646  */
    { args_after_notifier += 1;
		  if (args_after_notifier >= 3)  {
                    cerr << (yylsp[0]) << ": warning: timing checks are not supported "
		                  "and delayed signal \"" << *(yyvsp[0].pform_name)
		         << "\" will not be driven." << endl;
		  }
                  delete (yyvsp[0].pform_name); }
#line 15406 "parse.cc" /* yacc.c:1646  */
    break;

  case 945:
#line 6133 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete[](yyvsp[0].text); }
#line 15412 "parse.cc" /* yacc.c:1646  */
    break;

  case 946:
#line 6145 "parse.y" /* yacc.c:1646  */
    { PCAssign*tmp = new PCAssign((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 15421 "parse.cc" /* yacc.c:1646  */
    break;

  case 947:
#line 6151 "parse.y" /* yacc.c:1646  */
    { PDeassign*tmp = new PDeassign((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 15430 "parse.cc" /* yacc.c:1646  */
    break;

  case 948:
#line 6161 "parse.y" /* yacc.c:1646  */
    { PForce*tmp = new PForce((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 15439 "parse.cc" /* yacc.c:1646  */
    break;

  case 949:
#line 6166 "parse.y" /* yacc.c:1646  */
    { PRelease*tmp = new PRelease((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 15448 "parse.cc" /* yacc.c:1646  */
    break;

  case 950:
#line 6178 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 15457 "parse.cc" /* yacc.c:1646  */
    break;

  case 951:
#line 6184 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope(0, PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[0]));
	current_block_stack.push(tmp);
      }
#line 15466 "parse.cc" /* yacc.c:1646  */
    break;

  case 952:
#line 6189 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[0].flag)) {
	    if (! gn_system_verilog()) {
		  yyerror("error: Variable declaration in unnamed block "
		          "requires SystemVerilog.");
	    }
	} else {
	    /* If there are no declarations in the scope then just delete it. */
	    pform_pop_scope();
	    assert(! current_block_stack.empty());
	    PBlock*tmp = current_block_stack.top();
	    current_block_stack.pop();
	    delete tmp;
	}
      }
#line 15485 "parse.cc" /* yacc.c:1646  */
    break;

  case 953:
#line 6204 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp;
	if ((yyvsp[-3].flag)) {
	    pform_pop_scope();
	    assert(! current_block_stack.empty());
	    tmp = current_block_stack.top();
	    current_block_stack.pop();
	} else {
	    tmp = new PBlock(PBlock::BL_SEQ);
	    FILE_NAME(tmp, (yylsp[-5]));
	}
	if ((yyvsp[-1].statement_list)) tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 15504 "parse.cc" /* yacc.c:1646  */
    break;

  case 954:
#line 6219 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 15513 "parse.cc" /* yacc.c:1646  */
    break;

  case 955:
#line 6225 "parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	if ((yyvsp[-2].statement_list)) tmp->set_statement(*(yyvsp[-2].statement_list));
	delete (yyvsp[-2].statement_list);
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-5].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match begin name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Begin end labels require "
		                "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-5].text);
	(yyval.statement) = tmp;
      }
#line 15537 "parse.cc" /* yacc.c:1646  */
    break;

  case 956:
#line 6251 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock((yyvsp[0].join_keyword));
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 15546 "parse.cc" /* yacc.c:1646  */
    break;

  case 957:
#line 6257 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope(0, PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[0]));
	current_block_stack.push(tmp);
      }
#line 15555 "parse.cc" /* yacc.c:1646  */
    break;

  case 958:
#line 6262 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[0].flag)) {
	    if (! gn_system_verilog()) {
		  yyerror("error: Variable declaration in unnamed block "
		          "requires SystemVerilog.");
	    }
	} else {
	    /* If there are no declarations in the scope then just delete it. */
	    pform_pop_scope();
	    assert(! current_block_stack.empty());
	    PBlock*tmp = current_block_stack.top();
	    current_block_stack.pop();
	    delete tmp;
	}
      }
#line 15574 "parse.cc" /* yacc.c:1646  */
    break;

  case 959:
#line 6277 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp;
	if ((yyvsp[-3].flag)) {
	    pform_pop_scope();
	    assert(! current_block_stack.empty());
	    tmp = current_block_stack.top();
	    current_block_stack.pop();
	    tmp->set_join_type((yyvsp[0].join_keyword));
	} else {
	    tmp = new PBlock((yyvsp[0].join_keyword));
	    FILE_NAME(tmp, (yylsp[-5]));
	}
	if ((yyvsp[-1].statement_list)) tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 15594 "parse.cc" /* yacc.c:1646  */
    break;

  case 960:
#line 6293 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 15603 "parse.cc" /* yacc.c:1646  */
    break;

  case 961:
#line 6299 "parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_join_type((yyvsp[-1].join_keyword));
	if ((yyvsp[-2].statement_list)) tmp->set_statement(*(yyvsp[-2].statement_list));
	delete (yyvsp[-2].statement_list);
	if ((yyvsp[0].text)) {
	      if (strcmp((yyvsp[-5].text),(yyvsp[0].text)) != 0) {
		    yyerror((yylsp[0]), "error: End label doesn't match fork name");
	      }
	      if (! gn_system_verilog()) {
		    yyerror((yylsp[0]), "error: Fork end labels require "
		                "SystemVerilog.");
	      }
	      delete[](yyvsp[0].text);
	}
	delete[](yyvsp[-5].text);
	(yyval.statement) = tmp;
      }
#line 15628 "parse.cc" /* yacc.c:1646  */
    break;

  case 962:
#line 6321 "parse.y" /* yacc.c:1646  */
    { PDisable*tmp = new PDisable(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 15638 "parse.cc" /* yacc.c:1646  */
    break;

  case 963:
#line 6327 "parse.y" /* yacc.c:1646  */
    { pform_name_t tmp_name;
		  PDisable*tmp = new PDisable(tmp_name);
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 15648 "parse.cc" /* yacc.c:1646  */
    break;

  case 964:
#line 6333 "parse.y" /* yacc.c:1646  */
    { PTrigger*tmp = new PTrigger(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 15658 "parse.cc" /* yacc.c:1646  */
    break;

  case 965:
#line 6339 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 15664 "parse.cc" /* yacc.c:1646  */
    break;

  case 966:
#line 6341 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 15670 "parse.cc" /* yacc.c:1646  */
    break;

  case 967:
#line 6343 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 15676 "parse.cc" /* yacc.c:1646  */
    break;

  case 968:
#line 6346 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 15685 "parse.cc" /* yacc.c:1646  */
    break;

  case 969:
#line 6351 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 15694 "parse.cc" /* yacc.c:1646  */
    break;

  case 970:
#line 6356 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 15703 "parse.cc" /* yacc.c:1646  */
    break;

  case 971:
#line 6361 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 15709 "parse.cc" /* yacc.c:1646  */
    break;

  case 972:
#line 6363 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 15715 "parse.cc" /* yacc.c:1646  */
    break;

  case 973:
#line 6365 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 15721 "parse.cc" /* yacc.c:1646  */
    break;

  case 974:
#line 6367 "parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-2].expr), (yyvsp[0].statement), 0);
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 15730 "parse.cc" /* yacc.c:1646  */
    break;

  case 975:
#line 6372 "parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-4].expr), (yyvsp[-2].statement), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-6]));
		  (yyval.statement) = tmp;
		}
#line 15739 "parse.cc" /* yacc.c:1646  */
    break;

  case 976:
#line 6377 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[0].statement);
		}
#line 15747 "parse.cc" /* yacc.c:1646  */
    break;

  case 977:
#line 6381 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-6]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[-2].statement);
		}
#line 15755 "parse.cc" /* yacc.c:1646  */
    break;

  case 978:
#line 6387 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 15761 "parse.cc" /* yacc.c:1646  */
    break;

  case 979:
#line 6393 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = pform_compressed_assign_from_inc_dec((yylsp[-1]), (yyvsp[-1].expr)); }
#line 15767 "parse.cc" /* yacc.c:1646  */
    break;

  case 980:
#line 6398 "parse.y" /* yacc.c:1646  */
    { PExpr*del = (yyvsp[-1].exprs)->front();
	assert((yyvsp[-1].exprs)->size() == 1);
	delete (yyvsp[-1].exprs);
	PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[0].statement));
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 15779 "parse.cc" /* yacc.c:1646  */
    break;

  case 981:
#line 6407 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = (yyvsp[-1].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[-1]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      tmp->set_statement((yyvsp[0].statement));
	      (yyval.statement) = tmp;
	}
      }
#line 15793 "parse.cc" /* yacc.c:1646  */
    break;

  case 982:
#line 6417 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 15803 "parse.cc" /* yacc.c:1646  */
    break;

  case 983:
#line 6423 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-4]));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 15813 "parse.cc" /* yacc.c:1646  */
    break;

  case 984:
#line 6432 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-3].expr),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-3]));
	(yyval.statement) = tmp;
      }
#line 15822 "parse.cc" /* yacc.c:1646  */
    break;

  case 985:
#line 6438 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
	yyerrok;
	(yyval.statement) = new PNoop;
      }
#line 15831 "parse.cc" /* yacc.c:1646  */
    break;

  case 986:
#line 6443 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-3].expr),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-3]));
	(yyval.statement) = tmp;
      }
#line 15840 "parse.cc" /* yacc.c:1646  */
    break;

  case 987:
#line 6448 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
	yyerrok;
	(yyval.statement) = new PNoop;
      }
#line 15849 "parse.cc" /* yacc.c:1646  */
    break;

  case 988:
#line 6453 "parse.y" /* yacc.c:1646  */
    { PExpr*del = (yyvsp[-2].exprs)->front(); (yyvsp[-2].exprs)->pop_front();
	assert((yyvsp[-2].exprs)->empty());
	PAssign*tmp = new PAssign((yyvsp[-4].expr),del,(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.statement) = tmp;
      }
#line 15860 "parse.cc" /* yacc.c:1646  */
    break;

  case 989:
#line 6460 "parse.y" /* yacc.c:1646  */
    { PExpr*del = (yyvsp[-2].exprs)->front(); (yyvsp[-2].exprs)->pop_front();
	assert((yyvsp[-2].exprs)->empty());
	PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),del,(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.statement) = tmp;
      }
#line 15871 "parse.cc" /* yacc.c:1646  */
    break;

  case 990:
#line 6467 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.statement) = tmp;
      }
#line 15880 "parse.cc" /* yacc.c:1646  */
    break;

  case 991:
#line 6472 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-8]));
	tmp->set_lineno((yylsp[-8]).first_line);
	(yyval.statement) = tmp;
      }
#line 15890 "parse.cc" /* yacc.c:1646  */
    break;

  case 992:
#line 6478 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-4]));
	(yyval.statement) = tmp;
      }
#line 15899 "parse.cc" /* yacc.c:1646  */
    break;

  case 993:
#line 6483 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-8]));
	(yyval.statement) = tmp;
      }
#line 15908 "parse.cc" /* yacc.c:1646  */
    break;

  case 994:
#line 6494 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-3].expr),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-3]));
	(yyval.statement) = tmp;
      }
#line 15917 "parse.cc" /* yacc.c:1646  */
    break;

  case 995:
#line 6503 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-3].expr),(yyvsp[-1].expr));
	FILE_NAME(tmp, (yylsp[-3]));
	(yyval.statement) = tmp;
      }
#line 15926 "parse.cc" /* yacc.c:1646  */
    break;

  case 996:
#line 6509 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[-2].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[-4]));
		  tmp->set_statement((yyvsp[0].statement));
		  (yyval.statement) = tmp;
		}
#line 15938 "parse.cc" /* yacc.c:1646  */
    break;

  case 997:
#line 6517 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement((PEEvent*)0);
		  FILE_NAME(tmp,(yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 15947 "parse.cc" /* yacc.c:1646  */
    break;

  case 998:
#line 6522 "parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-4].text)), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp,(yylsp[-4]));
		  delete[](yyvsp[-4].text);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 15958 "parse.cc" /* yacc.c:1646  */
    break;

  case 999:
#line 6529 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>pt;
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-1].text)), pt);
		  FILE_NAME(tmp,(yylsp[-1]));
		  delete[](yyvsp[-1].text);
		  (yyval.statement) = tmp;
		}
#line 15969 "parse.cc" /* yacc.c:1646  */
    break;

  case 1000:
#line 6537 "parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = pform_make_call_task((yylsp[-4]), *(yyvsp[-4].pform_name), *(yyvsp[-2].exprs));
	delete (yyvsp[-4].pform_name);
	delete (yyvsp[-2].exprs);
	(yyval.statement) = tmp;
      }
#line 15979 "parse.cc" /* yacc.c:1646  */
    break;

  case 1001:
#line 6544 "parse.y" /* yacc.c:1646  */
    { /* ....randomize with { <constraints> } */
	if ((yyvsp[-5].pform_name) && peek_tail_name(*(yyvsp[-5].pform_name)) == "randomize") {
	      if (!gn_system_verilog())
		    yyerror((yylsp[-4]), "error: Randomize with constraint requires SystemVerilog.");
	      else
		    yyerror((yylsp[-4]), "sorry: Randomize with constraint not supported.");
	} else {
	      yyerror((yylsp[-4]), "error: Constraint block can only be applied to randomize method.");
	}
	list<PExpr*>pt;
	PCallTask*tmp = new PCallTask(*(yyvsp[-5].pform_name), pt);
	FILE_NAME(tmp, (yylsp[-5]));
	delete (yyvsp[-5].pform_name);
	(yyval.statement) = tmp;
      }
#line 15999 "parse.cc" /* yacc.c:1646  */
    break;

  case 1002:
#line 6561 "parse.y" /* yacc.c:1646  */
    { pform_name_t*t_name = (yyvsp[-6].pform_name);
	while (! (yyvsp[-4].pform_name)->empty()) {
	      t_name->push_back((yyvsp[-4].pform_name)->front());
	      (yyvsp[-4].pform_name)->pop_front();
	}
	PCallTask*tmp = new PCallTask(*t_name, *(yyvsp[-2].exprs));
	FILE_NAME(tmp, (yylsp[-6]));
	delete (yyvsp[-6].pform_name);
	delete (yyvsp[-4].pform_name);
	delete (yyvsp[-2].exprs);
	(yyval.statement) = tmp;
      }
#line 16016 "parse.cc" /* yacc.c:1646  */
    break;

  case 1003:
#line 6575 "parse.y" /* yacc.c:1646  */
    { list<PExpr*>pt;
	PCallTask*tmp = pform_make_call_task((yylsp[-1]), *(yyvsp[-1].pform_name), pt);
	delete (yyvsp[-1].pform_name);
	(yyval.statement) = tmp;
      }
#line 16026 "parse.cc" /* yacc.c:1646  */
    break;

  case 1004:
#line 6589 "parse.y" /* yacc.c:1646  */
    { PChainConstructor*tmp = new PChainConstructor(*(yyvsp[-2].exprs));
	FILE_NAME(tmp, (yylsp[-4]));
	delete (yyvsp[-6].pform_name);
	(yyval.statement) = tmp;
      }
#line 16036 "parse.cc" /* yacc.c:1646  */
    break;

  case 1005:
#line 6595 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: Syntax error in task arguments.");
	list<PExpr*>pt;
	PCallTask*tmp = pform_make_call_task((yylsp[-4]), *(yyvsp[-4].pform_name), pt);
	delete (yyvsp[-4].pform_name);
	(yyval.statement) = tmp;
      }
#line 16047 "parse.cc" /* yacc.c:1646  */
    break;

  case 1006:
#line 6603 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: malformed statement");
	yyerrok;
	(yyval.statement) = new PNoop;
      }
#line 16056 "parse.cc" /* yacc.c:1646  */
    break;

  case 1007:
#line 6612 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '+', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16065 "parse.cc" /* yacc.c:1646  */
    break;

  case 1008:
#line 6617 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '-', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16074 "parse.cc" /* yacc.c:1646  */
    break;

  case 1009:
#line 6622 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '*', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16083 "parse.cc" /* yacc.c:1646  */
    break;

  case 1010:
#line 6627 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '/', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16092 "parse.cc" /* yacc.c:1646  */
    break;

  case 1011:
#line 6632 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '%', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16101 "parse.cc" /* yacc.c:1646  */
    break;

  case 1012:
#line 6637 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '&', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16110 "parse.cc" /* yacc.c:1646  */
    break;

  case 1013:
#line 6642 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '|', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16119 "parse.cc" /* yacc.c:1646  */
    break;

  case 1014:
#line 6647 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), '^', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16128 "parse.cc" /* yacc.c:1646  */
    break;

  case 1015:
#line 6652 "parse.y" /* yacc.c:1646  */
    { PAssign  *tmp = new PAssign((yyvsp[-2].expr), 'l', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16137 "parse.cc" /* yacc.c:1646  */
    break;

  case 1016:
#line 6657 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-2].expr), 'r', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16146 "parse.cc" /* yacc.c:1646  */
    break;

  case 1017:
#line 6662 "parse.y" /* yacc.c:1646  */
    { PAssign  *tmp = new PAssign((yyvsp[-2].expr), 'R', (yyvsp[0].expr));
	FILE_NAME(tmp, (yylsp[-2]));
	(yyval.statement) = tmp;
      }
#line 16155 "parse.cc" /* yacc.c:1646  */
    break;

  case 1018:
#line 6671 "parse.y" /* yacc.c:1646  */
    { (yyval.statement_list) = (yyvsp[0].statement_list); }
#line 16161 "parse.cc" /* yacc.c:1646  */
    break;

  case 1019:
#line 6673 "parse.y" /* yacc.c:1646  */
    { (yyval.statement_list) = 0; }
#line 16167 "parse.cc" /* yacc.c:1646  */
    break;

  case 1020:
#line 6678 "parse.y" /* yacc.c:1646  */
    { vector<Statement*>*tmp = (yyvsp[-1].statement_list);
	if ((yyvsp[0].statement)) tmp->push_back((yyvsp[0].statement));
	(yyval.statement_list) = tmp;
      }
#line 16176 "parse.cc" /* yacc.c:1646  */
    break;

  case 1021:
#line 6683 "parse.y" /* yacc.c:1646  */
    { vector<Statement*>*tmp = new vector<Statement*>(0);
	if ((yyvsp[0].statement)) tmp->push_back((yyvsp[0].statement));
	(yyval.statement_list) = tmp;
      }
#line 16185 "parse.cc" /* yacc.c:1646  */
    break;

  case 1022:
#line 6691 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = pform_contribution_statement((yylsp[-2]), (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 16191 "parse.cc" /* yacc.c:1646  */
    break;

  case 1023:
#line 6697 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = new vector<pform_tf_port_t>(0); }
#line 16197 "parse.cc" /* yacc.c:1646  */
    break;

  case 1024:
#line 6698 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 16203 "parse.cc" /* yacc.c:1646  */
    break;

  case 1025:
#line 6703 "parse.y" /* yacc.c:1646  */
    { vector<pform_tf_port_t>*tmp = (yyvsp[-1].tf_ports);
	size_t s1 = tmp->size();
	tmp->resize(s1 + (yyvsp[0].tf_ports)->size());
	for (size_t idx = 0 ; idx < (yyvsp[0].tf_ports)->size() ; idx += 1)
	      tmp->at(s1 + idx) = (yyvsp[0].tf_ports)->at(idx);
	delete (yyvsp[0].tf_ports);
	(yyval.tf_ports) = tmp;
      }
#line 16216 "parse.cc" /* yacc.c:1646  */
    break;

  case 1026:
#line 6712 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 16222 "parse.cc" /* yacc.c:1646  */
    break;

  case 1027:
#line 6717 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 16228 "parse.cc" /* yacc.c:1646  */
    break;

  case 1028:
#line 6719 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = 0; }
#line 16234 "parse.cc" /* yacc.c:1646  */
    break;

  case 1029:
#line 6723 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = (yyvsp[0].tf_ports); }
#line 16240 "parse.cc" /* yacc.c:1646  */
    break;

  case 1030:
#line 6724 "parse.y" /* yacc.c:1646  */
    { (yyval.tf_ports) = 0; }
#line 16246 "parse.cc" /* yacc.c:1646  */
    break;

  case 1031:
#line 6733 "parse.y" /* yacc.c:1646  */
    { lex_end_table();
	(yyval.strings) = (yyvsp[-1].strings);
      }
#line 16254 "parse.cc" /* yacc.c:1646  */
    break;

  case 1032:
#line 6737 "parse.y" /* yacc.c:1646  */
    { lex_end_table();
	yyerror((yylsp[-1]), "error: Empty UDP table.");
	(yyval.strings) = 0;
      }
#line 16263 "parse.cc" /* yacc.c:1646  */
    break;

  case 1033:
#line 6742 "parse.y" /* yacc.c:1646  */
    { lex_end_table();
	yyerror((yylsp[-1]), "Errors in UDP table");
	yyerrok;
	(yyval.strings) = 0;
      }
#line 16273 "parse.cc" /* yacc.c:1646  */
    break;

  case 1036:
#line 6756 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-3].text))+3];
		  strcpy(tmp, (yyvsp[-3].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.text) = tmp;
		}
#line 16287 "parse.cc" /* yacc.c:1646  */
    break;

  case 1037:
#line 6769 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 16297 "parse.cc" /* yacc.c:1646  */
    break;

  case 1038:
#line 6775 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 16307 "parse.cc" /* yacc.c:1646  */
    break;

  case 1039:
#line 6784 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 16317 "parse.cc" /* yacc.c:1646  */
    break;

  case 1040:
#line 6790 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 16327 "parse.cc" /* yacc.c:1646  */
    break;

  case 1041:
#line 6799 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-5].text))+5];
		  strcpy(tmp, (yyvsp[-5].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-3].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		}
#line 16342 "parse.cc" /* yacc.c:1646  */
    break;

  case 1042:
#line 6813 "parse.y" /* yacc.c:1646  */
    { PExpr*etmp = new PENumber((yyvsp[-1].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[-3]));
		  delete[](yyvsp[-3].text);
		  (yyval.statement) = atmp;
		}
#line 16354 "parse.cc" /* yacc.c:1646  */
    break;

  case 1043:
#line 6823 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 16360 "parse.cc" /* yacc.c:1646  */
    break;

  case 1044:
#line 6824 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 16366 "parse.cc" /* yacc.c:1646  */
    break;

  case 1045:
#line 6829 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[0].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		}
#line 16376 "parse.cc" /* yacc.c:1646  */
    break;

  case 1046:
#line 6835 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-1].text))+2];
		  strcpy(tmp, (yyvsp[-1].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[0].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-1].text);
		  (yyval.text) = tmp;
		}
#line 16389 "parse.cc" /* yacc.c:1646  */
    break;

  case 1047:
#line 6846 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 16395 "parse.cc" /* yacc.c:1646  */
    break;

  case 1048:
#line 6847 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 16401 "parse.cc" /* yacc.c:1646  */
    break;

  case 1049:
#line 6848 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 16407 "parse.cc" /* yacc.c:1646  */
    break;

  case 1050:
#line 6849 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '?'; }
#line 16413 "parse.cc" /* yacc.c:1646  */
    break;

  case 1051:
#line 6850 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'b'; }
#line 16419 "parse.cc" /* yacc.c:1646  */
    break;

  case 1052:
#line 6851 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '*'; }
#line 16425 "parse.cc" /* yacc.c:1646  */
    break;

  case 1053:
#line 6852 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '%'; }
#line 16431 "parse.cc" /* yacc.c:1646  */
    break;

  case 1054:
#line 6853 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'f'; }
#line 16437 "parse.cc" /* yacc.c:1646  */
    break;

  case 1055:
#line 6854 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'F'; }
#line 16443 "parse.cc" /* yacc.c:1646  */
    break;

  case 1056:
#line 6855 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'l'; }
#line 16449 "parse.cc" /* yacc.c:1646  */
    break;

  case 1057:
#line 6856 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'h'; }
#line 16455 "parse.cc" /* yacc.c:1646  */
    break;

  case 1058:
#line 6857 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'B'; }
#line 16461 "parse.cc" /* yacc.c:1646  */
    break;

  case 1059:
#line 6858 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'r'; }
#line 16467 "parse.cc" /* yacc.c:1646  */
    break;

  case 1060:
#line 6859 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'R'; }
#line 16473 "parse.cc" /* yacc.c:1646  */
    break;

  case 1061:
#line 6860 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'M'; }
#line 16479 "parse.cc" /* yacc.c:1646  */
    break;

  case 1062:
#line 6861 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'n'; }
#line 16485 "parse.cc" /* yacc.c:1646  */
    break;

  case 1063:
#line 6862 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'N'; }
#line 16491 "parse.cc" /* yacc.c:1646  */
    break;

  case 1064:
#line 6863 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'p'; }
#line 16497 "parse.cc" /* yacc.c:1646  */
    break;

  case 1065:
#line 6864 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'P'; }
#line 16503 "parse.cc" /* yacc.c:1646  */
    break;

  case 1066:
#line 6865 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'Q'; }
#line 16509 "parse.cc" /* yacc.c:1646  */
    break;

  case 1067:
#line 6866 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'q'; }
#line 16515 "parse.cc" /* yacc.c:1646  */
    break;

  case 1068:
#line 6867 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '_'; }
#line 16521 "parse.cc" /* yacc.c:1646  */
    break;

  case 1069:
#line 6868 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 16527 "parse.cc" /* yacc.c:1646  */
    break;

  case 1070:
#line 6869 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "internal error: Input digits parse as decimal number!"); (yyval.letter) = '0'; }
#line 16533 "parse.cc" /* yacc.c:1646  */
    break;

  case 1071:
#line 6873 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 16539 "parse.cc" /* yacc.c:1646  */
    break;

  case 1072:
#line 6874 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 16545 "parse.cc" /* yacc.c:1646  */
    break;

  case 1073:
#line 6875 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 16551 "parse.cc" /* yacc.c:1646  */
    break;

  case 1074:
#line 6876 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 16557 "parse.cc" /* yacc.c:1646  */
    break;

  case 1075:
#line 6877 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "internal error: Output digits parse as decimal number!"); (yyval.letter) = '0'; }
#line 16563 "parse.cc" /* yacc.c:1646  */
    break;

  case 1076:
#line 6885 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[-1].perm_strings)); }
#line 16569 "parse.cc" /* yacc.c:1646  */
    break;

  case 1077:
#line 6887 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	vector<PWire*>*tmp = new vector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 16581 "parse.cc" /* yacc.c:1646  */
    break;

  case 1078:
#line 6895 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	vector<PWire*>*tmp = new vector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 16593 "parse.cc" /* yacc.c:1646  */
    break;

  case 1079:
#line 6903 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	vector<PWire*>*tmp = new vector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 16605 "parse.cc" /* yacc.c:1646  */
    break;

  case 1080:
#line 6914 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 16611 "parse.cc" /* yacc.c:1646  */
    break;

  case 1081:
#line 6916 "parse.y" /* yacc.c:1646  */
    { vector<PWire*>*tmp = (yyvsp[-1].wires);
	size_t s1 = (yyvsp[-1].wires)->size();
	tmp->resize(s1+(yyvsp[0].wires)->size());
	for (size_t idx = 0 ; idx < (yyvsp[0].wires)->size() ; idx += 1)
	      tmp->at(s1+idx) = (yyvsp[0].wires)->at(idx);
	(yyval.wires) = tmp;
	delete (yyvsp[0].wires);
      }
#line 16624 "parse.cc" /* yacc.c:1646  */
    break;

  case 1082:
#line 6928 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 16634 "parse.cc" /* yacc.c:1646  */
    break;

  case 1083:
#line 6934 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 16644 "parse.cc" /* yacc.c:1646  */
    break;

  case 1084:
#line 6941 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 16650 "parse.cc" /* yacc.c:1646  */
    break;

  case 1085:
#line 6941 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 16656 "parse.cc" /* yacc.c:1646  */
    break;

  case 1086:
#line 6944 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 16662 "parse.cc" /* yacc.c:1646  */
    break;

  case 1087:
#line 6945 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 16668 "parse.cc" /* yacc.c:1646  */
    break;

  case 1088:
#line 6950 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 16678 "parse.cc" /* yacc.c:1646  */
    break;

  case 1089:
#line 6956 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-3].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 16688 "parse.cc" /* yacc.c:1646  */
    break;

  case 1090:
#line 6974 "parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-9].text));
		  pform_make_udp(tmp2, (yyvsp[-7].perm_strings), (yyvsp[-4].wires), (yyvsp[-2].strings), (yyvsp[-3].statement),
				 (yylsp[-9]).text, (yylsp[-9]).first_line);
		  if ((yyvsp[0].text)) {
			if (strcmp((yyvsp[-9].text),(yyvsp[0].text)) != 0) {
			      yyerror((yylsp[0]), "error: End label doesn't match "
			                   "primitive name");
			}
			if (! gn_system_verilog()) {
			      yyerror((yylsp[0]), "error: Primitive end labels "
			                   "require SystemVerilog.");
			}
			delete[](yyvsp[0].text);
		  }
		  delete[](yyvsp[-9].text);
		}
#line 16709 "parse.cc" /* yacc.c:1646  */
    break;

  case 1091:
#line 7000 "parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-12].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[-8].text));
		  pform_make_udp(tmp2, (yyvsp[-9].flag), tmp6, (yyvsp[-7].expr), (yyvsp[-5].perm_strings), (yyvsp[-2].strings),
				 (yylsp[-12]).text, (yylsp[-12]).first_line);
		  if ((yyvsp[0].text)) {
			if (strcmp((yyvsp[-12].text),(yyvsp[0].text)) != 0) {
			      yyerror((yylsp[0]), "error: End label doesn't match "
			                   "primitive name");
			}
			if (! gn_system_verilog()) {
			      yyerror((yylsp[0]), "error: Primitive end labels "
			                   "require SystemVerilog.");
			}
			delete[](yyvsp[0].text);
		  }
		  delete[](yyvsp[-12].text);
		  delete[](yyvsp[-8].text);
		}
#line 16732 "parse.cc" /* yacc.c:1646  */
    break;

  case 1092:
#line 7024 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 16738 "parse.cc" /* yacc.c:1646  */
    break;

  case 1093:
#line 7024 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 16744 "parse.cc" /* yacc.c:1646  */
    break;

  case 1094:
#line 7025 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 16750 "parse.cc" /* yacc.c:1646  */
    break;

  case 1095:
#line 7025 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 16756 "parse.cc" /* yacc.c:1646  */
    break;

  case 1096:
#line 7026 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 16762 "parse.cc" /* yacc.c:1646  */
    break;

  case 1097:
#line 7026 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 16768 "parse.cc" /* yacc.c:1646  */
    break;

  case 1098:
#line 7027 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 16774 "parse.cc" /* yacc.c:1646  */
    break;

  case 1099:
#line 7027 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 16780 "parse.cc" /* yacc.c:1646  */
    break;


#line 16784 "parse.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
